#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 11
#define STATE_COUNT 1257
#define LARGE_STATE_COUNT 242
#define SYMBOL_COUNT 178
#define ALIAS_COUNT 0
#define TOKEN_COUNT 82
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 9
#define MAX_ALIAS_SEQUENCE_LENGTH 10

enum {
  sym__lower_id = 1,
  anon_sym_module = 2,
  anon_sym_LBRACE = 3,
  anon_sym_RBRACE = 4,
  anon_sym_SEMI = 5,
  anon_sym_LPAREN = 6,
  anon_sym_COMMA = 7,
  anon_sym_RPAREN = 8,
  anon_sym_or = 9,
  anon_sym_from = 10,
  anon_sym_where = 11,
  anon_sym_select = 12,
  anon_sym_if = 13,
  anon_sym_then = 14,
  anon_sym_else = 15,
  anon_sym_and = 16,
  anon_sym_implies = 17,
  anon_sym_PIPE = 18,
  anon_sym_DOT = 19,
  anon_sym_LBRACK = 20,
  anon_sym_RBRACK = 21,
  anon_sym_DOT_DOT = 22,
  anon_sym_order = 23,
  anon_sym_by = 24,
  sym_qldoc = 25,
  anon_sym_COLON_COLON = 26,
  anon_sym_float = 27,
  anon_sym_int = 28,
  anon_sym_string = 29,
  sym__upper_id = 30,
  sym__at_lower_id = 31,
  sym_integer = 32,
  sym_float = 33,
  sym_string = 34,
  sym_line_comment = 35,
  sym_block_comment = 36,
  sym_any = 37,
  sym_as = 38,
  sym_asc = 39,
  sym_avg = 40,
  sym_boolean = 41,
  sym_class = 42,
  sym_newtype = 43,
  sym_count = 44,
  sym_date = 45,
  sym_desc = 46,
  sym_exists = 47,
  sym_extends = 48,
  sym_false = 49,
  sym_forall = 50,
  sym_forex = 51,
  sym_import = 52,
  sym_in = 53,
  sym_instanceof = 54,
  sym_max = 55,
  sym_min = 56,
  sym_not = 57,
  sym_none = 58,
  sym_predicate = 59,
  sym_rank = 60,
  sym_result = 61,
  sym_strictcount = 62,
  sym_strictsum = 63,
  sym_strictconcat = 64,
  sym_concat = 65,
  sym_sum = 66,
  sym_super = 67,
  sym_this = 68,
  sym_true = 69,
  sym_lt = 70,
  sym_le = 71,
  sym_eq = 72,
  sym_gt = 73,
  sym_ge = 74,
  sym_underscore = 75,
  sym_minus = 76,
  sym_ne = 77,
  sym_slash = 78,
  sym_star = 79,
  sym_mod = 80,
  sym_plus = 81,
  sym_ql = 82,
  sym_module = 83,
  sym_moduleMember = 84,
  sym_imprt = 85,
  sym_moduleAliasBody = 86,
  sym_predicateAliasBody = 87,
  sym_typeAliasBody = 88,
  sym_classlessPredicate = 89,
  sym_datatype = 90,
  sym_datatypeBranches = 91,
  sym_datatypeBranch = 92,
  sym_select = 93,
  sym_dataclass = 94,
  sym_classMember = 95,
  sym_charpred = 96,
  sym_memberPredicate = 97,
  sym_field = 98,
  sym__optbody = 99,
  sym_empty = 100,
  sym_body = 101,
  sym_higherOrderTerm = 102,
  sym_special_call = 103,
  sym_prefix_cast = 104,
  sym_unary_expr = 105,
  sym_mul_expr = 106,
  sym_add_expr = 107,
  sym_in_expr = 108,
  sym_comp_term = 109,
  sym_instance_of = 110,
  sym_negation = 111,
  sym_if_term = 112,
  sym_conjunction = 113,
  sym_disjunction = 114,
  sym_implication = 115,
  sym_quantified = 116,
  sym_specialId = 117,
  sym_quantifier = 118,
  sym__call_arg = 119,
  sym_qualifiedRhs = 120,
  sym_classless_predicate_call = 121,
  sym_qualified_expr = 122,
  sym_super_ref = 123,
  sym_full_aggregate_body = 124,
  sym_expr_aggregate_body = 125,
  sym_aggregate = 126,
  sym_range = 127,
  sym_par_expr = 128,
  sym__exprOrTerm = 129,
  sym__primary = 130,
  sym_literal = 131,
  sym_bool = 132,
  sym_variable = 133,
  sym_compop = 134,
  sym_unop = 135,
  sym_mulop = 136,
  sym_addop = 137,
  sym_closure = 138,
  sym_direction = 139,
  sym_varDecl = 140,
  sym_asExprs = 141,
  sym_asExpr = 142,
  sym_orderBys = 143,
  sym_orderBy = 144,
  sym_literalId = 145,
  sym_annotation = 146,
  sym_annotName = 147,
  sym_annotArg = 148,
  sym_moduleName = 149,
  sym_qualModuleExpr = 150,
  sym_importModuleExpr = 151,
  sym_moduleExpr = 152,
  sym_typeLiteral = 153,
  sym_simpleId = 154,
  sym_className = 155,
  sym_dbtype = 156,
  sym_returnType = 157,
  sym_typeExpr = 158,
  sym_predicateName = 159,
  sym_aritylessPredicateExpr = 160,
  sym_predicateExpr = 161,
  sym_varName = 162,
  sym_aggId = 163,
  aux_sym_ql_repeat1 = 164,
  aux_sym_moduleMember_repeat1 = 165,
  aux_sym_classlessPredicate_repeat1 = 166,
  aux_sym_datatypeBranches_repeat1 = 167,
  aux_sym_dataclass_repeat1 = 168,
  aux_sym_dataclass_repeat2 = 169,
  aux_sym_higherOrderTerm_repeat1 = 170,
  aux_sym_higherOrderTerm_repeat2 = 171,
  aux_sym_aggregate_repeat1 = 172,
  aux_sym_asExprs_repeat1 = 173,
  aux_sym_orderBys_repeat1 = 174,
  aux_sym_annotation_repeat1 = 175,
  aux_sym_qualModuleExpr_repeat1 = 176,
  aux_sym_importModuleExpr_repeat1 = 177,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym__lower_id] = "_lower_id",
  [anon_sym_module] = "module",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_SEMI] = ";",
  [anon_sym_LPAREN] = "(",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [anon_sym_or] = "or",
  [anon_sym_from] = "from",
  [anon_sym_where] = "where",
  [anon_sym_select] = "select",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_else] = "else",
  [anon_sym_and] = "and",
  [anon_sym_implies] = "implies",
  [anon_sym_PIPE] = "|",
  [anon_sym_DOT] = ".",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_order] = "order",
  [anon_sym_by] = "by",
  [sym_qldoc] = "qldoc",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_float] = "float",
  [anon_sym_int] = "int",
  [anon_sym_string] = "string",
  [sym__upper_id] = "_upper_id",
  [sym__at_lower_id] = "_at_lower_id",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [sym_string] = "string",
  [sym_line_comment] = "line_comment",
  [sym_block_comment] = "block_comment",
  [sym_any] = "any",
  [sym_as] = "as",
  [sym_asc] = "asc",
  [sym_avg] = "avg",
  [sym_boolean] = "boolean",
  [sym_class] = "class",
  [sym_newtype] = "newtype",
  [sym_count] = "count",
  [sym_date] = "date",
  [sym_desc] = "desc",
  [sym_exists] = "exists",
  [sym_extends] = "extends",
  [sym_false] = "false",
  [sym_forall] = "forall",
  [sym_forex] = "forex",
  [sym_import] = "import",
  [sym_in] = "in",
  [sym_instanceof] = "instanceof",
  [sym_max] = "max",
  [sym_min] = "min",
  [sym_not] = "not",
  [sym_none] = "none",
  [sym_predicate] = "predicate",
  [sym_rank] = "rank",
  [sym_result] = "result",
  [sym_strictcount] = "strictcount",
  [sym_strictsum] = "strictsum",
  [sym_strictconcat] = "strictconcat",
  [sym_concat] = "concat",
  [sym_sum] = "sum",
  [sym_super] = "super",
  [sym_this] = "this",
  [sym_true] = "true",
  [sym_lt] = "lt",
  [sym_le] = "le",
  [sym_eq] = "eq",
  [sym_gt] = "gt",
  [sym_ge] = "ge",
  [sym_underscore] = "underscore",
  [sym_minus] = "minus",
  [sym_ne] = "ne",
  [sym_slash] = "slash",
  [sym_star] = "star",
  [sym_mod] = "mod",
  [sym_plus] = "plus",
  [sym_ql] = "ql",
  [sym_module] = "module",
  [sym_moduleMember] = "moduleMember",
  [sym_imprt] = "imprt",
  [sym_moduleAliasBody] = "moduleAliasBody",
  [sym_predicateAliasBody] = "predicateAliasBody",
  [sym_typeAliasBody] = "typeAliasBody",
  [sym_classlessPredicate] = "classlessPredicate",
  [sym_datatype] = "datatype",
  [sym_datatypeBranches] = "datatypeBranches",
  [sym_datatypeBranch] = "datatypeBranch",
  [sym_select] = "select",
  [sym_dataclass] = "dataclass",
  [sym_classMember] = "classMember",
  [sym_charpred] = "charpred",
  [sym_memberPredicate] = "memberPredicate",
  [sym_field] = "field",
  [sym__optbody] = "_optbody",
  [sym_empty] = "empty",
  [sym_body] = "body",
  [sym_higherOrderTerm] = "higherOrderTerm",
  [sym_special_call] = "special_call",
  [sym_prefix_cast] = "prefix_cast",
  [sym_unary_expr] = "unary_expr",
  [sym_mul_expr] = "mul_expr",
  [sym_add_expr] = "add_expr",
  [sym_in_expr] = "in_expr",
  [sym_comp_term] = "comp_term",
  [sym_instance_of] = "instance_of",
  [sym_negation] = "negation",
  [sym_if_term] = "if_term",
  [sym_conjunction] = "conjunction",
  [sym_disjunction] = "disjunction",
  [sym_implication] = "implication",
  [sym_quantified] = "quantified",
  [sym_specialId] = "specialId",
  [sym_quantifier] = "quantifier",
  [sym__call_arg] = "_call_arg",
  [sym_qualifiedRhs] = "qualifiedRhs",
  [sym_classless_predicate_call] = "classless_predicate_call",
  [sym_qualified_expr] = "qualified_expr",
  [sym_super_ref] = "super_ref",
  [sym_full_aggregate_body] = "full_aggregate_body",
  [sym_expr_aggregate_body] = "expr_aggregate_body",
  [sym_aggregate] = "aggregate",
  [sym_range] = "range",
  [sym_par_expr] = "par_expr",
  [sym__exprOrTerm] = "_exprOrTerm",
  [sym__primary] = "_primary",
  [sym_literal] = "literal",
  [sym_bool] = "bool",
  [sym_variable] = "variable",
  [sym_compop] = "compop",
  [sym_unop] = "unop",
  [sym_mulop] = "mulop",
  [sym_addop] = "addop",
  [sym_closure] = "closure",
  [sym_direction] = "direction",
  [sym_varDecl] = "varDecl",
  [sym_asExprs] = "asExprs",
  [sym_asExpr] = "asExpr",
  [sym_orderBys] = "orderBys",
  [sym_orderBy] = "orderBy",
  [sym_literalId] = "literalId",
  [sym_annotation] = "annotation",
  [sym_annotName] = "annotName",
  [sym_annotArg] = "annotArg",
  [sym_moduleName] = "moduleName",
  [sym_qualModuleExpr] = "qualModuleExpr",
  [sym_importModuleExpr] = "importModuleExpr",
  [sym_moduleExpr] = "moduleExpr",
  [sym_typeLiteral] = "typeLiteral",
  [sym_simpleId] = "simpleId",
  [sym_className] = "className",
  [sym_dbtype] = "dbtype",
  [sym_returnType] = "returnType",
  [sym_typeExpr] = "typeExpr",
  [sym_predicateName] = "predicateName",
  [sym_aritylessPredicateExpr] = "aritylessPredicateExpr",
  [sym_predicateExpr] = "predicateExpr",
  [sym_varName] = "varName",
  [sym_aggId] = "aggId",
  [aux_sym_ql_repeat1] = "ql_repeat1",
  [aux_sym_moduleMember_repeat1] = "moduleMember_repeat1",
  [aux_sym_classlessPredicate_repeat1] = "classlessPredicate_repeat1",
  [aux_sym_datatypeBranches_repeat1] = "datatypeBranches_repeat1",
  [aux_sym_dataclass_repeat1] = "dataclass_repeat1",
  [aux_sym_dataclass_repeat2] = "dataclass_repeat2",
  [aux_sym_higherOrderTerm_repeat1] = "higherOrderTerm_repeat1",
  [aux_sym_higherOrderTerm_repeat2] = "higherOrderTerm_repeat2",
  [aux_sym_aggregate_repeat1] = "aggregate_repeat1",
  [aux_sym_asExprs_repeat1] = "asExprs_repeat1",
  [aux_sym_orderBys_repeat1] = "orderBys_repeat1",
  [aux_sym_annotation_repeat1] = "annotation_repeat1",
  [aux_sym_qualModuleExpr_repeat1] = "qualModuleExpr_repeat1",
  [aux_sym_importModuleExpr_repeat1] = "importModuleExpr_repeat1",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym__lower_id] = sym__lower_id,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_where] = anon_sym_where,
  [anon_sym_select] = anon_sym_select,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_implies] = anon_sym_implies,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_order] = anon_sym_order,
  [anon_sym_by] = anon_sym_by,
  [sym_qldoc] = sym_qldoc,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_string] = anon_sym_string,
  [sym__upper_id] = sym__upper_id,
  [sym__at_lower_id] = sym__at_lower_id,
  [sym_integer] = sym_integer,
  [sym_float] = sym_float,
  [sym_string] = sym_string,
  [sym_line_comment] = sym_line_comment,
  [sym_block_comment] = sym_block_comment,
  [sym_any] = sym_any,
  [sym_as] = sym_as,
  [sym_asc] = sym_asc,
  [sym_avg] = sym_avg,
  [sym_boolean] = sym_boolean,
  [sym_class] = sym_class,
  [sym_newtype] = sym_newtype,
  [sym_count] = sym_count,
  [sym_date] = sym_date,
  [sym_desc] = sym_desc,
  [sym_exists] = sym_exists,
  [sym_extends] = sym_extends,
  [sym_false] = sym_false,
  [sym_forall] = sym_forall,
  [sym_forex] = sym_forex,
  [sym_import] = sym_import,
  [sym_in] = sym_in,
  [sym_instanceof] = sym_instanceof,
  [sym_max] = sym_max,
  [sym_min] = sym_min,
  [sym_not] = sym_not,
  [sym_none] = sym_none,
  [sym_predicate] = sym_predicate,
  [sym_rank] = sym_rank,
  [sym_result] = sym_result,
  [sym_strictcount] = sym_strictcount,
  [sym_strictsum] = sym_strictsum,
  [sym_strictconcat] = sym_strictconcat,
  [sym_concat] = sym_concat,
  [sym_sum] = sym_sum,
  [sym_super] = sym_super,
  [sym_this] = sym_this,
  [sym_true] = sym_true,
  [sym_lt] = sym_lt,
  [sym_le] = sym_le,
  [sym_eq] = sym_eq,
  [sym_gt] = sym_gt,
  [sym_ge] = sym_ge,
  [sym_underscore] = sym_underscore,
  [sym_minus] = sym_minus,
  [sym_ne] = sym_ne,
  [sym_slash] = sym_slash,
  [sym_star] = sym_star,
  [sym_mod] = sym_mod,
  [sym_plus] = sym_plus,
  [sym_ql] = sym_ql,
  [sym_module] = sym_module,
  [sym_moduleMember] = sym_moduleMember,
  [sym_imprt] = sym_imprt,
  [sym_moduleAliasBody] = sym_moduleAliasBody,
  [sym_predicateAliasBody] = sym_predicateAliasBody,
  [sym_typeAliasBody] = sym_typeAliasBody,
  [sym_classlessPredicate] = sym_classlessPredicate,
  [sym_datatype] = sym_datatype,
  [sym_datatypeBranches] = sym_datatypeBranches,
  [sym_datatypeBranch] = sym_datatypeBranch,
  [sym_select] = sym_select,
  [sym_dataclass] = sym_dataclass,
  [sym_classMember] = sym_classMember,
  [sym_charpred] = sym_charpred,
  [sym_memberPredicate] = sym_memberPredicate,
  [sym_field] = sym_field,
  [sym__optbody] = sym__optbody,
  [sym_empty] = sym_empty,
  [sym_body] = sym_body,
  [sym_higherOrderTerm] = sym_higherOrderTerm,
  [sym_special_call] = sym_special_call,
  [sym_prefix_cast] = sym_prefix_cast,
  [sym_unary_expr] = sym_unary_expr,
  [sym_mul_expr] = sym_mul_expr,
  [sym_add_expr] = sym_add_expr,
  [sym_in_expr] = sym_in_expr,
  [sym_comp_term] = sym_comp_term,
  [sym_instance_of] = sym_instance_of,
  [sym_negation] = sym_negation,
  [sym_if_term] = sym_if_term,
  [sym_conjunction] = sym_conjunction,
  [sym_disjunction] = sym_disjunction,
  [sym_implication] = sym_implication,
  [sym_quantified] = sym_quantified,
  [sym_specialId] = sym_specialId,
  [sym_quantifier] = sym_quantifier,
  [sym__call_arg] = sym__call_arg,
  [sym_qualifiedRhs] = sym_qualifiedRhs,
  [sym_classless_predicate_call] = sym_classless_predicate_call,
  [sym_qualified_expr] = sym_qualified_expr,
  [sym_super_ref] = sym_super_ref,
  [sym_full_aggregate_body] = sym_full_aggregate_body,
  [sym_expr_aggregate_body] = sym_expr_aggregate_body,
  [sym_aggregate] = sym_aggregate,
  [sym_range] = sym_range,
  [sym_par_expr] = sym_par_expr,
  [sym__exprOrTerm] = sym__exprOrTerm,
  [sym__primary] = sym__primary,
  [sym_literal] = sym_literal,
  [sym_bool] = sym_bool,
  [sym_variable] = sym_variable,
  [sym_compop] = sym_compop,
  [sym_unop] = sym_unop,
  [sym_mulop] = sym_mulop,
  [sym_addop] = sym_addop,
  [sym_closure] = sym_closure,
  [sym_direction] = sym_direction,
  [sym_varDecl] = sym_varDecl,
  [sym_asExprs] = sym_asExprs,
  [sym_asExpr] = sym_asExpr,
  [sym_orderBys] = sym_orderBys,
  [sym_orderBy] = sym_orderBy,
  [sym_literalId] = sym_literalId,
  [sym_annotation] = sym_annotation,
  [sym_annotName] = sym_annotName,
  [sym_annotArg] = sym_annotArg,
  [sym_moduleName] = sym_moduleName,
  [sym_qualModuleExpr] = sym_qualModuleExpr,
  [sym_importModuleExpr] = sym_importModuleExpr,
  [sym_moduleExpr] = sym_moduleExpr,
  [sym_typeLiteral] = sym_typeLiteral,
  [sym_simpleId] = sym_simpleId,
  [sym_className] = sym_className,
  [sym_dbtype] = sym_dbtype,
  [sym_returnType] = sym_returnType,
  [sym_typeExpr] = sym_typeExpr,
  [sym_predicateName] = sym_predicateName,
  [sym_aritylessPredicateExpr] = sym_aritylessPredicateExpr,
  [sym_predicateExpr] = sym_predicateExpr,
  [sym_varName] = sym_varName,
  [sym_aggId] = sym_aggId,
  [aux_sym_ql_repeat1] = aux_sym_ql_repeat1,
  [aux_sym_moduleMember_repeat1] = aux_sym_moduleMember_repeat1,
  [aux_sym_classlessPredicate_repeat1] = aux_sym_classlessPredicate_repeat1,
  [aux_sym_datatypeBranches_repeat1] = aux_sym_datatypeBranches_repeat1,
  [aux_sym_dataclass_repeat1] = aux_sym_dataclass_repeat1,
  [aux_sym_dataclass_repeat2] = aux_sym_dataclass_repeat2,
  [aux_sym_higherOrderTerm_repeat1] = aux_sym_higherOrderTerm_repeat1,
  [aux_sym_higherOrderTerm_repeat2] = aux_sym_higherOrderTerm_repeat2,
  [aux_sym_aggregate_repeat1] = aux_sym_aggregate_repeat1,
  [aux_sym_asExprs_repeat1] = aux_sym_asExprs_repeat1,
  [aux_sym_orderBys_repeat1] = aux_sym_orderBys_repeat1,
  [aux_sym_annotation_repeat1] = aux_sym_annotation_repeat1,
  [aux_sym_qualModuleExpr_repeat1] = aux_sym_qualModuleExpr_repeat1,
  [aux_sym_importModuleExpr_repeat1] = aux_sym_importModuleExpr_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym__lower_id] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_where] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_select] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implies] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_order] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_by] = {
    .visible = true,
    .named = false,
  },
  [sym_qldoc] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [sym__upper_id] = {
    .visible = false,
    .named = true,
  },
  [sym__at_lower_id] = {
    .visible = false,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_any] = {
    .visible = true,
    .named = true,
  },
  [sym_as] = {
    .visible = true,
    .named = true,
  },
  [sym_asc] = {
    .visible = true,
    .named = true,
  },
  [sym_avg] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_newtype] = {
    .visible = true,
    .named = true,
  },
  [sym_count] = {
    .visible = true,
    .named = true,
  },
  [sym_date] = {
    .visible = true,
    .named = true,
  },
  [sym_desc] = {
    .visible = true,
    .named = true,
  },
  [sym_exists] = {
    .visible = true,
    .named = true,
  },
  [sym_extends] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_forall] = {
    .visible = true,
    .named = true,
  },
  [sym_forex] = {
    .visible = true,
    .named = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_in] = {
    .visible = true,
    .named = true,
  },
  [sym_instanceof] = {
    .visible = true,
    .named = true,
  },
  [sym_max] = {
    .visible = true,
    .named = true,
  },
  [sym_min] = {
    .visible = true,
    .named = true,
  },
  [sym_not] = {
    .visible = true,
    .named = true,
  },
  [sym_none] = {
    .visible = true,
    .named = true,
  },
  [sym_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_rank] = {
    .visible = true,
    .named = true,
  },
  [sym_result] = {
    .visible = true,
    .named = true,
  },
  [sym_strictcount] = {
    .visible = true,
    .named = true,
  },
  [sym_strictsum] = {
    .visible = true,
    .named = true,
  },
  [sym_strictconcat] = {
    .visible = true,
    .named = true,
  },
  [sym_concat] = {
    .visible = true,
    .named = true,
  },
  [sym_sum] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_lt] = {
    .visible = true,
    .named = true,
  },
  [sym_le] = {
    .visible = true,
    .named = true,
  },
  [sym_eq] = {
    .visible = true,
    .named = true,
  },
  [sym_gt] = {
    .visible = true,
    .named = true,
  },
  [sym_ge] = {
    .visible = true,
    .named = true,
  },
  [sym_underscore] = {
    .visible = true,
    .named = true,
  },
  [sym_minus] = {
    .visible = true,
    .named = true,
  },
  [sym_ne] = {
    .visible = true,
    .named = true,
  },
  [sym_slash] = {
    .visible = true,
    .named = true,
  },
  [sym_star] = {
    .visible = true,
    .named = true,
  },
  [sym_mod] = {
    .visible = true,
    .named = true,
  },
  [sym_plus] = {
    .visible = true,
    .named = true,
  },
  [sym_ql] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_moduleMember] = {
    .visible = true,
    .named = true,
  },
  [sym_imprt] = {
    .visible = true,
    .named = true,
  },
  [sym_moduleAliasBody] = {
    .visible = true,
    .named = true,
  },
  [sym_predicateAliasBody] = {
    .visible = true,
    .named = true,
  },
  [sym_typeAliasBody] = {
    .visible = true,
    .named = true,
  },
  [sym_classlessPredicate] = {
    .visible = true,
    .named = true,
  },
  [sym_datatype] = {
    .visible = true,
    .named = true,
  },
  [sym_datatypeBranches] = {
    .visible = true,
    .named = true,
  },
  [sym_datatypeBranch] = {
    .visible = true,
    .named = true,
  },
  [sym_select] = {
    .visible = true,
    .named = true,
  },
  [sym_dataclass] = {
    .visible = true,
    .named = true,
  },
  [sym_classMember] = {
    .visible = true,
    .named = true,
  },
  [sym_charpred] = {
    .visible = true,
    .named = true,
  },
  [sym_memberPredicate] = {
    .visible = true,
    .named = true,
  },
  [sym_field] = {
    .visible = true,
    .named = true,
  },
  [sym__optbody] = {
    .visible = false,
    .named = true,
  },
  [sym_empty] = {
    .visible = true,
    .named = true,
  },
  [sym_body] = {
    .visible = true,
    .named = true,
  },
  [sym_higherOrderTerm] = {
    .visible = true,
    .named = true,
  },
  [sym_special_call] = {
    .visible = true,
    .named = true,
  },
  [sym_prefix_cast] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_mul_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_add_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_in_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_comp_term] = {
    .visible = true,
    .named = true,
  },
  [sym_instance_of] = {
    .visible = true,
    .named = true,
  },
  [sym_negation] = {
    .visible = true,
    .named = true,
  },
  [sym_if_term] = {
    .visible = true,
    .named = true,
  },
  [sym_conjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_disjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_implication] = {
    .visible = true,
    .named = true,
  },
  [sym_quantified] = {
    .visible = true,
    .named = true,
  },
  [sym_specialId] = {
    .visible = true,
    .named = true,
  },
  [sym_quantifier] = {
    .visible = true,
    .named = true,
  },
  [sym__call_arg] = {
    .visible = false,
    .named = true,
  },
  [sym_qualifiedRhs] = {
    .visible = true,
    .named = true,
  },
  [sym_classless_predicate_call] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_super_ref] = {
    .visible = true,
    .named = true,
  },
  [sym_full_aggregate_body] = {
    .visible = true,
    .named = true,
  },
  [sym_expr_aggregate_body] = {
    .visible = true,
    .named = true,
  },
  [sym_aggregate] = {
    .visible = true,
    .named = true,
  },
  [sym_range] = {
    .visible = true,
    .named = true,
  },
  [sym_par_expr] = {
    .visible = true,
    .named = true,
  },
  [sym__exprOrTerm] = {
    .visible = false,
    .named = true,
  },
  [sym__primary] = {
    .visible = false,
    .named = true,
  },
  [sym_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_bool] = {
    .visible = true,
    .named = true,
  },
  [sym_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_compop] = {
    .visible = true,
    .named = true,
  },
  [sym_unop] = {
    .visible = true,
    .named = true,
  },
  [sym_mulop] = {
    .visible = true,
    .named = true,
  },
  [sym_addop] = {
    .visible = true,
    .named = true,
  },
  [sym_closure] = {
    .visible = true,
    .named = true,
  },
  [sym_direction] = {
    .visible = true,
    .named = true,
  },
  [sym_varDecl] = {
    .visible = true,
    .named = true,
  },
  [sym_asExprs] = {
    .visible = true,
    .named = true,
  },
  [sym_asExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_orderBys] = {
    .visible = true,
    .named = true,
  },
  [sym_orderBy] = {
    .visible = true,
    .named = true,
  },
  [sym_literalId] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_annotName] = {
    .visible = true,
    .named = true,
  },
  [sym_annotArg] = {
    .visible = true,
    .named = true,
  },
  [sym_moduleName] = {
    .visible = true,
    .named = true,
  },
  [sym_qualModuleExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_importModuleExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_moduleExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_typeLiteral] = {
    .visible = true,
    .named = true,
  },
  [sym_simpleId] = {
    .visible = true,
    .named = true,
  },
  [sym_className] = {
    .visible = true,
    .named = true,
  },
  [sym_dbtype] = {
    .visible = true,
    .named = true,
  },
  [sym_returnType] = {
    .visible = true,
    .named = true,
  },
  [sym_typeExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_predicateName] = {
    .visible = true,
    .named = true,
  },
  [sym_aritylessPredicateExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_predicateExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_varName] = {
    .visible = true,
    .named = true,
  },
  [sym_aggId] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_ql_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_moduleMember_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_classlessPredicate_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_datatypeBranches_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dataclass_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dataclass_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_higherOrderTerm_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_higherOrderTerm_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_aggregate_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_asExprs_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_orderBys_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_annotation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_qualModuleExpr_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_importModuleExpr_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_args = 1,
  field_cond = 2,
  field_first = 3,
  field_left = 4,
  field_lower = 5,
  field_name = 6,
  field_right = 7,
  field_second = 8,
  field_upper = 9,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_args] = "args",
  [field_cond] = "cond",
  [field_first] = "first",
  [field_left] = "left",
  [field_lower] = "lower",
  [field_name] = "name",
  [field_right] = "right",
  [field_second] = "second",
  [field_upper] = "upper",
};

static const TSFieldMapSlice ts_field_map_slices[8] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 2},
  [3] = {.index = 3, .length = 2},
  [4] = {.index = 5, .length = 3},
  [5] = {.index = 8, .length = 2},
  [6] = {.index = 10, .length = 3},
  [7] = {.index = 13, .length = 1},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 0},
  [1] =
    {field_left, 0},
    {field_right, 2},
  [3] =
    {field_args, 2},
    {field_name, 0},
  [5] =
    {field_args, 2},
    {field_args, 3},
    {field_name, 0},
  [8] =
    {field_lower, 1},
    {field_upper, 3},
  [10] =
    {field_cond, 1},
    {field_first, 3},
    {field_second, 5},
  [13] =
    {field_name, 1},
};

static TSSymbol ts_alias_sequences[8][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(18);
      if (lookahead == '!') ADVANCE(13);
      if (lookahead == '"') ADVANCE(1);
      if (lookahead == '%') ADVANCE(53);
      if (lookahead == '(') ADVANCE(22);
      if (lookahead == ')') ADVANCE(24);
      if (lookahead == '*') ADVANCE(52);
      if (lookahead == '+') ADVANCE(54);
      if (lookahead == ',') ADVANCE(23);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '.') ADVANCE(26);
      if (lookahead == '/') ADVANCE(50);
      if (lookahead == ':') ADVANCE(12);
      if (lookahead == ';') ADVANCE(21);
      if (lookahead == '<') ADVANCE(42);
      if (lookahead == '=') ADVANCE(44);
      if (lookahead == '>') ADVANCE(45);
      if (lookahead == '@') ADVANCE(16);
      if (lookahead == '[') ADVANCE(27);
      if (lookahead == ']') ADVANCE(28);
      if (lookahead == '_') ADVANCE(47);
      if (lookahead == '{') ADVANCE(19);
      if (lookahead == '|') ADVANCE(25);
      if (lookahead == '}') ADVANCE(20);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(35);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(32);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(33);
      END_STATE();
    case 1:
      if (lookahead == '"') ADVANCE(38);
      if (lookahead == '\\') ADVANCE(14);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(1);
      END_STATE();
    case 2:
      if (lookahead == '*') ADVANCE(5);
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 3:
      if (lookahead == '*') ADVANCE(10);
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 4:
      if (lookahead == '*') ADVANCE(3);
      if (lookahead == '/') ADVANCE(39);
      END_STATE();
    case 5:
      if (lookahead == '*') ADVANCE(6);
      if (lookahead == '/') ADVANCE(41);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 6:
      if (lookahead == '*') ADVANCE(6);
      if (lookahead == '/') ADVANCE(30);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 7:
      if (lookahead == '*') ADVANCE(6);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 8:
      if (lookahead == '*') ADVANCE(8);
      if (lookahead == '/') ADVANCE(40);
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 9:
      if (lookahead == '*') ADVANCE(8);
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 10:
      if (lookahead == '/') ADVANCE(40);
      END_STATE();
    case 11:
      if (lookahead == '/') ADVANCE(4);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(11)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(36);
      END_STATE();
    case 12:
      if (lookahead == ':') ADVANCE(31);
      END_STATE();
    case 13:
      if (lookahead == '=') ADVANCE(49);
      END_STATE();
    case 14:
      if (lookahead == '"' ||
          lookahead == '\\' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          lookahead == 't') ADVANCE(1);
      END_STATE();
    case 15:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(37);
      END_STATE();
    case 16:
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(34);
      END_STATE();
    case 17:
      if (eof) ADVANCE(18);
      if (lookahead == '!') ADVANCE(13);
      if (lookahead == '"') ADVANCE(1);
      if (lookahead == '%') ADVANCE(53);
      if (lookahead == '(') ADVANCE(22);
      if (lookahead == ')') ADVANCE(24);
      if (lookahead == '*') ADVANCE(52);
      if (lookahead == '+') ADVANCE(54);
      if (lookahead == ',') ADVANCE(23);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '.') ADVANCE(26);
      if (lookahead == '/') ADVANCE(51);
      if (lookahead == ':') ADVANCE(12);
      if (lookahead == ';') ADVANCE(21);
      if (lookahead == '<') ADVANCE(42);
      if (lookahead == '=') ADVANCE(44);
      if (lookahead == '>') ADVANCE(45);
      if (lookahead == '@') ADVANCE(16);
      if (lookahead == '[') ADVANCE(27);
      if (lookahead == ']') ADVANCE(28);
      if (lookahead == '_') ADVANCE(47);
      if (lookahead == '{') ADVANCE(19);
      if (lookahead == '|') ADVANCE(25);
      if (lookahead == '}') ADVANCE(20);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(17)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(35);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(32);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(33);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(29);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(sym_qldoc);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(sym__upper_id);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(32);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(sym__lower_id);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(33);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(sym__at_lower_id);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(34);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(35);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(sym_integer);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(36);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(37);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(sym_string);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(39);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(sym_block_comment);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(sym_block_comment);
      if (lookahead == '*') ADVANCE(6);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(sym_lt);
      if (lookahead == '=') ADVANCE(43);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(sym_le);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_eq);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(sym_gt);
      if (lookahead == '=') ADVANCE(46);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(sym_ge);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(sym_underscore);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(sym_minus);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(sym_ne);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(sym_slash);
      if (lookahead == '*') ADVANCE(2);
      if (lookahead == '/') ADVANCE(39);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(sym_slash);
      if (lookahead == '*') ADVANCE(3);
      if (lookahead == '/') ADVANCE(39);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(sym_star);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym_mod);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym_plus);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'i') ADVANCE(7);
      if (lookahead == 'm') ADVANCE(8);
      if (lookahead == 'n') ADVANCE(9);
      if (lookahead == 'o') ADVANCE(10);
      if (lookahead == 'p') ADVANCE(11);
      if (lookahead == 'r') ADVANCE(12);
      if (lookahead == 's') ADVANCE(13);
      if (lookahead == 't') ADVANCE(14);
      if (lookahead == 'w') ADVANCE(15);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'n') ADVANCE(16);
      if (lookahead == 's') ADVANCE(17);
      if (lookahead == 'v') ADVANCE(18);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(19);
      if (lookahead == 'y') ADVANCE(20);
      END_STATE();
    case 3:
      if (lookahead == 'l') ADVANCE(21);
      if (lookahead == 'o') ADVANCE(22);
      END_STATE();
    case 4:
      if (lookahead == 'a') ADVANCE(23);
      if (lookahead == 'e') ADVANCE(24);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(25);
      if (lookahead == 'x') ADVANCE(26);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(27);
      if (lookahead == 'l') ADVANCE(28);
      if (lookahead == 'o') ADVANCE(29);
      if (lookahead == 'r') ADVANCE(30);
      END_STATE();
    case 7:
      if (lookahead == 'f') ADVANCE(31);
      if (lookahead == 'm') ADVANCE(32);
      if (lookahead == 'n') ADVANCE(33);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(34);
      if (lookahead == 'i') ADVANCE(35);
      if (lookahead == 'o') ADVANCE(36);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      END_STATE();
    case 10:
      if (lookahead == 'r') ADVANCE(39);
      END_STATE();
    case 11:
      if (lookahead == 'r') ADVANCE(40);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(41);
      if (lookahead == 'e') ADVANCE(42);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(43);
      if (lookahead == 't') ADVANCE(44);
      if (lookahead == 'u') ADVANCE(45);
      END_STATE();
    case 14:
      if (lookahead == 'h') ADVANCE(46);
      if (lookahead == 'r') ADVANCE(47);
      END_STATE();
    case 15:
      if (lookahead == 'h') ADVANCE(48);
      END_STATE();
    case 16:
      if (lookahead == 'd') ADVANCE(49);
      if (lookahead == 'y') ADVANCE(50);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(sym_as);
      if (lookahead == 'c') ADVANCE(51);
      END_STATE();
    case 18:
      if (lookahead == 'g') ADVANCE(52);
      END_STATE();
    case 19:
      if (lookahead == 'o') ADVANCE(53);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_by);
      END_STATE();
    case 21:
      if (lookahead == 'a') ADVANCE(54);
      END_STATE();
    case 22:
      if (lookahead == 'n') ADVANCE(55);
      if (lookahead == 'u') ADVANCE(56);
      END_STATE();
    case 23:
      if (lookahead == 't') ADVANCE(57);
      END_STATE();
    case 24:
      if (lookahead == 's') ADVANCE(58);
      END_STATE();
    case 25:
      if (lookahead == 's') ADVANCE(59);
      END_STATE();
    case 26:
      if (lookahead == 'i') ADVANCE(60);
      if (lookahead == 't') ADVANCE(61);
      END_STATE();
    case 27:
      if (lookahead == 'l') ADVANCE(62);
      END_STATE();
    case 28:
      if (lookahead == 'o') ADVANCE(63);
      END_STATE();
    case 29:
      if (lookahead == 'r') ADVANCE(64);
      END_STATE();
    case 30:
      if (lookahead == 'o') ADVANCE(65);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 32:
      if (lookahead == 'p') ADVANCE(66);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(sym_in);
      if (lookahead == 's') ADVANCE(67);
      if (lookahead == 't') ADVANCE(68);
      END_STATE();
    case 34:
      if (lookahead == 'x') ADVANCE(69);
      END_STATE();
    case 35:
      if (lookahead == 'n') ADVANCE(70);
      END_STATE();
    case 36:
      if (lookahead == 'd') ADVANCE(71);
      END_STATE();
    case 37:
      if (lookahead == 'w') ADVANCE(72);
      END_STATE();
    case 38:
      if (lookahead == 'n') ADVANCE(73);
      if (lookahead == 't') ADVANCE(74);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == 'd') ADVANCE(75);
      END_STATE();
    case 40:
      if (lookahead == 'e') ADVANCE(76);
      END_STATE();
    case 41:
      if (lookahead == 'n') ADVANCE(77);
      END_STATE();
    case 42:
      if (lookahead == 's') ADVANCE(78);
      END_STATE();
    case 43:
      if (lookahead == 'l') ADVANCE(79);
      END_STATE();
    case 44:
      if (lookahead == 'r') ADVANCE(80);
      END_STATE();
    case 45:
      if (lookahead == 'm') ADVANCE(81);
      if (lookahead == 'p') ADVANCE(82);
      END_STATE();
    case 46:
      if (lookahead == 'e') ADVANCE(83);
      if (lookahead == 'i') ADVANCE(84);
      END_STATE();
    case 47:
      if (lookahead == 'u') ADVANCE(85);
      END_STATE();
    case 48:
      if (lookahead == 'e') ADVANCE(86);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(sym_any);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(sym_asc);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(sym_avg);
      END_STATE();
    case 53:
      if (lookahead == 'l') ADVANCE(87);
      END_STATE();
    case 54:
      if (lookahead == 's') ADVANCE(88);
      END_STATE();
    case 55:
      if (lookahead == 'c') ADVANCE(89);
      END_STATE();
    case 56:
      if (lookahead == 'n') ADVANCE(90);
      END_STATE();
    case 57:
      if (lookahead == 'e') ADVANCE(91);
      END_STATE();
    case 58:
      if (lookahead == 'c') ADVANCE(92);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(93);
      END_STATE();
    case 60:
      if (lookahead == 's') ADVANCE(94);
      END_STATE();
    case 61:
      if (lookahead == 'e') ADVANCE(95);
      END_STATE();
    case 62:
      if (lookahead == 's') ADVANCE(96);
      END_STATE();
    case 63:
      if (lookahead == 'a') ADVANCE(97);
      END_STATE();
    case 64:
      if (lookahead == 'a') ADVANCE(98);
      if (lookahead == 'e') ADVANCE(99);
      END_STATE();
    case 65:
      if (lookahead == 'm') ADVANCE(100);
      END_STATE();
    case 66:
      if (lookahead == 'l') ADVANCE(101);
      if (lookahead == 'o') ADVANCE(102);
      END_STATE();
    case 67:
      if (lookahead == 't') ADVANCE(103);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_int);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_max);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_min);
      END_STATE();
    case 71:
      if (lookahead == 'u') ADVANCE(104);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(105);
      END_STATE();
    case 73:
      if (lookahead == 'e') ADVANCE(106);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_not);
      END_STATE();
    case 75:
      if (lookahead == 'e') ADVANCE(107);
      END_STATE();
    case 76:
      if (lookahead == 'd') ADVANCE(108);
      END_STATE();
    case 77:
      if (lookahead == 'k') ADVANCE(109);
      END_STATE();
    case 78:
      if (lookahead == 'u') ADVANCE(110);
      END_STATE();
    case 79:
      if (lookahead == 'e') ADVANCE(111);
      END_STATE();
    case 80:
      if (lookahead == 'i') ADVANCE(112);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_sum);
      END_STATE();
    case 82:
      if (lookahead == 'e') ADVANCE(113);
      END_STATE();
    case 83:
      if (lookahead == 'n') ADVANCE(114);
      END_STATE();
    case 84:
      if (lookahead == 's') ADVANCE(115);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(116);
      END_STATE();
    case 86:
      if (lookahead == 'r') ADVANCE(117);
      END_STATE();
    case 87:
      if (lookahead == 'e') ADVANCE(118);
      END_STATE();
    case 88:
      if (lookahead == 's') ADVANCE(119);
      END_STATE();
    case 89:
      if (lookahead == 'a') ADVANCE(120);
      END_STATE();
    case 90:
      if (lookahead == 't') ADVANCE(121);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_date);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_desc);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 94:
      if (lookahead == 't') ADVANCE(122);
      END_STATE();
    case 95:
      if (lookahead == 'n') ADVANCE(123);
      END_STATE();
    case 96:
      if (lookahead == 'e') ADVANCE(124);
      END_STATE();
    case 97:
      if (lookahead == 't') ADVANCE(125);
      END_STATE();
    case 98:
      if (lookahead == 'l') ADVANCE(126);
      END_STATE();
    case 99:
      if (lookahead == 'x') ADVANCE(127);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 101:
      if (lookahead == 'i') ADVANCE(128);
      END_STATE();
    case 102:
      if (lookahead == 'r') ADVANCE(129);
      END_STATE();
    case 103:
      if (lookahead == 'a') ADVANCE(130);
      END_STATE();
    case 104:
      if (lookahead == 'l') ADVANCE(131);
      END_STATE();
    case 105:
      if (lookahead == 'y') ADVANCE(132);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_none);
      END_STATE();
    case 107:
      if (lookahead == 'r') ADVANCE(133);
      END_STATE();
    case 108:
      if (lookahead == 'i') ADVANCE(134);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_rank);
      END_STATE();
    case 110:
      if (lookahead == 'l') ADVANCE(135);
      END_STATE();
    case 111:
      if (lookahead == 'c') ADVANCE(136);
      END_STATE();
    case 112:
      if (lookahead == 'c') ADVANCE(137);
      if (lookahead == 'n') ADVANCE(138);
      END_STATE();
    case 113:
      if (lookahead == 'r') ADVANCE(139);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 117:
      if (lookahead == 'e') ADVANCE(140);
      END_STATE();
    case 118:
      if (lookahead == 'a') ADVANCE(141);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_class);
      END_STATE();
    case 120:
      if (lookahead == 't') ADVANCE(142);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_count);
      END_STATE();
    case 122:
      if (lookahead == 's') ADVANCE(143);
      END_STATE();
    case 123:
      if (lookahead == 'd') ADVANCE(144);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 126:
      if (lookahead == 'l') ADVANCE(145);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_forex);
      END_STATE();
    case 128:
      if (lookahead == 'e') ADVANCE(146);
      END_STATE();
    case 129:
      if (lookahead == 't') ADVANCE(147);
      END_STATE();
    case 130:
      if (lookahead == 'n') ADVANCE(148);
      END_STATE();
    case 131:
      if (lookahead == 'e') ADVANCE(149);
      END_STATE();
    case 132:
      if (lookahead == 'p') ADVANCE(150);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_order);
      END_STATE();
    case 134:
      if (lookahead == 'c') ADVANCE(151);
      END_STATE();
    case 135:
      if (lookahead == 't') ADVANCE(152);
      END_STATE();
    case 136:
      if (lookahead == 't') ADVANCE(153);
      END_STATE();
    case 137:
      if (lookahead == 't') ADVANCE(154);
      END_STATE();
    case 138:
      if (lookahead == 'g') ADVANCE(155);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_where);
      END_STATE();
    case 141:
      if (lookahead == 'n') ADVANCE(156);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_concat);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_exists);
      END_STATE();
    case 144:
      if (lookahead == 's') ADVANCE(157);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_forall);
      END_STATE();
    case 146:
      if (lookahead == 's') ADVANCE(158);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_import);
      END_STATE();
    case 148:
      if (lookahead == 'c') ADVANCE(159);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 150:
      if (lookahead == 'e') ADVANCE(160);
      END_STATE();
    case 151:
      if (lookahead == 'a') ADVANCE(161);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_result);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_select);
      END_STATE();
    case 154:
      if (lookahead == 'c') ADVANCE(162);
      if (lookahead == 's') ADVANCE(163);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_boolean);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_extends);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_implies);
      END_STATE();
    case 159:
      if (lookahead == 'e') ADVANCE(164);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_newtype);
      END_STATE();
    case 161:
      if (lookahead == 't') ADVANCE(165);
      END_STATE();
    case 162:
      if (lookahead == 'o') ADVANCE(166);
      END_STATE();
    case 163:
      if (lookahead == 'u') ADVANCE(167);
      END_STATE();
    case 164:
      if (lookahead == 'o') ADVANCE(168);
      END_STATE();
    case 165:
      if (lookahead == 'e') ADVANCE(169);
      END_STATE();
    case 166:
      if (lookahead == 'n') ADVANCE(170);
      if (lookahead == 'u') ADVANCE(171);
      END_STATE();
    case 167:
      if (lookahead == 'm') ADVANCE(172);
      END_STATE();
    case 168:
      if (lookahead == 'f') ADVANCE(173);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_predicate);
      END_STATE();
    case 170:
      if (lookahead == 'c') ADVANCE(174);
      END_STATE();
    case 171:
      if (lookahead == 'n') ADVANCE(175);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_strictsum);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_instanceof);
      END_STATE();
    case 174:
      if (lookahead == 'a') ADVANCE(176);
      END_STATE();
    case 175:
      if (lookahead == 't') ADVANCE(177);
      END_STATE();
    case 176:
      if (lookahead == 't') ADVANCE(178);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_strictcount);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_strictconcat);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 0},
  [2] = {.lex_state = 17},
  [3] = {.lex_state = 17},
  [4] = {.lex_state = 17},
  [5] = {.lex_state = 17},
  [6] = {.lex_state = 17},
  [7] = {.lex_state = 17},
  [8] = {.lex_state = 17},
  [9] = {.lex_state = 17},
  [10] = {.lex_state = 17},
  [11] = {.lex_state = 17},
  [12] = {.lex_state = 17},
  [13] = {.lex_state = 17},
  [14] = {.lex_state = 17},
  [15] = {.lex_state = 17},
  [16] = {.lex_state = 17},
  [17] = {.lex_state = 17},
  [18] = {.lex_state = 17},
  [19] = {.lex_state = 17},
  [20] = {.lex_state = 17},
  [21] = {.lex_state = 17},
  [22] = {.lex_state = 17},
  [23] = {.lex_state = 17},
  [24] = {.lex_state = 17},
  [25] = {.lex_state = 17},
  [26] = {.lex_state = 17},
  [27] = {.lex_state = 17},
  [28] = {.lex_state = 17},
  [29] = {.lex_state = 17},
  [30] = {.lex_state = 17},
  [31] = {.lex_state = 17},
  [32] = {.lex_state = 17},
  [33] = {.lex_state = 17},
  [34] = {.lex_state = 17},
  [35] = {.lex_state = 17},
  [36] = {.lex_state = 17},
  [37] = {.lex_state = 17},
  [38] = {.lex_state = 17},
  [39] = {.lex_state = 17},
  [40] = {.lex_state = 17},
  [41] = {.lex_state = 17},
  [42] = {.lex_state = 17},
  [43] = {.lex_state = 17},
  [44] = {.lex_state = 17},
  [45] = {.lex_state = 17},
  [46] = {.lex_state = 17},
  [47] = {.lex_state = 17},
  [48] = {.lex_state = 17},
  [49] = {.lex_state = 17},
  [50] = {.lex_state = 17},
  [51] = {.lex_state = 17},
  [52] = {.lex_state = 17},
  [53] = {.lex_state = 17},
  [54] = {.lex_state = 17},
  [55] = {.lex_state = 17},
  [56] = {.lex_state = 17},
  [57] = {.lex_state = 17},
  [58] = {.lex_state = 17},
  [59] = {.lex_state = 17},
  [60] = {.lex_state = 17},
  [61] = {.lex_state = 17},
  [62] = {.lex_state = 17},
  [63] = {.lex_state = 17},
  [64] = {.lex_state = 17},
  [65] = {.lex_state = 17},
  [66] = {.lex_state = 17},
  [67] = {.lex_state = 17},
  [68] = {.lex_state = 17},
  [69] = {.lex_state = 17},
  [70] = {.lex_state = 17},
  [71] = {.lex_state = 17},
  [72] = {.lex_state = 17},
  [73] = {.lex_state = 17},
  [74] = {.lex_state = 17},
  [75] = {.lex_state = 17},
  [76] = {.lex_state = 17},
  [77] = {.lex_state = 17},
  [78] = {.lex_state = 17},
  [79] = {.lex_state = 17},
  [80] = {.lex_state = 17},
  [81] = {.lex_state = 17},
  [82] = {.lex_state = 17},
  [83] = {.lex_state = 17},
  [84] = {.lex_state = 17},
  [85] = {.lex_state = 17},
  [86] = {.lex_state = 17},
  [87] = {.lex_state = 17},
  [88] = {.lex_state = 17},
  [89] = {.lex_state = 17},
  [90] = {.lex_state = 17},
  [91] = {.lex_state = 17},
  [92] = {.lex_state = 17},
  [93] = {.lex_state = 17},
  [94] = {.lex_state = 17},
  [95] = {.lex_state = 17},
  [96] = {.lex_state = 17},
  [97] = {.lex_state = 17},
  [98] = {.lex_state = 17},
  [99] = {.lex_state = 17},
  [100] = {.lex_state = 17},
  [101] = {.lex_state = 17},
  [102] = {.lex_state = 17},
  [103] = {.lex_state = 17},
  [104] = {.lex_state = 17},
  [105] = {.lex_state = 17},
  [106] = {.lex_state = 17},
  [107] = {.lex_state = 17},
  [108] = {.lex_state = 17},
  [109] = {.lex_state = 17},
  [110] = {.lex_state = 17},
  [111] = {.lex_state = 17},
  [112] = {.lex_state = 17},
  [113] = {.lex_state = 17},
  [114] = {.lex_state = 17},
  [115] = {.lex_state = 17},
  [116] = {.lex_state = 17},
  [117] = {.lex_state = 17},
  [118] = {.lex_state = 17},
  [119] = {.lex_state = 17},
  [120] = {.lex_state = 17},
  [121] = {.lex_state = 17},
  [122] = {.lex_state = 17},
  [123] = {.lex_state = 17},
  [124] = {.lex_state = 17},
  [125] = {.lex_state = 17},
  [126] = {.lex_state = 17},
  [127] = {.lex_state = 17},
  [128] = {.lex_state = 17},
  [129] = {.lex_state = 17},
  [130] = {.lex_state = 17},
  [131] = {.lex_state = 17},
  [132] = {.lex_state = 17},
  [133] = {.lex_state = 17},
  [134] = {.lex_state = 17},
  [135] = {.lex_state = 17},
  [136] = {.lex_state = 17},
  [137] = {.lex_state = 17},
  [138] = {.lex_state = 17},
  [139] = {.lex_state = 17},
  [140] = {.lex_state = 17},
  [141] = {.lex_state = 17},
  [142] = {.lex_state = 17},
  [143] = {.lex_state = 17},
  [144] = {.lex_state = 17},
  [145] = {.lex_state = 17},
  [146] = {.lex_state = 17},
  [147] = {.lex_state = 17},
  [148] = {.lex_state = 17},
  [149] = {.lex_state = 17},
  [150] = {.lex_state = 17},
  [151] = {.lex_state = 17},
  [152] = {.lex_state = 17},
  [153] = {.lex_state = 17},
  [154] = {.lex_state = 17},
  [155] = {.lex_state = 17},
  [156] = {.lex_state = 17},
  [157] = {.lex_state = 17},
  [158] = {.lex_state = 17},
  [159] = {.lex_state = 17},
  [160] = {.lex_state = 17},
  [161] = {.lex_state = 17},
  [162] = {.lex_state = 17},
  [163] = {.lex_state = 17},
  [164] = {.lex_state = 17},
  [165] = {.lex_state = 17},
  [166] = {.lex_state = 17},
  [167] = {.lex_state = 17},
  [168] = {.lex_state = 17},
  [169] = {.lex_state = 17},
  [170] = {.lex_state = 17},
  [171] = {.lex_state = 17},
  [172] = {.lex_state = 17},
  [173] = {.lex_state = 17},
  [174] = {.lex_state = 17},
  [175] = {.lex_state = 17},
  [176] = {.lex_state = 17},
  [177] = {.lex_state = 17},
  [178] = {.lex_state = 17},
  [179] = {.lex_state = 17},
  [180] = {.lex_state = 17},
  [181] = {.lex_state = 17},
  [182] = {.lex_state = 17},
  [183] = {.lex_state = 17},
  [184] = {.lex_state = 17},
  [185] = {.lex_state = 17},
  [186] = {.lex_state = 17},
  [187] = {.lex_state = 17},
  [188] = {.lex_state = 17},
  [189] = {.lex_state = 17},
  [190] = {.lex_state = 17},
  [191] = {.lex_state = 17},
  [192] = {.lex_state = 17},
  [193] = {.lex_state = 17},
  [194] = {.lex_state = 17},
  [195] = {.lex_state = 17},
  [196] = {.lex_state = 17},
  [197] = {.lex_state = 17},
  [198] = {.lex_state = 17},
  [199] = {.lex_state = 17},
  [200] = {.lex_state = 17},
  [201] = {.lex_state = 17},
  [202] = {.lex_state = 17},
  [203] = {.lex_state = 17},
  [204] = {.lex_state = 17},
  [205] = {.lex_state = 17},
  [206] = {.lex_state = 17},
  [207] = {.lex_state = 17},
  [208] = {.lex_state = 17},
  [209] = {.lex_state = 17},
  [210] = {.lex_state = 17},
  [211] = {.lex_state = 17},
  [212] = {.lex_state = 17},
  [213] = {.lex_state = 17},
  [214] = {.lex_state = 17},
  [215] = {.lex_state = 17},
  [216] = {.lex_state = 17},
  [217] = {.lex_state = 17},
  [218] = {.lex_state = 17},
  [219] = {.lex_state = 17},
  [220] = {.lex_state = 17},
  [221] = {.lex_state = 17},
  [222] = {.lex_state = 17},
  [223] = {.lex_state = 17},
  [224] = {.lex_state = 17},
  [225] = {.lex_state = 17},
  [226] = {.lex_state = 17},
  [227] = {.lex_state = 17},
  [228] = {.lex_state = 17},
  [229] = {.lex_state = 17},
  [230] = {.lex_state = 17},
  [231] = {.lex_state = 17},
  [232] = {.lex_state = 17},
  [233] = {.lex_state = 17},
  [234] = {.lex_state = 17},
  [235] = {.lex_state = 17},
  [236] = {.lex_state = 17},
  [237] = {.lex_state = 17},
  [238] = {.lex_state = 17},
  [239] = {.lex_state = 17},
  [240] = {.lex_state = 17},
  [241] = {.lex_state = 17},
  [242] = {.lex_state = 0},
  [243] = {.lex_state = 0},
  [244] = {.lex_state = 0},
  [245] = {.lex_state = 0},
  [246] = {.lex_state = 0},
  [247] = {.lex_state = 0},
  [248] = {.lex_state = 0},
  [249] = {.lex_state = 0},
  [250] = {.lex_state = 0},
  [251] = {.lex_state = 0},
  [252] = {.lex_state = 0},
  [253] = {.lex_state = 0},
  [254] = {.lex_state = 0},
  [255] = {.lex_state = 0},
  [256] = {.lex_state = 0},
  [257] = {.lex_state = 0},
  [258] = {.lex_state = 0},
  [259] = {.lex_state = 0},
  [260] = {.lex_state = 0},
  [261] = {.lex_state = 0},
  [262] = {.lex_state = 0},
  [263] = {.lex_state = 0},
  [264] = {.lex_state = 0},
  [265] = {.lex_state = 0},
  [266] = {.lex_state = 0},
  [267] = {.lex_state = 0},
  [268] = {.lex_state = 0},
  [269] = {.lex_state = 0},
  [270] = {.lex_state = 0},
  [271] = {.lex_state = 0},
  [272] = {.lex_state = 0},
  [273] = {.lex_state = 0},
  [274] = {.lex_state = 0},
  [275] = {.lex_state = 0},
  [276] = {.lex_state = 0},
  [277] = {.lex_state = 0},
  [278] = {.lex_state = 0},
  [279] = {.lex_state = 0},
  [280] = {.lex_state = 0},
  [281] = {.lex_state = 0},
  [282] = {.lex_state = 0},
  [283] = {.lex_state = 0},
  [284] = {.lex_state = 0},
  [285] = {.lex_state = 0},
  [286] = {.lex_state = 0},
  [287] = {.lex_state = 0},
  [288] = {.lex_state = 0},
  [289] = {.lex_state = 0},
  [290] = {.lex_state = 0},
  [291] = {.lex_state = 0},
  [292] = {.lex_state = 0},
  [293] = {.lex_state = 0},
  [294] = {.lex_state = 0},
  [295] = {.lex_state = 0},
  [296] = {.lex_state = 0},
  [297] = {.lex_state = 0},
  [298] = {.lex_state = 0},
  [299] = {.lex_state = 0},
  [300] = {.lex_state = 0},
  [301] = {.lex_state = 0},
  [302] = {.lex_state = 0},
  [303] = {.lex_state = 0},
  [304] = {.lex_state = 0},
  [305] = {.lex_state = 0},
  [306] = {.lex_state = 0},
  [307] = {.lex_state = 0},
  [308] = {.lex_state = 0},
  [309] = {.lex_state = 0},
  [310] = {.lex_state = 0},
  [311] = {.lex_state = 0},
  [312] = {.lex_state = 0},
  [313] = {.lex_state = 0},
  [314] = {.lex_state = 0},
  [315] = {.lex_state = 0},
  [316] = {.lex_state = 0},
  [317] = {.lex_state = 0},
  [318] = {.lex_state = 0},
  [319] = {.lex_state = 0},
  [320] = {.lex_state = 0},
  [321] = {.lex_state = 0},
  [322] = {.lex_state = 0},
  [323] = {.lex_state = 0},
  [324] = {.lex_state = 0},
  [325] = {.lex_state = 0},
  [326] = {.lex_state = 0},
  [327] = {.lex_state = 0},
  [328] = {.lex_state = 0},
  [329] = {.lex_state = 0},
  [330] = {.lex_state = 0},
  [331] = {.lex_state = 0},
  [332] = {.lex_state = 0},
  [333] = {.lex_state = 0},
  [334] = {.lex_state = 0},
  [335] = {.lex_state = 0},
  [336] = {.lex_state = 0},
  [337] = {.lex_state = 0},
  [338] = {.lex_state = 0},
  [339] = {.lex_state = 0},
  [340] = {.lex_state = 0},
  [341] = {.lex_state = 0},
  [342] = {.lex_state = 0},
  [343] = {.lex_state = 0},
  [344] = {.lex_state = 0},
  [345] = {.lex_state = 0},
  [346] = {.lex_state = 0},
  [347] = {.lex_state = 0},
  [348] = {.lex_state = 0},
  [349] = {.lex_state = 0},
  [350] = {.lex_state = 0},
  [351] = {.lex_state = 0},
  [352] = {.lex_state = 0},
  [353] = {.lex_state = 0},
  [354] = {.lex_state = 0},
  [355] = {.lex_state = 0},
  [356] = {.lex_state = 0},
  [357] = {.lex_state = 0},
  [358] = {.lex_state = 0},
  [359] = {.lex_state = 0},
  [360] = {.lex_state = 0},
  [361] = {.lex_state = 0},
  [362] = {.lex_state = 0},
  [363] = {.lex_state = 0},
  [364] = {.lex_state = 0},
  [365] = {.lex_state = 0},
  [366] = {.lex_state = 0},
  [367] = {.lex_state = 0},
  [368] = {.lex_state = 0},
  [369] = {.lex_state = 0},
  [370] = {.lex_state = 0},
  [371] = {.lex_state = 0},
  [372] = {.lex_state = 0},
  [373] = {.lex_state = 0},
  [374] = {.lex_state = 0},
  [375] = {.lex_state = 0},
  [376] = {.lex_state = 0},
  [377] = {.lex_state = 0},
  [378] = {.lex_state = 0},
  [379] = {.lex_state = 0},
  [380] = {.lex_state = 0},
  [381] = {.lex_state = 0},
  [382] = {.lex_state = 0},
  [383] = {.lex_state = 0},
  [384] = {.lex_state = 0},
  [385] = {.lex_state = 0},
  [386] = {.lex_state = 0},
  [387] = {.lex_state = 0},
  [388] = {.lex_state = 0},
  [389] = {.lex_state = 0},
  [390] = {.lex_state = 0},
  [391] = {.lex_state = 0},
  [392] = {.lex_state = 0},
  [393] = {.lex_state = 0},
  [394] = {.lex_state = 0},
  [395] = {.lex_state = 0},
  [396] = {.lex_state = 0},
  [397] = {.lex_state = 17},
  [398] = {.lex_state = 0},
  [399] = {.lex_state = 0},
  [400] = {.lex_state = 0},
  [401] = {.lex_state = 0},
  [402] = {.lex_state = 0},
  [403] = {.lex_state = 0},
  [404] = {.lex_state = 0},
  [405] = {.lex_state = 0},
  [406] = {.lex_state = 0},
  [407] = {.lex_state = 0},
  [408] = {.lex_state = 17},
  [409] = {.lex_state = 0},
  [410] = {.lex_state = 0},
  [411] = {.lex_state = 0},
  [412] = {.lex_state = 0},
  [413] = {.lex_state = 0},
  [414] = {.lex_state = 0},
  [415] = {.lex_state = 0},
  [416] = {.lex_state = 0},
  [417] = {.lex_state = 0},
  [418] = {.lex_state = 0},
  [419] = {.lex_state = 0},
  [420] = {.lex_state = 0},
  [421] = {.lex_state = 17},
  [422] = {.lex_state = 0},
  [423] = {.lex_state = 0},
  [424] = {.lex_state = 0},
  [425] = {.lex_state = 17},
  [426] = {.lex_state = 0},
  [427] = {.lex_state = 0},
  [428] = {.lex_state = 0},
  [429] = {.lex_state = 0},
  [430] = {.lex_state = 0},
  [431] = {.lex_state = 0},
  [432] = {.lex_state = 0},
  [433] = {.lex_state = 0},
  [434] = {.lex_state = 0},
  [435] = {.lex_state = 0},
  [436] = {.lex_state = 0},
  [437] = {.lex_state = 0},
  [438] = {.lex_state = 0},
  [439] = {.lex_state = 0},
  [440] = {.lex_state = 0},
  [441] = {.lex_state = 0},
  [442] = {.lex_state = 0},
  [443] = {.lex_state = 0},
  [444] = {.lex_state = 0},
  [445] = {.lex_state = 0},
  [446] = {.lex_state = 0},
  [447] = {.lex_state = 0},
  [448] = {.lex_state = 0},
  [449] = {.lex_state = 0},
  [450] = {.lex_state = 0},
  [451] = {.lex_state = 0},
  [452] = {.lex_state = 0},
  [453] = {.lex_state = 0},
  [454] = {.lex_state = 0},
  [455] = {.lex_state = 0},
  [456] = {.lex_state = 0},
  [457] = {.lex_state = 17},
  [458] = {.lex_state = 17},
  [459] = {.lex_state = 17},
  [460] = {.lex_state = 17},
  [461] = {.lex_state = 17},
  [462] = {.lex_state = 17},
  [463] = {.lex_state = 17},
  [464] = {.lex_state = 17},
  [465] = {.lex_state = 17},
  [466] = {.lex_state = 17},
  [467] = {.lex_state = 17},
  [468] = {.lex_state = 17},
  [469] = {.lex_state = 17},
  [470] = {.lex_state = 17},
  [471] = {.lex_state = 17},
  [472] = {.lex_state = 17},
  [473] = {.lex_state = 17},
  [474] = {.lex_state = 17},
  [475] = {.lex_state = 17},
  [476] = {.lex_state = 17},
  [477] = {.lex_state = 17},
  [478] = {.lex_state = 17},
  [479] = {.lex_state = 17},
  [480] = {.lex_state = 17},
  [481] = {.lex_state = 17},
  [482] = {.lex_state = 17},
  [483] = {.lex_state = 17},
  [484] = {.lex_state = 17},
  [485] = {.lex_state = 17},
  [486] = {.lex_state = 17},
  [487] = {.lex_state = 17},
  [488] = {.lex_state = 17},
  [489] = {.lex_state = 17},
  [490] = {.lex_state = 0},
  [491] = {.lex_state = 17},
  [492] = {.lex_state = 17},
  [493] = {.lex_state = 0},
  [494] = {.lex_state = 17},
  [495] = {.lex_state = 17},
  [496] = {.lex_state = 0},
  [497] = {.lex_state = 0},
  [498] = {.lex_state = 0},
  [499] = {.lex_state = 17},
  [500] = {.lex_state = 17},
  [501] = {.lex_state = 0},
  [502] = {.lex_state = 0},
  [503] = {.lex_state = 17},
  [504] = {.lex_state = 0},
  [505] = {.lex_state = 17},
  [506] = {.lex_state = 0},
  [507] = {.lex_state = 17},
  [508] = {.lex_state = 17},
  [509] = {.lex_state = 17},
  [510] = {.lex_state = 17},
  [511] = {.lex_state = 17},
  [512] = {.lex_state = 17},
  [513] = {.lex_state = 17},
  [514] = {.lex_state = 17},
  [515] = {.lex_state = 17},
  [516] = {.lex_state = 17},
  [517] = {.lex_state = 17},
  [518] = {.lex_state = 17},
  [519] = {.lex_state = 17},
  [520] = {.lex_state = 17},
  [521] = {.lex_state = 17},
  [522] = {.lex_state = 17},
  [523] = {.lex_state = 17},
  [524] = {.lex_state = 17},
  [525] = {.lex_state = 17},
  [526] = {.lex_state = 17},
  [527] = {.lex_state = 17},
  [528] = {.lex_state = 17},
  [529] = {.lex_state = 17},
  [530] = {.lex_state = 17},
  [531] = {.lex_state = 17},
  [532] = {.lex_state = 17},
  [533] = {.lex_state = 17},
  [534] = {.lex_state = 17},
  [535] = {.lex_state = 17},
  [536] = {.lex_state = 17},
  [537] = {.lex_state = 17},
  [538] = {.lex_state = 17},
  [539] = {.lex_state = 17},
  [540] = {.lex_state = 17},
  [541] = {.lex_state = 0},
  [542] = {.lex_state = 17},
  [543] = {.lex_state = 0},
  [544] = {.lex_state = 17},
  [545] = {.lex_state = 17},
  [546] = {.lex_state = 17},
  [547] = {.lex_state = 0},
  [548] = {.lex_state = 0},
  [549] = {.lex_state = 0},
  [550] = {.lex_state = 17},
  [551] = {.lex_state = 17},
  [552] = {.lex_state = 17},
  [553] = {.lex_state = 17},
  [554] = {.lex_state = 17},
  [555] = {.lex_state = 0},
  [556] = {.lex_state = 17},
  [557] = {.lex_state = 0},
  [558] = {.lex_state = 0},
  [559] = {.lex_state = 0},
  [560] = {.lex_state = 0},
  [561] = {.lex_state = 0},
  [562] = {.lex_state = 17},
  [563] = {.lex_state = 17},
  [564] = {.lex_state = 17},
  [565] = {.lex_state = 17},
  [566] = {.lex_state = 17},
  [567] = {.lex_state = 17},
  [568] = {.lex_state = 0},
  [569] = {.lex_state = 17},
  [570] = {.lex_state = 17},
  [571] = {.lex_state = 0},
  [572] = {.lex_state = 0},
  [573] = {.lex_state = 0},
  [574] = {.lex_state = 17},
  [575] = {.lex_state = 0},
  [576] = {.lex_state = 0},
  [577] = {.lex_state = 17},
  [578] = {.lex_state = 0},
  [579] = {.lex_state = 17},
  [580] = {.lex_state = 17},
  [581] = {.lex_state = 0},
  [582] = {.lex_state = 0},
  [583] = {.lex_state = 0},
  [584] = {.lex_state = 17},
  [585] = {.lex_state = 0},
  [586] = {.lex_state = 0},
  [587] = {.lex_state = 17},
  [588] = {.lex_state = 17},
  [589] = {.lex_state = 17},
  [590] = {.lex_state = 17},
  [591] = {.lex_state = 17},
  [592] = {.lex_state = 17},
  [593] = {.lex_state = 0},
  [594] = {.lex_state = 17},
  [595] = {.lex_state = 0},
  [596] = {.lex_state = 17},
  [597] = {.lex_state = 0},
  [598] = {.lex_state = 17},
  [599] = {.lex_state = 17},
  [600] = {.lex_state = 17},
  [601] = {.lex_state = 17},
  [602] = {.lex_state = 0},
  [603] = {.lex_state = 17},
  [604] = {.lex_state = 17},
  [605] = {.lex_state = 17},
  [606] = {.lex_state = 17},
  [607] = {.lex_state = 17},
  [608] = {.lex_state = 17},
  [609] = {.lex_state = 0},
  [610] = {.lex_state = 17},
  [611] = {.lex_state = 0},
  [612] = {.lex_state = 17},
  [613] = {.lex_state = 17},
  [614] = {.lex_state = 17},
  [615] = {.lex_state = 17},
  [616] = {.lex_state = 17},
  [617] = {.lex_state = 0},
  [618] = {.lex_state = 17},
  [619] = {.lex_state = 17},
  [620] = {.lex_state = 0},
  [621] = {.lex_state = 17},
  [622] = {.lex_state = 17},
  [623] = {.lex_state = 17},
  [624] = {.lex_state = 17},
  [625] = {.lex_state = 17},
  [626] = {.lex_state = 17},
  [627] = {.lex_state = 0},
  [628] = {.lex_state = 17},
  [629] = {.lex_state = 17},
  [630] = {.lex_state = 0},
  [631] = {.lex_state = 0},
  [632] = {.lex_state = 17},
  [633] = {.lex_state = 0},
  [634] = {.lex_state = 0},
  [635] = {.lex_state = 17},
  [636] = {.lex_state = 17},
  [637] = {.lex_state = 17},
  [638] = {.lex_state = 0},
  [639] = {.lex_state = 17},
  [640] = {.lex_state = 17},
  [641] = {.lex_state = 17},
  [642] = {.lex_state = 0},
  [643] = {.lex_state = 0},
  [644] = {.lex_state = 17},
  [645] = {.lex_state = 0},
  [646] = {.lex_state = 17},
  [647] = {.lex_state = 17},
  [648] = {.lex_state = 17},
  [649] = {.lex_state = 17},
  [650] = {.lex_state = 0},
  [651] = {.lex_state = 0},
  [652] = {.lex_state = 17},
  [653] = {.lex_state = 0},
  [654] = {.lex_state = 0},
  [655] = {.lex_state = 17},
  [656] = {.lex_state = 17},
  [657] = {.lex_state = 17},
  [658] = {.lex_state = 0},
  [659] = {.lex_state = 17},
  [660] = {.lex_state = 17},
  [661] = {.lex_state = 17},
  [662] = {.lex_state = 17},
  [663] = {.lex_state = 17},
  [664] = {.lex_state = 17},
  [665] = {.lex_state = 0},
  [666] = {.lex_state = 17},
  [667] = {.lex_state = 17},
  [668] = {.lex_state = 17},
  [669] = {.lex_state = 0},
  [670] = {.lex_state = 17},
  [671] = {.lex_state = 17},
  [672] = {.lex_state = 17},
  [673] = {.lex_state = 17},
  [674] = {.lex_state = 0},
  [675] = {.lex_state = 17},
  [676] = {.lex_state = 17},
  [677] = {.lex_state = 17},
  [678] = {.lex_state = 17},
  [679] = {.lex_state = 17},
  [680] = {.lex_state = 17},
  [681] = {.lex_state = 17},
  [682] = {.lex_state = 17},
  [683] = {.lex_state = 17},
  [684] = {.lex_state = 17},
  [685] = {.lex_state = 17},
  [686] = {.lex_state = 17},
  [687] = {.lex_state = 17},
  [688] = {.lex_state = 17},
  [689] = {.lex_state = 17},
  [690] = {.lex_state = 0},
  [691] = {.lex_state = 17},
  [692] = {.lex_state = 17},
  [693] = {.lex_state = 17},
  [694] = {.lex_state = 0},
  [695] = {.lex_state = 17},
  [696] = {.lex_state = 17},
  [697] = {.lex_state = 17},
  [698] = {.lex_state = 17},
  [699] = {.lex_state = 17},
  [700] = {.lex_state = 17},
  [701] = {.lex_state = 17},
  [702] = {.lex_state = 0},
  [703] = {.lex_state = 17},
  [704] = {.lex_state = 17},
  [705] = {.lex_state = 17},
  [706] = {.lex_state = 0},
  [707] = {.lex_state = 17},
  [708] = {.lex_state = 17},
  [709] = {.lex_state = 0},
  [710] = {.lex_state = 17},
  [711] = {.lex_state = 17},
  [712] = {.lex_state = 0},
  [713] = {.lex_state = 17},
  [714] = {.lex_state = 17},
  [715] = {.lex_state = 17},
  [716] = {.lex_state = 17},
  [717] = {.lex_state = 17},
  [718] = {.lex_state = 17},
  [719] = {.lex_state = 17},
  [720] = {.lex_state = 17},
  [721] = {.lex_state = 0},
  [722] = {.lex_state = 17},
  [723] = {.lex_state = 17},
  [724] = {.lex_state = 0},
  [725] = {.lex_state = 0},
  [726] = {.lex_state = 0},
  [727] = {.lex_state = 0},
  [728] = {.lex_state = 17},
  [729] = {.lex_state = 17},
  [730] = {.lex_state = 17},
  [731] = {.lex_state = 0},
  [732] = {.lex_state = 17},
  [733] = {.lex_state = 0},
  [734] = {.lex_state = 0},
  [735] = {.lex_state = 0},
  [736] = {.lex_state = 17},
  [737] = {.lex_state = 17},
  [738] = {.lex_state = 17},
  [739] = {.lex_state = 0},
  [740] = {.lex_state = 17},
  [741] = {.lex_state = 17},
  [742] = {.lex_state = 0},
  [743] = {.lex_state = 0},
  [744] = {.lex_state = 0},
  [745] = {.lex_state = 0},
  [746] = {.lex_state = 0},
  [747] = {.lex_state = 0},
  [748] = {.lex_state = 0},
  [749] = {.lex_state = 0},
  [750] = {.lex_state = 17},
  [751] = {.lex_state = 0},
  [752] = {.lex_state = 0},
  [753] = {.lex_state = 0},
  [754] = {.lex_state = 0},
  [755] = {.lex_state = 0},
  [756] = {.lex_state = 0},
  [757] = {.lex_state = 0},
  [758] = {.lex_state = 0},
  [759] = {.lex_state = 0},
  [760] = {.lex_state = 0},
  [761] = {.lex_state = 0},
  [762] = {.lex_state = 0},
  [763] = {.lex_state = 0},
  [764] = {.lex_state = 0},
  [765] = {.lex_state = 0},
  [766] = {.lex_state = 0},
  [767] = {.lex_state = 0},
  [768] = {.lex_state = 0},
  [769] = {.lex_state = 0},
  [770] = {.lex_state = 0},
  [771] = {.lex_state = 0},
  [772] = {.lex_state = 0},
  [773] = {.lex_state = 0},
  [774] = {.lex_state = 0},
  [775] = {.lex_state = 0},
  [776] = {.lex_state = 0},
  [777] = {.lex_state = 0},
  [778] = {.lex_state = 0},
  [779] = {.lex_state = 0},
  [780] = {.lex_state = 0},
  [781] = {.lex_state = 0},
  [782] = {.lex_state = 0},
  [783] = {.lex_state = 0},
  [784] = {.lex_state = 0},
  [785] = {.lex_state = 0},
  [786] = {.lex_state = 0},
  [787] = {.lex_state = 0},
  [788] = {.lex_state = 0},
  [789] = {.lex_state = 0},
  [790] = {.lex_state = 0},
  [791] = {.lex_state = 0},
  [792] = {.lex_state = 0},
  [793] = {.lex_state = 0},
  [794] = {.lex_state = 0},
  [795] = {.lex_state = 0},
  [796] = {.lex_state = 0},
  [797] = {.lex_state = 0},
  [798] = {.lex_state = 0},
  [799] = {.lex_state = 0},
  [800] = {.lex_state = 0},
  [801] = {.lex_state = 0},
  [802] = {.lex_state = 0},
  [803] = {.lex_state = 0},
  [804] = {.lex_state = 0},
  [805] = {.lex_state = 0},
  [806] = {.lex_state = 0},
  [807] = {.lex_state = 0},
  [808] = {.lex_state = 0},
  [809] = {.lex_state = 0},
  [810] = {.lex_state = 0},
  [811] = {.lex_state = 0},
  [812] = {.lex_state = 0},
  [813] = {.lex_state = 0},
  [814] = {.lex_state = 0},
  [815] = {.lex_state = 0},
  [816] = {.lex_state = 0},
  [817] = {.lex_state = 17},
  [818] = {.lex_state = 0},
  [819] = {.lex_state = 0},
  [820] = {.lex_state = 0},
  [821] = {.lex_state = 0},
  [822] = {.lex_state = 0},
  [823] = {.lex_state = 0},
  [824] = {.lex_state = 0},
  [825] = {.lex_state = 0},
  [826] = {.lex_state = 0},
  [827] = {.lex_state = 0},
  [828] = {.lex_state = 17},
  [829] = {.lex_state = 17},
  [830] = {.lex_state = 17},
  [831] = {.lex_state = 17},
  [832] = {.lex_state = 17},
  [833] = {.lex_state = 17},
  [834] = {.lex_state = 17},
  [835] = {.lex_state = 17},
  [836] = {.lex_state = 17},
  [837] = {.lex_state = 17},
  [838] = {.lex_state = 17},
  [839] = {.lex_state = 17},
  [840] = {.lex_state = 17},
  [841] = {.lex_state = 17},
  [842] = {.lex_state = 17},
  [843] = {.lex_state = 17},
  [844] = {.lex_state = 17},
  [845] = {.lex_state = 17},
  [846] = {.lex_state = 17},
  [847] = {.lex_state = 17},
  [848] = {.lex_state = 17},
  [849] = {.lex_state = 17},
  [850] = {.lex_state = 17},
  [851] = {.lex_state = 17},
  [852] = {.lex_state = 17},
  [853] = {.lex_state = 17},
  [854] = {.lex_state = 17},
  [855] = {.lex_state = 17},
  [856] = {.lex_state = 17},
  [857] = {.lex_state = 17},
  [858] = {.lex_state = 17},
  [859] = {.lex_state = 17},
  [860] = {.lex_state = 17},
  [861] = {.lex_state = 0},
  [862] = {.lex_state = 0},
  [863] = {.lex_state = 0},
  [864] = {.lex_state = 0},
  [865] = {.lex_state = 0},
  [866] = {.lex_state = 0},
  [867] = {.lex_state = 17},
  [868] = {.lex_state = 0},
  [869] = {.lex_state = 0},
  [870] = {.lex_state = 17},
  [871] = {.lex_state = 17},
  [872] = {.lex_state = 17},
  [873] = {.lex_state = 0},
  [874] = {.lex_state = 17},
  [875] = {.lex_state = 17},
  [876] = {.lex_state = 17},
  [877] = {.lex_state = 0},
  [878] = {.lex_state = 17},
  [879] = {.lex_state = 0},
  [880] = {.lex_state = 17},
  [881] = {.lex_state = 17},
  [882] = {.lex_state = 17},
  [883] = {.lex_state = 17},
  [884] = {.lex_state = 17},
  [885] = {.lex_state = 17},
  [886] = {.lex_state = 17},
  [887] = {.lex_state = 17},
  [888] = {.lex_state = 17},
  [889] = {.lex_state = 17},
  [890] = {.lex_state = 17},
  [891] = {.lex_state = 17},
  [892] = {.lex_state = 17},
  [893] = {.lex_state = 17},
  [894] = {.lex_state = 17},
  [895] = {.lex_state = 17},
  [896] = {.lex_state = 17},
  [897] = {.lex_state = 17},
  [898] = {.lex_state = 17},
  [899] = {.lex_state = 17},
  [900] = {.lex_state = 17},
  [901] = {.lex_state = 17},
  [902] = {.lex_state = 17},
  [903] = {.lex_state = 17},
  [904] = {.lex_state = 17},
  [905] = {.lex_state = 17},
  [906] = {.lex_state = 17},
  [907] = {.lex_state = 17},
  [908] = {.lex_state = 17},
  [909] = {.lex_state = 17},
  [910] = {.lex_state = 17},
  [911] = {.lex_state = 17},
  [912] = {.lex_state = 17},
  [913] = {.lex_state = 17},
  [914] = {.lex_state = 17},
  [915] = {.lex_state = 17},
  [916] = {.lex_state = 17},
  [917] = {.lex_state = 17},
  [918] = {.lex_state = 17},
  [919] = {.lex_state = 17},
  [920] = {.lex_state = 17},
  [921] = {.lex_state = 17},
  [922] = {.lex_state = 17},
  [923] = {.lex_state = 17},
  [924] = {.lex_state = 17},
  [925] = {.lex_state = 17},
  [926] = {.lex_state = 17},
  [927] = {.lex_state = 17},
  [928] = {.lex_state = 17},
  [929] = {.lex_state = 17},
  [930] = {.lex_state = 17},
  [931] = {.lex_state = 17},
  [932] = {.lex_state = 17},
  [933] = {.lex_state = 17},
  [934] = {.lex_state = 17},
  [935] = {.lex_state = 17},
  [936] = {.lex_state = 17},
  [937] = {.lex_state = 17},
  [938] = {.lex_state = 17},
  [939] = {.lex_state = 17},
  [940] = {.lex_state = 17},
  [941] = {.lex_state = 17},
  [942] = {.lex_state = 17},
  [943] = {.lex_state = 17},
  [944] = {.lex_state = 17},
  [945] = {.lex_state = 17},
  [946] = {.lex_state = 17},
  [947] = {.lex_state = 17},
  [948] = {.lex_state = 17},
  [949] = {.lex_state = 17},
  [950] = {.lex_state = 17},
  [951] = {.lex_state = 17},
  [952] = {.lex_state = 17},
  [953] = {.lex_state = 17},
  [954] = {.lex_state = 17},
  [955] = {.lex_state = 17},
  [956] = {.lex_state = 17},
  [957] = {.lex_state = 17},
  [958] = {.lex_state = 17},
  [959] = {.lex_state = 17},
  [960] = {.lex_state = 17},
  [961] = {.lex_state = 17},
  [962] = {.lex_state = 17},
  [963] = {.lex_state = 17},
  [964] = {.lex_state = 17},
  [965] = {.lex_state = 17},
  [966] = {.lex_state = 17},
  [967] = {.lex_state = 17},
  [968] = {.lex_state = 17},
  [969] = {.lex_state = 17},
  [970] = {.lex_state = 17},
  [971] = {.lex_state = 17},
  [972] = {.lex_state = 17},
  [973] = {.lex_state = 17},
  [974] = {.lex_state = 17},
  [975] = {.lex_state = 17},
  [976] = {.lex_state = 17},
  [977] = {.lex_state = 17},
  [978] = {.lex_state = 17},
  [979] = {.lex_state = 17},
  [980] = {.lex_state = 17},
  [981] = {.lex_state = 17},
  [982] = {.lex_state = 17},
  [983] = {.lex_state = 17},
  [984] = {.lex_state = 17},
  [985] = {.lex_state = 17},
  [986] = {.lex_state = 17},
  [987] = {.lex_state = 17},
  [988] = {.lex_state = 17},
  [989] = {.lex_state = 17},
  [990] = {.lex_state = 17},
  [991] = {.lex_state = 17},
  [992] = {.lex_state = 17},
  [993] = {.lex_state = 17},
  [994] = {.lex_state = 17},
  [995] = {.lex_state = 17},
  [996] = {.lex_state = 17},
  [997] = {.lex_state = 17},
  [998] = {.lex_state = 17},
  [999] = {.lex_state = 17},
  [1000] = {.lex_state = 17},
  [1001] = {.lex_state = 17},
  [1002] = {.lex_state = 17},
  [1003] = {.lex_state = 17},
  [1004] = {.lex_state = 17},
  [1005] = {.lex_state = 17},
  [1006] = {.lex_state = 17},
  [1007] = {.lex_state = 17},
  [1008] = {.lex_state = 17},
  [1009] = {.lex_state = 17},
  [1010] = {.lex_state = 17},
  [1011] = {.lex_state = 17},
  [1012] = {.lex_state = 17},
  [1013] = {.lex_state = 17},
  [1014] = {.lex_state = 17},
  [1015] = {.lex_state = 17},
  [1016] = {.lex_state = 17},
  [1017] = {.lex_state = 17},
  [1018] = {.lex_state = 17},
  [1019] = {.lex_state = 17},
  [1020] = {.lex_state = 17},
  [1021] = {.lex_state = 17},
  [1022] = {.lex_state = 17},
  [1023] = {.lex_state = 17},
  [1024] = {.lex_state = 17},
  [1025] = {.lex_state = 17},
  [1026] = {.lex_state = 17},
  [1027] = {.lex_state = 17},
  [1028] = {.lex_state = 17},
  [1029] = {.lex_state = 17},
  [1030] = {.lex_state = 17},
  [1031] = {.lex_state = 17},
  [1032] = {.lex_state = 17},
  [1033] = {.lex_state = 17},
  [1034] = {.lex_state = 17},
  [1035] = {.lex_state = 17},
  [1036] = {.lex_state = 17},
  [1037] = {.lex_state = 17},
  [1038] = {.lex_state = 17},
  [1039] = {.lex_state = 17},
  [1040] = {.lex_state = 17},
  [1041] = {.lex_state = 17},
  [1042] = {.lex_state = 17},
  [1043] = {.lex_state = 17},
  [1044] = {.lex_state = 17},
  [1045] = {.lex_state = 17},
  [1046] = {.lex_state = 17},
  [1047] = {.lex_state = 17},
  [1048] = {.lex_state = 17},
  [1049] = {.lex_state = 17},
  [1050] = {.lex_state = 17},
  [1051] = {.lex_state = 17},
  [1052] = {.lex_state = 17},
  [1053] = {.lex_state = 17},
  [1054] = {.lex_state = 17},
  [1055] = {.lex_state = 17},
  [1056] = {.lex_state = 17},
  [1057] = {.lex_state = 17},
  [1058] = {.lex_state = 17},
  [1059] = {.lex_state = 17},
  [1060] = {.lex_state = 17},
  [1061] = {.lex_state = 17},
  [1062] = {.lex_state = 17},
  [1063] = {.lex_state = 17},
  [1064] = {.lex_state = 17},
  [1065] = {.lex_state = 17},
  [1066] = {.lex_state = 17},
  [1067] = {.lex_state = 17},
  [1068] = {.lex_state = 17},
  [1069] = {.lex_state = 17},
  [1070] = {.lex_state = 17},
  [1071] = {.lex_state = 17},
  [1072] = {.lex_state = 17},
  [1073] = {.lex_state = 17},
  [1074] = {.lex_state = 17},
  [1075] = {.lex_state = 17},
  [1076] = {.lex_state = 17},
  [1077] = {.lex_state = 17},
  [1078] = {.lex_state = 17},
  [1079] = {.lex_state = 17},
  [1080] = {.lex_state = 17},
  [1081] = {.lex_state = 17},
  [1082] = {.lex_state = 17},
  [1083] = {.lex_state = 17},
  [1084] = {.lex_state = 17},
  [1085] = {.lex_state = 17},
  [1086] = {.lex_state = 17},
  [1087] = {.lex_state = 17},
  [1088] = {.lex_state = 17},
  [1089] = {.lex_state = 17},
  [1090] = {.lex_state = 17},
  [1091] = {.lex_state = 17},
  [1092] = {.lex_state = 17},
  [1093] = {.lex_state = 17},
  [1094] = {.lex_state = 17},
  [1095] = {.lex_state = 17},
  [1096] = {.lex_state = 17},
  [1097] = {.lex_state = 17},
  [1098] = {.lex_state = 17},
  [1099] = {.lex_state = 17},
  [1100] = {.lex_state = 17},
  [1101] = {.lex_state = 17},
  [1102] = {.lex_state = 17},
  [1103] = {.lex_state = 17},
  [1104] = {.lex_state = 17},
  [1105] = {.lex_state = 17},
  [1106] = {.lex_state = 17},
  [1107] = {.lex_state = 17},
  [1108] = {.lex_state = 17},
  [1109] = {.lex_state = 17},
  [1110] = {.lex_state = 17},
  [1111] = {.lex_state = 17},
  [1112] = {.lex_state = 17},
  [1113] = {.lex_state = 17},
  [1114] = {.lex_state = 17},
  [1115] = {.lex_state = 17},
  [1116] = {.lex_state = 17},
  [1117] = {.lex_state = 17},
  [1118] = {.lex_state = 17},
  [1119] = {.lex_state = 17},
  [1120] = {.lex_state = 17},
  [1121] = {.lex_state = 17},
  [1122] = {.lex_state = 17},
  [1123] = {.lex_state = 17},
  [1124] = {.lex_state = 17},
  [1125] = {.lex_state = 17},
  [1126] = {.lex_state = 17},
  [1127] = {.lex_state = 17},
  [1128] = {.lex_state = 17},
  [1129] = {.lex_state = 17},
  [1130] = {.lex_state = 17},
  [1131] = {.lex_state = 17},
  [1132] = {.lex_state = 17},
  [1133] = {.lex_state = 17},
  [1134] = {.lex_state = 17},
  [1135] = {.lex_state = 17},
  [1136] = {.lex_state = 17},
  [1137] = {.lex_state = 17},
  [1138] = {.lex_state = 17},
  [1139] = {.lex_state = 17},
  [1140] = {.lex_state = 17},
  [1141] = {.lex_state = 17},
  [1142] = {.lex_state = 17},
  [1143] = {.lex_state = 17},
  [1144] = {.lex_state = 17},
  [1145] = {.lex_state = 17},
  [1146] = {.lex_state = 17},
  [1147] = {.lex_state = 17},
  [1148] = {.lex_state = 11},
  [1149] = {.lex_state = 17},
  [1150] = {.lex_state = 17},
  [1151] = {.lex_state = 17},
  [1152] = {.lex_state = 17},
  [1153] = {.lex_state = 17},
  [1154] = {.lex_state = 17},
  [1155] = {.lex_state = 17},
  [1156] = {.lex_state = 17},
  [1157] = {.lex_state = 17},
  [1158] = {.lex_state = 17},
  [1159] = {.lex_state = 17},
  [1160] = {.lex_state = 17},
  [1161] = {.lex_state = 17},
  [1162] = {.lex_state = 17},
  [1163] = {.lex_state = 17},
  [1164] = {.lex_state = 17},
  [1165] = {.lex_state = 17},
  [1166] = {.lex_state = 17},
  [1167] = {.lex_state = 17},
  [1168] = {.lex_state = 17},
  [1169] = {.lex_state = 17},
  [1170] = {.lex_state = 17},
  [1171] = {.lex_state = 17},
  [1172] = {.lex_state = 17},
  [1173] = {.lex_state = 17},
  [1174] = {.lex_state = 17},
  [1175] = {.lex_state = 17},
  [1176] = {.lex_state = 17},
  [1177] = {.lex_state = 17},
  [1178] = {.lex_state = 17},
  [1179] = {.lex_state = 17},
  [1180] = {.lex_state = 17},
  [1181] = {.lex_state = 17},
  [1182] = {.lex_state = 17},
  [1183] = {.lex_state = 17},
  [1184] = {.lex_state = 17},
  [1185] = {.lex_state = 17},
  [1186] = {.lex_state = 17},
  [1187] = {.lex_state = 17},
  [1188] = {.lex_state = 17},
  [1189] = {.lex_state = 17},
  [1190] = {.lex_state = 17},
  [1191] = {.lex_state = 17},
  [1192] = {.lex_state = 17},
  [1193] = {.lex_state = 17},
  [1194] = {.lex_state = 17},
  [1195] = {.lex_state = 17},
  [1196] = {.lex_state = 17},
  [1197] = {.lex_state = 17},
  [1198] = {.lex_state = 17},
  [1199] = {.lex_state = 17},
  [1200] = {.lex_state = 17},
  [1201] = {.lex_state = 17},
  [1202] = {.lex_state = 17},
  [1203] = {.lex_state = 17},
  [1204] = {.lex_state = 17},
  [1205] = {.lex_state = 17},
  [1206] = {.lex_state = 17},
  [1207] = {.lex_state = 17},
  [1208] = {.lex_state = 17},
  [1209] = {.lex_state = 17},
  [1210] = {.lex_state = 17},
  [1211] = {.lex_state = 17},
  [1212] = {.lex_state = 17},
  [1213] = {.lex_state = 17},
  [1214] = {.lex_state = 17},
  [1215] = {.lex_state = 17},
  [1216] = {.lex_state = 17},
  [1217] = {.lex_state = 17},
  [1218] = {.lex_state = 17},
  [1219] = {.lex_state = 17},
  [1220] = {.lex_state = 17},
  [1221] = {.lex_state = 17},
  [1222] = {.lex_state = 17},
  [1223] = {.lex_state = 17},
  [1224] = {.lex_state = 17},
  [1225] = {.lex_state = 17},
  [1226] = {.lex_state = 17},
  [1227] = {.lex_state = 17},
  [1228] = {.lex_state = 17},
  [1229] = {.lex_state = 17},
  [1230] = {.lex_state = 17},
  [1231] = {.lex_state = 17},
  [1232] = {.lex_state = 17},
  [1233] = {.lex_state = 17},
  [1234] = {.lex_state = 17},
  [1235] = {.lex_state = 17},
  [1236] = {.lex_state = 17},
  [1237] = {.lex_state = 17},
  [1238] = {.lex_state = 17},
  [1239] = {.lex_state = 17},
  [1240] = {.lex_state = 17},
  [1241] = {.lex_state = 17},
  [1242] = {.lex_state = 17},
  [1243] = {.lex_state = 17},
  [1244] = {.lex_state = 17},
  [1245] = {.lex_state = 17},
  [1246] = {.lex_state = 17},
  [1247] = {.lex_state = 17},
  [1248] = {.lex_state = 17},
  [1249] = {.lex_state = 17},
  [1250] = {.lex_state = 17},
  [1251] = {.lex_state = 17},
  [1252] = {.lex_state = 17},
  [1253] = {.lex_state = 17},
  [1254] = {.lex_state = 17},
  [1255] = {.lex_state = 17},
  [1256] = {.lex_state = 17},
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym__lower_id] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_where] = ACTIONS(1),
    [anon_sym_select] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_implies] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_order] = ACTIONS(1),
    [anon_sym_by] = ACTIONS(1),
    [sym_qldoc] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [sym__upper_id] = ACTIONS(1),
    [sym__at_lower_id] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [sym_string] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_any] = ACTIONS(1),
    [sym_as] = ACTIONS(1),
    [sym_asc] = ACTIONS(1),
    [sym_avg] = ACTIONS(1),
    [sym_boolean] = ACTIONS(1),
    [sym_class] = ACTIONS(1),
    [sym_newtype] = ACTIONS(1),
    [sym_count] = ACTIONS(1),
    [sym_date] = ACTIONS(1),
    [sym_desc] = ACTIONS(1),
    [sym_exists] = ACTIONS(1),
    [sym_extends] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_forall] = ACTIONS(1),
    [sym_forex] = ACTIONS(1),
    [sym_import] = ACTIONS(1),
    [sym_in] = ACTIONS(1),
    [sym_instanceof] = ACTIONS(1),
    [sym_max] = ACTIONS(1),
    [sym_min] = ACTIONS(1),
    [sym_not] = ACTIONS(1),
    [sym_none] = ACTIONS(1),
    [sym_predicate] = ACTIONS(1),
    [sym_rank] = ACTIONS(1),
    [sym_result] = ACTIONS(1),
    [sym_strictcount] = ACTIONS(1),
    [sym_strictsum] = ACTIONS(1),
    [sym_strictconcat] = ACTIONS(1),
    [sym_concat] = ACTIONS(1),
    [sym_sum] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_lt] = ACTIONS(1),
    [sym_le] = ACTIONS(1),
    [sym_eq] = ACTIONS(1),
    [sym_gt] = ACTIONS(1),
    [sym_ge] = ACTIONS(1),
    [sym_underscore] = ACTIONS(1),
    [sym_minus] = ACTIONS(1),
    [sym_ne] = ACTIONS(1),
    [sym_slash] = ACTIONS(1),
    [sym_star] = ACTIONS(1),
    [sym_mod] = ACTIONS(1),
    [sym_plus] = ACTIONS(1),
  },
  [1] = {
    [sym_ql] = STATE(1252),
    [sym_module] = STATE(825),
    [sym_moduleMember] = STATE(454),
    [sym_imprt] = STATE(825),
    [sym_classlessPredicate] = STATE(825),
    [sym_datatype] = STATE(825),
    [sym_select] = STATE(825),
    [sym_dataclass] = STATE(825),
    [sym_annotation] = STATE(463),
    [sym_annotName] = STATE(830),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_returnType] = STATE(1092),
    [sym_typeExpr] = STATE(1253),
    [aux_sym_ql_repeat1] = STATE(454),
    [aux_sym_moduleMember_repeat1] = STATE(463),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym__lower_id] = ACTIONS(9),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_where] = ACTIONS(15),
    [anon_sym_select] = ACTIONS(17),
    [sym_qldoc] = ACTIONS(19),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(21),
    [sym_class] = ACTIONS(27),
    [sym_newtype] = ACTIONS(29),
    [sym_date] = ACTIONS(21),
    [sym_import] = ACTIONS(31),
    [sym_predicate] = ACTIONS(33),
  },
  [2] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1156),
    [sym_expr_aggregate_body] = STATE(1156),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [3] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1238),
    [sym_expr_aggregate_body] = STATE(1238),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [4] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1191),
    [sym_expr_aggregate_body] = STATE(1191),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [5] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1193),
    [sym_expr_aggregate_body] = STATE(1193),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [6] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1192),
    [sym_expr_aggregate_body] = STATE(1192),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [7] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1231),
    [sym_expr_aggregate_body] = STATE(1231),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [8] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1255),
    [sym_expr_aggregate_body] = STATE(1255),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [9] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1199),
    [sym_expr_aggregate_body] = STATE(1199),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [10] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1227),
    [sym_expr_aggregate_body] = STATE(1227),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(83),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [11] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1222),
    [sym_expr_aggregate_body] = STATE(1222),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(85),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [12] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1174),
    [sym_expr_aggregate_body] = STATE(1174),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [13] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1224),
    [sym_expr_aggregate_body] = STATE(1224),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [14] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1245),
    [sym_expr_aggregate_body] = STATE(1245),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [15] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1133),
    [sym_expr_aggregate_body] = STATE(1133),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(93),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [16] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1155),
    [sym_expr_aggregate_body] = STATE(1155),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(95),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [17] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1248),
    [sym_expr_aggregate_body] = STATE(1248),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [18] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1244),
    [sym_expr_aggregate_body] = STATE(1244),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [19] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1154),
    [sym_expr_aggregate_body] = STATE(1154),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [20] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1019),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(107),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(127),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [21] = {
    [sym_special_call] = STATE(677),
    [sym_prefix_cast] = STATE(677),
    [sym_unary_expr] = STATE(677),
    [sym_mul_expr] = STATE(677),
    [sym_add_expr] = STATE(677),
    [sym_in_expr] = STATE(677),
    [sym_comp_term] = STATE(677),
    [sym_instance_of] = STATE(677),
    [sym_negation] = STATE(677),
    [sym_if_term] = STATE(677),
    [sym_conjunction] = STATE(677),
    [sym_disjunction] = STATE(677),
    [sym_implication] = STATE(677),
    [sym_quantified] = STATE(677),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(677),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_varDecl] = STATE(946),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(901),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [22] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1070),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(133),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(135),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [23] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(963),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(139),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [24] = {
    [sym_special_call] = STATE(701),
    [sym_prefix_cast] = STATE(701),
    [sym_unary_expr] = STATE(701),
    [sym_mul_expr] = STATE(701),
    [sym_add_expr] = STATE(701),
    [sym_in_expr] = STATE(701),
    [sym_comp_term] = STATE(701),
    [sym_instance_of] = STATE(701),
    [sym_negation] = STATE(701),
    [sym_if_term] = STATE(701),
    [sym_conjunction] = STATE(701),
    [sym_disjunction] = STATE(701),
    [sym_implication] = STATE(701),
    [sym_quantified] = STATE(701),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(701),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_varDecl] = STATE(947),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(901),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(143),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [25] = {
    [sym_special_call] = STATE(703),
    [sym_prefix_cast] = STATE(703),
    [sym_unary_expr] = STATE(703),
    [sym_mul_expr] = STATE(703),
    [sym_add_expr] = STATE(703),
    [sym_in_expr] = STATE(703),
    [sym_comp_term] = STATE(703),
    [sym_instance_of] = STATE(703),
    [sym_negation] = STATE(703),
    [sym_if_term] = STATE(703),
    [sym_conjunction] = STATE(703),
    [sym_disjunction] = STATE(703),
    [sym_implication] = STATE(703),
    [sym_quantified] = STATE(703),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(703),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_varDecl] = STATE(915),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(901),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(145),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(147),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [26] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1026),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(149),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(151),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [27] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1035),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(155),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [28] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1051),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(159),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [29] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1063),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(161),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(163),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [30] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(988),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(167),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [31] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1032),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(169),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(171),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [32] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1061),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(173),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(175),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [33] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(962),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(179),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [34] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1028),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(183),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [35] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1010),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(187),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [36] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1007),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(189),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(191),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [37] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(965),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(195),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [38] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1014),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(199),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [39] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1021),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(203),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [40] = {
    [sym_special_call] = STATE(676),
    [sym_prefix_cast] = STATE(676),
    [sym_unary_expr] = STATE(676),
    [sym_mul_expr] = STATE(676),
    [sym_add_expr] = STATE(676),
    [sym_in_expr] = STATE(676),
    [sym_comp_term] = STATE(676),
    [sym_instance_of] = STATE(676),
    [sym_negation] = STATE(676),
    [sym_if_term] = STATE(676),
    [sym_conjunction] = STATE(676),
    [sym_disjunction] = STATE(676),
    [sym_implication] = STATE(676),
    [sym_quantified] = STATE(676),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(676),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_varDecl] = STATE(934),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(901),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [41] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1023),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(211),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [42] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(995),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(215),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [43] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(966),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(219),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [44] = {
    [sym_special_call] = STATE(720),
    [sym_prefix_cast] = STATE(720),
    [sym_unary_expr] = STATE(720),
    [sym_mul_expr] = STATE(720),
    [sym_add_expr] = STATE(720),
    [sym_in_expr] = STATE(720),
    [sym_comp_term] = STATE(720),
    [sym_instance_of] = STATE(720),
    [sym_negation] = STATE(720),
    [sym_if_term] = STATE(720),
    [sym_conjunction] = STATE(720),
    [sym_disjunction] = STATE(720),
    [sym_implication] = STATE(720),
    [sym_quantified] = STATE(720),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(720),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_varDecl] = STATE(930),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(901),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(221),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(223),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [45] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1013),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(227),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [46] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(972),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(231),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [47] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(986),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(233),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(235),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [48] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1045),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(237),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(239),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [49] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(982),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(241),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(243),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [50] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1017),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(245),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(247),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [51] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1053),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(249),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(251),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [52] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1025),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(255),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [53] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1062),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(257),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(259),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [54] = {
    [sym_special_call] = STATE(693),
    [sym_prefix_cast] = STATE(693),
    [sym_unary_expr] = STATE(693),
    [sym_mul_expr] = STATE(693),
    [sym_add_expr] = STATE(693),
    [sym_in_expr] = STATE(693),
    [sym_comp_term] = STATE(693),
    [sym_instance_of] = STATE(693),
    [sym_negation] = STATE(693),
    [sym_if_term] = STATE(693),
    [sym_conjunction] = STATE(693),
    [sym_disjunction] = STATE(693),
    [sym_implication] = STATE(693),
    [sym_quantified] = STATE(693),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(693),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_varDecl] = STATE(959),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(901),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [55] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1080),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(267),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [56] = {
    [sym_special_call] = STATE(567),
    [sym_prefix_cast] = STATE(567),
    [sym_unary_expr] = STATE(567),
    [sym_mul_expr] = STATE(567),
    [sym_add_expr] = STATE(567),
    [sym_in_expr] = STATE(567),
    [sym_comp_term] = STATE(567),
    [sym_instance_of] = STATE(567),
    [sym_negation] = STATE(567),
    [sym_if_term] = STATE(567),
    [sym_conjunction] = STATE(567),
    [sym_disjunction] = STATE(567),
    [sym_implication] = STATE(567),
    [sym_quantified] = STATE(567),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(567),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [57] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_asExprs] = STATE(1043),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [58] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_asExprs] = STATE(1059),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [59] = {
    [sym_special_call] = STATE(261),
    [sym_prefix_cast] = STATE(261),
    [sym_unary_expr] = STATE(261),
    [sym_mul_expr] = STATE(261),
    [sym_add_expr] = STATE(261),
    [sym_in_expr] = STATE(261),
    [sym_comp_term] = STATE(261),
    [sym_instance_of] = STATE(261),
    [sym_negation] = STATE(261),
    [sym_if_term] = STATE(261),
    [sym_conjunction] = STATE(261),
    [sym_disjunction] = STATE(261),
    [sym_implication] = STATE(261),
    [sym_quantified] = STATE(261),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(261),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_asExprs] = STATE(733),
    [sym_asExpr] = STATE(568),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [60] = {
    [sym_special_call] = STATE(264),
    [sym_prefix_cast] = STATE(264),
    [sym_unary_expr] = STATE(264),
    [sym_mul_expr] = STATE(264),
    [sym_add_expr] = STATE(264),
    [sym_in_expr] = STATE(264),
    [sym_comp_term] = STATE(264),
    [sym_instance_of] = STATE(264),
    [sym_negation] = STATE(264),
    [sym_if_term] = STATE(264),
    [sym_conjunction] = STATE(264),
    [sym_disjunction] = STATE(264),
    [sym_implication] = STATE(264),
    [sym_quantified] = STATE(264),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(264),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_asExprs] = STATE(645),
    [sym_asExpr] = STATE(561),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [61] = {
    [sym_special_call] = STATE(261),
    [sym_prefix_cast] = STATE(261),
    [sym_unary_expr] = STATE(261),
    [sym_mul_expr] = STATE(261),
    [sym_add_expr] = STATE(261),
    [sym_in_expr] = STATE(261),
    [sym_comp_term] = STATE(261),
    [sym_instance_of] = STATE(261),
    [sym_negation] = STATE(261),
    [sym_if_term] = STATE(261),
    [sym_conjunction] = STATE(261),
    [sym_disjunction] = STATE(261),
    [sym_implication] = STATE(261),
    [sym_quantified] = STATE(261),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(261),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_asExprs] = STATE(724),
    [sym_asExpr] = STATE(568),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [62] = {
    [sym_special_call] = STATE(264),
    [sym_prefix_cast] = STATE(264),
    [sym_unary_expr] = STATE(264),
    [sym_mul_expr] = STATE(264),
    [sym_add_expr] = STATE(264),
    [sym_in_expr] = STATE(264),
    [sym_comp_term] = STATE(264),
    [sym_instance_of] = STATE(264),
    [sym_negation] = STATE(264),
    [sym_if_term] = STATE(264),
    [sym_conjunction] = STATE(264),
    [sym_disjunction] = STATE(264),
    [sym_implication] = STATE(264),
    [sym_quantified] = STATE(264),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(264),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_asExprs] = STATE(669),
    [sym_asExpr] = STATE(561),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [63] = {
    [sym_special_call] = STATE(261),
    [sym_prefix_cast] = STATE(261),
    [sym_unary_expr] = STATE(261),
    [sym_mul_expr] = STATE(261),
    [sym_add_expr] = STATE(261),
    [sym_in_expr] = STATE(261),
    [sym_comp_term] = STATE(261),
    [sym_instance_of] = STATE(261),
    [sym_negation] = STATE(261),
    [sym_if_term] = STATE(261),
    [sym_conjunction] = STATE(261),
    [sym_disjunction] = STATE(261),
    [sym_implication] = STATE(261),
    [sym_quantified] = STATE(261),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(261),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_asExprs] = STATE(721),
    [sym_asExpr] = STATE(568),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [64] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_asExprs] = STATE(1076),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [65] = {
    [sym_special_call] = STATE(601),
    [sym_prefix_cast] = STATE(601),
    [sym_unary_expr] = STATE(601),
    [sym_mul_expr] = STATE(601),
    [sym_add_expr] = STATE(601),
    [sym_in_expr] = STATE(601),
    [sym_comp_term] = STATE(601),
    [sym_instance_of] = STATE(601),
    [sym_negation] = STATE(601),
    [sym_if_term] = STATE(601),
    [sym_conjunction] = STATE(601),
    [sym_disjunction] = STATE(601),
    [sym_implication] = STATE(601),
    [sym_quantified] = STATE(601),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(601),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(319),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [66] = {
    [sym_special_call] = STATE(625),
    [sym_prefix_cast] = STATE(625),
    [sym_unary_expr] = STATE(625),
    [sym_mul_expr] = STATE(625),
    [sym_add_expr] = STATE(625),
    [sym_in_expr] = STATE(625),
    [sym_comp_term] = STATE(625),
    [sym_instance_of] = STATE(625),
    [sym_negation] = STATE(625),
    [sym_if_term] = STATE(625),
    [sym_conjunction] = STATE(625),
    [sym_disjunction] = STATE(625),
    [sym_implication] = STATE(625),
    [sym_quantified] = STATE(625),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(625),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(323),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [67] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_asExprs] = STATE(1081),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [68] = {
    [sym_special_call] = STATE(261),
    [sym_prefix_cast] = STATE(261),
    [sym_unary_expr] = STATE(261),
    [sym_mul_expr] = STATE(261),
    [sym_add_expr] = STATE(261),
    [sym_in_expr] = STATE(261),
    [sym_comp_term] = STATE(261),
    [sym_instance_of] = STATE(261),
    [sym_negation] = STATE(261),
    [sym_if_term] = STATE(261),
    [sym_conjunction] = STATE(261),
    [sym_disjunction] = STATE(261),
    [sym_implication] = STATE(261),
    [sym_quantified] = STATE(261),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(261),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_asExprs] = STATE(690),
    [sym_asExpr] = STATE(568),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [69] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1121),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(325),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [70] = {
    [sym_special_call] = STATE(261),
    [sym_prefix_cast] = STATE(261),
    [sym_unary_expr] = STATE(261),
    [sym_mul_expr] = STATE(261),
    [sym_add_expr] = STATE(261),
    [sym_in_expr] = STATE(261),
    [sym_comp_term] = STATE(261),
    [sym_instance_of] = STATE(261),
    [sym_negation] = STATE(261),
    [sym_if_term] = STATE(261),
    [sym_conjunction] = STATE(261),
    [sym_disjunction] = STATE(261),
    [sym_implication] = STATE(261),
    [sym_quantified] = STATE(261),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(261),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_asExprs] = STATE(735),
    [sym_asExpr] = STATE(568),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [71] = {
    [sym_special_call] = STATE(261),
    [sym_prefix_cast] = STATE(261),
    [sym_unary_expr] = STATE(261),
    [sym_mul_expr] = STATE(261),
    [sym_add_expr] = STATE(261),
    [sym_in_expr] = STATE(261),
    [sym_comp_term] = STATE(261),
    [sym_instance_of] = STATE(261),
    [sym_negation] = STATE(261),
    [sym_if_term] = STATE(261),
    [sym_conjunction] = STATE(261),
    [sym_disjunction] = STATE(261),
    [sym_implication] = STATE(261),
    [sym_quantified] = STATE(261),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(261),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_asExprs] = STATE(702),
    [sym_asExpr] = STATE(568),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [72] = {
    [sym_special_call] = STATE(264),
    [sym_prefix_cast] = STATE(264),
    [sym_unary_expr] = STATE(264),
    [sym_mul_expr] = STATE(264),
    [sym_add_expr] = STATE(264),
    [sym_in_expr] = STATE(264),
    [sym_comp_term] = STATE(264),
    [sym_instance_of] = STATE(264),
    [sym_negation] = STATE(264),
    [sym_if_term] = STATE(264),
    [sym_conjunction] = STATE(264),
    [sym_disjunction] = STATE(264),
    [sym_implication] = STATE(264),
    [sym_quantified] = STATE(264),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(264),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_asExprs] = STATE(630),
    [sym_asExpr] = STATE(561),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [73] = {
    [sym_special_call] = STATE(264),
    [sym_prefix_cast] = STATE(264),
    [sym_unary_expr] = STATE(264),
    [sym_mul_expr] = STATE(264),
    [sym_add_expr] = STATE(264),
    [sym_in_expr] = STATE(264),
    [sym_comp_term] = STATE(264),
    [sym_instance_of] = STATE(264),
    [sym_negation] = STATE(264),
    [sym_if_term] = STATE(264),
    [sym_conjunction] = STATE(264),
    [sym_disjunction] = STATE(264),
    [sym_implication] = STATE(264),
    [sym_quantified] = STATE(264),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(264),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_asExprs] = STATE(725),
    [sym_asExpr] = STATE(561),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [74] = {
    [sym_special_call] = STATE(264),
    [sym_prefix_cast] = STATE(264),
    [sym_unary_expr] = STATE(264),
    [sym_mul_expr] = STATE(264),
    [sym_add_expr] = STATE(264),
    [sym_in_expr] = STATE(264),
    [sym_comp_term] = STATE(264),
    [sym_instance_of] = STATE(264),
    [sym_negation] = STATE(264),
    [sym_if_term] = STATE(264),
    [sym_conjunction] = STATE(264),
    [sym_disjunction] = STATE(264),
    [sym_implication] = STATE(264),
    [sym_quantified] = STATE(264),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(264),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_asExprs] = STATE(709),
    [sym_asExpr] = STATE(561),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [75] = {
    [sym_special_call] = STATE(264),
    [sym_prefix_cast] = STATE(264),
    [sym_unary_expr] = STATE(264),
    [sym_mul_expr] = STATE(264),
    [sym_add_expr] = STATE(264),
    [sym_in_expr] = STATE(264),
    [sym_comp_term] = STATE(264),
    [sym_instance_of] = STATE(264),
    [sym_negation] = STATE(264),
    [sym_if_term] = STATE(264),
    [sym_conjunction] = STATE(264),
    [sym_disjunction] = STATE(264),
    [sym_implication] = STATE(264),
    [sym_quantified] = STATE(264),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(264),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_asExprs] = STATE(706),
    [sym_asExpr] = STATE(561),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [76] = {
    [sym_special_call] = STATE(243),
    [sym_prefix_cast] = STATE(243),
    [sym_unary_expr] = STATE(243),
    [sym_mul_expr] = STATE(243),
    [sym_add_expr] = STATE(243),
    [sym_in_expr] = STATE(243),
    [sym_comp_term] = STATE(243),
    [sym_instance_of] = STATE(243),
    [sym_negation] = STATE(243),
    [sym_if_term] = STATE(243),
    [sym_conjunction] = STATE(243),
    [sym_disjunction] = STATE(243),
    [sym_implication] = STATE(243),
    [sym_quantified] = STATE(243),
    [sym_specialId] = STATE(1185),
    [sym_quantifier] = STATE(1186),
    [sym_classless_predicate_call] = STATE(366),
    [sym_qualified_expr] = STATE(366),
    [sym_super_ref] = STATE(366),
    [sym_aggregate] = STATE(366),
    [sym_range] = STATE(366),
    [sym_par_expr] = STATE(366),
    [sym__exprOrTerm] = STATE(243),
    [sym__primary] = STATE(366),
    [sym_literal] = STATE(366),
    [sym_bool] = STATE(362),
    [sym_variable] = STATE(366),
    [sym_unop] = STATE(205),
    [sym_orderBy] = STATE(650),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(294),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1187),
    [sym_aritylessPredicateExpr] = STATE(939),
    [sym_varName] = STATE(364),
    [sym_aggId] = STATE(1117),
    [sym__lower_id] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_if] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(335),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(341),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(343),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(345),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(347),
    [sym_this] = ACTIONS(345),
    [sym_true] = ACTIONS(341),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [77] = {
    [sym_special_call] = STATE(242),
    [sym_prefix_cast] = STATE(242),
    [sym_unary_expr] = STATE(242),
    [sym_mul_expr] = STATE(242),
    [sym_add_expr] = STATE(242),
    [sym_in_expr] = STATE(242),
    [sym_comp_term] = STATE(242),
    [sym_instance_of] = STATE(242),
    [sym_negation] = STATE(242),
    [sym_if_term] = STATE(242),
    [sym_conjunction] = STATE(242),
    [sym_disjunction] = STATE(242),
    [sym_implication] = STATE(242),
    [sym_quantified] = STATE(242),
    [sym_specialId] = STATE(1165),
    [sym_quantifier] = STATE(1166),
    [sym_classless_predicate_call] = STATE(335),
    [sym_qualified_expr] = STATE(335),
    [sym_super_ref] = STATE(335),
    [sym_aggregate] = STATE(335),
    [sym_range] = STATE(335),
    [sym_par_expr] = STATE(335),
    [sym__exprOrTerm] = STATE(242),
    [sym__primary] = STATE(335),
    [sym_literal] = STATE(335),
    [sym_bool] = STATE(331),
    [sym_variable] = STATE(335),
    [sym_unop] = STATE(114),
    [sym_orderBy] = STATE(731),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(295),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1167),
    [sym_aritylessPredicateExpr] = STATE(923),
    [sym_varName] = STATE(333),
    [sym_aggId] = STATE(1122),
    [sym__lower_id] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(355),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(357),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(361),
    [sym_string] = ACTIONS(361),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(363),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(365),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(367),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(369),
    [sym_this] = ACTIONS(367),
    [sym_true] = ACTIONS(363),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [78] = {
    [sym_special_call] = STATE(242),
    [sym_prefix_cast] = STATE(242),
    [sym_unary_expr] = STATE(242),
    [sym_mul_expr] = STATE(242),
    [sym_add_expr] = STATE(242),
    [sym_in_expr] = STATE(242),
    [sym_comp_term] = STATE(242),
    [sym_instance_of] = STATE(242),
    [sym_negation] = STATE(242),
    [sym_if_term] = STATE(242),
    [sym_conjunction] = STATE(242),
    [sym_disjunction] = STATE(242),
    [sym_implication] = STATE(242),
    [sym_quantified] = STATE(242),
    [sym_specialId] = STATE(1165),
    [sym_quantifier] = STATE(1166),
    [sym_classless_predicate_call] = STATE(335),
    [sym_qualified_expr] = STATE(335),
    [sym_super_ref] = STATE(335),
    [sym_aggregate] = STATE(335),
    [sym_range] = STATE(335),
    [sym_par_expr] = STATE(335),
    [sym__exprOrTerm] = STATE(242),
    [sym__primary] = STATE(335),
    [sym_literal] = STATE(335),
    [sym_bool] = STATE(331),
    [sym_variable] = STATE(335),
    [sym_unop] = STATE(114),
    [sym_orderBy] = STATE(763),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(295),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1167),
    [sym_aritylessPredicateExpr] = STATE(923),
    [sym_varName] = STATE(333),
    [sym_aggId] = STATE(1122),
    [sym__lower_id] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(355),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(357),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(361),
    [sym_string] = ACTIONS(361),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(363),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(365),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(367),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(369),
    [sym_this] = ACTIONS(367),
    [sym_true] = ACTIONS(363),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [79] = {
    [sym_special_call] = STATE(528),
    [sym_prefix_cast] = STATE(528),
    [sym_unary_expr] = STATE(528),
    [sym_mul_expr] = STATE(528),
    [sym_add_expr] = STATE(528),
    [sym_in_expr] = STATE(528),
    [sym_comp_term] = STATE(528),
    [sym_instance_of] = STATE(528),
    [sym_negation] = STATE(528),
    [sym_if_term] = STATE(528),
    [sym_conjunction] = STATE(528),
    [sym_disjunction] = STATE(528),
    [sym_implication] = STATE(528),
    [sym_quantified] = STATE(528),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(528),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_orderBy] = STATE(1115),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [80] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_asExpr] = STATE(997),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [81] = {
    [sym_special_call] = STATE(528),
    [sym_prefix_cast] = STATE(528),
    [sym_unary_expr] = STATE(528),
    [sym_mul_expr] = STATE(528),
    [sym_add_expr] = STATE(528),
    [sym_in_expr] = STATE(528),
    [sym_comp_term] = STATE(528),
    [sym_instance_of] = STATE(528),
    [sym_negation] = STATE(528),
    [sym_if_term] = STATE(528),
    [sym_conjunction] = STATE(528),
    [sym_disjunction] = STATE(528),
    [sym_implication] = STATE(528),
    [sym_quantified] = STATE(528),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(528),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_orderBy] = STATE(992),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [82] = {
    [sym_special_call] = STATE(261),
    [sym_prefix_cast] = STATE(261),
    [sym_unary_expr] = STATE(261),
    [sym_mul_expr] = STATE(261),
    [sym_add_expr] = STATE(261),
    [sym_in_expr] = STATE(261),
    [sym_comp_term] = STATE(261),
    [sym_instance_of] = STATE(261),
    [sym_negation] = STATE(261),
    [sym_if_term] = STATE(261),
    [sym_conjunction] = STATE(261),
    [sym_disjunction] = STATE(261),
    [sym_implication] = STATE(261),
    [sym_quantified] = STATE(261),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(261),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_asExpr] = STATE(653),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [83] = {
    [sym_special_call] = STATE(264),
    [sym_prefix_cast] = STATE(264),
    [sym_unary_expr] = STATE(264),
    [sym_mul_expr] = STATE(264),
    [sym_add_expr] = STATE(264),
    [sym_in_expr] = STATE(264),
    [sym_comp_term] = STATE(264),
    [sym_instance_of] = STATE(264),
    [sym_negation] = STATE(264),
    [sym_if_term] = STATE(264),
    [sym_conjunction] = STATE(264),
    [sym_disjunction] = STATE(264),
    [sym_implication] = STATE(264),
    [sym_quantified] = STATE(264),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(264),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_asExpr] = STATE(642),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [84] = {
    [sym_special_call] = STATE(243),
    [sym_prefix_cast] = STATE(243),
    [sym_unary_expr] = STATE(243),
    [sym_mul_expr] = STATE(243),
    [sym_add_expr] = STATE(243),
    [sym_in_expr] = STATE(243),
    [sym_comp_term] = STATE(243),
    [sym_instance_of] = STATE(243),
    [sym_negation] = STATE(243),
    [sym_if_term] = STATE(243),
    [sym_conjunction] = STATE(243),
    [sym_disjunction] = STATE(243),
    [sym_implication] = STATE(243),
    [sym_quantified] = STATE(243),
    [sym_specialId] = STATE(1185),
    [sym_quantifier] = STATE(1186),
    [sym_classless_predicate_call] = STATE(366),
    [sym_qualified_expr] = STATE(366),
    [sym_super_ref] = STATE(366),
    [sym_aggregate] = STATE(366),
    [sym_range] = STATE(366),
    [sym_par_expr] = STATE(366),
    [sym__exprOrTerm] = STATE(243),
    [sym__primary] = STATE(366),
    [sym_literal] = STATE(366),
    [sym_bool] = STATE(362),
    [sym_variable] = STATE(366),
    [sym_unop] = STATE(205),
    [sym_orderBy] = STATE(747),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(294),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1187),
    [sym_aritylessPredicateExpr] = STATE(939),
    [sym_varName] = STATE(364),
    [sym_aggId] = STATE(1117),
    [sym__lower_id] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_if] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(335),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(341),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(343),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(345),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(347),
    [sym_this] = ACTIONS(345),
    [sym_true] = ACTIONS(341),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [85] = {
    [sym_special_call] = STATE(666),
    [sym_prefix_cast] = STATE(666),
    [sym_unary_expr] = STATE(666),
    [sym_mul_expr] = STATE(666),
    [sym_add_expr] = STATE(666),
    [sym_in_expr] = STATE(666),
    [sym_comp_term] = STATE(666),
    [sym_instance_of] = STATE(666),
    [sym_negation] = STATE(666),
    [sym_if_term] = STATE(666),
    [sym_conjunction] = STATE(666),
    [sym_disjunction] = STATE(666),
    [sym_implication] = STATE(666),
    [sym_quantified] = STATE(666),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(666),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [86] = {
    [sym_special_call] = STATE(623),
    [sym_prefix_cast] = STATE(623),
    [sym_unary_expr] = STATE(623),
    [sym_mul_expr] = STATE(623),
    [sym_add_expr] = STATE(623),
    [sym_in_expr] = STATE(623),
    [sym_comp_term] = STATE(623),
    [sym_instance_of] = STATE(623),
    [sym_negation] = STATE(623),
    [sym_if_term] = STATE(623),
    [sym_conjunction] = STATE(623),
    [sym_disjunction] = STATE(623),
    [sym_implication] = STATE(623),
    [sym_quantified] = STATE(623),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(623),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [87] = {
    [sym_special_call] = STATE(678),
    [sym_prefix_cast] = STATE(678),
    [sym_unary_expr] = STATE(678),
    [sym_mul_expr] = STATE(678),
    [sym_add_expr] = STATE(678),
    [sym_in_expr] = STATE(678),
    [sym_comp_term] = STATE(678),
    [sym_instance_of] = STATE(678),
    [sym_negation] = STATE(678),
    [sym_if_term] = STATE(678),
    [sym_conjunction] = STATE(678),
    [sym_disjunction] = STATE(678),
    [sym_implication] = STATE(678),
    [sym_quantified] = STATE(678),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(678),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [88] = {
    [sym_special_call] = STATE(550),
    [sym_prefix_cast] = STATE(550),
    [sym_unary_expr] = STATE(550),
    [sym_mul_expr] = STATE(550),
    [sym_add_expr] = STATE(550),
    [sym_in_expr] = STATE(550),
    [sym_comp_term] = STATE(550),
    [sym_instance_of] = STATE(550),
    [sym_negation] = STATE(550),
    [sym_if_term] = STATE(550),
    [sym_conjunction] = STATE(550),
    [sym_disjunction] = STATE(550),
    [sym_implication] = STATE(550),
    [sym_quantified] = STATE(550),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(550),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [89] = {
    [sym_special_call] = STATE(681),
    [sym_prefix_cast] = STATE(681),
    [sym_unary_expr] = STATE(681),
    [sym_mul_expr] = STATE(681),
    [sym_add_expr] = STATE(681),
    [sym_in_expr] = STATE(681),
    [sym_comp_term] = STATE(681),
    [sym_instance_of] = STATE(681),
    [sym_negation] = STATE(681),
    [sym_if_term] = STATE(681),
    [sym_conjunction] = STATE(681),
    [sym_disjunction] = STATE(681),
    [sym_implication] = STATE(681),
    [sym_quantified] = STATE(681),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(681),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [90] = {
    [sym_special_call] = STATE(682),
    [sym_prefix_cast] = STATE(682),
    [sym_unary_expr] = STATE(682),
    [sym_mul_expr] = STATE(682),
    [sym_add_expr] = STATE(682),
    [sym_in_expr] = STATE(682),
    [sym_comp_term] = STATE(682),
    [sym_instance_of] = STATE(682),
    [sym_negation] = STATE(682),
    [sym_if_term] = STATE(682),
    [sym_conjunction] = STATE(682),
    [sym_disjunction] = STATE(682),
    [sym_implication] = STATE(682),
    [sym_quantified] = STATE(682),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(682),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [91] = {
    [sym_special_call] = STATE(551),
    [sym_prefix_cast] = STATE(551),
    [sym_unary_expr] = STATE(551),
    [sym_mul_expr] = STATE(551),
    [sym_add_expr] = STATE(551),
    [sym_in_expr] = STATE(551),
    [sym_comp_term] = STATE(551),
    [sym_instance_of] = STATE(551),
    [sym_negation] = STATE(551),
    [sym_if_term] = STATE(551),
    [sym_conjunction] = STATE(551),
    [sym_disjunction] = STATE(551),
    [sym_implication] = STATE(551),
    [sym_quantified] = STATE(551),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(551),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [92] = {
    [sym_special_call] = STATE(512),
    [sym_prefix_cast] = STATE(512),
    [sym_unary_expr] = STATE(512),
    [sym_mul_expr] = STATE(512),
    [sym_add_expr] = STATE(512),
    [sym_in_expr] = STATE(512),
    [sym_comp_term] = STATE(512),
    [sym_instance_of] = STATE(512),
    [sym_negation] = STATE(512),
    [sym_if_term] = STATE(512),
    [sym_conjunction] = STATE(512),
    [sym_disjunction] = STATE(512),
    [sym_implication] = STATE(512),
    [sym_quantified] = STATE(512),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(512),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [93] = {
    [sym_special_call] = STATE(511),
    [sym_prefix_cast] = STATE(511),
    [sym_unary_expr] = STATE(511),
    [sym_mul_expr] = STATE(511),
    [sym_add_expr] = STATE(511),
    [sym_in_expr] = STATE(511),
    [sym_comp_term] = STATE(511),
    [sym_instance_of] = STATE(511),
    [sym_negation] = STATE(511),
    [sym_if_term] = STATE(511),
    [sym_conjunction] = STATE(511),
    [sym_disjunction] = STATE(511),
    [sym_implication] = STATE(511),
    [sym_quantified] = STATE(511),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(511),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [94] = {
    [sym_special_call] = STATE(510),
    [sym_prefix_cast] = STATE(510),
    [sym_unary_expr] = STATE(510),
    [sym_mul_expr] = STATE(510),
    [sym_add_expr] = STATE(510),
    [sym_in_expr] = STATE(510),
    [sym_comp_term] = STATE(510),
    [sym_instance_of] = STATE(510),
    [sym_negation] = STATE(510),
    [sym_if_term] = STATE(510),
    [sym_conjunction] = STATE(510),
    [sym_disjunction] = STATE(510),
    [sym_implication] = STATE(510),
    [sym_quantified] = STATE(510),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(510),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [95] = {
    [sym_special_call] = STATE(737),
    [sym_prefix_cast] = STATE(737),
    [sym_unary_expr] = STATE(737),
    [sym_mul_expr] = STATE(737),
    [sym_add_expr] = STATE(737),
    [sym_in_expr] = STATE(737),
    [sym_comp_term] = STATE(737),
    [sym_instance_of] = STATE(737),
    [sym_negation] = STATE(737),
    [sym_if_term] = STATE(737),
    [sym_conjunction] = STATE(737),
    [sym_disjunction] = STATE(737),
    [sym_implication] = STATE(737),
    [sym_quantified] = STATE(737),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(737),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [96] = {
    [sym_special_call] = STATE(685),
    [sym_prefix_cast] = STATE(685),
    [sym_unary_expr] = STATE(685),
    [sym_mul_expr] = STATE(685),
    [sym_add_expr] = STATE(685),
    [sym_in_expr] = STATE(685),
    [sym_comp_term] = STATE(685),
    [sym_instance_of] = STATE(685),
    [sym_negation] = STATE(685),
    [sym_if_term] = STATE(685),
    [sym_conjunction] = STATE(685),
    [sym_disjunction] = STATE(685),
    [sym_implication] = STATE(685),
    [sym_quantified] = STATE(685),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(685),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [97] = {
    [sym_special_call] = STATE(262),
    [sym_prefix_cast] = STATE(262),
    [sym_unary_expr] = STATE(262),
    [sym_mul_expr] = STATE(262),
    [sym_add_expr] = STATE(262),
    [sym_in_expr] = STATE(262),
    [sym_comp_term] = STATE(262),
    [sym_instance_of] = STATE(262),
    [sym_negation] = STATE(262),
    [sym_if_term] = STATE(262),
    [sym_conjunction] = STATE(262),
    [sym_disjunction] = STATE(262),
    [sym_implication] = STATE(262),
    [sym_quantified] = STATE(262),
    [sym_specialId] = STATE(1165),
    [sym_quantifier] = STATE(1166),
    [sym_classless_predicate_call] = STATE(335),
    [sym_qualified_expr] = STATE(335),
    [sym_super_ref] = STATE(335),
    [sym_aggregate] = STATE(335),
    [sym_range] = STATE(335),
    [sym_par_expr] = STATE(335),
    [sym__exprOrTerm] = STATE(262),
    [sym__primary] = STATE(335),
    [sym_literal] = STATE(335),
    [sym_bool] = STATE(331),
    [sym_variable] = STATE(335),
    [sym_unop] = STATE(114),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(295),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1167),
    [sym_aritylessPredicateExpr] = STATE(923),
    [sym_varName] = STATE(333),
    [sym_aggId] = STATE(1122),
    [sym__lower_id] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(355),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(357),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(361),
    [sym_string] = ACTIONS(361),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(363),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(365),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(367),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(369),
    [sym_this] = ACTIONS(367),
    [sym_true] = ACTIONS(363),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [98] = {
    [sym_special_call] = STATE(688),
    [sym_prefix_cast] = STATE(688),
    [sym_unary_expr] = STATE(688),
    [sym_mul_expr] = STATE(688),
    [sym_add_expr] = STATE(688),
    [sym_in_expr] = STATE(688),
    [sym_comp_term] = STATE(688),
    [sym_instance_of] = STATE(688),
    [sym_negation] = STATE(688),
    [sym_if_term] = STATE(688),
    [sym_conjunction] = STATE(688),
    [sym_disjunction] = STATE(688),
    [sym_implication] = STATE(688),
    [sym_quantified] = STATE(688),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(688),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [99] = {
    [sym_special_call] = STATE(284),
    [sym_prefix_cast] = STATE(284),
    [sym_unary_expr] = STATE(284),
    [sym_mul_expr] = STATE(284),
    [sym_add_expr] = STATE(284),
    [sym_in_expr] = STATE(284),
    [sym_comp_term] = STATE(284),
    [sym_instance_of] = STATE(284),
    [sym_negation] = STATE(284),
    [sym_if_term] = STATE(284),
    [sym_conjunction] = STATE(284),
    [sym_disjunction] = STATE(284),
    [sym_implication] = STATE(284),
    [sym_quantified] = STATE(284),
    [sym_specialId] = STATE(1165),
    [sym_quantifier] = STATE(1166),
    [sym_classless_predicate_call] = STATE(335),
    [sym_qualified_expr] = STATE(335),
    [sym_super_ref] = STATE(335),
    [sym_aggregate] = STATE(335),
    [sym_range] = STATE(335),
    [sym_par_expr] = STATE(335),
    [sym__exprOrTerm] = STATE(284),
    [sym__primary] = STATE(335),
    [sym_literal] = STATE(335),
    [sym_bool] = STATE(331),
    [sym_variable] = STATE(335),
    [sym_unop] = STATE(114),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(295),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1167),
    [sym_aritylessPredicateExpr] = STATE(923),
    [sym_varName] = STATE(333),
    [sym_aggId] = STATE(1122),
    [sym__lower_id] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(355),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(357),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(361),
    [sym_string] = ACTIONS(361),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(363),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(365),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(367),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(369),
    [sym_this] = ACTIONS(367),
    [sym_true] = ACTIONS(363),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [100] = {
    [sym_special_call] = STATE(518),
    [sym_prefix_cast] = STATE(518),
    [sym_unary_expr] = STATE(518),
    [sym_mul_expr] = STATE(518),
    [sym_add_expr] = STATE(518),
    [sym_in_expr] = STATE(518),
    [sym_comp_term] = STATE(518),
    [sym_instance_of] = STATE(518),
    [sym_negation] = STATE(518),
    [sym_if_term] = STATE(518),
    [sym_conjunction] = STATE(518),
    [sym_disjunction] = STATE(518),
    [sym_implication] = STATE(518),
    [sym_quantified] = STATE(518),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(518),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [101] = {
    [sym_special_call] = STATE(517),
    [sym_prefix_cast] = STATE(517),
    [sym_unary_expr] = STATE(517),
    [sym_mul_expr] = STATE(517),
    [sym_add_expr] = STATE(517),
    [sym_in_expr] = STATE(517),
    [sym_comp_term] = STATE(517),
    [sym_instance_of] = STATE(517),
    [sym_negation] = STATE(517),
    [sym_if_term] = STATE(517),
    [sym_conjunction] = STATE(517),
    [sym_disjunction] = STATE(517),
    [sym_implication] = STATE(517),
    [sym_quantified] = STATE(517),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(517),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [102] = {
    [sym_special_call] = STATE(515),
    [sym_prefix_cast] = STATE(515),
    [sym_unary_expr] = STATE(515),
    [sym_mul_expr] = STATE(515),
    [sym_add_expr] = STATE(515),
    [sym_in_expr] = STATE(515),
    [sym_comp_term] = STATE(515),
    [sym_instance_of] = STATE(515),
    [sym_negation] = STATE(515),
    [sym_if_term] = STATE(515),
    [sym_conjunction] = STATE(515),
    [sym_disjunction] = STATE(515),
    [sym_implication] = STATE(515),
    [sym_quantified] = STATE(515),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(515),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [103] = {
    [sym_special_call] = STATE(283),
    [sym_prefix_cast] = STATE(283),
    [sym_unary_expr] = STATE(283),
    [sym_mul_expr] = STATE(283),
    [sym_add_expr] = STATE(283),
    [sym_in_expr] = STATE(283),
    [sym_comp_term] = STATE(283),
    [sym_instance_of] = STATE(283),
    [sym_negation] = STATE(283),
    [sym_if_term] = STATE(283),
    [sym_conjunction] = STATE(283),
    [sym_disjunction] = STATE(283),
    [sym_implication] = STATE(283),
    [sym_quantified] = STATE(283),
    [sym_specialId] = STATE(1165),
    [sym_quantifier] = STATE(1166),
    [sym_classless_predicate_call] = STATE(335),
    [sym_qualified_expr] = STATE(335),
    [sym_super_ref] = STATE(335),
    [sym_aggregate] = STATE(335),
    [sym_range] = STATE(335),
    [sym_par_expr] = STATE(335),
    [sym__exprOrTerm] = STATE(283),
    [sym__primary] = STATE(335),
    [sym_literal] = STATE(335),
    [sym_bool] = STATE(331),
    [sym_variable] = STATE(335),
    [sym_unop] = STATE(114),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(295),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1167),
    [sym_aritylessPredicateExpr] = STATE(923),
    [sym_varName] = STATE(333),
    [sym_aggId] = STATE(1122),
    [sym__lower_id] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(355),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(357),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(361),
    [sym_string] = ACTIONS(361),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(363),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(365),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(367),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(369),
    [sym_this] = ACTIONS(367),
    [sym_true] = ACTIONS(363),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [104] = {
    [sym_special_call] = STATE(245),
    [sym_prefix_cast] = STATE(245),
    [sym_unary_expr] = STATE(245),
    [sym_mul_expr] = STATE(245),
    [sym_add_expr] = STATE(245),
    [sym_in_expr] = STATE(245),
    [sym_comp_term] = STATE(245),
    [sym_instance_of] = STATE(245),
    [sym_negation] = STATE(245),
    [sym_if_term] = STATE(245),
    [sym_conjunction] = STATE(245),
    [sym_disjunction] = STATE(245),
    [sym_implication] = STATE(245),
    [sym_quantified] = STATE(245),
    [sym_specialId] = STATE(1165),
    [sym_quantifier] = STATE(1166),
    [sym_classless_predicate_call] = STATE(335),
    [sym_qualified_expr] = STATE(335),
    [sym_super_ref] = STATE(335),
    [sym_aggregate] = STATE(335),
    [sym_range] = STATE(335),
    [sym_par_expr] = STATE(335),
    [sym__exprOrTerm] = STATE(245),
    [sym__primary] = STATE(335),
    [sym_literal] = STATE(335),
    [sym_bool] = STATE(331),
    [sym_variable] = STATE(335),
    [sym_unop] = STATE(114),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(295),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1167),
    [sym_aritylessPredicateExpr] = STATE(923),
    [sym_varName] = STATE(333),
    [sym_aggId] = STATE(1122),
    [sym__lower_id] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(355),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(357),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(361),
    [sym_string] = ACTIONS(361),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(363),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(365),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(367),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(369),
    [sym_this] = ACTIONS(367),
    [sym_true] = ACTIONS(363),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [105] = {
    [sym_special_call] = STATE(289),
    [sym_prefix_cast] = STATE(289),
    [sym_unary_expr] = STATE(289),
    [sym_mul_expr] = STATE(289),
    [sym_add_expr] = STATE(289),
    [sym_in_expr] = STATE(289),
    [sym_comp_term] = STATE(289),
    [sym_instance_of] = STATE(289),
    [sym_negation] = STATE(289),
    [sym_if_term] = STATE(289),
    [sym_conjunction] = STATE(289),
    [sym_disjunction] = STATE(289),
    [sym_implication] = STATE(289),
    [sym_quantified] = STATE(289),
    [sym_specialId] = STATE(1165),
    [sym_quantifier] = STATE(1166),
    [sym_classless_predicate_call] = STATE(335),
    [sym_qualified_expr] = STATE(335),
    [sym_super_ref] = STATE(335),
    [sym_aggregate] = STATE(335),
    [sym_range] = STATE(335),
    [sym_par_expr] = STATE(335),
    [sym__exprOrTerm] = STATE(289),
    [sym__primary] = STATE(335),
    [sym_literal] = STATE(335),
    [sym_bool] = STATE(331),
    [sym_variable] = STATE(335),
    [sym_unop] = STATE(114),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(295),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1167),
    [sym_aritylessPredicateExpr] = STATE(923),
    [sym_varName] = STATE(333),
    [sym_aggId] = STATE(1122),
    [sym__lower_id] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(355),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(357),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(361),
    [sym_string] = ACTIONS(361),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(363),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(365),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(367),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(369),
    [sym_this] = ACTIONS(367),
    [sym_true] = ACTIONS(363),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [106] = {
    [sym_special_call] = STATE(280),
    [sym_prefix_cast] = STATE(280),
    [sym_unary_expr] = STATE(280),
    [sym_mul_expr] = STATE(280),
    [sym_add_expr] = STATE(280),
    [sym_in_expr] = STATE(280),
    [sym_comp_term] = STATE(280),
    [sym_instance_of] = STATE(280),
    [sym_negation] = STATE(280),
    [sym_if_term] = STATE(280),
    [sym_conjunction] = STATE(280),
    [sym_disjunction] = STATE(280),
    [sym_implication] = STATE(280),
    [sym_quantified] = STATE(280),
    [sym_specialId] = STATE(1165),
    [sym_quantifier] = STATE(1166),
    [sym_classless_predicate_call] = STATE(335),
    [sym_qualified_expr] = STATE(335),
    [sym_super_ref] = STATE(335),
    [sym_aggregate] = STATE(335),
    [sym_range] = STATE(335),
    [sym_par_expr] = STATE(335),
    [sym__exprOrTerm] = STATE(280),
    [sym__primary] = STATE(335),
    [sym_literal] = STATE(335),
    [sym_bool] = STATE(331),
    [sym_variable] = STATE(335),
    [sym_unop] = STATE(114),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(295),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1167),
    [sym_aritylessPredicateExpr] = STATE(923),
    [sym_varName] = STATE(333),
    [sym_aggId] = STATE(1122),
    [sym__lower_id] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(355),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(357),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(361),
    [sym_string] = ACTIONS(361),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(363),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(365),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(367),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(369),
    [sym_this] = ACTIONS(367),
    [sym_true] = ACTIONS(363),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [107] = {
    [sym_special_call] = STATE(292),
    [sym_prefix_cast] = STATE(292),
    [sym_unary_expr] = STATE(292),
    [sym_mul_expr] = STATE(292),
    [sym_add_expr] = STATE(292),
    [sym_in_expr] = STATE(292),
    [sym_comp_term] = STATE(292),
    [sym_instance_of] = STATE(292),
    [sym_negation] = STATE(292),
    [sym_if_term] = STATE(292),
    [sym_conjunction] = STATE(292),
    [sym_disjunction] = STATE(292),
    [sym_implication] = STATE(292),
    [sym_quantified] = STATE(292),
    [sym_specialId] = STATE(1165),
    [sym_quantifier] = STATE(1166),
    [sym_classless_predicate_call] = STATE(335),
    [sym_qualified_expr] = STATE(335),
    [sym_super_ref] = STATE(335),
    [sym_aggregate] = STATE(335),
    [sym_range] = STATE(335),
    [sym_par_expr] = STATE(335),
    [sym__exprOrTerm] = STATE(292),
    [sym__primary] = STATE(335),
    [sym_literal] = STATE(335),
    [sym_bool] = STATE(331),
    [sym_variable] = STATE(335),
    [sym_unop] = STATE(114),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(295),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1167),
    [sym_aritylessPredicateExpr] = STATE(923),
    [sym_varName] = STATE(333),
    [sym_aggId] = STATE(1122),
    [sym__lower_id] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(355),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(357),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(361),
    [sym_string] = ACTIONS(361),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(363),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(365),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(367),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(369),
    [sym_this] = ACTIONS(367),
    [sym_true] = ACTIONS(363),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [108] = {
    [sym_special_call] = STATE(646),
    [sym_prefix_cast] = STATE(646),
    [sym_unary_expr] = STATE(646),
    [sym_mul_expr] = STATE(646),
    [sym_add_expr] = STATE(646),
    [sym_in_expr] = STATE(646),
    [sym_comp_term] = STATE(646),
    [sym_instance_of] = STATE(646),
    [sym_negation] = STATE(646),
    [sym_if_term] = STATE(646),
    [sym_conjunction] = STATE(646),
    [sym_disjunction] = STATE(646),
    [sym_implication] = STATE(646),
    [sym_quantified] = STATE(646),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(646),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [109] = {
    [sym_special_call] = STATE(552),
    [sym_prefix_cast] = STATE(552),
    [sym_unary_expr] = STATE(552),
    [sym_mul_expr] = STATE(552),
    [sym_add_expr] = STATE(552),
    [sym_in_expr] = STATE(552),
    [sym_comp_term] = STATE(552),
    [sym_instance_of] = STATE(552),
    [sym_negation] = STATE(552),
    [sym_if_term] = STATE(552),
    [sym_conjunction] = STATE(552),
    [sym_disjunction] = STATE(552),
    [sym_implication] = STATE(552),
    [sym_quantified] = STATE(552),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(552),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [110] = {
    [sym_special_call] = STATE(661),
    [sym_prefix_cast] = STATE(661),
    [sym_unary_expr] = STATE(661),
    [sym_mul_expr] = STATE(661),
    [sym_add_expr] = STATE(661),
    [sym_in_expr] = STATE(661),
    [sym_comp_term] = STATE(661),
    [sym_instance_of] = STATE(661),
    [sym_negation] = STATE(661),
    [sym_if_term] = STATE(661),
    [sym_conjunction] = STATE(661),
    [sym_disjunction] = STATE(661),
    [sym_implication] = STATE(661),
    [sym_quantified] = STATE(661),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(661),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [111] = {
    [sym_special_call] = STATE(662),
    [sym_prefix_cast] = STATE(662),
    [sym_unary_expr] = STATE(662),
    [sym_mul_expr] = STATE(662),
    [sym_add_expr] = STATE(662),
    [sym_in_expr] = STATE(662),
    [sym_comp_term] = STATE(662),
    [sym_instance_of] = STATE(662),
    [sym_negation] = STATE(662),
    [sym_if_term] = STATE(662),
    [sym_conjunction] = STATE(662),
    [sym_disjunction] = STATE(662),
    [sym_implication] = STATE(662),
    [sym_quantified] = STATE(662),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(662),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [112] = {
    [sym_special_call] = STATE(554),
    [sym_prefix_cast] = STATE(554),
    [sym_unary_expr] = STATE(554),
    [sym_mul_expr] = STATE(554),
    [sym_add_expr] = STATE(554),
    [sym_in_expr] = STATE(554),
    [sym_comp_term] = STATE(554),
    [sym_instance_of] = STATE(554),
    [sym_negation] = STATE(554),
    [sym_if_term] = STATE(554),
    [sym_conjunction] = STATE(554),
    [sym_disjunction] = STATE(554),
    [sym_implication] = STATE(554),
    [sym_quantified] = STATE(554),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(554),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [113] = {
    [sym_special_call] = STATE(692),
    [sym_prefix_cast] = STATE(692),
    [sym_unary_expr] = STATE(692),
    [sym_mul_expr] = STATE(692),
    [sym_add_expr] = STATE(692),
    [sym_in_expr] = STATE(692),
    [sym_comp_term] = STATE(692),
    [sym_instance_of] = STATE(692),
    [sym_negation] = STATE(692),
    [sym_if_term] = STATE(692),
    [sym_conjunction] = STATE(692),
    [sym_disjunction] = STATE(692),
    [sym_implication] = STATE(692),
    [sym_quantified] = STATE(692),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(692),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [114] = {
    [sym_special_call] = STATE(291),
    [sym_prefix_cast] = STATE(291),
    [sym_unary_expr] = STATE(291),
    [sym_mul_expr] = STATE(291),
    [sym_add_expr] = STATE(291),
    [sym_in_expr] = STATE(291),
    [sym_comp_term] = STATE(291),
    [sym_instance_of] = STATE(291),
    [sym_negation] = STATE(291),
    [sym_if_term] = STATE(291),
    [sym_conjunction] = STATE(291),
    [sym_disjunction] = STATE(291),
    [sym_implication] = STATE(291),
    [sym_quantified] = STATE(291),
    [sym_specialId] = STATE(1165),
    [sym_quantifier] = STATE(1166),
    [sym_classless_predicate_call] = STATE(335),
    [sym_qualified_expr] = STATE(335),
    [sym_super_ref] = STATE(335),
    [sym_aggregate] = STATE(335),
    [sym_range] = STATE(335),
    [sym_par_expr] = STATE(335),
    [sym__exprOrTerm] = STATE(291),
    [sym__primary] = STATE(335),
    [sym_literal] = STATE(335),
    [sym_bool] = STATE(331),
    [sym_variable] = STATE(335),
    [sym_unop] = STATE(114),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(295),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1167),
    [sym_aritylessPredicateExpr] = STATE(923),
    [sym_varName] = STATE(333),
    [sym_aggId] = STATE(1122),
    [sym__lower_id] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(355),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(357),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(361),
    [sym_string] = ACTIONS(361),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(363),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(365),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(367),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(369),
    [sym_this] = ACTIONS(367),
    [sym_true] = ACTIONS(363),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [115] = {
    [sym_special_call] = STATE(276),
    [sym_prefix_cast] = STATE(276),
    [sym_unary_expr] = STATE(276),
    [sym_mul_expr] = STATE(276),
    [sym_add_expr] = STATE(276),
    [sym_in_expr] = STATE(276),
    [sym_comp_term] = STATE(276),
    [sym_instance_of] = STATE(276),
    [sym_negation] = STATE(276),
    [sym_if_term] = STATE(276),
    [sym_conjunction] = STATE(276),
    [sym_disjunction] = STATE(276),
    [sym_implication] = STATE(276),
    [sym_quantified] = STATE(276),
    [sym_specialId] = STATE(1165),
    [sym_quantifier] = STATE(1166),
    [sym_classless_predicate_call] = STATE(335),
    [sym_qualified_expr] = STATE(335),
    [sym_super_ref] = STATE(335),
    [sym_aggregate] = STATE(335),
    [sym_range] = STATE(335),
    [sym_par_expr] = STATE(335),
    [sym__exprOrTerm] = STATE(276),
    [sym__primary] = STATE(335),
    [sym_literal] = STATE(335),
    [sym_bool] = STATE(331),
    [sym_variable] = STATE(335),
    [sym_unop] = STATE(114),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(295),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1167),
    [sym_aritylessPredicateExpr] = STATE(923),
    [sym_varName] = STATE(333),
    [sym_aggId] = STATE(1122),
    [sym__lower_id] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(355),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(357),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(361),
    [sym_string] = ACTIONS(361),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(363),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(365),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(367),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(369),
    [sym_this] = ACTIONS(367),
    [sym_true] = ACTIONS(363),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [116] = {
    [sym_special_call] = STATE(699),
    [sym_prefix_cast] = STATE(699),
    [sym_unary_expr] = STATE(699),
    [sym_mul_expr] = STATE(699),
    [sym_add_expr] = STATE(699),
    [sym_in_expr] = STATE(699),
    [sym_comp_term] = STATE(699),
    [sym_instance_of] = STATE(699),
    [sym_negation] = STATE(699),
    [sym_if_term] = STATE(699),
    [sym_conjunction] = STATE(699),
    [sym_disjunction] = STATE(699),
    [sym_implication] = STATE(699),
    [sym_quantified] = STATE(699),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(699),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [117] = {
    [sym_special_call] = STATE(708),
    [sym_prefix_cast] = STATE(708),
    [sym_unary_expr] = STATE(708),
    [sym_mul_expr] = STATE(708),
    [sym_add_expr] = STATE(708),
    [sym_in_expr] = STATE(708),
    [sym_comp_term] = STATE(708),
    [sym_instance_of] = STATE(708),
    [sym_negation] = STATE(708),
    [sym_if_term] = STATE(708),
    [sym_conjunction] = STATE(708),
    [sym_disjunction] = STATE(708),
    [sym_implication] = STATE(708),
    [sym_quantified] = STATE(708),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(708),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [118] = {
    [sym_special_call] = STATE(671),
    [sym_prefix_cast] = STATE(671),
    [sym_unary_expr] = STATE(671),
    [sym_mul_expr] = STATE(671),
    [sym_add_expr] = STATE(671),
    [sym_in_expr] = STATE(671),
    [sym_comp_term] = STATE(671),
    [sym_instance_of] = STATE(671),
    [sym_negation] = STATE(671),
    [sym_if_term] = STATE(671),
    [sym_conjunction] = STATE(671),
    [sym_disjunction] = STATE(671),
    [sym_implication] = STATE(671),
    [sym_quantified] = STATE(671),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(671),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [119] = {
    [sym_special_call] = STATE(691),
    [sym_prefix_cast] = STATE(691),
    [sym_unary_expr] = STATE(691),
    [sym_mul_expr] = STATE(691),
    [sym_add_expr] = STATE(691),
    [sym_in_expr] = STATE(691),
    [sym_comp_term] = STATE(691),
    [sym_instance_of] = STATE(691),
    [sym_negation] = STATE(691),
    [sym_if_term] = STATE(691),
    [sym_conjunction] = STATE(691),
    [sym_disjunction] = STATE(691),
    [sym_implication] = STATE(691),
    [sym_quantified] = STATE(691),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(691),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [120] = {
    [sym_special_call] = STATE(710),
    [sym_prefix_cast] = STATE(710),
    [sym_unary_expr] = STATE(710),
    [sym_mul_expr] = STATE(710),
    [sym_add_expr] = STATE(710),
    [sym_in_expr] = STATE(710),
    [sym_comp_term] = STATE(710),
    [sym_instance_of] = STATE(710),
    [sym_negation] = STATE(710),
    [sym_if_term] = STATE(710),
    [sym_conjunction] = STATE(710),
    [sym_disjunction] = STATE(710),
    [sym_implication] = STATE(710),
    [sym_quantified] = STATE(710),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(710),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1097),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [121] = {
    [sym_special_call] = STATE(672),
    [sym_prefix_cast] = STATE(672),
    [sym_unary_expr] = STATE(672),
    [sym_mul_expr] = STATE(672),
    [sym_add_expr] = STATE(672),
    [sym_in_expr] = STATE(672),
    [sym_comp_term] = STATE(672),
    [sym_instance_of] = STATE(672),
    [sym_negation] = STATE(672),
    [sym_if_term] = STATE(672),
    [sym_conjunction] = STATE(672),
    [sym_disjunction] = STATE(672),
    [sym_implication] = STATE(672),
    [sym_quantified] = STATE(672),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(672),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [122] = {
    [sym_special_call] = STATE(287),
    [sym_prefix_cast] = STATE(287),
    [sym_unary_expr] = STATE(287),
    [sym_mul_expr] = STATE(287),
    [sym_add_expr] = STATE(287),
    [sym_in_expr] = STATE(287),
    [sym_comp_term] = STATE(287),
    [sym_instance_of] = STATE(287),
    [sym_negation] = STATE(287),
    [sym_if_term] = STATE(287),
    [sym_conjunction] = STATE(287),
    [sym_disjunction] = STATE(287),
    [sym_implication] = STATE(287),
    [sym_quantified] = STATE(287),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(287),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [123] = {
    [sym_special_call] = STATE(673),
    [sym_prefix_cast] = STATE(673),
    [sym_unary_expr] = STATE(673),
    [sym_mul_expr] = STATE(673),
    [sym_add_expr] = STATE(673),
    [sym_in_expr] = STATE(673),
    [sym_comp_term] = STATE(673),
    [sym_instance_of] = STATE(673),
    [sym_negation] = STATE(673),
    [sym_if_term] = STATE(673),
    [sym_conjunction] = STATE(673),
    [sym_disjunction] = STATE(673),
    [sym_implication] = STATE(673),
    [sym_quantified] = STATE(673),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(673),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [124] = {
    [sym_special_call] = STATE(587),
    [sym_prefix_cast] = STATE(587),
    [sym_unary_expr] = STATE(587),
    [sym_mul_expr] = STATE(587),
    [sym_add_expr] = STATE(587),
    [sym_in_expr] = STATE(587),
    [sym_comp_term] = STATE(587),
    [sym_instance_of] = STATE(587),
    [sym_negation] = STATE(587),
    [sym_if_term] = STATE(587),
    [sym_conjunction] = STATE(587),
    [sym_disjunction] = STATE(587),
    [sym_implication] = STATE(587),
    [sym_quantified] = STATE(587),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(587),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [125] = {
    [sym_special_call] = STATE(679),
    [sym_prefix_cast] = STATE(679),
    [sym_unary_expr] = STATE(679),
    [sym_mul_expr] = STATE(679),
    [sym_add_expr] = STATE(679),
    [sym_in_expr] = STATE(679),
    [sym_comp_term] = STATE(679),
    [sym_instance_of] = STATE(679),
    [sym_negation] = STATE(679),
    [sym_if_term] = STATE(679),
    [sym_conjunction] = STATE(679),
    [sym_disjunction] = STATE(679),
    [sym_implication] = STATE(679),
    [sym_quantified] = STATE(679),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(679),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [126] = {
    [sym_special_call] = STATE(546),
    [sym_prefix_cast] = STATE(546),
    [sym_unary_expr] = STATE(546),
    [sym_mul_expr] = STATE(546),
    [sym_add_expr] = STATE(546),
    [sym_in_expr] = STATE(546),
    [sym_comp_term] = STATE(546),
    [sym_instance_of] = STATE(546),
    [sym_negation] = STATE(546),
    [sym_if_term] = STATE(546),
    [sym_conjunction] = STATE(546),
    [sym_disjunction] = STATE(546),
    [sym_implication] = STATE(546),
    [sym_quantified] = STATE(546),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(546),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [127] = {
    [sym_special_call] = STATE(664),
    [sym_prefix_cast] = STATE(664),
    [sym_unary_expr] = STATE(664),
    [sym_mul_expr] = STATE(664),
    [sym_add_expr] = STATE(664),
    [sym_in_expr] = STATE(664),
    [sym_comp_term] = STATE(664),
    [sym_instance_of] = STATE(664),
    [sym_negation] = STATE(664),
    [sym_if_term] = STATE(664),
    [sym_conjunction] = STATE(664),
    [sym_disjunction] = STATE(664),
    [sym_implication] = STATE(664),
    [sym_quantified] = STATE(664),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(664),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [128] = {
    [sym_special_call] = STATE(663),
    [sym_prefix_cast] = STATE(663),
    [sym_unary_expr] = STATE(663),
    [sym_mul_expr] = STATE(663),
    [sym_add_expr] = STATE(663),
    [sym_in_expr] = STATE(663),
    [sym_comp_term] = STATE(663),
    [sym_instance_of] = STATE(663),
    [sym_negation] = STATE(663),
    [sym_if_term] = STATE(663),
    [sym_conjunction] = STATE(663),
    [sym_disjunction] = STATE(663),
    [sym_implication] = STATE(663),
    [sym_quantified] = STATE(663),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(663),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [129] = {
    [sym_special_call] = STATE(596),
    [sym_prefix_cast] = STATE(596),
    [sym_unary_expr] = STATE(596),
    [sym_mul_expr] = STATE(596),
    [sym_add_expr] = STATE(596),
    [sym_in_expr] = STATE(596),
    [sym_comp_term] = STATE(596),
    [sym_instance_of] = STATE(596),
    [sym_negation] = STATE(596),
    [sym_if_term] = STATE(596),
    [sym_conjunction] = STATE(596),
    [sym_disjunction] = STATE(596),
    [sym_implication] = STATE(596),
    [sym_quantified] = STATE(596),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(596),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [130] = {
    [sym_special_call] = STATE(700),
    [sym_prefix_cast] = STATE(700),
    [sym_unary_expr] = STATE(700),
    [sym_mul_expr] = STATE(700),
    [sym_add_expr] = STATE(700),
    [sym_in_expr] = STATE(700),
    [sym_comp_term] = STATE(700),
    [sym_instance_of] = STATE(700),
    [sym_negation] = STATE(700),
    [sym_if_term] = STATE(700),
    [sym_conjunction] = STATE(700),
    [sym_disjunction] = STATE(700),
    [sym_implication] = STATE(700),
    [sym_quantified] = STATE(700),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(700),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [131] = {
    [sym_special_call] = STATE(704),
    [sym_prefix_cast] = STATE(704),
    [sym_unary_expr] = STATE(704),
    [sym_mul_expr] = STATE(704),
    [sym_add_expr] = STATE(704),
    [sym_in_expr] = STATE(704),
    [sym_comp_term] = STATE(704),
    [sym_instance_of] = STATE(704),
    [sym_negation] = STATE(704),
    [sym_if_term] = STATE(704),
    [sym_conjunction] = STATE(704),
    [sym_disjunction] = STATE(704),
    [sym_implication] = STATE(704),
    [sym_quantified] = STATE(704),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(704),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [132] = {
    [sym_special_call] = STATE(715),
    [sym_prefix_cast] = STATE(715),
    [sym_unary_expr] = STATE(715),
    [sym_mul_expr] = STATE(715),
    [sym_add_expr] = STATE(715),
    [sym_in_expr] = STATE(715),
    [sym_comp_term] = STATE(715),
    [sym_instance_of] = STATE(715),
    [sym_negation] = STATE(715),
    [sym_if_term] = STATE(715),
    [sym_conjunction] = STATE(715),
    [sym_disjunction] = STATE(715),
    [sym_implication] = STATE(715),
    [sym_quantified] = STATE(715),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(715),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [133] = {
    [sym_special_call] = STATE(569),
    [sym_prefix_cast] = STATE(569),
    [sym_unary_expr] = STATE(569),
    [sym_mul_expr] = STATE(569),
    [sym_add_expr] = STATE(569),
    [sym_in_expr] = STATE(569),
    [sym_comp_term] = STATE(569),
    [sym_instance_of] = STATE(569),
    [sym_negation] = STATE(569),
    [sym_if_term] = STATE(569),
    [sym_conjunction] = STATE(569),
    [sym_disjunction] = STATE(569),
    [sym_implication] = STATE(569),
    [sym_quantified] = STATE(569),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(569),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [134] = {
    [sym_special_call] = STATE(717),
    [sym_prefix_cast] = STATE(717),
    [sym_unary_expr] = STATE(717),
    [sym_mul_expr] = STATE(717),
    [sym_add_expr] = STATE(717),
    [sym_in_expr] = STATE(717),
    [sym_comp_term] = STATE(717),
    [sym_instance_of] = STATE(717),
    [sym_negation] = STATE(717),
    [sym_if_term] = STATE(717),
    [sym_conjunction] = STATE(717),
    [sym_disjunction] = STATE(717),
    [sym_implication] = STATE(717),
    [sym_quantified] = STATE(717),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(717),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1102),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [135] = {
    [sym_special_call] = STATE(285),
    [sym_prefix_cast] = STATE(285),
    [sym_unary_expr] = STATE(285),
    [sym_mul_expr] = STATE(285),
    [sym_add_expr] = STATE(285),
    [sym_in_expr] = STATE(285),
    [sym_comp_term] = STATE(285),
    [sym_instance_of] = STATE(285),
    [sym_negation] = STATE(285),
    [sym_if_term] = STATE(285),
    [sym_conjunction] = STATE(285),
    [sym_disjunction] = STATE(285),
    [sym_implication] = STATE(285),
    [sym_quantified] = STATE(285),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(285),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [136] = {
    [sym_special_call] = STATE(722),
    [sym_prefix_cast] = STATE(722),
    [sym_unary_expr] = STATE(722),
    [sym_mul_expr] = STATE(722),
    [sym_add_expr] = STATE(722),
    [sym_in_expr] = STATE(722),
    [sym_comp_term] = STATE(722),
    [sym_instance_of] = STATE(722),
    [sym_negation] = STATE(722),
    [sym_if_term] = STATE(722),
    [sym_conjunction] = STATE(722),
    [sym_disjunction] = STATE(722),
    [sym_implication] = STATE(722),
    [sym_quantified] = STATE(722),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(722),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [137] = {
    [sym_special_call] = STATE(282),
    [sym_prefix_cast] = STATE(282),
    [sym_unary_expr] = STATE(282),
    [sym_mul_expr] = STATE(282),
    [sym_add_expr] = STATE(282),
    [sym_in_expr] = STATE(282),
    [sym_comp_term] = STATE(282),
    [sym_instance_of] = STATE(282),
    [sym_negation] = STATE(282),
    [sym_if_term] = STATE(282),
    [sym_conjunction] = STATE(282),
    [sym_disjunction] = STATE(282),
    [sym_implication] = STATE(282),
    [sym_quantified] = STATE(282),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(282),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [138] = {
    [sym_special_call] = STATE(244),
    [sym_prefix_cast] = STATE(244),
    [sym_unary_expr] = STATE(244),
    [sym_mul_expr] = STATE(244),
    [sym_add_expr] = STATE(244),
    [sym_in_expr] = STATE(244),
    [sym_comp_term] = STATE(244),
    [sym_instance_of] = STATE(244),
    [sym_negation] = STATE(244),
    [sym_if_term] = STATE(244),
    [sym_conjunction] = STATE(244),
    [sym_disjunction] = STATE(244),
    [sym_implication] = STATE(244),
    [sym_quantified] = STATE(244),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(244),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [139] = {
    [sym_special_call] = STATE(689),
    [sym_prefix_cast] = STATE(689),
    [sym_unary_expr] = STATE(689),
    [sym_mul_expr] = STATE(689),
    [sym_add_expr] = STATE(689),
    [sym_in_expr] = STATE(689),
    [sym_comp_term] = STATE(689),
    [sym_instance_of] = STATE(689),
    [sym_negation] = STATE(689),
    [sym_if_term] = STATE(689),
    [sym_conjunction] = STATE(689),
    [sym_disjunction] = STATE(689),
    [sym_implication] = STATE(689),
    [sym_quantified] = STATE(689),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(689),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [140] = {
    [sym_special_call] = STATE(269),
    [sym_prefix_cast] = STATE(269),
    [sym_unary_expr] = STATE(269),
    [sym_mul_expr] = STATE(269),
    [sym_add_expr] = STATE(269),
    [sym_in_expr] = STATE(269),
    [sym_comp_term] = STATE(269),
    [sym_instance_of] = STATE(269),
    [sym_negation] = STATE(269),
    [sym_if_term] = STATE(269),
    [sym_conjunction] = STATE(269),
    [sym_disjunction] = STATE(269),
    [sym_implication] = STATE(269),
    [sym_quantified] = STATE(269),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(269),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [141] = {
    [sym_special_call] = STATE(281),
    [sym_prefix_cast] = STATE(281),
    [sym_unary_expr] = STATE(281),
    [sym_mul_expr] = STATE(281),
    [sym_add_expr] = STATE(281),
    [sym_in_expr] = STATE(281),
    [sym_comp_term] = STATE(281),
    [sym_instance_of] = STATE(281),
    [sym_negation] = STATE(281),
    [sym_if_term] = STATE(281),
    [sym_conjunction] = STATE(281),
    [sym_disjunction] = STATE(281),
    [sym_implication] = STATE(281),
    [sym_quantified] = STATE(281),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(281),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [142] = {
    [sym_special_call] = STATE(508),
    [sym_prefix_cast] = STATE(508),
    [sym_unary_expr] = STATE(508),
    [sym_mul_expr] = STATE(508),
    [sym_add_expr] = STATE(508),
    [sym_in_expr] = STATE(508),
    [sym_comp_term] = STATE(508),
    [sym_instance_of] = STATE(508),
    [sym_negation] = STATE(508),
    [sym_if_term] = STATE(508),
    [sym_conjunction] = STATE(508),
    [sym_disjunction] = STATE(508),
    [sym_implication] = STATE(508),
    [sym_quantified] = STATE(508),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(508),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [143] = {
    [sym_special_call] = STATE(697),
    [sym_prefix_cast] = STATE(697),
    [sym_unary_expr] = STATE(697),
    [sym_mul_expr] = STATE(697),
    [sym_add_expr] = STATE(697),
    [sym_in_expr] = STATE(697),
    [sym_comp_term] = STATE(697),
    [sym_instance_of] = STATE(697),
    [sym_negation] = STATE(697),
    [sym_if_term] = STATE(697),
    [sym_conjunction] = STATE(697),
    [sym_disjunction] = STATE(697),
    [sym_implication] = STATE(697),
    [sym_quantified] = STATE(697),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(697),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [144] = {
    [sym_special_call] = STATE(698),
    [sym_prefix_cast] = STATE(698),
    [sym_unary_expr] = STATE(698),
    [sym_mul_expr] = STATE(698),
    [sym_add_expr] = STATE(698),
    [sym_in_expr] = STATE(698),
    [sym_comp_term] = STATE(698),
    [sym_instance_of] = STATE(698),
    [sym_negation] = STATE(698),
    [sym_if_term] = STATE(698),
    [sym_conjunction] = STATE(698),
    [sym_disjunction] = STATE(698),
    [sym_implication] = STATE(698),
    [sym_quantified] = STATE(698),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(698),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [145] = {
    [sym_special_call] = STATE(268),
    [sym_prefix_cast] = STATE(268),
    [sym_unary_expr] = STATE(268),
    [sym_mul_expr] = STATE(268),
    [sym_add_expr] = STATE(268),
    [sym_in_expr] = STATE(268),
    [sym_comp_term] = STATE(268),
    [sym_instance_of] = STATE(268),
    [sym_negation] = STATE(268),
    [sym_if_term] = STATE(268),
    [sym_conjunction] = STATE(268),
    [sym_disjunction] = STATE(268),
    [sym_implication] = STATE(268),
    [sym_quantified] = STATE(268),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(268),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [146] = {
    [sym_special_call] = STATE(279),
    [sym_prefix_cast] = STATE(279),
    [sym_unary_expr] = STATE(279),
    [sym_mul_expr] = STATE(279),
    [sym_add_expr] = STATE(279),
    [sym_in_expr] = STATE(279),
    [sym_comp_term] = STATE(279),
    [sym_instance_of] = STATE(279),
    [sym_negation] = STATE(279),
    [sym_if_term] = STATE(279),
    [sym_conjunction] = STATE(279),
    [sym_disjunction] = STATE(279),
    [sym_implication] = STATE(279),
    [sym_quantified] = STATE(279),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(279),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [147] = {
    [sym_special_call] = STATE(588),
    [sym_prefix_cast] = STATE(588),
    [sym_unary_expr] = STATE(588),
    [sym_mul_expr] = STATE(588),
    [sym_add_expr] = STATE(588),
    [sym_in_expr] = STATE(588),
    [sym_comp_term] = STATE(588),
    [sym_instance_of] = STATE(588),
    [sym_negation] = STATE(588),
    [sym_if_term] = STATE(588),
    [sym_conjunction] = STATE(588),
    [sym_disjunction] = STATE(588),
    [sym_implication] = STATE(588),
    [sym_quantified] = STATE(588),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(588),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [148] = {
    [sym_special_call] = STATE(687),
    [sym_prefix_cast] = STATE(687),
    [sym_unary_expr] = STATE(687),
    [sym_mul_expr] = STATE(687),
    [sym_add_expr] = STATE(687),
    [sym_in_expr] = STATE(687),
    [sym_comp_term] = STATE(687),
    [sym_instance_of] = STATE(687),
    [sym_negation] = STATE(687),
    [sym_if_term] = STATE(687),
    [sym_conjunction] = STATE(687),
    [sym_disjunction] = STATE(687),
    [sym_implication] = STATE(687),
    [sym_quantified] = STATE(687),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(687),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1113),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [149] = {
    [sym_special_call] = STATE(723),
    [sym_prefix_cast] = STATE(723),
    [sym_unary_expr] = STATE(723),
    [sym_mul_expr] = STATE(723),
    [sym_add_expr] = STATE(723),
    [sym_in_expr] = STATE(723),
    [sym_comp_term] = STATE(723),
    [sym_instance_of] = STATE(723),
    [sym_negation] = STATE(723),
    [sym_if_term] = STATE(723),
    [sym_conjunction] = STATE(723),
    [sym_disjunction] = STATE(723),
    [sym_implication] = STATE(723),
    [sym_quantified] = STATE(723),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(723),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [150] = {
    [sym_special_call] = STATE(277),
    [sym_prefix_cast] = STATE(277),
    [sym_unary_expr] = STATE(277),
    [sym_mul_expr] = STATE(277),
    [sym_add_expr] = STATE(277),
    [sym_in_expr] = STATE(277),
    [sym_comp_term] = STATE(277),
    [sym_instance_of] = STATE(277),
    [sym_negation] = STATE(277),
    [sym_if_term] = STATE(277),
    [sym_conjunction] = STATE(277),
    [sym_disjunction] = STATE(277),
    [sym_implication] = STATE(277),
    [sym_quantified] = STATE(277),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(277),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [151] = {
    [sym_special_call] = STATE(266),
    [sym_prefix_cast] = STATE(266),
    [sym_unary_expr] = STATE(266),
    [sym_mul_expr] = STATE(266),
    [sym_add_expr] = STATE(266),
    [sym_in_expr] = STATE(266),
    [sym_comp_term] = STATE(266),
    [sym_instance_of] = STATE(266),
    [sym_negation] = STATE(266),
    [sym_if_term] = STATE(266),
    [sym_conjunction] = STATE(266),
    [sym_disjunction] = STATE(266),
    [sym_implication] = STATE(266),
    [sym_quantified] = STATE(266),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(266),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [152] = {
    [sym_special_call] = STATE(705),
    [sym_prefix_cast] = STATE(705),
    [sym_unary_expr] = STATE(705),
    [sym_mul_expr] = STATE(705),
    [sym_add_expr] = STATE(705),
    [sym_in_expr] = STATE(705),
    [sym_comp_term] = STATE(705),
    [sym_instance_of] = STATE(705),
    [sym_negation] = STATE(705),
    [sym_if_term] = STATE(705),
    [sym_conjunction] = STATE(705),
    [sym_disjunction] = STATE(705),
    [sym_implication] = STATE(705),
    [sym_quantified] = STATE(705),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(705),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [153] = {
    [sym_special_call] = STATE(579),
    [sym_prefix_cast] = STATE(579),
    [sym_unary_expr] = STATE(579),
    [sym_mul_expr] = STATE(579),
    [sym_add_expr] = STATE(579),
    [sym_in_expr] = STATE(579),
    [sym_comp_term] = STATE(579),
    [sym_instance_of] = STATE(579),
    [sym_negation] = STATE(579),
    [sym_if_term] = STATE(579),
    [sym_conjunction] = STATE(579),
    [sym_disjunction] = STATE(579),
    [sym_implication] = STATE(579),
    [sym_quantified] = STATE(579),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(579),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [154] = {
    [sym_special_call] = STATE(556),
    [sym_prefix_cast] = STATE(556),
    [sym_unary_expr] = STATE(556),
    [sym_mul_expr] = STATE(556),
    [sym_add_expr] = STATE(556),
    [sym_in_expr] = STATE(556),
    [sym_comp_term] = STATE(556),
    [sym_instance_of] = STATE(556),
    [sym_negation] = STATE(556),
    [sym_if_term] = STATE(556),
    [sym_conjunction] = STATE(556),
    [sym_disjunction] = STATE(556),
    [sym_implication] = STATE(556),
    [sym_quantified] = STATE(556),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(556),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [155] = {
    [sym_special_call] = STATE(545),
    [sym_prefix_cast] = STATE(545),
    [sym_unary_expr] = STATE(545),
    [sym_mul_expr] = STATE(545),
    [sym_add_expr] = STATE(545),
    [sym_in_expr] = STATE(545),
    [sym_comp_term] = STATE(545),
    [sym_instance_of] = STATE(545),
    [sym_negation] = STATE(545),
    [sym_if_term] = STATE(545),
    [sym_conjunction] = STATE(545),
    [sym_disjunction] = STATE(545),
    [sym_implication] = STATE(545),
    [sym_quantified] = STATE(545),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(545),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [156] = {
    [sym_special_call] = STATE(514),
    [sym_prefix_cast] = STATE(514),
    [sym_unary_expr] = STATE(514),
    [sym_mul_expr] = STATE(514),
    [sym_add_expr] = STATE(514),
    [sym_in_expr] = STATE(514),
    [sym_comp_term] = STATE(514),
    [sym_instance_of] = STATE(514),
    [sym_negation] = STATE(514),
    [sym_if_term] = STATE(514),
    [sym_conjunction] = STATE(514),
    [sym_disjunction] = STATE(514),
    [sym_implication] = STATE(514),
    [sym_quantified] = STATE(514),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(514),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [157] = {
    [sym_special_call] = STATE(729),
    [sym_prefix_cast] = STATE(729),
    [sym_unary_expr] = STATE(729),
    [sym_mul_expr] = STATE(729),
    [sym_add_expr] = STATE(729),
    [sym_in_expr] = STATE(729),
    [sym_comp_term] = STATE(729),
    [sym_instance_of] = STATE(729),
    [sym_negation] = STATE(729),
    [sym_if_term] = STATE(729),
    [sym_conjunction] = STATE(729),
    [sym_disjunction] = STATE(729),
    [sym_implication] = STATE(729),
    [sym_quantified] = STATE(729),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(729),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [158] = {
    [sym_special_call] = STATE(732),
    [sym_prefix_cast] = STATE(732),
    [sym_unary_expr] = STATE(732),
    [sym_mul_expr] = STATE(732),
    [sym_add_expr] = STATE(732),
    [sym_in_expr] = STATE(732),
    [sym_comp_term] = STATE(732),
    [sym_instance_of] = STATE(732),
    [sym_negation] = STATE(732),
    [sym_if_term] = STATE(732),
    [sym_conjunction] = STATE(732),
    [sym_disjunction] = STATE(732),
    [sym_implication] = STATE(732),
    [sym_quantified] = STATE(732),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(732),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [159] = {
    [sym_special_call] = STATE(513),
    [sym_prefix_cast] = STATE(513),
    [sym_unary_expr] = STATE(513),
    [sym_mul_expr] = STATE(513),
    [sym_add_expr] = STATE(513),
    [sym_in_expr] = STATE(513),
    [sym_comp_term] = STATE(513),
    [sym_instance_of] = STATE(513),
    [sym_negation] = STATE(513),
    [sym_if_term] = STATE(513),
    [sym_conjunction] = STATE(513),
    [sym_disjunction] = STATE(513),
    [sym_implication] = STATE(513),
    [sym_quantified] = STATE(513),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(513),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [160] = {
    [sym_special_call] = STATE(534),
    [sym_prefix_cast] = STATE(534),
    [sym_unary_expr] = STATE(534),
    [sym_mul_expr] = STATE(534),
    [sym_add_expr] = STATE(534),
    [sym_in_expr] = STATE(534),
    [sym_comp_term] = STATE(534),
    [sym_instance_of] = STATE(534),
    [sym_negation] = STATE(534),
    [sym_if_term] = STATE(534),
    [sym_conjunction] = STATE(534),
    [sym_disjunction] = STATE(534),
    [sym_implication] = STATE(534),
    [sym_quantified] = STATE(534),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(534),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [161] = {
    [sym_special_call] = STATE(570),
    [sym_prefix_cast] = STATE(570),
    [sym_unary_expr] = STATE(570),
    [sym_mul_expr] = STATE(570),
    [sym_add_expr] = STATE(570),
    [sym_in_expr] = STATE(570),
    [sym_comp_term] = STATE(570),
    [sym_instance_of] = STATE(570),
    [sym_negation] = STATE(570),
    [sym_if_term] = STATE(570),
    [sym_conjunction] = STATE(570),
    [sym_disjunction] = STATE(570),
    [sym_implication] = STATE(570),
    [sym_quantified] = STATE(570),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(570),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [162] = {
    [sym_special_call] = STATE(695),
    [sym_prefix_cast] = STATE(695),
    [sym_unary_expr] = STATE(695),
    [sym_mul_expr] = STATE(695),
    [sym_add_expr] = STATE(695),
    [sym_in_expr] = STATE(695),
    [sym_comp_term] = STATE(695),
    [sym_instance_of] = STATE(695),
    [sym_negation] = STATE(695),
    [sym_if_term] = STATE(695),
    [sym_conjunction] = STATE(695),
    [sym_disjunction] = STATE(695),
    [sym_implication] = STATE(695),
    [sym_quantified] = STATE(695),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(695),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [163] = {
    [sym_special_call] = STATE(536),
    [sym_prefix_cast] = STATE(536),
    [sym_unary_expr] = STATE(536),
    [sym_mul_expr] = STATE(536),
    [sym_add_expr] = STATE(536),
    [sym_in_expr] = STATE(536),
    [sym_comp_term] = STATE(536),
    [sym_instance_of] = STATE(536),
    [sym_negation] = STATE(536),
    [sym_if_term] = STATE(536),
    [sym_conjunction] = STATE(536),
    [sym_disjunction] = STATE(536),
    [sym_implication] = STATE(536),
    [sym_quantified] = STATE(536),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(536),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [164] = {
    [sym_special_call] = STATE(537),
    [sym_prefix_cast] = STATE(537),
    [sym_unary_expr] = STATE(537),
    [sym_mul_expr] = STATE(537),
    [sym_add_expr] = STATE(537),
    [sym_in_expr] = STATE(537),
    [sym_comp_term] = STATE(537),
    [sym_instance_of] = STATE(537),
    [sym_negation] = STATE(537),
    [sym_if_term] = STATE(537),
    [sym_conjunction] = STATE(537),
    [sym_disjunction] = STATE(537),
    [sym_implication] = STATE(537),
    [sym_quantified] = STATE(537),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(537),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [165] = {
    [sym_special_call] = STATE(696),
    [sym_prefix_cast] = STATE(696),
    [sym_unary_expr] = STATE(696),
    [sym_mul_expr] = STATE(696),
    [sym_add_expr] = STATE(696),
    [sym_in_expr] = STATE(696),
    [sym_comp_term] = STATE(696),
    [sym_instance_of] = STATE(696),
    [sym_negation] = STATE(696),
    [sym_if_term] = STATE(696),
    [sym_conjunction] = STATE(696),
    [sym_disjunction] = STATE(696),
    [sym_implication] = STATE(696),
    [sym_quantified] = STATE(696),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(696),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [166] = {
    [sym_special_call] = STATE(538),
    [sym_prefix_cast] = STATE(538),
    [sym_unary_expr] = STATE(538),
    [sym_mul_expr] = STATE(538),
    [sym_add_expr] = STATE(538),
    [sym_in_expr] = STATE(538),
    [sym_comp_term] = STATE(538),
    [sym_instance_of] = STATE(538),
    [sym_negation] = STATE(538),
    [sym_if_term] = STATE(538),
    [sym_conjunction] = STATE(538),
    [sym_disjunction] = STATE(538),
    [sym_implication] = STATE(538),
    [sym_quantified] = STATE(538),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(538),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [167] = {
    [sym_special_call] = STATE(286),
    [sym_prefix_cast] = STATE(286),
    [sym_unary_expr] = STATE(286),
    [sym_mul_expr] = STATE(286),
    [sym_add_expr] = STATE(286),
    [sym_in_expr] = STATE(286),
    [sym_comp_term] = STATE(286),
    [sym_instance_of] = STATE(286),
    [sym_negation] = STATE(286),
    [sym_if_term] = STATE(286),
    [sym_conjunction] = STATE(286),
    [sym_disjunction] = STATE(286),
    [sym_implication] = STATE(286),
    [sym_quantified] = STATE(286),
    [sym_specialId] = STATE(1165),
    [sym_quantifier] = STATE(1166),
    [sym_classless_predicate_call] = STATE(335),
    [sym_qualified_expr] = STATE(335),
    [sym_super_ref] = STATE(335),
    [sym_aggregate] = STATE(335),
    [sym_range] = STATE(335),
    [sym_par_expr] = STATE(335),
    [sym__exprOrTerm] = STATE(286),
    [sym__primary] = STATE(335),
    [sym_literal] = STATE(335),
    [sym_bool] = STATE(331),
    [sym_variable] = STATE(335),
    [sym_unop] = STATE(114),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(295),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1167),
    [sym_aritylessPredicateExpr] = STATE(923),
    [sym_varName] = STATE(333),
    [sym_aggId] = STATE(1122),
    [sym__lower_id] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(355),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(357),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(361),
    [sym_string] = ACTIONS(361),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(363),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(365),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(367),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(369),
    [sym_this] = ACTIONS(367),
    [sym_true] = ACTIONS(363),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [168] = {
    [sym_special_call] = STATE(539),
    [sym_prefix_cast] = STATE(539),
    [sym_unary_expr] = STATE(539),
    [sym_mul_expr] = STATE(539),
    [sym_add_expr] = STATE(539),
    [sym_in_expr] = STATE(539),
    [sym_comp_term] = STATE(539),
    [sym_instance_of] = STATE(539),
    [sym_negation] = STATE(539),
    [sym_if_term] = STATE(539),
    [sym_conjunction] = STATE(539),
    [sym_disjunction] = STATE(539),
    [sym_implication] = STATE(539),
    [sym_quantified] = STATE(539),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(539),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [169] = {
    [sym_special_call] = STATE(649),
    [sym_prefix_cast] = STATE(649),
    [sym_unary_expr] = STATE(649),
    [sym_mul_expr] = STATE(649),
    [sym_add_expr] = STATE(649),
    [sym_in_expr] = STATE(649),
    [sym_comp_term] = STATE(649),
    [sym_instance_of] = STATE(649),
    [sym_negation] = STATE(649),
    [sym_if_term] = STATE(649),
    [sym_conjunction] = STATE(649),
    [sym_disjunction] = STATE(649),
    [sym_implication] = STATE(649),
    [sym_quantified] = STATE(649),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(649),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [170] = {
    [sym_special_call] = STATE(741),
    [sym_prefix_cast] = STATE(741),
    [sym_unary_expr] = STATE(741),
    [sym_mul_expr] = STATE(741),
    [sym_add_expr] = STATE(741),
    [sym_in_expr] = STATE(741),
    [sym_comp_term] = STATE(741),
    [sym_instance_of] = STATE(741),
    [sym_negation] = STATE(741),
    [sym_if_term] = STATE(741),
    [sym_conjunction] = STATE(741),
    [sym_disjunction] = STATE(741),
    [sym_implication] = STATE(741),
    [sym_quantified] = STATE(741),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(741),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1125),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [171] = {
    [sym_special_call] = STATE(711),
    [sym_prefix_cast] = STATE(711),
    [sym_unary_expr] = STATE(711),
    [sym_mul_expr] = STATE(711),
    [sym_add_expr] = STATE(711),
    [sym_in_expr] = STATE(711),
    [sym_comp_term] = STATE(711),
    [sym_instance_of] = STATE(711),
    [sym_negation] = STATE(711),
    [sym_if_term] = STATE(711),
    [sym_conjunction] = STATE(711),
    [sym_disjunction] = STATE(711),
    [sym_implication] = STATE(711),
    [sym_quantified] = STATE(711),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(711),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [172] = {
    [sym_special_call] = STATE(713),
    [sym_prefix_cast] = STATE(713),
    [sym_unary_expr] = STATE(713),
    [sym_mul_expr] = STATE(713),
    [sym_add_expr] = STATE(713),
    [sym_in_expr] = STATE(713),
    [sym_comp_term] = STATE(713),
    [sym_instance_of] = STATE(713),
    [sym_negation] = STATE(713),
    [sym_if_term] = STATE(713),
    [sym_conjunction] = STATE(713),
    [sym_disjunction] = STATE(713),
    [sym_implication] = STATE(713),
    [sym_quantified] = STATE(713),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(713),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [173] = {
    [sym_special_call] = STATE(532),
    [sym_prefix_cast] = STATE(532),
    [sym_unary_expr] = STATE(532),
    [sym_mul_expr] = STATE(532),
    [sym_add_expr] = STATE(532),
    [sym_in_expr] = STATE(532),
    [sym_comp_term] = STATE(532),
    [sym_instance_of] = STATE(532),
    [sym_negation] = STATE(532),
    [sym_if_term] = STATE(532),
    [sym_conjunction] = STATE(532),
    [sym_disjunction] = STATE(532),
    [sym_implication] = STATE(532),
    [sym_quantified] = STATE(532),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(532),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [174] = {
    [sym_special_call] = STATE(535),
    [sym_prefix_cast] = STATE(535),
    [sym_unary_expr] = STATE(535),
    [sym_mul_expr] = STATE(535),
    [sym_add_expr] = STATE(535),
    [sym_in_expr] = STATE(535),
    [sym_comp_term] = STATE(535),
    [sym_instance_of] = STATE(535),
    [sym_negation] = STATE(535),
    [sym_if_term] = STATE(535),
    [sym_conjunction] = STATE(535),
    [sym_disjunction] = STATE(535),
    [sym_implication] = STATE(535),
    [sym_quantified] = STATE(535),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(535),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [175] = {
    [sym_special_call] = STATE(675),
    [sym_prefix_cast] = STATE(675),
    [sym_unary_expr] = STATE(675),
    [sym_mul_expr] = STATE(675),
    [sym_add_expr] = STATE(675),
    [sym_in_expr] = STATE(675),
    [sym_comp_term] = STATE(675),
    [sym_instance_of] = STATE(675),
    [sym_negation] = STATE(675),
    [sym_if_term] = STATE(675),
    [sym_conjunction] = STATE(675),
    [sym_disjunction] = STATE(675),
    [sym_implication] = STATE(675),
    [sym_quantified] = STATE(675),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(675),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [176] = {
    [sym_special_call] = STATE(647),
    [sym_prefix_cast] = STATE(647),
    [sym_unary_expr] = STATE(647),
    [sym_mul_expr] = STATE(647),
    [sym_add_expr] = STATE(647),
    [sym_in_expr] = STATE(647),
    [sym_comp_term] = STATE(647),
    [sym_instance_of] = STATE(647),
    [sym_negation] = STATE(647),
    [sym_if_term] = STATE(647),
    [sym_conjunction] = STATE(647),
    [sym_disjunction] = STATE(647),
    [sym_implication] = STATE(647),
    [sym_quantified] = STATE(647),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(647),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [177] = {
    [sym_special_call] = STATE(608),
    [sym_prefix_cast] = STATE(608),
    [sym_unary_expr] = STATE(608),
    [sym_mul_expr] = STATE(608),
    [sym_add_expr] = STATE(608),
    [sym_in_expr] = STATE(608),
    [sym_comp_term] = STATE(608),
    [sym_instance_of] = STATE(608),
    [sym_negation] = STATE(608),
    [sym_if_term] = STATE(608),
    [sym_conjunction] = STATE(608),
    [sym_disjunction] = STATE(608),
    [sym_implication] = STATE(608),
    [sym_quantified] = STATE(608),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(608),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [178] = {
    [sym_special_call] = STATE(616),
    [sym_prefix_cast] = STATE(616),
    [sym_unary_expr] = STATE(616),
    [sym_mul_expr] = STATE(616),
    [sym_add_expr] = STATE(616),
    [sym_in_expr] = STATE(616),
    [sym_comp_term] = STATE(616),
    [sym_instance_of] = STATE(616),
    [sym_negation] = STATE(616),
    [sym_if_term] = STATE(616),
    [sym_conjunction] = STATE(616),
    [sym_disjunction] = STATE(616),
    [sym_implication] = STATE(616),
    [sym_quantified] = STATE(616),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(616),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [179] = {
    [sym_special_call] = STATE(714),
    [sym_prefix_cast] = STATE(714),
    [sym_unary_expr] = STATE(714),
    [sym_mul_expr] = STATE(714),
    [sym_add_expr] = STATE(714),
    [sym_in_expr] = STATE(714),
    [sym_comp_term] = STATE(714),
    [sym_instance_of] = STATE(714),
    [sym_negation] = STATE(714),
    [sym_if_term] = STATE(714),
    [sym_conjunction] = STATE(714),
    [sym_disjunction] = STATE(714),
    [sym_implication] = STATE(714),
    [sym_quantified] = STATE(714),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(714),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [180] = {
    [sym_special_call] = STATE(531),
    [sym_prefix_cast] = STATE(531),
    [sym_unary_expr] = STATE(531),
    [sym_mul_expr] = STATE(531),
    [sym_add_expr] = STATE(531),
    [sym_in_expr] = STATE(531),
    [sym_comp_term] = STATE(531),
    [sym_instance_of] = STATE(531),
    [sym_negation] = STATE(531),
    [sym_if_term] = STATE(531),
    [sym_conjunction] = STATE(531),
    [sym_disjunction] = STATE(531),
    [sym_implication] = STATE(531),
    [sym_quantified] = STATE(531),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(531),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [181] = {
    [sym_special_call] = STATE(544),
    [sym_prefix_cast] = STATE(544),
    [sym_unary_expr] = STATE(544),
    [sym_mul_expr] = STATE(544),
    [sym_add_expr] = STATE(544),
    [sym_in_expr] = STATE(544),
    [sym_comp_term] = STATE(544),
    [sym_instance_of] = STATE(544),
    [sym_negation] = STATE(544),
    [sym_if_term] = STATE(544),
    [sym_conjunction] = STATE(544),
    [sym_disjunction] = STATE(544),
    [sym_implication] = STATE(544),
    [sym_quantified] = STATE(544),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(544),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [182] = {
    [sym_special_call] = STATE(520),
    [sym_prefix_cast] = STATE(520),
    [sym_unary_expr] = STATE(520),
    [sym_mul_expr] = STATE(520),
    [sym_add_expr] = STATE(520),
    [sym_in_expr] = STATE(520),
    [sym_comp_term] = STATE(520),
    [sym_instance_of] = STATE(520),
    [sym_negation] = STATE(520),
    [sym_if_term] = STATE(520),
    [sym_conjunction] = STATE(520),
    [sym_disjunction] = STATE(520),
    [sym_implication] = STATE(520),
    [sym_quantified] = STATE(520),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(520),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [183] = {
    [sym_special_call] = STATE(628),
    [sym_prefix_cast] = STATE(628),
    [sym_unary_expr] = STATE(628),
    [sym_mul_expr] = STATE(628),
    [sym_add_expr] = STATE(628),
    [sym_in_expr] = STATE(628),
    [sym_comp_term] = STATE(628),
    [sym_instance_of] = STATE(628),
    [sym_negation] = STATE(628),
    [sym_if_term] = STATE(628),
    [sym_conjunction] = STATE(628),
    [sym_disjunction] = STATE(628),
    [sym_implication] = STATE(628),
    [sym_quantified] = STATE(628),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(628),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [184] = {
    [sym_special_call] = STATE(644),
    [sym_prefix_cast] = STATE(644),
    [sym_unary_expr] = STATE(644),
    [sym_mul_expr] = STATE(644),
    [sym_add_expr] = STATE(644),
    [sym_in_expr] = STATE(644),
    [sym_comp_term] = STATE(644),
    [sym_instance_of] = STATE(644),
    [sym_negation] = STATE(644),
    [sym_if_term] = STATE(644),
    [sym_conjunction] = STATE(644),
    [sym_disjunction] = STATE(644),
    [sym_implication] = STATE(644),
    [sym_quantified] = STATE(644),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(644),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [185] = {
    [sym_special_call] = STATE(530),
    [sym_prefix_cast] = STATE(530),
    [sym_unary_expr] = STATE(530),
    [sym_mul_expr] = STATE(530),
    [sym_add_expr] = STATE(530),
    [sym_in_expr] = STATE(530),
    [sym_comp_term] = STATE(530),
    [sym_instance_of] = STATE(530),
    [sym_negation] = STATE(530),
    [sym_if_term] = STATE(530),
    [sym_conjunction] = STATE(530),
    [sym_disjunction] = STATE(530),
    [sym_implication] = STATE(530),
    [sym_quantified] = STATE(530),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(530),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [186] = {
    [sym_special_call] = STATE(522),
    [sym_prefix_cast] = STATE(522),
    [sym_unary_expr] = STATE(522),
    [sym_mul_expr] = STATE(522),
    [sym_add_expr] = STATE(522),
    [sym_in_expr] = STATE(522),
    [sym_comp_term] = STATE(522),
    [sym_instance_of] = STATE(522),
    [sym_negation] = STATE(522),
    [sym_if_term] = STATE(522),
    [sym_conjunction] = STATE(522),
    [sym_disjunction] = STATE(522),
    [sym_implication] = STATE(522),
    [sym_quantified] = STATE(522),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(522),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [187] = {
    [sym_special_call] = STATE(527),
    [sym_prefix_cast] = STATE(527),
    [sym_unary_expr] = STATE(527),
    [sym_mul_expr] = STATE(527),
    [sym_add_expr] = STATE(527),
    [sym_in_expr] = STATE(527),
    [sym_comp_term] = STATE(527),
    [sym_instance_of] = STATE(527),
    [sym_negation] = STATE(527),
    [sym_if_term] = STATE(527),
    [sym_conjunction] = STATE(527),
    [sym_disjunction] = STATE(527),
    [sym_implication] = STATE(527),
    [sym_quantified] = STATE(527),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(527),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [188] = {
    [sym_special_call] = STATE(529),
    [sym_prefix_cast] = STATE(529),
    [sym_unary_expr] = STATE(529),
    [sym_mul_expr] = STATE(529),
    [sym_add_expr] = STATE(529),
    [sym_in_expr] = STATE(529),
    [sym_comp_term] = STATE(529),
    [sym_instance_of] = STATE(529),
    [sym_negation] = STATE(529),
    [sym_if_term] = STATE(529),
    [sym_conjunction] = STATE(529),
    [sym_disjunction] = STATE(529),
    [sym_implication] = STATE(529),
    [sym_quantified] = STATE(529),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(529),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [189] = {
    [sym_special_call] = STATE(526),
    [sym_prefix_cast] = STATE(526),
    [sym_unary_expr] = STATE(526),
    [sym_mul_expr] = STATE(526),
    [sym_add_expr] = STATE(526),
    [sym_in_expr] = STATE(526),
    [sym_comp_term] = STATE(526),
    [sym_instance_of] = STATE(526),
    [sym_negation] = STATE(526),
    [sym_if_term] = STATE(526),
    [sym_conjunction] = STATE(526),
    [sym_disjunction] = STATE(526),
    [sym_implication] = STATE(526),
    [sym_quantified] = STATE(526),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(526),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [190] = {
    [sym_special_call] = STATE(521),
    [sym_prefix_cast] = STATE(521),
    [sym_unary_expr] = STATE(521),
    [sym_mul_expr] = STATE(521),
    [sym_add_expr] = STATE(521),
    [sym_in_expr] = STATE(521),
    [sym_comp_term] = STATE(521),
    [sym_instance_of] = STATE(521),
    [sym_negation] = STATE(521),
    [sym_if_term] = STATE(521),
    [sym_conjunction] = STATE(521),
    [sym_disjunction] = STATE(521),
    [sym_implication] = STATE(521),
    [sym_quantified] = STATE(521),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(521),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [191] = {
    [sym_special_call] = STATE(525),
    [sym_prefix_cast] = STATE(525),
    [sym_unary_expr] = STATE(525),
    [sym_mul_expr] = STATE(525),
    [sym_add_expr] = STATE(525),
    [sym_in_expr] = STATE(525),
    [sym_comp_term] = STATE(525),
    [sym_instance_of] = STATE(525),
    [sym_negation] = STATE(525),
    [sym_if_term] = STATE(525),
    [sym_conjunction] = STATE(525),
    [sym_disjunction] = STATE(525),
    [sym_implication] = STATE(525),
    [sym_quantified] = STATE(525),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(525),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [192] = {
    [sym_special_call] = STATE(267),
    [sym_prefix_cast] = STATE(267),
    [sym_unary_expr] = STATE(267),
    [sym_mul_expr] = STATE(267),
    [sym_add_expr] = STATE(267),
    [sym_in_expr] = STATE(267),
    [sym_comp_term] = STATE(267),
    [sym_instance_of] = STATE(267),
    [sym_negation] = STATE(267),
    [sym_if_term] = STATE(267),
    [sym_conjunction] = STATE(267),
    [sym_disjunction] = STATE(267),
    [sym_implication] = STATE(267),
    [sym_quantified] = STATE(267),
    [sym_specialId] = STATE(1185),
    [sym_quantifier] = STATE(1186),
    [sym_classless_predicate_call] = STATE(366),
    [sym_qualified_expr] = STATE(366),
    [sym_super_ref] = STATE(366),
    [sym_aggregate] = STATE(366),
    [sym_range] = STATE(366),
    [sym_par_expr] = STATE(366),
    [sym__exprOrTerm] = STATE(267),
    [sym__primary] = STATE(366),
    [sym_literal] = STATE(366),
    [sym_bool] = STATE(362),
    [sym_variable] = STATE(366),
    [sym_unop] = STATE(205),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(294),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1187),
    [sym_aritylessPredicateExpr] = STATE(939),
    [sym_varName] = STATE(364),
    [sym_aggId] = STATE(1117),
    [sym__lower_id] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_if] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(335),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(341),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(343),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(345),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(347),
    [sym_this] = ACTIONS(345),
    [sym_true] = ACTIONS(341),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [193] = {
    [sym_special_call] = STATE(640),
    [sym_prefix_cast] = STATE(640),
    [sym_unary_expr] = STATE(640),
    [sym_mul_expr] = STATE(640),
    [sym_add_expr] = STATE(640),
    [sym_in_expr] = STATE(640),
    [sym_comp_term] = STATE(640),
    [sym_instance_of] = STATE(640),
    [sym_negation] = STATE(640),
    [sym_if_term] = STATE(640),
    [sym_conjunction] = STATE(640),
    [sym_disjunction] = STATE(640),
    [sym_implication] = STATE(640),
    [sym_quantified] = STATE(640),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(640),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [194] = {
    [sym_special_call] = STATE(718),
    [sym_prefix_cast] = STATE(718),
    [sym_unary_expr] = STATE(718),
    [sym_mul_expr] = STATE(718),
    [sym_add_expr] = STATE(718),
    [sym_in_expr] = STATE(718),
    [sym_comp_term] = STATE(718),
    [sym_instance_of] = STATE(718),
    [sym_negation] = STATE(718),
    [sym_if_term] = STATE(718),
    [sym_conjunction] = STATE(718),
    [sym_disjunction] = STATE(718),
    [sym_implication] = STATE(718),
    [sym_quantified] = STATE(718),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(718),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [195] = {
    [sym_special_call] = STATE(719),
    [sym_prefix_cast] = STATE(719),
    [sym_unary_expr] = STATE(719),
    [sym_mul_expr] = STATE(719),
    [sym_add_expr] = STATE(719),
    [sym_in_expr] = STATE(719),
    [sym_comp_term] = STATE(719),
    [sym_instance_of] = STATE(719),
    [sym_negation] = STATE(719),
    [sym_if_term] = STATE(719),
    [sym_conjunction] = STATE(719),
    [sym_disjunction] = STATE(719),
    [sym_implication] = STATE(719),
    [sym_quantified] = STATE(719),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(719),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [196] = {
    [sym_special_call] = STATE(686),
    [sym_prefix_cast] = STATE(686),
    [sym_unary_expr] = STATE(686),
    [sym_mul_expr] = STATE(686),
    [sym_add_expr] = STATE(686),
    [sym_in_expr] = STATE(686),
    [sym_comp_term] = STATE(686),
    [sym_instance_of] = STATE(686),
    [sym_negation] = STATE(686),
    [sym_if_term] = STATE(686),
    [sym_conjunction] = STATE(686),
    [sym_disjunction] = STATE(686),
    [sym_implication] = STATE(686),
    [sym_quantified] = STATE(686),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(686),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1118),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [197] = {
    [sym_special_call] = STATE(740),
    [sym_prefix_cast] = STATE(740),
    [sym_unary_expr] = STATE(740),
    [sym_mul_expr] = STATE(740),
    [sym_add_expr] = STATE(740),
    [sym_in_expr] = STATE(740),
    [sym_comp_term] = STATE(740),
    [sym_instance_of] = STATE(740),
    [sym_negation] = STATE(740),
    [sym_if_term] = STATE(740),
    [sym_conjunction] = STATE(740),
    [sym_disjunction] = STATE(740),
    [sym_implication] = STATE(740),
    [sym_quantified] = STATE(740),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(740),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [198] = {
    [sym_special_call] = STATE(524),
    [sym_prefix_cast] = STATE(524),
    [sym_unary_expr] = STATE(524),
    [sym_mul_expr] = STATE(524),
    [sym_add_expr] = STATE(524),
    [sym_in_expr] = STATE(524),
    [sym_comp_term] = STATE(524),
    [sym_instance_of] = STATE(524),
    [sym_negation] = STATE(524),
    [sym_if_term] = STATE(524),
    [sym_conjunction] = STATE(524),
    [sym_disjunction] = STATE(524),
    [sym_implication] = STATE(524),
    [sym_quantified] = STATE(524),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(524),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [199] = {
    [sym_special_call] = STATE(523),
    [sym_prefix_cast] = STATE(523),
    [sym_unary_expr] = STATE(523),
    [sym_mul_expr] = STATE(523),
    [sym_add_expr] = STATE(523),
    [sym_in_expr] = STATE(523),
    [sym_comp_term] = STATE(523),
    [sym_instance_of] = STATE(523),
    [sym_negation] = STATE(523),
    [sym_if_term] = STATE(523),
    [sym_conjunction] = STATE(523),
    [sym_disjunction] = STATE(523),
    [sym_implication] = STATE(523),
    [sym_quantified] = STATE(523),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(523),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [200] = {
    [sym_special_call] = STATE(730),
    [sym_prefix_cast] = STATE(730),
    [sym_unary_expr] = STATE(730),
    [sym_mul_expr] = STATE(730),
    [sym_add_expr] = STATE(730),
    [sym_in_expr] = STATE(730),
    [sym_comp_term] = STATE(730),
    [sym_instance_of] = STATE(730),
    [sym_negation] = STATE(730),
    [sym_if_term] = STATE(730),
    [sym_conjunction] = STATE(730),
    [sym_disjunction] = STATE(730),
    [sym_implication] = STATE(730),
    [sym_quantified] = STATE(730),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(730),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [201] = {
    [sym_special_call] = STATE(707),
    [sym_prefix_cast] = STATE(707),
    [sym_unary_expr] = STATE(707),
    [sym_mul_expr] = STATE(707),
    [sym_add_expr] = STATE(707),
    [sym_in_expr] = STATE(707),
    [sym_comp_term] = STATE(707),
    [sym_instance_of] = STATE(707),
    [sym_negation] = STATE(707),
    [sym_if_term] = STATE(707),
    [sym_conjunction] = STATE(707),
    [sym_disjunction] = STATE(707),
    [sym_implication] = STATE(707),
    [sym_quantified] = STATE(707),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(707),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [202] = {
    [sym_special_call] = STATE(624),
    [sym_prefix_cast] = STATE(624),
    [sym_unary_expr] = STATE(624),
    [sym_mul_expr] = STATE(624),
    [sym_add_expr] = STATE(624),
    [sym_in_expr] = STATE(624),
    [sym_comp_term] = STATE(624),
    [sym_instance_of] = STATE(624),
    [sym_negation] = STATE(624),
    [sym_if_term] = STATE(624),
    [sym_conjunction] = STATE(624),
    [sym_disjunction] = STATE(624),
    [sym_implication] = STATE(624),
    [sym_quantified] = STATE(624),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(624),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [203] = {
    [sym_special_call] = STATE(670),
    [sym_prefix_cast] = STATE(670),
    [sym_unary_expr] = STATE(670),
    [sym_mul_expr] = STATE(670),
    [sym_add_expr] = STATE(670),
    [sym_in_expr] = STATE(670),
    [sym_comp_term] = STATE(670),
    [sym_instance_of] = STATE(670),
    [sym_negation] = STATE(670),
    [sym_if_term] = STATE(670),
    [sym_conjunction] = STATE(670),
    [sym_disjunction] = STATE(670),
    [sym_implication] = STATE(670),
    [sym_quantified] = STATE(670),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(670),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [204] = {
    [sym_special_call] = STATE(290),
    [sym_prefix_cast] = STATE(290),
    [sym_unary_expr] = STATE(290),
    [sym_mul_expr] = STATE(290),
    [sym_add_expr] = STATE(290),
    [sym_in_expr] = STATE(290),
    [sym_comp_term] = STATE(290),
    [sym_instance_of] = STATE(290),
    [sym_negation] = STATE(290),
    [sym_if_term] = STATE(290),
    [sym_conjunction] = STATE(290),
    [sym_disjunction] = STATE(290),
    [sym_implication] = STATE(290),
    [sym_quantified] = STATE(290),
    [sym_specialId] = STATE(1185),
    [sym_quantifier] = STATE(1186),
    [sym_classless_predicate_call] = STATE(366),
    [sym_qualified_expr] = STATE(366),
    [sym_super_ref] = STATE(366),
    [sym_aggregate] = STATE(366),
    [sym_range] = STATE(366),
    [sym_par_expr] = STATE(366),
    [sym__exprOrTerm] = STATE(290),
    [sym__primary] = STATE(366),
    [sym_literal] = STATE(366),
    [sym_bool] = STATE(362),
    [sym_variable] = STATE(366),
    [sym_unop] = STATE(205),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(294),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1187),
    [sym_aritylessPredicateExpr] = STATE(939),
    [sym_varName] = STATE(364),
    [sym_aggId] = STATE(1117),
    [sym__lower_id] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_if] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(335),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(341),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(343),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(345),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(347),
    [sym_this] = ACTIONS(345),
    [sym_true] = ACTIONS(341),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [205] = {
    [sym_special_call] = STATE(248),
    [sym_prefix_cast] = STATE(248),
    [sym_unary_expr] = STATE(248),
    [sym_mul_expr] = STATE(248),
    [sym_add_expr] = STATE(248),
    [sym_in_expr] = STATE(248),
    [sym_comp_term] = STATE(248),
    [sym_instance_of] = STATE(248),
    [sym_negation] = STATE(248),
    [sym_if_term] = STATE(248),
    [sym_conjunction] = STATE(248),
    [sym_disjunction] = STATE(248),
    [sym_implication] = STATE(248),
    [sym_quantified] = STATE(248),
    [sym_specialId] = STATE(1185),
    [sym_quantifier] = STATE(1186),
    [sym_classless_predicate_call] = STATE(366),
    [sym_qualified_expr] = STATE(366),
    [sym_super_ref] = STATE(366),
    [sym_aggregate] = STATE(366),
    [sym_range] = STATE(366),
    [sym_par_expr] = STATE(366),
    [sym__exprOrTerm] = STATE(248),
    [sym__primary] = STATE(366),
    [sym_literal] = STATE(366),
    [sym_bool] = STATE(362),
    [sym_variable] = STATE(366),
    [sym_unop] = STATE(205),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(294),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1187),
    [sym_aritylessPredicateExpr] = STATE(939),
    [sym_varName] = STATE(364),
    [sym_aggId] = STATE(1117),
    [sym__lower_id] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_if] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(335),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(341),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(343),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(345),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(347),
    [sym_this] = ACTIONS(345),
    [sym_true] = ACTIONS(341),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [206] = {
    [sym_special_call] = STATE(250),
    [sym_prefix_cast] = STATE(250),
    [sym_unary_expr] = STATE(250),
    [sym_mul_expr] = STATE(250),
    [sym_add_expr] = STATE(250),
    [sym_in_expr] = STATE(250),
    [sym_comp_term] = STATE(250),
    [sym_instance_of] = STATE(250),
    [sym_negation] = STATE(250),
    [sym_if_term] = STATE(250),
    [sym_conjunction] = STATE(250),
    [sym_disjunction] = STATE(250),
    [sym_implication] = STATE(250),
    [sym_quantified] = STATE(250),
    [sym_specialId] = STATE(1185),
    [sym_quantifier] = STATE(1186),
    [sym_classless_predicate_call] = STATE(366),
    [sym_qualified_expr] = STATE(366),
    [sym_super_ref] = STATE(366),
    [sym_aggregate] = STATE(366),
    [sym_range] = STATE(366),
    [sym_par_expr] = STATE(366),
    [sym__exprOrTerm] = STATE(250),
    [sym__primary] = STATE(366),
    [sym_literal] = STATE(366),
    [sym_bool] = STATE(362),
    [sym_variable] = STATE(366),
    [sym_unop] = STATE(205),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(294),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1187),
    [sym_aritylessPredicateExpr] = STATE(939),
    [sym_varName] = STATE(364),
    [sym_aggId] = STATE(1117),
    [sym__lower_id] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_if] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(335),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(341),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(343),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(345),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(347),
    [sym_this] = ACTIONS(345),
    [sym_true] = ACTIONS(341),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [207] = {
    [sym_special_call] = STATE(257),
    [sym_prefix_cast] = STATE(257),
    [sym_unary_expr] = STATE(257),
    [sym_mul_expr] = STATE(257),
    [sym_add_expr] = STATE(257),
    [sym_in_expr] = STATE(257),
    [sym_comp_term] = STATE(257),
    [sym_instance_of] = STATE(257),
    [sym_negation] = STATE(257),
    [sym_if_term] = STATE(257),
    [sym_conjunction] = STATE(257),
    [sym_disjunction] = STATE(257),
    [sym_implication] = STATE(257),
    [sym_quantified] = STATE(257),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(257),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [208] = {
    [sym_special_call] = STATE(247),
    [sym_prefix_cast] = STATE(247),
    [sym_unary_expr] = STATE(247),
    [sym_mul_expr] = STATE(247),
    [sym_add_expr] = STATE(247),
    [sym_in_expr] = STATE(247),
    [sym_comp_term] = STATE(247),
    [sym_instance_of] = STATE(247),
    [sym_negation] = STATE(247),
    [sym_if_term] = STATE(247),
    [sym_conjunction] = STATE(247),
    [sym_disjunction] = STATE(247),
    [sym_implication] = STATE(247),
    [sym_quantified] = STATE(247),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(247),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [209] = {
    [sym_special_call] = STATE(270),
    [sym_prefix_cast] = STATE(270),
    [sym_unary_expr] = STATE(270),
    [sym_mul_expr] = STATE(270),
    [sym_add_expr] = STATE(270),
    [sym_in_expr] = STATE(270),
    [sym_comp_term] = STATE(270),
    [sym_instance_of] = STATE(270),
    [sym_negation] = STATE(270),
    [sym_if_term] = STATE(270),
    [sym_conjunction] = STATE(270),
    [sym_disjunction] = STATE(270),
    [sym_implication] = STATE(270),
    [sym_quantified] = STATE(270),
    [sym_specialId] = STATE(1185),
    [sym_quantifier] = STATE(1186),
    [sym_classless_predicate_call] = STATE(366),
    [sym_qualified_expr] = STATE(366),
    [sym_super_ref] = STATE(366),
    [sym_aggregate] = STATE(366),
    [sym_range] = STATE(366),
    [sym_par_expr] = STATE(366),
    [sym__exprOrTerm] = STATE(270),
    [sym__primary] = STATE(366),
    [sym_literal] = STATE(366),
    [sym_bool] = STATE(362),
    [sym_variable] = STATE(366),
    [sym_unop] = STATE(205),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(294),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1187),
    [sym_aritylessPredicateExpr] = STATE(939),
    [sym_varName] = STATE(364),
    [sym_aggId] = STATE(1117),
    [sym__lower_id] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_if] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(335),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(341),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(343),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(345),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(347),
    [sym_this] = ACTIONS(345),
    [sym_true] = ACTIONS(341),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [210] = {
    [sym_special_call] = STATE(615),
    [sym_prefix_cast] = STATE(615),
    [sym_unary_expr] = STATE(615),
    [sym_mul_expr] = STATE(615),
    [sym_add_expr] = STATE(615),
    [sym_in_expr] = STATE(615),
    [sym_comp_term] = STATE(615),
    [sym_instance_of] = STATE(615),
    [sym_negation] = STATE(615),
    [sym_if_term] = STATE(615),
    [sym_conjunction] = STATE(615),
    [sym_disjunction] = STATE(615),
    [sym_implication] = STATE(615),
    [sym_quantified] = STATE(615),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(615),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [211] = {
    [sym_special_call] = STATE(594),
    [sym_prefix_cast] = STATE(594),
    [sym_unary_expr] = STATE(594),
    [sym_mul_expr] = STATE(594),
    [sym_add_expr] = STATE(594),
    [sym_in_expr] = STATE(594),
    [sym_comp_term] = STATE(594),
    [sym_instance_of] = STATE(594),
    [sym_negation] = STATE(594),
    [sym_if_term] = STATE(594),
    [sym_conjunction] = STATE(594),
    [sym_disjunction] = STATE(594),
    [sym_implication] = STATE(594),
    [sym_quantified] = STATE(594),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(594),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [212] = {
    [sym_special_call] = STATE(716),
    [sym_prefix_cast] = STATE(716),
    [sym_unary_expr] = STATE(716),
    [sym_mul_expr] = STATE(716),
    [sym_add_expr] = STATE(716),
    [sym_in_expr] = STATE(716),
    [sym_comp_term] = STATE(716),
    [sym_instance_of] = STATE(716),
    [sym_negation] = STATE(716),
    [sym_if_term] = STATE(716),
    [sym_conjunction] = STATE(716),
    [sym_disjunction] = STATE(716),
    [sym_implication] = STATE(716),
    [sym_quantified] = STATE(716),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(716),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [213] = {
    [sym_special_call] = STATE(251),
    [sym_prefix_cast] = STATE(251),
    [sym_unary_expr] = STATE(251),
    [sym_mul_expr] = STATE(251),
    [sym_add_expr] = STATE(251),
    [sym_in_expr] = STATE(251),
    [sym_comp_term] = STATE(251),
    [sym_instance_of] = STATE(251),
    [sym_negation] = STATE(251),
    [sym_if_term] = STATE(251),
    [sym_conjunction] = STATE(251),
    [sym_disjunction] = STATE(251),
    [sym_implication] = STATE(251),
    [sym_quantified] = STATE(251),
    [sym_specialId] = STATE(1185),
    [sym_quantifier] = STATE(1186),
    [sym_classless_predicate_call] = STATE(366),
    [sym_qualified_expr] = STATE(366),
    [sym_super_ref] = STATE(366),
    [sym_aggregate] = STATE(366),
    [sym_range] = STATE(366),
    [sym_par_expr] = STATE(366),
    [sym__exprOrTerm] = STATE(251),
    [sym__primary] = STATE(366),
    [sym_literal] = STATE(366),
    [sym_bool] = STATE(362),
    [sym_variable] = STATE(366),
    [sym_unop] = STATE(205),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(294),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1187),
    [sym_aritylessPredicateExpr] = STATE(939),
    [sym_varName] = STATE(364),
    [sym_aggId] = STATE(1117),
    [sym__lower_id] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_if] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(335),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(341),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(343),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(345),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(347),
    [sym_this] = ACTIONS(345),
    [sym_true] = ACTIONS(341),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [214] = {
    [sym_special_call] = STATE(604),
    [sym_prefix_cast] = STATE(604),
    [sym_unary_expr] = STATE(604),
    [sym_mul_expr] = STATE(604),
    [sym_add_expr] = STATE(604),
    [sym_in_expr] = STATE(604),
    [sym_comp_term] = STATE(604),
    [sym_instance_of] = STATE(604),
    [sym_negation] = STATE(604),
    [sym_if_term] = STATE(604),
    [sym_conjunction] = STATE(604),
    [sym_disjunction] = STATE(604),
    [sym_implication] = STATE(604),
    [sym_quantified] = STATE(604),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(604),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [215] = {
    [sym_special_call] = STATE(275),
    [sym_prefix_cast] = STATE(275),
    [sym_unary_expr] = STATE(275),
    [sym_mul_expr] = STATE(275),
    [sym_add_expr] = STATE(275),
    [sym_in_expr] = STATE(275),
    [sym_comp_term] = STATE(275),
    [sym_instance_of] = STATE(275),
    [sym_negation] = STATE(275),
    [sym_if_term] = STATE(275),
    [sym_conjunction] = STATE(275),
    [sym_disjunction] = STATE(275),
    [sym_implication] = STATE(275),
    [sym_quantified] = STATE(275),
    [sym_specialId] = STATE(1185),
    [sym_quantifier] = STATE(1186),
    [sym_classless_predicate_call] = STATE(366),
    [sym_qualified_expr] = STATE(366),
    [sym_super_ref] = STATE(366),
    [sym_aggregate] = STATE(366),
    [sym_range] = STATE(366),
    [sym_par_expr] = STATE(366),
    [sym__exprOrTerm] = STATE(275),
    [sym__primary] = STATE(366),
    [sym_literal] = STATE(366),
    [sym_bool] = STATE(362),
    [sym_variable] = STATE(366),
    [sym_unop] = STATE(205),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(294),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1187),
    [sym_aritylessPredicateExpr] = STATE(939),
    [sym_varName] = STATE(364),
    [sym_aggId] = STATE(1117),
    [sym__lower_id] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_if] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(335),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(341),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(343),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(345),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(347),
    [sym_this] = ACTIONS(345),
    [sym_true] = ACTIONS(341),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [216] = {
    [sym_special_call] = STATE(265),
    [sym_prefix_cast] = STATE(265),
    [sym_unary_expr] = STATE(265),
    [sym_mul_expr] = STATE(265),
    [sym_add_expr] = STATE(265),
    [sym_in_expr] = STATE(265),
    [sym_comp_term] = STATE(265),
    [sym_instance_of] = STATE(265),
    [sym_negation] = STATE(265),
    [sym_if_term] = STATE(265),
    [sym_conjunction] = STATE(265),
    [sym_disjunction] = STATE(265),
    [sym_implication] = STATE(265),
    [sym_quantified] = STATE(265),
    [sym_specialId] = STATE(1185),
    [sym_quantifier] = STATE(1186),
    [sym_classless_predicate_call] = STATE(366),
    [sym_qualified_expr] = STATE(366),
    [sym_super_ref] = STATE(366),
    [sym_aggregate] = STATE(366),
    [sym_range] = STATE(366),
    [sym_par_expr] = STATE(366),
    [sym__exprOrTerm] = STATE(265),
    [sym__primary] = STATE(366),
    [sym_literal] = STATE(366),
    [sym_bool] = STATE(362),
    [sym_variable] = STATE(366),
    [sym_unop] = STATE(205),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(294),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1187),
    [sym_aritylessPredicateExpr] = STATE(939),
    [sym_varName] = STATE(364),
    [sym_aggId] = STATE(1117),
    [sym__lower_id] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_if] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(335),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(341),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(343),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(345),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(347),
    [sym_this] = ACTIONS(345),
    [sym_true] = ACTIONS(341),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [217] = {
    [sym_special_call] = STATE(293),
    [sym_prefix_cast] = STATE(293),
    [sym_unary_expr] = STATE(293),
    [sym_mul_expr] = STATE(293),
    [sym_add_expr] = STATE(293),
    [sym_in_expr] = STATE(293),
    [sym_comp_term] = STATE(293),
    [sym_instance_of] = STATE(293),
    [sym_negation] = STATE(293),
    [sym_if_term] = STATE(293),
    [sym_conjunction] = STATE(293),
    [sym_disjunction] = STATE(293),
    [sym_implication] = STATE(293),
    [sym_quantified] = STATE(293),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(293),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [218] = {
    [sym_special_call] = STATE(574),
    [sym_prefix_cast] = STATE(574),
    [sym_unary_expr] = STATE(574),
    [sym_mul_expr] = STATE(574),
    [sym_add_expr] = STATE(574),
    [sym_in_expr] = STATE(574),
    [sym_comp_term] = STATE(574),
    [sym_instance_of] = STATE(574),
    [sym_negation] = STATE(574),
    [sym_if_term] = STATE(574),
    [sym_conjunction] = STATE(574),
    [sym_disjunction] = STATE(574),
    [sym_implication] = STATE(574),
    [sym_quantified] = STATE(574),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(574),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [219] = {
    [sym_special_call] = STATE(252),
    [sym_prefix_cast] = STATE(252),
    [sym_unary_expr] = STATE(252),
    [sym_mul_expr] = STATE(252),
    [sym_add_expr] = STATE(252),
    [sym_in_expr] = STATE(252),
    [sym_comp_term] = STATE(252),
    [sym_instance_of] = STATE(252),
    [sym_negation] = STATE(252),
    [sym_if_term] = STATE(252),
    [sym_conjunction] = STATE(252),
    [sym_disjunction] = STATE(252),
    [sym_implication] = STATE(252),
    [sym_quantified] = STATE(252),
    [sym_specialId] = STATE(1185),
    [sym_quantifier] = STATE(1186),
    [sym_classless_predicate_call] = STATE(366),
    [sym_qualified_expr] = STATE(366),
    [sym_super_ref] = STATE(366),
    [sym_aggregate] = STATE(366),
    [sym_range] = STATE(366),
    [sym_par_expr] = STATE(366),
    [sym__exprOrTerm] = STATE(252),
    [sym__primary] = STATE(366),
    [sym_literal] = STATE(366),
    [sym_bool] = STATE(362),
    [sym_variable] = STATE(366),
    [sym_unop] = STATE(205),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(294),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1187),
    [sym_aritylessPredicateExpr] = STATE(939),
    [sym_varName] = STATE(364),
    [sym_aggId] = STATE(1117),
    [sym__lower_id] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_if] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(335),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(341),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(343),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(345),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(347),
    [sym_this] = ACTIONS(345),
    [sym_true] = ACTIONS(341),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [220] = {
    [sym_special_call] = STATE(509),
    [sym_prefix_cast] = STATE(509),
    [sym_unary_expr] = STATE(509),
    [sym_mul_expr] = STATE(509),
    [sym_add_expr] = STATE(509),
    [sym_in_expr] = STATE(509),
    [sym_comp_term] = STATE(509),
    [sym_instance_of] = STATE(509),
    [sym_negation] = STATE(509),
    [sym_if_term] = STATE(509),
    [sym_conjunction] = STATE(509),
    [sym_disjunction] = STATE(509),
    [sym_implication] = STATE(509),
    [sym_quantified] = STATE(509),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(509),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [221] = {
    [sym_special_call] = STATE(717),
    [sym_prefix_cast] = STATE(717),
    [sym_unary_expr] = STATE(717),
    [sym_mul_expr] = STATE(717),
    [sym_add_expr] = STATE(717),
    [sym_in_expr] = STATE(717),
    [sym_comp_term] = STATE(717),
    [sym_instance_of] = STATE(717),
    [sym_negation] = STATE(717),
    [sym_if_term] = STATE(717),
    [sym_conjunction] = STATE(717),
    [sym_disjunction] = STATE(717),
    [sym_implication] = STATE(717),
    [sym_quantified] = STATE(717),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(717),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1093),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [222] = {
    [sym_special_call] = STATE(667),
    [sym_prefix_cast] = STATE(667),
    [sym_unary_expr] = STATE(667),
    [sym_mul_expr] = STATE(667),
    [sym_add_expr] = STATE(667),
    [sym_in_expr] = STATE(667),
    [sym_comp_term] = STATE(667),
    [sym_instance_of] = STATE(667),
    [sym_negation] = STATE(667),
    [sym_if_term] = STATE(667),
    [sym_conjunction] = STATE(667),
    [sym_disjunction] = STATE(667),
    [sym_implication] = STATE(667),
    [sym_quantified] = STATE(667),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(667),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [223] = {
    [sym_special_call] = STATE(253),
    [sym_prefix_cast] = STATE(253),
    [sym_unary_expr] = STATE(253),
    [sym_mul_expr] = STATE(253),
    [sym_add_expr] = STATE(253),
    [sym_in_expr] = STATE(253),
    [sym_comp_term] = STATE(253),
    [sym_instance_of] = STATE(253),
    [sym_negation] = STATE(253),
    [sym_if_term] = STATE(253),
    [sym_conjunction] = STATE(253),
    [sym_disjunction] = STATE(253),
    [sym_implication] = STATE(253),
    [sym_quantified] = STATE(253),
    [sym_specialId] = STATE(1185),
    [sym_quantifier] = STATE(1186),
    [sym_classless_predicate_call] = STATE(366),
    [sym_qualified_expr] = STATE(366),
    [sym_super_ref] = STATE(366),
    [sym_aggregate] = STATE(366),
    [sym_range] = STATE(366),
    [sym_par_expr] = STATE(366),
    [sym__exprOrTerm] = STATE(253),
    [sym__primary] = STATE(366),
    [sym_literal] = STATE(366),
    [sym_bool] = STATE(362),
    [sym_variable] = STATE(366),
    [sym_unop] = STATE(205),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(294),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1187),
    [sym_aritylessPredicateExpr] = STATE(939),
    [sym_varName] = STATE(364),
    [sym_aggId] = STATE(1117),
    [sym__lower_id] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_if] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(335),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(341),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(343),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(345),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(347),
    [sym_this] = ACTIONS(345),
    [sym_true] = ACTIONS(341),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [224] = {
    [sym_special_call] = STATE(641),
    [sym_prefix_cast] = STATE(641),
    [sym_unary_expr] = STATE(641),
    [sym_mul_expr] = STATE(641),
    [sym_add_expr] = STATE(641),
    [sym_in_expr] = STATE(641),
    [sym_comp_term] = STATE(641),
    [sym_instance_of] = STATE(641),
    [sym_negation] = STATE(641),
    [sym_if_term] = STATE(641),
    [sym_conjunction] = STATE(641),
    [sym_disjunction] = STATE(641),
    [sym_implication] = STATE(641),
    [sym_quantified] = STATE(641),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(641),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [225] = {
    [sym_special_call] = STATE(626),
    [sym_prefix_cast] = STATE(626),
    [sym_unary_expr] = STATE(626),
    [sym_mul_expr] = STATE(626),
    [sym_add_expr] = STATE(626),
    [sym_in_expr] = STATE(626),
    [sym_comp_term] = STATE(626),
    [sym_instance_of] = STATE(626),
    [sym_negation] = STATE(626),
    [sym_if_term] = STATE(626),
    [sym_conjunction] = STATE(626),
    [sym_disjunction] = STATE(626),
    [sym_implication] = STATE(626),
    [sym_quantified] = STATE(626),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(626),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [226] = {
    [sym_special_call] = STATE(639),
    [sym_prefix_cast] = STATE(639),
    [sym_unary_expr] = STATE(639),
    [sym_mul_expr] = STATE(639),
    [sym_add_expr] = STATE(639),
    [sym_in_expr] = STATE(639),
    [sym_comp_term] = STATE(639),
    [sym_instance_of] = STATE(639),
    [sym_negation] = STATE(639),
    [sym_if_term] = STATE(639),
    [sym_conjunction] = STATE(639),
    [sym_disjunction] = STATE(639),
    [sym_implication] = STATE(639),
    [sym_quantified] = STATE(639),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(639),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1107),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [227] = {
    [sym_special_call] = STATE(684),
    [sym_prefix_cast] = STATE(684),
    [sym_unary_expr] = STATE(684),
    [sym_mul_expr] = STATE(684),
    [sym_add_expr] = STATE(684),
    [sym_in_expr] = STATE(684),
    [sym_comp_term] = STATE(684),
    [sym_instance_of] = STATE(684),
    [sym_negation] = STATE(684),
    [sym_if_term] = STATE(684),
    [sym_conjunction] = STATE(684),
    [sym_disjunction] = STATE(684),
    [sym_implication] = STATE(684),
    [sym_quantified] = STATE(684),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(684),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [228] = {
    [sym_special_call] = STATE(668),
    [sym_prefix_cast] = STATE(668),
    [sym_unary_expr] = STATE(668),
    [sym_mul_expr] = STATE(668),
    [sym_add_expr] = STATE(668),
    [sym_in_expr] = STATE(668),
    [sym_comp_term] = STATE(668),
    [sym_instance_of] = STATE(668),
    [sym_negation] = STATE(668),
    [sym_if_term] = STATE(668),
    [sym_conjunction] = STATE(668),
    [sym_disjunction] = STATE(668),
    [sym_implication] = STATE(668),
    [sym_quantified] = STATE(668),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(668),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [229] = {
    [sym_special_call] = STATE(263),
    [sym_prefix_cast] = STATE(263),
    [sym_unary_expr] = STATE(263),
    [sym_mul_expr] = STATE(263),
    [sym_add_expr] = STATE(263),
    [sym_in_expr] = STATE(263),
    [sym_comp_term] = STATE(263),
    [sym_instance_of] = STATE(263),
    [sym_negation] = STATE(263),
    [sym_if_term] = STATE(263),
    [sym_conjunction] = STATE(263),
    [sym_disjunction] = STATE(263),
    [sym_implication] = STATE(263),
    [sym_quantified] = STATE(263),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(263),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [230] = {
    [sym_special_call] = STATE(610),
    [sym_prefix_cast] = STATE(610),
    [sym_unary_expr] = STATE(610),
    [sym_mul_expr] = STATE(610),
    [sym_add_expr] = STATE(610),
    [sym_in_expr] = STATE(610),
    [sym_comp_term] = STATE(610),
    [sym_instance_of] = STATE(610),
    [sym_negation] = STATE(610),
    [sym_if_term] = STATE(610),
    [sym_conjunction] = STATE(610),
    [sym_disjunction] = STATE(610),
    [sym_implication] = STATE(610),
    [sym_quantified] = STATE(610),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(610),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [231] = {
    [sym_special_call] = STATE(271),
    [sym_prefix_cast] = STATE(271),
    [sym_unary_expr] = STATE(271),
    [sym_mul_expr] = STATE(271),
    [sym_add_expr] = STATE(271),
    [sym_in_expr] = STATE(271),
    [sym_comp_term] = STATE(271),
    [sym_instance_of] = STATE(271),
    [sym_negation] = STATE(271),
    [sym_if_term] = STATE(271),
    [sym_conjunction] = STATE(271),
    [sym_disjunction] = STATE(271),
    [sym_implication] = STATE(271),
    [sym_quantified] = STATE(271),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(271),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [232] = {
    [sym_special_call] = STATE(683),
    [sym_prefix_cast] = STATE(683),
    [sym_unary_expr] = STATE(683),
    [sym_mul_expr] = STATE(683),
    [sym_add_expr] = STATE(683),
    [sym_in_expr] = STATE(683),
    [sym_comp_term] = STATE(683),
    [sym_instance_of] = STATE(683),
    [sym_negation] = STATE(683),
    [sym_if_term] = STATE(683),
    [sym_conjunction] = STATE(683),
    [sym_disjunction] = STATE(683),
    [sym_implication] = STATE(683),
    [sym_quantified] = STATE(683),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(683),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [233] = {
    [sym_special_call] = STATE(256),
    [sym_prefix_cast] = STATE(256),
    [sym_unary_expr] = STATE(256),
    [sym_mul_expr] = STATE(256),
    [sym_add_expr] = STATE(256),
    [sym_in_expr] = STATE(256),
    [sym_comp_term] = STATE(256),
    [sym_instance_of] = STATE(256),
    [sym_negation] = STATE(256),
    [sym_if_term] = STATE(256),
    [sym_conjunction] = STATE(256),
    [sym_disjunction] = STATE(256),
    [sym_implication] = STATE(256),
    [sym_quantified] = STATE(256),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(256),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [234] = {
    [sym_special_call] = STATE(584),
    [sym_prefix_cast] = STATE(584),
    [sym_unary_expr] = STATE(584),
    [sym_mul_expr] = STATE(584),
    [sym_add_expr] = STATE(584),
    [sym_in_expr] = STATE(584),
    [sym_comp_term] = STATE(584),
    [sym_instance_of] = STATE(584),
    [sym_negation] = STATE(584),
    [sym_if_term] = STATE(584),
    [sym_conjunction] = STATE(584),
    [sym_disjunction] = STATE(584),
    [sym_implication] = STATE(584),
    [sym_quantified] = STATE(584),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(584),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [235] = {
    [sym_special_call] = STATE(680),
    [sym_prefix_cast] = STATE(680),
    [sym_unary_expr] = STATE(680),
    [sym_mul_expr] = STATE(680),
    [sym_add_expr] = STATE(680),
    [sym_in_expr] = STATE(680),
    [sym_comp_term] = STATE(680),
    [sym_instance_of] = STATE(680),
    [sym_negation] = STATE(680),
    [sym_if_term] = STATE(680),
    [sym_conjunction] = STATE(680),
    [sym_disjunction] = STATE(680),
    [sym_implication] = STATE(680),
    [sym_quantified] = STATE(680),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(680),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [236] = {
    [sym_special_call] = STATE(660),
    [sym_prefix_cast] = STATE(660),
    [sym_unary_expr] = STATE(660),
    [sym_mul_expr] = STATE(660),
    [sym_add_expr] = STATE(660),
    [sym_in_expr] = STATE(660),
    [sym_comp_term] = STATE(660),
    [sym_instance_of] = STATE(660),
    [sym_negation] = STATE(660),
    [sym_if_term] = STATE(660),
    [sym_conjunction] = STATE(660),
    [sym_disjunction] = STATE(660),
    [sym_implication] = STATE(660),
    [sym_quantified] = STATE(660),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(660),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [237] = {
    [sym_special_call] = STATE(255),
    [sym_prefix_cast] = STATE(255),
    [sym_unary_expr] = STATE(255),
    [sym_mul_expr] = STATE(255),
    [sym_add_expr] = STATE(255),
    [sym_in_expr] = STATE(255),
    [sym_comp_term] = STATE(255),
    [sym_instance_of] = STATE(255),
    [sym_negation] = STATE(255),
    [sym_if_term] = STATE(255),
    [sym_conjunction] = STATE(255),
    [sym_disjunction] = STATE(255),
    [sym_implication] = STATE(255),
    [sym_quantified] = STATE(255),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(255),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [238] = {
    [sym_special_call] = STATE(254),
    [sym_prefix_cast] = STATE(254),
    [sym_unary_expr] = STATE(254),
    [sym_mul_expr] = STATE(254),
    [sym_add_expr] = STATE(254),
    [sym_in_expr] = STATE(254),
    [sym_comp_term] = STATE(254),
    [sym_instance_of] = STATE(254),
    [sym_negation] = STATE(254),
    [sym_if_term] = STATE(254),
    [sym_conjunction] = STATE(254),
    [sym_disjunction] = STATE(254),
    [sym_implication] = STATE(254),
    [sym_quantified] = STATE(254),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(254),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [239] = {
    [sym_special_call] = STATE(600),
    [sym_prefix_cast] = STATE(600),
    [sym_unary_expr] = STATE(600),
    [sym_mul_expr] = STATE(600),
    [sym_add_expr] = STATE(600),
    [sym_in_expr] = STATE(600),
    [sym_comp_term] = STATE(600),
    [sym_instance_of] = STATE(600),
    [sym_negation] = STATE(600),
    [sym_if_term] = STATE(600),
    [sym_conjunction] = STATE(600),
    [sym_disjunction] = STATE(600),
    [sym_implication] = STATE(600),
    [sym_quantified] = STATE(600),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(600),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [240] = {
    [sym_special_call] = STATE(249),
    [sym_prefix_cast] = STATE(249),
    [sym_unary_expr] = STATE(249),
    [sym_mul_expr] = STATE(249),
    [sym_add_expr] = STATE(249),
    [sym_in_expr] = STATE(249),
    [sym_comp_term] = STATE(249),
    [sym_instance_of] = STATE(249),
    [sym_negation] = STATE(249),
    [sym_if_term] = STATE(249),
    [sym_conjunction] = STATE(249),
    [sym_disjunction] = STATE(249),
    [sym_implication] = STATE(249),
    [sym_quantified] = STATE(249),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(249),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [241] = {
    [sym_special_call] = STATE(246),
    [sym_prefix_cast] = STATE(246),
    [sym_unary_expr] = STATE(246),
    [sym_mul_expr] = STATE(246),
    [sym_add_expr] = STATE(246),
    [sym_in_expr] = STATE(246),
    [sym_comp_term] = STATE(246),
    [sym_instance_of] = STATE(246),
    [sym_negation] = STATE(246),
    [sym_if_term] = STATE(246),
    [sym_conjunction] = STATE(246),
    [sym_disjunction] = STATE(246),
    [sym_implication] = STATE(246),
    [sym_quantified] = STATE(246),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(246),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 19,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(383), 1,
      anon_sym_or,
    ACTIONS(385), 1,
      anon_sym_and,
    ACTIONS(387), 1,
      anon_sym_implies,
    ACTIONS(391), 1,
      sym_in,
    ACTIONS(393), 1,
      sym_instanceof,
    ACTIONS(401), 1,
      sym_slash,
    STATE(99), 1,
      sym_addop,
    STATE(103), 1,
      sym_mulop,
    STATE(104), 1,
      sym_compop,
    STATE(745), 1,
      sym_direction,
    ACTIONS(389), 2,
      sym_asc,
      sym_desc,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(379), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(381), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [82] = 19,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(405), 1,
      anon_sym_or,
    ACTIONS(407), 1,
      anon_sym_and,
    ACTIONS(409), 1,
      anon_sym_implies,
    ACTIONS(413), 1,
      sym_in,
    ACTIONS(415), 1,
      sym_instanceof,
    STATE(215), 1,
      sym_compop,
    STATE(216), 1,
      sym_mulop,
    STATE(219), 1,
      sym_addop,
    STATE(749), 1,
      sym_direction,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(411), 2,
      sym_asc,
      sym_desc,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(379), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(381), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [164] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    STATE(137), 1,
      sym_addop,
    STATE(138), 1,
      sym_mulop,
    STATE(140), 1,
      sym_compop,
    ACTIONS(419), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(417), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [221] = 11,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(391), 1,
      sym_in,
    ACTIONS(401), 1,
      sym_slash,
    STATE(99), 1,
      sym_addop,
    STATE(103), 1,
      sym_mulop,
    STATE(104), 1,
      sym_compop,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(421), 9,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(423), 22,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
  [286] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(429), 1,
      anon_sym_or,
    ACTIONS(431), 1,
      anon_sym_and,
    ACTIONS(433), 1,
      sym_in,
    ACTIONS(435), 1,
      sym_instanceof,
    STATE(237), 1,
      sym_addop,
    STATE(238), 1,
      sym_mulop,
    STATE(240), 1,
      sym_compop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(425), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(427), 17,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [361] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(433), 1,
      sym_in,
    ACTIONS(435), 1,
      sym_instanceof,
    STATE(237), 1,
      sym_addop,
    STATE(238), 1,
      sym_mulop,
    STATE(240), 1,
      sym_compop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(437), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(439), 19,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [432] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(405), 1,
      anon_sym_or,
    ACTIONS(407), 1,
      anon_sym_and,
    ACTIONS(409), 1,
      anon_sym_implies,
    ACTIONS(413), 1,
      sym_in,
    ACTIONS(415), 1,
      sym_instanceof,
    STATE(215), 1,
      sym_compop,
    STATE(216), 1,
      sym_mulop,
    STATE(219), 1,
      sym_addop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(443), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(441), 16,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_predicate,
  [509] = 11,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(433), 1,
      sym_in,
    STATE(237), 1,
      sym_addop,
    STATE(238), 1,
      sym_mulop,
    STATE(240), 1,
      sym_compop,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(421), 9,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(423), 22,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
  [574] = 15,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(407), 1,
      anon_sym_and,
    ACTIONS(413), 1,
      sym_in,
    ACTIONS(415), 1,
      sym_instanceof,
    STATE(215), 1,
      sym_compop,
    STATE(216), 1,
      sym_mulop,
    STATE(219), 1,
      sym_addop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(447), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(445), 18,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_predicate,
  [647] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(405), 1,
      anon_sym_or,
    ACTIONS(407), 1,
      anon_sym_and,
    ACTIONS(413), 1,
      sym_in,
    ACTIONS(415), 1,
      sym_instanceof,
    STATE(215), 1,
      sym_compop,
    STATE(216), 1,
      sym_mulop,
    STATE(219), 1,
      sym_addop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(425), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(427), 17,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_predicate,
  [722] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    STATE(215), 1,
      sym_compop,
    STATE(216), 1,
      sym_mulop,
    STATE(219), 1,
      sym_addop,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(451), 11,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_plus,
    ACTIONS(449), 23,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
  [783] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(405), 1,
      anon_sym_or,
    ACTIONS(407), 1,
      anon_sym_and,
    ACTIONS(409), 1,
      anon_sym_implies,
    ACTIONS(413), 1,
      sym_in,
    ACTIONS(415), 1,
      sym_instanceof,
    STATE(215), 1,
      sym_compop,
    STATE(216), 1,
      sym_mulop,
    STATE(219), 1,
      sym_addop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(455), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(453), 16,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_predicate,
  [860] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    STATE(237), 1,
      sym_addop,
    STATE(238), 1,
      sym_mulop,
    STATE(240), 1,
      sym_compop,
    ACTIONS(419), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(417), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [917] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    STATE(237), 1,
      sym_addop,
    STATE(238), 1,
      sym_mulop,
    STATE(240), 1,
      sym_compop,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(451), 11,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_plus,
    ACTIONS(449), 23,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
  [978] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(429), 1,
      anon_sym_or,
    ACTIONS(431), 1,
      anon_sym_and,
    ACTIONS(433), 1,
      sym_in,
    ACTIONS(435), 1,
      sym_instanceof,
    ACTIONS(457), 1,
      anon_sym_implies,
    STATE(237), 1,
      sym_addop,
    STATE(238), 1,
      sym_mulop,
    STATE(240), 1,
      sym_compop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(455), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(453), 16,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [1055] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(433), 1,
      sym_in,
    ACTIONS(435), 1,
      sym_instanceof,
    STATE(237), 1,
      sym_addop,
    STATE(238), 1,
      sym_mulop,
    STATE(240), 1,
      sym_compop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(459), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(461), 19,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [1126] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 2,
      sym_star,
      sym_plus,
    ACTIONS(463), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_mod,
    ACTIONS(465), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [1181] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 2,
      sym_star,
      sym_plus,
    ACTIONS(463), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_mod,
    ACTIONS(465), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [1236] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(472), 1,
      anon_sym_DOT,
    ACTIONS(469), 2,
      sym_star,
      sym_plus,
    ACTIONS(463), 12,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_mod,
    ACTIONS(465), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [1293] = 18,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(479), 1,
      anon_sym_or,
    ACTIONS(481), 1,
      anon_sym_and,
    ACTIONS(483), 1,
      anon_sym_implies,
    ACTIONS(485), 1,
      sym_as,
    ACTIONS(487), 1,
      sym_in,
    ACTIONS(489), 1,
      sym_instanceof,
    STATE(137), 1,
      sym_addop,
    STATE(138), 1,
      sym_mulop,
    STATE(140), 1,
      sym_compop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(477), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(475), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [1372] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(383), 1,
      anon_sym_or,
    ACTIONS(385), 1,
      anon_sym_and,
    ACTIONS(387), 1,
      anon_sym_implies,
    ACTIONS(391), 1,
      sym_in,
    ACTIONS(393), 1,
      sym_instanceof,
    ACTIONS(401), 1,
      sym_slash,
    STATE(99), 1,
      sym_addop,
    STATE(103), 1,
      sym_mulop,
    STATE(104), 1,
      sym_compop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(455), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(453), 16,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_predicate,
  [1449] = 15,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(431), 1,
      anon_sym_and,
    ACTIONS(433), 1,
      sym_in,
    ACTIONS(435), 1,
      sym_instanceof,
    STATE(237), 1,
      sym_addop,
    STATE(238), 1,
      sym_mulop,
    STATE(240), 1,
      sym_compop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(447), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(445), 18,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [1522] = 18,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(429), 1,
      anon_sym_or,
    ACTIONS(431), 1,
      anon_sym_and,
    ACTIONS(433), 1,
      sym_in,
    ACTIONS(435), 1,
      sym_instanceof,
    ACTIONS(457), 1,
      anon_sym_implies,
    ACTIONS(491), 1,
      sym_as,
    STATE(237), 1,
      sym_addop,
    STATE(238), 1,
      sym_mulop,
    STATE(240), 1,
      sym_compop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(477), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(475), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [1601] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    STATE(215), 1,
      sym_compop,
    STATE(216), 1,
      sym_mulop,
    STATE(219), 1,
      sym_addop,
    ACTIONS(419), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(417), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [1658] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(487), 1,
      sym_in,
    ACTIONS(489), 1,
      sym_instanceof,
    STATE(137), 1,
      sym_addop,
    STATE(138), 1,
      sym_mulop,
    STATE(140), 1,
      sym_compop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(437), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(439), 19,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [1729] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(413), 1,
      sym_in,
    ACTIONS(415), 1,
      sym_instanceof,
    STATE(215), 1,
      sym_compop,
    STATE(216), 1,
      sym_mulop,
    STATE(219), 1,
      sym_addop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(459), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(461), 19,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_predicate,
  [1800] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(487), 1,
      sym_in,
    ACTIONS(489), 1,
      sym_instanceof,
    STATE(137), 1,
      sym_addop,
    STATE(138), 1,
      sym_mulop,
    STATE(140), 1,
      sym_compop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(495), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(493), 19,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [1871] = 11,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(487), 1,
      sym_in,
    STATE(137), 1,
      sym_addop,
    STATE(138), 1,
      sym_mulop,
    STATE(140), 1,
      sym_compop,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(421), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(423), 22,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
  [1936] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(413), 1,
      sym_in,
    ACTIONS(415), 1,
      sym_instanceof,
    STATE(215), 1,
      sym_compop,
    STATE(216), 1,
      sym_mulop,
    STATE(219), 1,
      sym_addop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(495), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(493), 19,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_predicate,
  [2007] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(433), 1,
      sym_in,
    ACTIONS(435), 1,
      sym_instanceof,
    STATE(237), 1,
      sym_addop,
    STATE(238), 1,
      sym_mulop,
    STATE(240), 1,
      sym_compop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(495), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(493), 19,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [2078] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(472), 1,
      anon_sym_DOT,
    ACTIONS(469), 2,
      sym_star,
      sym_plus,
    ACTIONS(463), 12,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_mod,
    ACTIONS(465), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [2135] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(472), 1,
      anon_sym_DOT,
    ACTIONS(469), 2,
      sym_star,
      sym_plus,
    ACTIONS(463), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_mod,
    ACTIONS(465), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [2192] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 2,
      sym_star,
      sym_plus,
    ACTIONS(463), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_mod,
    ACTIONS(465), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [2247] = 11,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(413), 1,
      sym_in,
    STATE(215), 1,
      sym_compop,
    STATE(216), 1,
      sym_mulop,
    STATE(219), 1,
      sym_addop,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(421), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(423), 22,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
  [2312] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(391), 1,
      sym_in,
    ACTIONS(393), 1,
      sym_instanceof,
    ACTIONS(401), 1,
      sym_slash,
    STATE(99), 1,
      sym_addop,
    STATE(103), 1,
      sym_mulop,
    STATE(104), 1,
      sym_compop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(437), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(439), 19,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_predicate,
  [2383] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(479), 1,
      anon_sym_or,
    ACTIONS(481), 1,
      anon_sym_and,
    ACTIONS(483), 1,
      anon_sym_implies,
    ACTIONS(487), 1,
      sym_in,
    ACTIONS(489), 1,
      sym_instanceof,
    STATE(137), 1,
      sym_addop,
    STATE(138), 1,
      sym_mulop,
    STATE(140), 1,
      sym_compop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(443), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(441), 16,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [2460] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(472), 1,
      anon_sym_DOT,
    ACTIONS(469), 2,
      sym_star,
      sym_plus,
    ACTIONS(463), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_mod,
    ACTIONS(465), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [2517] = 15,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(481), 1,
      anon_sym_and,
    ACTIONS(487), 1,
      sym_in,
    ACTIONS(489), 1,
      sym_instanceof,
    STATE(137), 1,
      sym_addop,
    STATE(138), 1,
      sym_mulop,
    STATE(140), 1,
      sym_compop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(447), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(445), 18,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [2590] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(391), 1,
      sym_in,
    ACTIONS(393), 1,
      sym_instanceof,
    ACTIONS(401), 1,
      sym_slash,
    STATE(99), 1,
      sym_addop,
    STATE(103), 1,
      sym_mulop,
    STATE(104), 1,
      sym_compop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(495), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(493), 19,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_predicate,
  [2661] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(479), 1,
      anon_sym_or,
    ACTIONS(481), 1,
      anon_sym_and,
    ACTIONS(487), 1,
      sym_in,
    ACTIONS(489), 1,
      sym_instanceof,
    STATE(137), 1,
      sym_addop,
    STATE(138), 1,
      sym_mulop,
    STATE(140), 1,
      sym_compop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(425), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(427), 17,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [2736] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    STATE(137), 1,
      sym_addop,
    STATE(138), 1,
      sym_mulop,
    STATE(140), 1,
      sym_compop,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(451), 11,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_plus,
    ACTIONS(449), 23,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
  [2797] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    STATE(99), 1,
      sym_addop,
    STATE(103), 1,
      sym_mulop,
    STATE(104), 1,
      sym_compop,
    ACTIONS(419), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(417), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [2854] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    STATE(99), 1,
      sym_addop,
    STATE(103), 1,
      sym_mulop,
    STATE(104), 1,
      sym_compop,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(451), 11,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_plus,
    ACTIONS(449), 23,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
  [2915] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(479), 1,
      anon_sym_or,
    ACTIONS(481), 1,
      anon_sym_and,
    ACTIONS(483), 1,
      anon_sym_implies,
    ACTIONS(487), 1,
      sym_in,
    ACTIONS(489), 1,
      sym_instanceof,
    STATE(137), 1,
      sym_addop,
    STATE(138), 1,
      sym_mulop,
    STATE(140), 1,
      sym_compop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(455), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(453), 16,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [2992] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(391), 1,
      sym_in,
    ACTIONS(393), 1,
      sym_instanceof,
    ACTIONS(401), 1,
      sym_slash,
    STATE(99), 1,
      sym_addop,
    STATE(103), 1,
      sym_mulop,
    STATE(104), 1,
      sym_compop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(459), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(461), 19,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_predicate,
  [3063] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(487), 1,
      sym_in,
    ACTIONS(489), 1,
      sym_instanceof,
    STATE(137), 1,
      sym_addop,
    STATE(138), 1,
      sym_mulop,
    STATE(140), 1,
      sym_compop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(459), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(461), 19,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [3134] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 2,
      sym_star,
      sym_plus,
    ACTIONS(463), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_mod,
    ACTIONS(465), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [3189] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(383), 1,
      anon_sym_or,
    ACTIONS(385), 1,
      anon_sym_and,
    ACTIONS(391), 1,
      sym_in,
    ACTIONS(393), 1,
      sym_instanceof,
    ACTIONS(401), 1,
      sym_slash,
    STATE(99), 1,
      sym_addop,
    STATE(103), 1,
      sym_mulop,
    STATE(104), 1,
      sym_compop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(425), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(427), 17,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_predicate,
  [3264] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(413), 1,
      sym_in,
    ACTIONS(415), 1,
      sym_instanceof,
    STATE(215), 1,
      sym_compop,
    STATE(216), 1,
      sym_mulop,
    STATE(219), 1,
      sym_addop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(437), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(439), 19,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_predicate,
  [3335] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(383), 1,
      anon_sym_or,
    ACTIONS(385), 1,
      anon_sym_and,
    ACTIONS(387), 1,
      anon_sym_implies,
    ACTIONS(391), 1,
      sym_in,
    ACTIONS(393), 1,
      sym_instanceof,
    ACTIONS(401), 1,
      sym_slash,
    STATE(99), 1,
      sym_addop,
    STATE(103), 1,
      sym_mulop,
    STATE(104), 1,
      sym_compop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(443), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(441), 16,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_predicate,
  [3412] = 15,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(385), 1,
      anon_sym_and,
    ACTIONS(391), 1,
      sym_in,
    ACTIONS(393), 1,
      sym_instanceof,
    ACTIONS(401), 1,
      sym_slash,
    STATE(99), 1,
      sym_addop,
    STATE(103), 1,
      sym_mulop,
    STATE(104), 1,
      sym_compop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(447), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(445), 18,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_predicate,
  [3485] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(429), 1,
      anon_sym_or,
    ACTIONS(431), 1,
      anon_sym_and,
    ACTIONS(433), 1,
      sym_in,
    ACTIONS(435), 1,
      sym_instanceof,
    ACTIONS(457), 1,
      anon_sym_implies,
    STATE(237), 1,
      sym_addop,
    STATE(238), 1,
      sym_mulop,
    STATE(240), 1,
      sym_compop,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(443), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(441), 16,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [3562] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(501), 1,
      anon_sym_COLON_COLON,
    ACTIONS(499), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(497), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [3614] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(501), 1,
      anon_sym_COLON_COLON,
    ACTIONS(499), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(497), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [3666] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(501), 1,
      anon_sym_COLON_COLON,
    ACTIONS(499), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(497), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [3718] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(501), 1,
      anon_sym_COLON_COLON,
    ACTIONS(499), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(497), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [3770] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(505), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(503), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [3819] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(507), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(509), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [3868] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(511), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(513), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [3919] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(519), 1,
      anon_sym_DOT,
    ACTIONS(517), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(515), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [3970] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(523), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(521), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [4019] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(527), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(525), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [4068] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(531), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(529), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [4117] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(535), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(533), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [4166] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(539), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(537), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [4215] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(543), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(541), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [4264] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(507), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(509), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [4313] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(547), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(545), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [4362] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(551), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(549), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [4411] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(555), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(553), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [4460] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(559), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(557), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [4509] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(563), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(561), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [4558] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(511), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(513), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [4609] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(567), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(565), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [4658] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(571), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(569), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [4707] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(575), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(573), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [4756] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(579), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(577), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [4805] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(583), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(581), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [4854] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(585), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(587), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [4903] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(589), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(591), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [4952] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(595), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(593), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [5001] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(595), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(593), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [5050] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(583), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(581), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [5099] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(589), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(591), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [5148] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(585), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(587), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [5197] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(511), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(513), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [5248] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(579), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(577), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [5297] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(575), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(573), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [5346] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(505), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(503), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [5395] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(535), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(533), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [5444] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(531), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(529), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [5493] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(527), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(525), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [5542] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(523), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(521), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [5591] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(597), 1,
      anon_sym_DOT,
    ACTIONS(517), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(515), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [5642] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(571), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(569), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [5691] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(567), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(565), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [5740] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(563), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(561), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [5789] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(539), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(537), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [5838] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(559), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(557), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [5887] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(555), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(553), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [5936] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(543), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(541), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [5985] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(507), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(509), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [6034] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(547), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(545), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [6083] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(551), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(549), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [6132] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(555), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(553), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [6181] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(559), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(557), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [6230] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(551), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(549), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [6279] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(547), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(545), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [6328] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(543), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(541), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [6377] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(563), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(561), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [6426] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(567), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(565), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [6475] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(571), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(569), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [6524] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(539), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(537), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [6573] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(505), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(503), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [6622] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(575), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(573), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [6671] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(579), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(577), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [6720] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(583), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(581), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [6769] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(595), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(593), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [6818] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(589), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(591), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [6867] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(585), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(587), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [6916] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(535), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(533), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [6965] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(531), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(529), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [7014] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(527), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(525), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [7063] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(523), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(521), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [7112] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(599), 1,
      anon_sym_DOT,
    ACTIONS(517), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(515), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [7163] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(539), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(537), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [7212] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(585), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(587), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [7261] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(601), 1,
      anon_sym_DOT,
    ACTIONS(517), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(515), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [7312] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(589), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(591), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [7361] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(523), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(521), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [7410] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(595), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(593), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [7459] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(527), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(525), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [7508] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(583), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(581), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [7557] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(531), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(529), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [7606] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(535), 14,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(533), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [7655] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(511), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(513), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [7706] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(579), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(577), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [7755] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(575), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(573), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [7804] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(505), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(503), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [7853] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(543), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(541), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [7902] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(571), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(569), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [7951] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(507), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(509), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [8000] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(567), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(565), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [8049] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(547), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(545), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [8098] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(551), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(549), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [8147] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(555), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(553), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [8196] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(563), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(561), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [8245] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(559), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(557), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [8294] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(605), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(603), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [8342] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(605), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(603), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [8390] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(609), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(607), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [8438] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(611), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(613), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [8486] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(617), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(615), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [8534] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(619), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(621), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [8582] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(625), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(623), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [8630] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(629), 8,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      sym__upper_id,
      sym__at_lower_id,
      sym_float,
      sym_string,
      sym_minus,
      sym_plus,
    ACTIONS(627), 29,
      anon_sym_if,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_integer,
      sym_any,
      sym_avg,
      sym_boolean,
      sym_count,
      sym_date,
      sym_exists,
      sym_false,
      sym_forall,
      sym_forex,
      sym_max,
      sym_min,
      sym_not,
      sym_none,
      sym_rank,
      sym_result,
      sym_strictcount,
      sym_strictsum,
      sym_strictconcat,
      sym_concat,
      sym_sum,
      sym_super,
      sym_this,
      sym_true,
  [8676] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(625), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(623), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [8724] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(633), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(631), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [8772] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(617), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(615), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [8820] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(637), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(635), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [8868] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(619), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(621), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [8916] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(617), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(615), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [8964] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(611), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(613), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [9012] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(619), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(621), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [9060] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(611), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(613), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [9108] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(639), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(641), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [9156] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(645), 8,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      sym__upper_id,
      sym__at_lower_id,
      sym_float,
      sym_string,
      sym_minus,
      sym_plus,
    ACTIONS(643), 29,
      anon_sym_if,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_integer,
      sym_any,
      sym_avg,
      sym_boolean,
      sym_count,
      sym_date,
      sym_exists,
      sym_false,
      sym_forall,
      sym_forex,
      sym_max,
      sym_min,
      sym_not,
      sym_none,
      sym_rank,
      sym_result,
      sym_strictcount,
      sym_strictsum,
      sym_strictconcat,
      sym_concat,
      sym_sum,
      sym_super,
      sym_this,
      sym_true,
  [9202] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(649), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(647), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [9250] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(653), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(651), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [9298] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(649), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(647), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [9346] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(639), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(641), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [9394] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(655), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(657), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [9442] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(661), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(659), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [9490] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(649), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(647), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [9538] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(609), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(607), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [9586] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(663), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(665), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [9634] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(653), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(651), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [9682] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(661), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(659), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [9730] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(663), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(665), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [9778] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(669), 8,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      sym__upper_id,
      sym__at_lower_id,
      sym_float,
      sym_string,
      sym_minus,
      sym_plus,
    ACTIONS(667), 29,
      anon_sym_if,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_integer,
      sym_any,
      sym_avg,
      sym_boolean,
      sym_count,
      sym_date,
      sym_exists,
      sym_false,
      sym_forall,
      sym_forex,
      sym_max,
      sym_min,
      sym_not,
      sym_none,
      sym_rank,
      sym_result,
      sym_strictcount,
      sym_strictsum,
      sym_strictconcat,
      sym_concat,
      sym_sum,
      sym_super,
      sym_this,
      sym_true,
  [9824] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(639), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(641), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [9872] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(605), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(603), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [9920] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(663), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(665), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [9968] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(673), 8,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      sym__upper_id,
      sym__at_lower_id,
      sym_float,
      sym_string,
      sym_minus,
      sym_plus,
    ACTIONS(671), 29,
      anon_sym_if,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_integer,
      sym_any,
      sym_avg,
      sym_boolean,
      sym_count,
      sym_date,
      sym_exists,
      sym_false,
      sym_forall,
      sym_forex,
      sym_max,
      sym_min,
      sym_not,
      sym_none,
      sym_rank,
      sym_result,
      sym_strictcount,
      sym_strictsum,
      sym_strictconcat,
      sym_concat,
      sym_sum,
      sym_super,
      sym_this,
      sym_true,
  [10014] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(637), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(635), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [10062] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(633), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(631), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [10110] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(653), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(651), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [10158] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(609), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(607), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [10206] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(625), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(623), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [10254] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(605), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(603), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [10302] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(617), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(615), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [10350] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(619), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(621), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [10398] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(637), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(635), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [10446] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(633), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(631), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [10494] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(609), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(607), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [10542] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(661), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(659), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [10590] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(611), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(613), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [10638] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(649), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(647), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [10686] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(655), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(657), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [10734] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(633), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(631), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [10782] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(639), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(641), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [10830] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(637), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(635), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [10878] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(655), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(657), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [10926] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(655), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(657), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [10974] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(661), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(659), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [11022] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(663), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(665), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [11070] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(653), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(651), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [11118] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(625), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
    ACTIONS(623), 24,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_asc,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_desc,
      sym_import,
      sym_in,
      sym_instanceof,
      sym_predicate,
      sym_lt,
      sym_gt,
      sym_slash,
  [11166] = 26,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(33), 1,
      sym_predicate,
    ACTIONS(675), 1,
      anon_sym_module,
    ACTIONS(677), 1,
      anon_sym_RBRACE,
    ACTIONS(679), 1,
      anon_sym_from,
    ACTIONS(681), 1,
      anon_sym_where,
    ACTIONS(683), 1,
      anon_sym_select,
    ACTIONS(685), 1,
      sym_qldoc,
    ACTIONS(687), 1,
      sym_class,
    ACTIONS(689), 1,
      sym_newtype,
    ACTIONS(691), 1,
      sym_import,
    STATE(458), 1,
      sym_dbtype,
    STATE(830), 1,
      sym_annotName,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1100), 1,
      sym_returnType,
    STATE(1251), 1,
      sym_moduleExpr,
    STATE(1253), 1,
      sym_typeExpr,
    STATE(456), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(459), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
    STATE(776), 6,
      sym_module,
      sym_imprt,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [11257] = 26,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(693), 1,
      ts_builtin_sym_end,
    ACTIONS(695), 1,
      sym__lower_id,
    ACTIONS(698), 1,
      anon_sym_module,
    ACTIONS(701), 1,
      anon_sym_from,
    ACTIONS(704), 1,
      anon_sym_where,
    ACTIONS(707), 1,
      anon_sym_select,
    ACTIONS(710), 1,
      sym_qldoc,
    ACTIONS(716), 1,
      sym__upper_id,
    ACTIONS(719), 1,
      sym__at_lower_id,
    ACTIONS(722), 1,
      sym_class,
    ACTIONS(725), 1,
      sym_newtype,
    ACTIONS(728), 1,
      sym_import,
    ACTIONS(731), 1,
      sym_predicate,
    STATE(458), 1,
      sym_dbtype,
    STATE(830), 1,
      sym_annotName,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1092), 1,
      sym_returnType,
    STATE(1251), 1,
      sym_moduleExpr,
    STATE(1253), 1,
      sym_typeExpr,
    STATE(451), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    STATE(463), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(713), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
    STATE(825), 6,
      sym_module,
      sym_imprt,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [11348] = 26,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(33), 1,
      sym_predicate,
    ACTIONS(675), 1,
      anon_sym_module,
    ACTIONS(679), 1,
      anon_sym_from,
    ACTIONS(681), 1,
      anon_sym_where,
    ACTIONS(683), 1,
      anon_sym_select,
    ACTIONS(685), 1,
      sym_qldoc,
    ACTIONS(687), 1,
      sym_class,
    ACTIONS(689), 1,
      sym_newtype,
    ACTIONS(691), 1,
      sym_import,
    ACTIONS(734), 1,
      anon_sym_RBRACE,
    STATE(458), 1,
      sym_dbtype,
    STATE(830), 1,
      sym_annotName,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1100), 1,
      sym_returnType,
    STATE(1251), 1,
      sym_moduleExpr,
    STATE(1253), 1,
      sym_typeExpr,
    STATE(456), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(459), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
    STATE(776), 6,
      sym_module,
      sym_imprt,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [11439] = 26,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(33), 1,
      sym_predicate,
    ACTIONS(675), 1,
      anon_sym_module,
    ACTIONS(679), 1,
      anon_sym_from,
    ACTIONS(681), 1,
      anon_sym_where,
    ACTIONS(683), 1,
      anon_sym_select,
    ACTIONS(685), 1,
      sym_qldoc,
    ACTIONS(687), 1,
      sym_class,
    ACTIONS(689), 1,
      sym_newtype,
    ACTIONS(691), 1,
      sym_import,
    ACTIONS(736), 1,
      anon_sym_RBRACE,
    STATE(458), 1,
      sym_dbtype,
    STATE(830), 1,
      sym_annotName,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1100), 1,
      sym_returnType,
    STATE(1251), 1,
      sym_moduleExpr,
    STATE(1253), 1,
      sym_typeExpr,
    STATE(450), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(459), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
    STATE(776), 6,
      sym_module,
      sym_imprt,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [11530] = 26,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(11), 1,
      anon_sym_module,
    ACTIONS(13), 1,
      anon_sym_from,
    ACTIONS(15), 1,
      anon_sym_where,
    ACTIONS(17), 1,
      anon_sym_select,
    ACTIONS(19), 1,
      sym_qldoc,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(27), 1,
      sym_class,
    ACTIONS(29), 1,
      sym_newtype,
    ACTIONS(31), 1,
      sym_import,
    ACTIONS(33), 1,
      sym_predicate,
    ACTIONS(738), 1,
      ts_builtin_sym_end,
    STATE(458), 1,
      sym_dbtype,
    STATE(830), 1,
      sym_annotName,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1092), 1,
      sym_returnType,
    STATE(1251), 1,
      sym_moduleExpr,
    STATE(1253), 1,
      sym_typeExpr,
    STATE(451), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    STATE(463), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
    STATE(825), 6,
      sym_module,
      sym_imprt,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [11621] = 26,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(33), 1,
      sym_predicate,
    ACTIONS(675), 1,
      anon_sym_module,
    ACTIONS(679), 1,
      anon_sym_from,
    ACTIONS(681), 1,
      anon_sym_where,
    ACTIONS(683), 1,
      anon_sym_select,
    ACTIONS(685), 1,
      sym_qldoc,
    ACTIONS(687), 1,
      sym_class,
    ACTIONS(689), 1,
      sym_newtype,
    ACTIONS(691), 1,
      sym_import,
    ACTIONS(740), 1,
      anon_sym_RBRACE,
    STATE(458), 1,
      sym_dbtype,
    STATE(830), 1,
      sym_annotName,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1100), 1,
      sym_returnType,
    STATE(1251), 1,
      sym_moduleExpr,
    STATE(1253), 1,
      sym_typeExpr,
    STATE(452), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(459), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
    STATE(776), 6,
      sym_module,
      sym_imprt,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [11712] = 26,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(693), 1,
      anon_sym_RBRACE,
    ACTIONS(695), 1,
      sym__lower_id,
    ACTIONS(716), 1,
      sym__upper_id,
    ACTIONS(719), 1,
      sym__at_lower_id,
    ACTIONS(731), 1,
      sym_predicate,
    ACTIONS(742), 1,
      anon_sym_module,
    ACTIONS(745), 1,
      anon_sym_from,
    ACTIONS(748), 1,
      anon_sym_where,
    ACTIONS(751), 1,
      anon_sym_select,
    ACTIONS(754), 1,
      sym_qldoc,
    ACTIONS(757), 1,
      sym_class,
    ACTIONS(760), 1,
      sym_newtype,
    ACTIONS(763), 1,
      sym_import,
    STATE(458), 1,
      sym_dbtype,
    STATE(830), 1,
      sym_annotName,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1100), 1,
      sym_returnType,
    STATE(1251), 1,
      sym_moduleExpr,
    STATE(1253), 1,
      sym_typeExpr,
    STATE(456), 2,
      sym_moduleMember,
      aux_sym_ql_repeat1,
    STATE(459), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(713), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
    STATE(776), 6,
      sym_module,
      sym_imprt,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [11803] = 4,
    ACTIONS(463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(513), 14,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      sym__lower_id,
      sym_asc,
      sym_desc,
      sym_in,
      sym_instanceof,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(511), 18,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym__upper_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [11847] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(615), 15,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      sym__lower_id,
      sym_asc,
      sym_desc,
      sym_in,
      sym_instanceof,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(617), 17,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym__upper_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [11888] = 22,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(33), 1,
      sym_predicate,
    ACTIONS(675), 1,
      anon_sym_module,
    ACTIONS(679), 1,
      anon_sym_from,
    ACTIONS(681), 1,
      anon_sym_where,
    ACTIONS(683), 1,
      anon_sym_select,
    ACTIONS(687), 1,
      sym_class,
    ACTIONS(689), 1,
      sym_newtype,
    ACTIONS(691), 1,
      sym_import,
    STATE(458), 1,
      sym_dbtype,
    STATE(830), 1,
      sym_annotName,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1100), 1,
      sym_returnType,
    STATE(1251), 1,
      sym_moduleExpr,
    STATE(1253), 1,
      sym_typeExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    STATE(750), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
    STATE(769), 6,
      sym_module,
      sym_imprt,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [11967] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(621), 15,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      sym__lower_id,
      sym_asc,
      sym_desc,
      sym_in,
      sym_instanceof,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(619), 17,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym__upper_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [12008] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(613), 15,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      sym__lower_id,
      sym_asc,
      sym_desc,
      sym_in,
      sym_instanceof,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(611), 17,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym__upper_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [12049] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(659), 15,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      sym__lower_id,
      sym_asc,
      sym_desc,
      sym_in,
      sym_instanceof,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(661), 17,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym__upper_id,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [12090] = 22,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(11), 1,
      anon_sym_module,
    ACTIONS(13), 1,
      anon_sym_from,
    ACTIONS(15), 1,
      anon_sym_where,
    ACTIONS(17), 1,
      anon_sym_select,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(27), 1,
      sym_class,
    ACTIONS(29), 1,
      sym_newtype,
    ACTIONS(31), 1,
      sym_import,
    ACTIONS(33), 1,
      sym_predicate,
    STATE(458), 1,
      sym_dbtype,
    STATE(830), 1,
      sym_annotName,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1092), 1,
      sym_returnType,
    STATE(1251), 1,
      sym_moduleExpr,
    STATE(1253), 1,
      sym_typeExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    STATE(750), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
    STATE(815), 6,
      sym_module,
      sym_imprt,
      sym_classlessPredicate,
      sym_datatype,
      sym_select,
      sym_dataclass,
  [12169] = 5,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(469), 2,
      sym_star,
      sym_plus,
    ACTIONS(465), 5,
      anon_sym_DOT,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(463), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_mod,
  [12212] = 4,
    ACTIONS(501), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(497), 5,
      anon_sym_DOT,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(499), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [12252] = 4,
    ACTIONS(766), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(515), 4,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(517), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [12291] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(509), 5,
      anon_sym_DOT,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(507), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [12328] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(593), 5,
      anon_sym_DOT,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(595), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [12365] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(565), 5,
      anon_sym_DOT,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(567), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [12402] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(557), 5,
      anon_sym_DOT,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(559), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [12439] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 5,
      anon_sym_DOT,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(583), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [12476] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(545), 5,
      anon_sym_DOT,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(547), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [12513] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(503), 5,
      anon_sym_DOT,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(505), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [12550] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(553), 5,
      anon_sym_DOT,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(555), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [12587] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 5,
      anon_sym_DOT,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(575), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [12624] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(541), 5,
      anon_sym_DOT,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(543), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [12661] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(521), 5,
      anon_sym_DOT,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(523), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [12698] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 5,
      anon_sym_DOT,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(571), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [12735] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(525), 5,
      anon_sym_DOT,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(527), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [12772] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(577), 5,
      anon_sym_DOT,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(579), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [12809] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(549), 5,
      anon_sym_DOT,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(551), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [12846] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(529), 5,
      anon_sym_DOT,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(531), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [12883] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(533), 5,
      anon_sym_DOT,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(535), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [12920] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(561), 5,
      anon_sym_DOT,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(563), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [12957] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(537), 5,
      anon_sym_DOT,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(539), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [12994] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(591), 5,
      anon_sym_DOT,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(589), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [13031] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(587), 5,
      anon_sym_DOT,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(585), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [13068] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(665), 4,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(663), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [13104] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(635), 4,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(637), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [13140] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(33), 1,
      sym_predicate,
    ACTIONS(768), 1,
      anon_sym_RBRACE,
    ACTIONS(770), 1,
      sym_qldoc,
    STATE(458), 1,
      sym_dbtype,
    STATE(461), 1,
      sym_typeLiteral,
    STATE(830), 1,
      sym_annotName,
    STATE(904), 1,
      sym_typeExpr,
    STATE(1058), 1,
      sym_className,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1112), 1,
      sym_returnType,
    STATE(1200), 1,
      sym_varDecl,
    STATE(1251), 1,
      sym_moduleExpr,
    STATE(506), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(533), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(863), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [13212] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(623), 4,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(625), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [13248] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(657), 4,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(655), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [13284] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(33), 1,
      sym_predicate,
    ACTIONS(768), 1,
      anon_sym_RBRACE,
    ACTIONS(770), 1,
      sym_qldoc,
    STATE(458), 1,
      sym_dbtype,
    STATE(461), 1,
      sym_typeLiteral,
    STATE(830), 1,
      sym_annotName,
    STATE(904), 1,
      sym_typeExpr,
    STATE(1058), 1,
      sym_className,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1112), 1,
      sym_returnType,
    STATE(1200), 1,
      sym_varDecl,
    STATE(1251), 1,
      sym_moduleExpr,
    STATE(502), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(533), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(863), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [13356] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(651), 4,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(653), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [13392] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(641), 4,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(639), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [13428] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(33), 1,
      sym_predicate,
    ACTIONS(770), 1,
      sym_qldoc,
    ACTIONS(772), 1,
      anon_sym_RBRACE,
    STATE(458), 1,
      sym_dbtype,
    STATE(461), 1,
      sym_typeLiteral,
    STATE(830), 1,
      sym_annotName,
    STATE(904), 1,
      sym_typeExpr,
    STATE(1058), 1,
      sym_className,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1112), 1,
      sym_returnType,
    STATE(1200), 1,
      sym_varDecl,
    STATE(1251), 1,
      sym_moduleExpr,
    STATE(502), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(533), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(863), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [13500] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(33), 1,
      sym_predicate,
    ACTIONS(770), 1,
      sym_qldoc,
    ACTIONS(772), 1,
      anon_sym_RBRACE,
    STATE(458), 1,
      sym_dbtype,
    STATE(461), 1,
      sym_typeLiteral,
    STATE(830), 1,
      sym_annotName,
    STATE(904), 1,
      sym_typeExpr,
    STATE(1058), 1,
      sym_className,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1112), 1,
      sym_returnType,
    STATE(1200), 1,
      sym_varDecl,
    STATE(1251), 1,
      sym_moduleExpr,
    STATE(504), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(533), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(863), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [13572] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(33), 1,
      sym_predicate,
    ACTIONS(770), 1,
      sym_qldoc,
    ACTIONS(774), 1,
      anon_sym_RBRACE,
    STATE(458), 1,
      sym_dbtype,
    STATE(461), 1,
      sym_typeLiteral,
    STATE(830), 1,
      sym_annotName,
    STATE(904), 1,
      sym_typeExpr,
    STATE(1058), 1,
      sym_className,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1112), 1,
      sym_returnType,
    STATE(1200), 1,
      sym_varDecl,
    STATE(1251), 1,
      sym_moduleExpr,
    STATE(493), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(533), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(863), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [13644] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(607), 4,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(609), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [13680] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(647), 4,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(649), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [13716] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(33), 1,
      sym_predicate,
    ACTIONS(770), 1,
      sym_qldoc,
    ACTIONS(776), 1,
      anon_sym_RBRACE,
    STATE(458), 1,
      sym_dbtype,
    STATE(461), 1,
      sym_typeLiteral,
    STATE(830), 1,
      sym_annotName,
    STATE(904), 1,
      sym_typeExpr,
    STATE(1058), 1,
      sym_className,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1112), 1,
      sym_returnType,
    STATE(1200), 1,
      sym_varDecl,
    STATE(1251), 1,
      sym_moduleExpr,
    STATE(496), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(533), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(863), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [13788] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(778), 1,
      sym__lower_id,
    ACTIONS(781), 1,
      anon_sym_RBRACE,
    ACTIONS(783), 1,
      sym_qldoc,
    ACTIONS(789), 1,
      sym__upper_id,
    ACTIONS(792), 1,
      sym__at_lower_id,
    ACTIONS(795), 1,
      sym_predicate,
    STATE(458), 1,
      sym_dbtype,
    STATE(461), 1,
      sym_typeLiteral,
    STATE(830), 1,
      sym_annotName,
    STATE(904), 1,
      sym_typeExpr,
    STATE(1058), 1,
      sym_className,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1112), 1,
      sym_returnType,
    STATE(1200), 1,
      sym_varDecl,
    STATE(1251), 1,
      sym_moduleExpr,
    STATE(502), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(533), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(863), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(786), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [13860] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(603), 4,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(605), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [13896] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(33), 1,
      sym_predicate,
    ACTIONS(770), 1,
      sym_qldoc,
    ACTIONS(798), 1,
      anon_sym_RBRACE,
    STATE(458), 1,
      sym_dbtype,
    STATE(461), 1,
      sym_typeLiteral,
    STATE(830), 1,
      sym_annotName,
    STATE(904), 1,
      sym_typeExpr,
    STATE(1058), 1,
      sym_className,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1112), 1,
      sym_returnType,
    STATE(1200), 1,
      sym_varDecl,
    STATE(1251), 1,
      sym_moduleExpr,
    STATE(502), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(533), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(863), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [13968] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(631), 4,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(633), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [14004] = 21,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(33), 1,
      sym_predicate,
    ACTIONS(770), 1,
      sym_qldoc,
    ACTIONS(800), 1,
      anon_sym_RBRACE,
    STATE(458), 1,
      sym_dbtype,
    STATE(461), 1,
      sym_typeLiteral,
    STATE(830), 1,
      sym_annotName,
    STATE(904), 1,
      sym_typeExpr,
    STATE(1058), 1,
      sym_className,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1112), 1,
      sym_returnType,
    STATE(1200), 1,
      sym_varDecl,
    STATE(1251), 1,
      sym_moduleExpr,
    STATE(502), 2,
      sym_classMember,
      aux_sym_dataclass_repeat2,
    STATE(533), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(863), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [14076] = 7,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(472), 1,
      anon_sym_RPAREN,
    ACTIONS(802), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(469), 2,
      sym_star,
      sym_plus,
    ACTIONS(465), 4,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(463), 18,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_mod,
  [14120] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(455), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [14179] = 12,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(459), 10,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [14232] = 14,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(425), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_implies,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [14289] = 12,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(495), 10,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [14342] = 13,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(447), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_implies,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [14397] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(443), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [14456] = 12,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(437), 10,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [14509] = 8,
    ACTIONS(401), 1,
      sym_slash,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(449), 3,
      sym_in,
      sym_lt,
      sym_gt,
    ACTIONS(451), 17,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_plus,
  [14554] = 8,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(472), 1,
      anon_sym_DOT,
    ACTIONS(511), 1,
      sym__upper_id,
    ACTIONS(513), 1,
      sym__lower_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(469), 2,
      sym_star,
      sym_plus,
    ACTIONS(463), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COLON_COLON,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_mod,
    ACTIONS(465), 10,
      anon_sym_or,
      anon_sym_and,
      anon_sym_implies,
      sym_asc,
      sym_desc,
      sym_in,
      sym_instanceof,
      sym_lt,
      sym_gt,
      sym_slash,
  [14599] = 6,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(417), 4,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(419), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [14640] = 10,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(423), 2,
      sym_lt,
      sym_gt,
    ACTIONS(421), 15,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_select,
      anon_sym_then,
      anon_sym_else,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [14689] = 8,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(472), 1,
      anon_sym_DOT,
    ACTIONS(511), 1,
      sym__upper_id,
    ACTIONS(513), 1,
      sym__lower_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(469), 2,
      sym_star,
      sym_plus,
    ACTIONS(463), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_mod,
    ACTIONS(465), 10,
      anon_sym_or,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      sym_as,
      sym_in,
      sym_instanceof,
      sym_lt,
      sym_gt,
      sym_slash,
  [14733] = 12,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(459), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      sym_asc,
      sym_desc,
  [14784] = 12,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(495), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      sym_asc,
      sym_desc,
  [14835] = 8,
    ACTIONS(401), 1,
      sym_slash,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(449), 3,
      sym_in,
      sym_lt,
      sym_gt,
    ACTIONS(451), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_plus,
  [14878] = 12,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(437), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      sym_asc,
      sym_desc,
  [14929] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(443), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_asc,
      sym_desc,
  [14986] = 13,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(817), 1,
      anon_sym_and,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(447), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_implies,
      anon_sym_PIPE,
      sym_asc,
      sym_desc,
  [15039] = 14,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(425), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_implies,
      anon_sym_PIPE,
      sym_asc,
      sym_desc,
  [15094] = 6,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(417), 4,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(419), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [15133] = 17,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    STATE(1087), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(379), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(821), 2,
      sym_asc,
      sym_desc,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [15194] = 10,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(423), 2,
      sym_lt,
      sym_gt,
    ACTIONS(421), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_PIPE,
      sym_asc,
      sym_desc,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [15241] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(455), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_asc,
      sym_desc,
  [15298] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(823), 1,
      anon_sym_or,
    ACTIONS(825), 1,
      anon_sym_and,
    ACTIONS(827), 1,
      anon_sym_implies,
    ACTIONS(829), 1,
      sym_in,
    ACTIONS(831), 1,
      sym_instanceof,
    STATE(163), 1,
      sym_addop,
    STATE(164), 1,
      sym_mulop,
    STATE(166), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(443), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_order,
      sym_as,
  [15354] = 13,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(493), 1,
      anon_sym_or,
    ACTIONS(829), 1,
      sym_in,
    ACTIONS(831), 1,
      sym_instanceof,
    STATE(163), 1,
      sym_addop,
    STATE(164), 1,
      sym_mulop,
    STATE(166), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(495), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      sym_as,
  [15406] = 17,
    ACTIONS(9), 1,
      sym__lower_id,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(33), 1,
      sym_predicate,
    STATE(458), 1,
      sym_dbtype,
    STATE(461), 1,
      sym_typeLiteral,
    STATE(830), 1,
      sym_annotName,
    STATE(904), 1,
      sym_typeExpr,
    STATE(1058), 1,
      sym_className,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1112), 1,
      sym_returnType,
    STATE(1200), 1,
      sym_varDecl,
    STATE(1251), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(750), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    STATE(861), 3,
      sym_charpred,
      sym_memberPredicate,
      sym_field,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [15466] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(823), 1,
      anon_sym_or,
    ACTIONS(825), 1,
      anon_sym_and,
    ACTIONS(827), 1,
      anon_sym_implies,
    ACTIONS(829), 1,
      sym_in,
    ACTIONS(831), 1,
      sym_instanceof,
    STATE(163), 1,
      sym_addop,
    STATE(164), 1,
      sym_mulop,
    STATE(166), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(455), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_order,
      sym_as,
  [15522] = 14,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(445), 1,
      anon_sym_or,
    ACTIONS(825), 1,
      anon_sym_and,
    ACTIONS(829), 1,
      sym_in,
    ACTIONS(831), 1,
      sym_instanceof,
    STATE(163), 1,
      sym_addop,
    STATE(164), 1,
      sym_mulop,
    STATE(166), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(447), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_implies,
      anon_sym_order,
      sym_as,
  [15576] = 8,
    ACTIONS(401), 1,
      sym_slash,
    STATE(163), 1,
      sym_addop,
    STATE(164), 1,
      sym_mulop,
    STATE(166), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(449), 4,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
    ACTIONS(451), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_plus,
  [15618] = 6,
    STATE(163), 1,
      sym_addop,
    STATE(164), 1,
      sym_mulop,
    STATE(166), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(417), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(419), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [15656] = 10,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(829), 1,
      sym_in,
    STATE(163), 1,
      sym_addop,
    STATE(164), 1,
      sym_mulop,
    STATE(166), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(423), 3,
      anon_sym_or,
      sym_lt,
      sym_gt,
    ACTIONS(421), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [15702] = 14,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(823), 1,
      anon_sym_or,
    ACTIONS(825), 1,
      anon_sym_and,
    ACTIONS(829), 1,
      sym_in,
    ACTIONS(831), 1,
      sym_instanceof,
    STATE(163), 1,
      sym_addop,
    STATE(164), 1,
      sym_mulop,
    STATE(166), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(425), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_implies,
      anon_sym_order,
      sym_as,
  [15756] = 5,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(469), 2,
      sym_star,
      sym_plus,
    ACTIONS(465), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(463), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_order,
      anon_sym_COLON_COLON,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_mod,
  [15792] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(463), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(465), 16,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [15826] = 16,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(823), 1,
      anon_sym_or,
    ACTIONS(825), 1,
      anon_sym_and,
    ACTIONS(827), 1,
      anon_sym_implies,
    ACTIONS(829), 1,
      sym_in,
    ACTIONS(831), 1,
      sym_instanceof,
    ACTIONS(833), 1,
      sym_as,
    STATE(163), 1,
      sym_addop,
    STATE(164), 1,
      sym_mulop,
    STATE(166), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(477), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_order,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [15884] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(463), 7,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(465), 16,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [15918] = 13,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(439), 1,
      anon_sym_or,
    ACTIONS(829), 1,
      sym_in,
    ACTIONS(831), 1,
      sym_instanceof,
    STATE(163), 1,
      sym_addop,
    STATE(164), 1,
      sym_mulop,
    STATE(166), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(437), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      sym_as,
  [15970] = 13,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(461), 1,
      anon_sym_or,
    ACTIONS(829), 1,
      sym_in,
    ACTIONS(831), 1,
      sym_instanceof,
    STATE(163), 1,
      sym_addop,
    STATE(164), 1,
      sym_mulop,
    STATE(166), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
    ACTIONS(459), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      sym_as,
  [16022] = 17,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(835), 1,
      anon_sym_COMMA,
    ACTIONS(837), 1,
      anon_sym_RBRACK,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    STATE(999), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [16081] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(843), 1,
      anon_sym_DOT,
    STATE(558), 1,
      aux_sym_qualModuleExpr_repeat1,
    ACTIONS(839), 5,
      ts_builtin_sym_end,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(841), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [16118] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(849), 1,
      anon_sym_DOT,
    STATE(548), 1,
      aux_sym_qualModuleExpr_repeat1,
    ACTIONS(847), 5,
      anon_sym_RBRACE,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(845), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [16155] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(856), 1,
      anon_sym_DOT,
    STATE(548), 1,
      aux_sym_qualModuleExpr_repeat1,
    ACTIONS(854), 5,
      anon_sym_RBRACE,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(852), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [16192] = 17,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(835), 1,
      anon_sym_COMMA,
    ACTIONS(858), 1,
      anon_sym_RBRACK,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    STATE(1020), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [16251] = 17,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(835), 1,
      anon_sym_COMMA,
    ACTIONS(860), 1,
      anon_sym_RBRACK,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    STATE(1012), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [16310] = 17,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(835), 1,
      anon_sym_COMMA,
    ACTIONS(862), 1,
      anon_sym_RBRACK,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    STATE(1041), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [16369] = 4,
    ACTIONS(501), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(497), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(499), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [16402] = 17,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(835), 1,
      anon_sym_COMMA,
    ACTIONS(864), 1,
      anon_sym_RBRACK,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    STATE(1002), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [16461] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(866), 1,
      anon_sym_DOT,
    STATE(555), 1,
      aux_sym_qualModuleExpr_repeat1,
    ACTIONS(847), 5,
      ts_builtin_sym_end,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(845), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [16498] = 17,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(835), 1,
      anon_sym_COMMA,
    ACTIONS(869), 1,
      anon_sym_RBRACK,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    STATE(976), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [16557] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(856), 1,
      anon_sym_DOT,
    STATE(549), 1,
      aux_sym_qualModuleExpr_repeat1,
    ACTIONS(839), 5,
      anon_sym_RBRACE,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(841), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [16594] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(843), 1,
      anon_sym_DOT,
    STATE(555), 1,
      aux_sym_qualModuleExpr_repeat1,
    ACTIONS(854), 5,
      ts_builtin_sym_end,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(852), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [16631] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(875), 1,
      anon_sym_LBRACE,
    STATE(748), 1,
      sym_body,
    ACTIONS(871), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(873), 15,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [16667] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(875), 1,
      anon_sym_LBRACE,
    STATE(755), 1,
      sym_body,
    ACTIONS(877), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(879), 15,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [16703] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(885), 1,
      anon_sym_COMMA,
    STATE(597), 1,
      aux_sym_asExprs_repeat1,
    ACTIONS(881), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(883), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [16739] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(533), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(535), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [16769] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(529), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(531), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [16799] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(525), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(527), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [16829] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(521), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(523), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [16859] = 4,
    ACTIONS(887), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(515), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(517), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [16891] = 16,
    ACTIONS(321), 1,
      anon_sym_RPAREN,
    ACTIONS(323), 1,
      anon_sym_PIPE,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [16947] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(889), 1,
      anon_sym_COMMA,
    STATE(575), 1,
      aux_sym_asExprs_repeat1,
    ACTIONS(881), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(883), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [16983] = 16,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(891), 1,
      anon_sym_RPAREN,
    ACTIONS(893), 1,
      anon_sym_PIPE,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [17039] = 16,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(895), 1,
      anon_sym_RPAREN,
    ACTIONS(897), 1,
      anon_sym_PIPE,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [17095] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(903), 1,
      anon_sym_COLON_COLON,
    STATE(581), 1,
      aux_sym_importModuleExpr_repeat1,
    ACTIONS(901), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(899), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [17131] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(847), 6,
      ts_builtin_sym_end,
      anon_sym_DOT,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(845), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [17163] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(909), 1,
      anon_sym_COLON_COLON,
    STATE(585), 1,
      aux_sym_importModuleExpr_repeat1,
    ACTIONS(905), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(907), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [17199] = 16,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(911), 1,
      anon_sym_RPAREN,
    ACTIONS(913), 1,
      anon_sym_PIPE,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [17255] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(889), 1,
      anon_sym_COMMA,
    STATE(595), 1,
      aux_sym_asExprs_repeat1,
    ACTIONS(917), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(915), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [17291] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    STATE(753), 1,
      sym_body,
    ACTIONS(871), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(873), 15,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [17327] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(537), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(539), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [17357] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(925), 1,
      anon_sym_COLON_COLON,
    STATE(578), 1,
      aux_sym_importModuleExpr_repeat1,
    ACTIONS(921), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(923), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [17393] = 16,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(928), 1,
      anon_sym_RPAREN,
    ACTIONS(930), 1,
      anon_sym_PIPE,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [17449] = 4,
    ACTIONS(463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(513), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(511), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [17481] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(932), 1,
      anon_sym_COLON_COLON,
    STATE(581), 1,
      aux_sym_importModuleExpr_repeat1,
    ACTIONS(921), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(923), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [17517] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(875), 1,
      anon_sym_LBRACE,
    STATE(754), 1,
      sym_body,
    ACTIONS(935), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(937), 15,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [17553] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(847), 6,
      anon_sym_RBRACE,
      anon_sym_DOT,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(845), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [17585] = 16,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(939), 1,
      anon_sym_RPAREN,
    ACTIONS(941), 1,
      anon_sym_PIPE,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [17641] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(909), 1,
      anon_sym_COLON_COLON,
    STATE(578), 1,
      aux_sym_importModuleExpr_repeat1,
    ACTIONS(901), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(899), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [17677] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    STATE(761), 1,
      sym_body,
    ACTIONS(945), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(943), 15,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [17713] = 16,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(947), 1,
      anon_sym_RPAREN,
    ACTIONS(949), 1,
      anon_sym_PIPE,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [17769] = 16,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(951), 1,
      anon_sym_RPAREN,
    ACTIONS(953), 1,
      anon_sym_PIPE,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [17825] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(541), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(543), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [17855] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(509), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(507), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [17885] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(545), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(547), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [17915] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(549), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(551), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [17945] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    STATE(757), 1,
      sym_body,
    ACTIONS(957), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(955), 15,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [17981] = 16,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(959), 1,
      anon_sym_RPAREN,
    ACTIONS(961), 1,
      anon_sym_PIPE,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [18037] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(967), 1,
      anon_sym_COMMA,
    STATE(595), 1,
      aux_sym_asExprs_repeat1,
    ACTIONS(965), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(963), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [18073] = 16,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(970), 1,
      anon_sym_RPAREN,
    ACTIONS(972), 1,
      anon_sym_PIPE,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [18129] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(885), 1,
      anon_sym_COMMA,
    STATE(620), 1,
      aux_sym_asExprs_repeat1,
    ACTIONS(917), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(915), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [18165] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(553), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(555), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [18195] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(557), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(559), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [18225] = 16,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(974), 1,
      anon_sym_RPAREN,
    ACTIONS(976), 1,
      anon_sym_PIPE,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [18281] = 16,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(978), 1,
      anon_sym_RPAREN,
    ACTIONS(980), 1,
      anon_sym_PIPE,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [18337] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(903), 1,
      anon_sym_COLON_COLON,
    STATE(571), 1,
      aux_sym_importModuleExpr_repeat1,
    ACTIONS(905), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(907), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [18373] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(561), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(563), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [18403] = 16,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(982), 1,
      anon_sym_RPAREN,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [18459] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(565), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(567), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [18489] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(569), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(571), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [18519] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(986), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [18573] = 16,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(988), 1,
      anon_sym_RPAREN,
    ACTIONS(990), 1,
      anon_sym_PIPE,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [18629] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    STATE(756), 1,
      sym_body,
    ACTIONS(877), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(879), 15,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [18665] = 16,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(992), 1,
      anon_sym_RPAREN,
    ACTIONS(994), 1,
      anon_sym_PIPE,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [18721] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(875), 1,
      anon_sym_LBRACE,
    STATE(760), 1,
      sym_body,
    ACTIONS(957), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(955), 15,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [18757] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(503), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(505), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [18787] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(573), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(575), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [18817] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(577), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(579), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [18847] = 16,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(996), 1,
      anon_sym_RPAREN,
    ACTIONS(998), 1,
      anon_sym_PIPE,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [18903] = 16,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1000), 1,
      anon_sym_RPAREN,
    ACTIONS(1002), 1,
      anon_sym_PIPE,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [18959] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    STATE(746), 1,
      sym_body,
    ACTIONS(935), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(937), 15,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [18995] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(581), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(583), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [19025] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(593), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(595), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [19055] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1004), 1,
      anon_sym_COMMA,
    STATE(620), 1,
      aux_sym_asExprs_repeat1,
    ACTIONS(965), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(963), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [19091] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(591), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(589), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [19121] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(587), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(585), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_DOT,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [19151] = 16,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1007), 1,
      anon_sym_RPAREN,
    ACTIONS(1009), 1,
      anon_sym_PIPE,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [19207] = 16,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1011), 1,
      anon_sym_RPAREN,
    ACTIONS(1013), 1,
      anon_sym_PIPE,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [19263] = 16,
    ACTIONS(317), 1,
      anon_sym_RPAREN,
    ACTIONS(319), 1,
      anon_sym_PIPE,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [19319] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(1015), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [19373] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(875), 1,
      anon_sym_LBRACE,
    STATE(762), 1,
      sym_body,
    ACTIONS(945), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(943), 15,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [19409] = 16,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1017), 1,
      anon_sym_RPAREN,
    ACTIONS(1019), 1,
      anon_sym_PIPE,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [19465] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(621), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(619), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [19494] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1025), 1,
      anon_sym_order,
    STATE(795), 1,
      sym_orderBys,
    ACTIONS(1021), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1023), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [19529] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1031), 1,
      anon_sym_COMMA,
    STATE(634), 1,
      aux_sym_orderBys_repeat1,
    ACTIONS(1029), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1027), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [19564] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(623), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(625), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [19593] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1033), 1,
      anon_sym_COMMA,
    STATE(674), 1,
      aux_sym_orderBys_repeat1,
    ACTIONS(1029), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1027), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [19628] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1039), 1,
      anon_sym_COMMA,
    STATE(634), 1,
      aux_sym_orderBys_repeat1,
    ACTIONS(1037), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1035), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [19663] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(641), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(639), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [19692] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(647), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(649), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [19721] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(607), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(609), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [19750] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1046), 1,
      anon_sym_or,
    STATE(739), 1,
      aux_sym_datatypeBranches_repeat1,
    ACTIONS(1042), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1044), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [19785] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1048), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [19838] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1050), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [19891] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1052), 1,
      anon_sym_else,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [19944] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(965), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(963), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [19975] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1054), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1056), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [20006] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1058), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [20059] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1025), 1,
      anon_sym_order,
    STATE(771), 1,
      sym_orderBys,
    ACTIONS(1060), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1062), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [20094] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1064), 1,
      anon_sym_select,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [20147] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(988), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [20200] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(657), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(655), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [20229] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1066), 1,
      anon_sym_RBRACE,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [20282] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1031), 1,
      anon_sym_COMMA,
    STATE(631), 1,
      aux_sym_orderBys_repeat1,
    ACTIONS(1070), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1068), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [20317] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(921), 5,
      ts_builtin_sym_end,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(923), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [20348] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(603), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(605), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [20377] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(965), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(963), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [20408] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1054), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1056), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [20439] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(631), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(633), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [20468] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(635), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(637), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [20497] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(651), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(653), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [20526] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1076), 1,
      anon_sym_or,
    STATE(658), 1,
      aux_sym_datatypeBranches_repeat1,
    ACTIONS(1072), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1074), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [20561] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(665), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(663), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [20590] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1079), 1,
      anon_sym_RBRACE,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [20643] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1081), 1,
      anon_sym_select,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [20696] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1083), 1,
      anon_sym_select,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [20749] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1085), 1,
      anon_sym_RBRACK,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [20802] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1087), 1,
      anon_sym_else,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [20855] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(499), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(497), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [20886] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1089), 1,
      anon_sym_RBRACK,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [20939] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1091), 1,
      anon_sym_else,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [20992] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1093), 1,
      anon_sym_RBRACK,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [21045] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1025), 1,
      anon_sym_order,
    STATE(822), 1,
      sym_orderBys,
    ACTIONS(1095), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1097), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [21080] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1011), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [21133] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1099), 1,
      anon_sym_else,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [21186] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1101), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [21239] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1103), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [21292] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1105), 1,
      anon_sym_COMMA,
    STATE(674), 1,
      aux_sym_orderBys_repeat1,
    ACTIONS(1037), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1035), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [21327] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1108), 1,
      anon_sym_then,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [21380] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1110), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [21433] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1112), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [21486] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1114), 1,
      anon_sym_select,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [21539] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(947), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [21592] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(939), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [21645] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1116), 1,
      anon_sym_DOT_DOT,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [21698] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1118), 1,
      anon_sym_then,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [21751] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1120), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [21804] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1122), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [21857] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1124), 1,
      anon_sym_DOT_DOT,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [21910] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1126), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [21963] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1128), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [22016] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1130), 1,
      anon_sym_then,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [22069] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1132), 1,
      anon_sym_select,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [22122] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1134), 1,
      anon_sym_order,
    STATE(808), 1,
      sym_orderBys,
    ACTIONS(1095), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1097), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [22157] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1136), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [22210] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1138), 1,
      anon_sym_DOT_DOT,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [22263] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1140), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [22316] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1142), 1,
      anon_sym_or,
    STATE(694), 1,
      aux_sym_datatypeBranches_repeat1,
    ACTIONS(1072), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1074), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [22351] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1145), 1,
      anon_sym_RBRACK,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [22404] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1147), 1,
      anon_sym_else,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [22457] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1149), 1,
      anon_sym_else,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [22510] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1151), 1,
      anon_sym_RBRACK,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [22563] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1153), 1,
      anon_sym_then,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [22616] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1155), 1,
      anon_sym_DOT_DOT,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [22669] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1157), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [22722] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1134), 1,
      anon_sym_order,
    STATE(827), 1,
      sym_orderBys,
    ACTIONS(1161), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1159), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [22757] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1163), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [22810] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1165), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [22863] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1167), 1,
      anon_sym_then,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [22916] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1025), 1,
      anon_sym_order,
    STATE(767), 1,
      sym_orderBys,
    ACTIONS(1169), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1171), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [22951] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1173), 1,
      anon_sym_select,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [23004] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1175), 1,
      anon_sym_select,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [23057] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1025), 1,
      anon_sym_order,
    STATE(801), 1,
      sym_orderBys,
    ACTIONS(1177), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1179), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [23092] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1181), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [23145] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1183), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [23198] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1189), 1,
      anon_sym_or,
    STATE(694), 1,
      aux_sym_datatypeBranches_repeat1,
    ACTIONS(1187), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1185), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [23233] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1191), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [23286] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1000), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [23339] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1193), 1,
      anon_sym_RBRACE,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [23392] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(959), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [23445] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1195), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [23498] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1197), 1,
      anon_sym_RBRACK,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [23551] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1199), 1,
      anon_sym_else,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [23604] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1201), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [23657] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1134), 1,
      anon_sym_order,
    STATE(816), 1,
      sym_orderBys,
    ACTIONS(1060), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1062), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [23692] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1203), 1,
      anon_sym_then,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [23745] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [23798] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1134), 1,
      anon_sym_order,
    STATE(781), 1,
      sym_orderBys,
    ACTIONS(1021), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1023), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [23833] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1025), 1,
      anon_sym_order,
    STATE(796), 1,
      sym_orderBys,
    ACTIONS(1161), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1159), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [23868] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(921), 5,
      anon_sym_RBRACE,
      sym_qldoc,
      anon_sym_COLON_COLON,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(923), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_as,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [23899] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1189), 1,
      anon_sym_or,
    STATE(712), 1,
      aux_sym_datatypeBranches_repeat1,
    ACTIONS(1042), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1044), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [23934] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(659), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(661), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [23963] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1207), 1,
      anon_sym_DOT_DOT,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [24016] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1209), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [24069] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1033), 1,
      anon_sym_COMMA,
    STATE(633), 1,
      aux_sym_orderBys_repeat1,
    ACTIONS(1070), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1068), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [24104] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1211), 1,
      anon_sym_then,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [24157] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1134), 1,
      anon_sym_order,
    STATE(818), 1,
      sym_orderBys,
    ACTIONS(1177), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1179), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [24192] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(499), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(497), 15,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_order,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [24223] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1134), 1,
      anon_sym_order,
    STATE(789), 1,
      sym_orderBys,
    ACTIONS(1169), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1171), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [24258] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(613), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(611), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [24287] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(805), 1,
      anon_sym_or,
    ACTIONS(807), 1,
      anon_sym_and,
    ACTIONS(809), 1,
      anon_sym_implies,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(1213), 1,
      anon_sym_select,
    STATE(100), 1,
      sym_compop,
    STATE(101), 1,
      sym_mulop,
    STATE(102), 1,
      sym_addop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [24340] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(615), 5,
      anon_sym_or,
      sym_in,
      sym_lt,
      sym_gt,
      sym_slash,
    ACTIONS(617), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_implies,
      anon_sym_order,
      sym_as,
      sym_instanceof,
      sym_le,
      sym_eq,
      sym_ge,
      sym_minus,
      sym_ne,
      sym_star,
      sym_mod,
      sym_plus,
  [24369] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1046), 1,
      anon_sym_or,
    STATE(658), 1,
      aux_sym_datatypeBranches_repeat1,
    ACTIONS(1187), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1185), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [24404] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1215), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [24457] = 15,
    ACTIONS(401), 1,
      sym_slash,
    ACTIONS(811), 1,
      sym_in,
    ACTIONS(813), 1,
      sym_instanceof,
    ACTIONS(815), 1,
      anon_sym_or,
    ACTIONS(817), 1,
      anon_sym_and,
    ACTIONS(819), 1,
      anon_sym_implies,
    ACTIONS(1217), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      sym_addop,
    STATE(187), 1,
      sym_mulop,
    STATE(188), 1,
      sym_compop,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(395), 2,
      sym_lt,
      sym_gt,
    ACTIONS(399), 2,
      sym_minus,
      sym_plus,
    ACTIONS(403), 2,
      sym_star,
      sym_mod,
    ACTIONS(397), 4,
      sym_le,
      sym_eq,
      sym_ge,
      sym_ne,
  [24510] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1219), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1221), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [24540] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1072), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1074), 15,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [24570] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1227), 1,
      sym_as,
    ACTIONS(1223), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1225), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [24602] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1229), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1231), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [24632] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(871), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(873), 15,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [24662] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1037), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1035), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [24692] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(877), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(879), 15,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [24722] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1229), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1231), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [24752] = 6,
    ACTIONS(1233), 1,
      sym__lower_id,
    STATE(830), 1,
      sym_annotName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1238), 2,
      sym__upper_id,
      sym__at_lower_id,
    STATE(750), 2,
      sym_annotation,
      aux_sym_moduleMember_repeat1,
    ACTIONS(1236), 13,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [24786] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1242), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1240), 15,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [24816] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1242), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1240), 15,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [24846] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(877), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(879), 15,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [24876] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(871), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(873), 15,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [24906] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(957), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(955), 15,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [24936] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(957), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(955), 15,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [24966] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(945), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(943), 15,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [24996] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1219), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1221), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25026] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1072), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1074), 15,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25056] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(945), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(943), 15,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25086] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1246), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1244), 15,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25116] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1246), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1244), 15,
      anon_sym_module,
      anon_sym_or,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25146] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1037), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1035), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25176] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1248), 1,
      sym_as,
    ACTIONS(1223), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1225), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25208] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1250), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1252), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25237] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1256), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1254), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25266] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1060), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1062), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25295] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1258), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1260), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25324] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1264), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1262), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25353] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1268), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1266), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25382] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1161), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1159), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25411] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1270), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1272), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25440] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1276), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1274), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25469] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1280), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1278), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25498] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1282), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1284), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25527] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1288), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1286), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25556] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1290), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1292), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25585] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1294), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1296), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25614] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1258), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1260), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25643] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1270), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1272), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25672] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1177), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1179), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25701] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1298), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1300), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25730] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1282), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1284), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25759] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1302), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1304), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25788] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1290), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1292), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25817] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1308), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1306), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25846] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1310), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1312), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25875] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1316), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1314), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25904] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1060), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1062), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25933] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1294), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1296), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25962] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1298), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1300), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [25991] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1310), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1312), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26020] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1256), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1254), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26049] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1276), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1274), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26078] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1177), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1179), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26107] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1095), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1097), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26136] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1316), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1314), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26165] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1318), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1320), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26194] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1318), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1320), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26223] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1322), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1324), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26252] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1169), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1171), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26281] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1326), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1328), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26310] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1332), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1330), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26339] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1334), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1336), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26368] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1308), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1306), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26397] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1338), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1340), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26426] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1344), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1342), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26455] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1348), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1346), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26484] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1338), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1340), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26513] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1352), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1350), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26542] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1280), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1278), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26571] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1332), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1330), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26600] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1326), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1328), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26629] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1268), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1266), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26658] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1264), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1262), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26687] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1161), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1159), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26716] = 4,
    ACTIONS(463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1356), 3,
      anon_sym_LBRACK,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1354), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26745] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1169), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1171), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26774] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1322), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1324), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26803] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1352), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1350), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26832] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1344), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1342), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26861] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1348), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1346), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26890] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1302), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1304), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26919] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1334), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1336), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26948] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1288), 4,
      ts_builtin_sym_end,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1286), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [26977] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1250), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1252), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [27006] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1095), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1097), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [27035] = 13,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(1358), 1,
      sym__lower_id,
    ACTIONS(1360), 1,
      anon_sym_where,
    ACTIONS(1362), 1,
      anon_sym_select,
    STATE(458), 1,
      sym_dbtype,
    STATE(905), 1,
      sym_varDecl,
    STATE(925), 1,
      sym_typeExpr,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1251), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [27081] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1356), 3,
      anon_sym_LBRACK,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1354), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [27107] = 4,
    ACTIONS(1366), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1368), 2,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1364), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [27135] = 13,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(1358), 1,
      sym__lower_id,
    ACTIONS(1370), 1,
      anon_sym_where,
    ACTIONS(1372), 1,
      anon_sym_select,
    STATE(458), 1,
      sym_dbtype,
    STATE(924), 1,
      sym_varDecl,
    STATE(925), 1,
      sym_typeExpr,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1251), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [27181] = 12,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(1358), 1,
      sym__lower_id,
    ACTIONS(1374), 1,
      anon_sym_RPAREN,
    STATE(458), 1,
      sym_dbtype,
    STATE(925), 1,
      sym_typeExpr,
    STATE(1009), 1,
      sym_varDecl,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1251), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [27224] = 12,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(1358), 1,
      sym__lower_id,
    ACTIONS(1376), 1,
      anon_sym_RPAREN,
    STATE(458), 1,
      sym_dbtype,
    STATE(925), 1,
      sym_typeExpr,
    STATE(1079), 1,
      sym_varDecl,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1251), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [27267] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1380), 2,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1378), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [27292] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1384), 2,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1382), 14,
      anon_sym_module,
      anon_sym_from,
      anon_sym_where,
      anon_sym_select,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_class,
      sym_newtype,
      sym_date,
      sym_import,
      sym_predicate,
  [27317] = 12,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(1358), 1,
      sym__lower_id,
    ACTIONS(1386), 1,
      anon_sym_RPAREN,
    STATE(458), 1,
      sym_dbtype,
    STATE(925), 1,
      sym_typeExpr,
    STATE(996), 1,
      sym_varDecl,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1251), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [27360] = 12,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(1358), 1,
      sym__lower_id,
    ACTIONS(1388), 1,
      anon_sym_RPAREN,
    STATE(458), 1,
      sym_dbtype,
    STATE(925), 1,
      sym_typeExpr,
    STATE(1015), 1,
      sym_varDecl,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1251), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [27403] = 12,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(1358), 1,
      sym__lower_id,
    ACTIONS(1390), 1,
      anon_sym_RPAREN,
    STATE(458), 1,
      sym_dbtype,
    STATE(925), 1,
      sym_typeExpr,
    STATE(1067), 1,
      sym_varDecl,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1251), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [27446] = 12,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(1358), 1,
      sym__lower_id,
    ACTIONS(1392), 1,
      anon_sym_RPAREN,
    STATE(458), 1,
      sym_dbtype,
    STATE(925), 1,
      sym_typeExpr,
    STATE(1001), 1,
      sym_varDecl,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1251), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [27489] = 12,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(1358), 1,
      sym__lower_id,
    ACTIONS(1394), 1,
      anon_sym_RPAREN,
    STATE(458), 1,
      sym_dbtype,
    STATE(925), 1,
      sym_typeExpr,
    STATE(1078), 1,
      sym_varDecl,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1251), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [27532] = 12,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(1358), 1,
      sym__lower_id,
    ACTIONS(1396), 1,
      anon_sym_RPAREN,
    STATE(458), 1,
      sym_dbtype,
    STATE(925), 1,
      sym_typeExpr,
    STATE(1040), 1,
      sym_varDecl,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1251), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [27575] = 12,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(1358), 1,
      sym__lower_id,
    ACTIONS(1398), 1,
      anon_sym_RPAREN,
    STATE(458), 1,
      sym_dbtype,
    STATE(925), 1,
      sym_typeExpr,
    STATE(1054), 1,
      sym_varDecl,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1251), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [27618] = 11,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(1358), 1,
      sym__lower_id,
    STATE(458), 1,
      sym_dbtype,
    STATE(894), 1,
      sym_varDecl,
    STATE(925), 1,
      sym_typeExpr,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1251), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [27658] = 10,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(1358), 1,
      sym__lower_id,
    STATE(458), 1,
      sym_dbtype,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1180), 1,
      sym_typeExpr,
    STATE(1251), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [27695] = 10,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(1358), 1,
      sym__lower_id,
    STATE(458), 1,
      sym_dbtype,
    STATE(1071), 1,
      sym_typeExpr,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1251), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [27732] = 10,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(1358), 1,
      sym__lower_id,
    STATE(458), 1,
      sym_dbtype,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1234), 1,
      sym_typeExpr,
    STATE(1251), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [27769] = 10,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(1358), 1,
      sym__lower_id,
    STATE(458), 1,
      sym_dbtype,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1251), 1,
      sym_moduleExpr,
    STATE(1254), 1,
      sym_typeExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [27806] = 10,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(1358), 1,
      sym__lower_id,
    STATE(458), 1,
      sym_dbtype,
    STATE(1004), 1,
      sym_typeExpr,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1251), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [27843] = 10,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(1358), 1,
      sym__lower_id,
    STATE(458), 1,
      sym_dbtype,
    STATE(505), 1,
      sym_typeExpr,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1251), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [27880] = 10,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(1358), 1,
      sym__lower_id,
    STATE(458), 1,
      sym_dbtype,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1226), 1,
      sym_typeExpr,
    STATE(1251), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [27917] = 10,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(1358), 1,
      sym__lower_id,
    STATE(458), 1,
      sym_dbtype,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1173), 1,
      sym_typeExpr,
    STATE(1251), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [27954] = 10,
    ACTIONS(1358), 1,
      sym__lower_id,
    ACTIONS(1402), 1,
      sym__upper_id,
    ACTIONS(1404), 1,
      sym__at_lower_id,
    STATE(432), 1,
      sym_dbtype,
    STATE(435), 1,
      sym_typeExpr,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1220), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(438), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(1400), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [27991] = 10,
    ACTIONS(1358), 1,
      sym__lower_id,
    ACTIONS(1408), 1,
      sym__upper_id,
    ACTIONS(1410), 1,
      sym__at_lower_id,
    STATE(394), 1,
      sym_dbtype,
    STATE(399), 1,
      sym_typeExpr,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1153), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(404), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(1406), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [28028] = 10,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(1358), 1,
      sym__lower_id,
    STATE(458), 1,
      sym_dbtype,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1111), 1,
      sym_typeExpr,
    STATE(1251), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [28065] = 10,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(1358), 1,
      sym__lower_id,
    STATE(458), 1,
      sym_dbtype,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1229), 1,
      sym_typeExpr,
    STATE(1251), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [28102] = 10,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(1358), 1,
      sym__lower_id,
    STATE(458), 1,
      sym_dbtype,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1195), 1,
      sym_typeExpr,
    STATE(1251), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [28139] = 10,
    ACTIONS(1358), 1,
      sym__lower_id,
    ACTIONS(1414), 1,
      sym__upper_id,
    ACTIONS(1416), 1,
      sym__at_lower_id,
    STATE(400), 1,
      sym_dbtype,
    STATE(427), 1,
      sym_typeExpr,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1188), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(393), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(1412), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [28176] = 10,
    ACTIONS(1358), 1,
      sym__lower_id,
    ACTIONS(1420), 1,
      sym__upper_id,
    ACTIONS(1422), 1,
      sym__at_lower_id,
    STATE(655), 1,
      sym_typeExpr,
    STATE(738), 1,
      sym_dbtype,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1256), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(736), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(1418), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [28213] = 10,
    ACTIONS(1358), 1,
      sym__lower_id,
    ACTIONS(1426), 1,
      sym__upper_id,
    ACTIONS(1428), 1,
      sym__at_lower_id,
    STATE(403), 1,
      sym_dbtype,
    STATE(441), 1,
      sym_typeExpr,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1233), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(406), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(1424), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [28250] = 10,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(25), 1,
      sym__at_lower_id,
    ACTIONS(1358), 1,
      sym__lower_id,
    STATE(458), 1,
      sym_dbtype,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1160), 1,
      sym_typeExpr,
    STATE(1251), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 2,
      sym_typeLiteral,
      sym_className,
    ACTIONS(21), 5,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym_boolean,
      sym_date,
  [28287] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1432), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1430), 7,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_date,
      sym_predicate,
  [28309] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1436), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1434), 7,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_date,
      sym_predicate,
  [28331] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1440), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1438), 7,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_date,
      sym_predicate,
  [28353] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1444), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1442), 7,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_date,
      sym_predicate,
  [28375] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1448), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1446), 7,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_date,
      sym_predicate,
  [28397] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1452), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1450), 7,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_date,
      sym_predicate,
  [28419] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(463), 11,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_select,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_order,
      anon_sym_COLON_COLON,
      sym_eq,
  [28437] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1456), 4,
      anon_sym_RBRACE,
      sym_qldoc,
      sym__upper_id,
      sym__at_lower_id,
    ACTIONS(1454), 7,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      sym__lower_id,
      sym_boolean,
      sym_date,
      sym_predicate,
  [28459] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1458), 1,
      sym__lower_id,
    ACTIONS(1460), 1,
      sym_qldoc,
    ACTIONS(1462), 1,
      sym__upper_id,
    STATE(638), 1,
      sym_datatypeBranch,
    STATE(814), 1,
      sym_datatypeBranches,
    STATE(830), 1,
      sym_annotName,
    STATE(1120), 1,
      sym_annotation,
    STATE(1176), 1,
      sym_className,
  [28490] = 4,
    ACTIONS(463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(467), 3,
      anon_sym_LPAREN,
      sym_star,
      sym_plus,
    ACTIONS(511), 4,
      anon_sym_RPAREN,
      anon_sym_DOT,
      sym__upper_id,
      sym__lower_id,
  [28509] = 8,
    ACTIONS(1466), 1,
      anon_sym_RPAREN,
    STATE(926), 1,
      sym_literalId,
    STATE(1048), 1,
      sym_predicateExpr,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1171), 1,
      sym_aritylessPredicateExpr,
    STATE(1172), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1464), 2,
      sym__upper_id,
      sym__lower_id,
  [28536] = 8,
    ACTIONS(1468), 1,
      anon_sym_RPAREN,
    STATE(926), 1,
      sym_literalId,
    STATE(975), 1,
      sym_predicateExpr,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1171), 1,
      sym_aritylessPredicateExpr,
    STATE(1172), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1464), 2,
      sym__upper_id,
      sym__lower_id,
  [28563] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1458), 1,
      sym__lower_id,
    ACTIONS(1462), 1,
      sym__upper_id,
    ACTIONS(1470), 1,
      sym_qldoc,
    STATE(727), 1,
      sym_datatypeBranch,
    STATE(770), 1,
      sym_datatypeBranches,
    STATE(830), 1,
      sym_annotName,
    STATE(1106), 1,
      sym_annotation,
    STATE(1202), 1,
      sym_className,
  [28594] = 5,
    ACTIONS(875), 1,
      anon_sym_LBRACE,
    ACTIONS(1472), 1,
      anon_sym_SEMI,
    ACTIONS(1474), 1,
      sym_eq,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(806), 4,
      sym__optbody,
      sym_empty,
      sym_body,
      sym_higherOrderTerm,
  [28614] = 5,
    ACTIONS(875), 1,
      anon_sym_LBRACE,
    ACTIONS(1472), 1,
      anon_sym_SEMI,
    ACTIONS(1474), 1,
      sym_eq,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(765), 4,
      sym__optbody,
      sym_empty,
      sym_body,
      sym_higherOrderTerm,
  [28634] = 5,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    ACTIONS(1476), 1,
      anon_sym_SEMI,
    ACTIONS(1478), 1,
      sym_eq,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(826), 4,
      sym__optbody,
      sym_empty,
      sym_body,
      sym_higherOrderTerm,
  [28654] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1458), 1,
      sym__lower_id,
    ACTIONS(1462), 1,
      sym__upper_id,
    ACTIONS(1470), 1,
      sym_qldoc,
    STATE(743), 1,
      sym_datatypeBranch,
    STATE(830), 1,
      sym_annotName,
    STATE(1106), 1,
      sym_annotation,
    STATE(1202), 1,
      sym_className,
  [28682] = 5,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    ACTIONS(1476), 1,
      anon_sym_SEMI,
    ACTIONS(1478), 1,
      sym_eq,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(862), 4,
      sym__optbody,
      sym_empty,
      sym_body,
      sym_higherOrderTerm,
  [28702] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(5), 1,
      sym_block_comment,
    ACTIONS(1458), 1,
      sym__lower_id,
    ACTIONS(1460), 1,
      sym_qldoc,
    ACTIONS(1462), 1,
      sym__upper_id,
    STATE(759), 1,
      sym_datatypeBranch,
    STATE(830), 1,
      sym_annotName,
    STATE(1120), 1,
      sym_annotation,
    STATE(1176), 1,
      sym_className,
  [28730] = 5,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    ACTIONS(1476), 1,
      anon_sym_SEMI,
    ACTIONS(1478), 1,
      sym_eq,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(864), 4,
      sym__optbody,
      sym_empty,
      sym_body,
      sym_higherOrderTerm,
  [28750] = 5,
    ACTIONS(875), 1,
      anon_sym_LBRACE,
    ACTIONS(1472), 1,
      anon_sym_SEMI,
    ACTIONS(1474), 1,
      sym_eq,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(820), 4,
      sym__optbody,
      sym_empty,
      sym_body,
      sym_higherOrderTerm,
  [28770] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(499), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_select,
      anon_sym_PIPE,
      anon_sym_order,
  [28784] = 5,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    ACTIONS(1476), 1,
      anon_sym_SEMI,
    ACTIONS(1478), 1,
      sym_eq,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(868), 4,
      sym__optbody,
      sym_empty,
      sym_body,
      sym_higherOrderTerm,
  [28804] = 5,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    ACTIONS(1476), 1,
      anon_sym_SEMI,
    ACTIONS(1478), 1,
      sym_eq,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(809), 4,
      sym__optbody,
      sym_empty,
      sym_body,
      sym_higherOrderTerm,
  [28824] = 7,
    STATE(926), 1,
      sym_literalId,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1171), 1,
      sym_aritylessPredicateExpr,
    STATE(1172), 1,
      sym_moduleExpr,
    STATE(1230), 1,
      sym_predicateExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1464), 2,
      sym__upper_id,
      sym__lower_id,
  [28848] = 5,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    ACTIONS(1476), 1,
      anon_sym_SEMI,
    ACTIONS(1478), 1,
      sym_eq,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(810), 4,
      sym__optbody,
      sym_empty,
      sym_body,
      sym_higherOrderTerm,
  [28868] = 7,
    STATE(926), 1,
      sym_literalId,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1123), 1,
      sym_predicateExpr,
    STATE(1171), 1,
      sym_aritylessPredicateExpr,
    STATE(1172), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1464), 2,
      sym__upper_id,
      sym__lower_id,
  [28892] = 7,
    STATE(926), 1,
      sym_literalId,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1164), 1,
      sym_predicateExpr,
    STATE(1171), 1,
      sym_aritylessPredicateExpr,
    STATE(1172), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1464), 2,
      sym__upper_id,
      sym__lower_id,
  [28916] = 6,
    ACTIONS(1358), 1,
      sym__lower_id,
    ACTIONS(1480), 1,
      sym__upper_id,
    STATE(1110), 1,
      sym_simpleId,
    STATE(1128), 1,
      sym_annotArg,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1482), 2,
      sym_result,
      sym_this,
  [28937] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1484), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_select,
      anon_sym_PIPE,
  [28950] = 4,
    ACTIONS(1486), 1,
      anon_sym_COMMA,
    STATE(891), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1489), 4,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_select,
      anon_sym_PIPE,
  [28967] = 6,
    ACTIONS(1358), 1,
      sym__lower_id,
    ACTIONS(1480), 1,
      sym__upper_id,
    STATE(979), 1,
      sym_annotArg,
    STATE(1110), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1482), 2,
      sym_result,
      sym_this,
  [28988] = 5,
    STATE(557), 1,
      sym_simpleId,
    STATE(602), 1,
      sym_qualModuleExpr,
    STATE(764), 1,
      sym_importModuleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1491), 2,
      sym__upper_id,
      sym__lower_id,
  [29006] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1489), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_select,
      anon_sym_PIPE,
  [29018] = 6,
    ACTIONS(1458), 1,
      sym__lower_id,
    ACTIONS(1462), 1,
      sym__upper_id,
    STATE(830), 1,
      sym_annotName,
    STATE(1127), 1,
      sym_annotation,
    STATE(1140), 1,
      sym_className,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29038] = 4,
    ACTIONS(463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1493), 1,
      sym_slash,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(467), 3,
      anon_sym_LPAREN,
      sym_star,
      sym_plus,
  [29054] = 5,
    STATE(547), 1,
      sym_simpleId,
    STATE(573), 1,
      sym_qualModuleExpr,
    STATE(744), 1,
      sym_importModuleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1495), 2,
      sym__upper_id,
      sym__lower_id,
  [29072] = 5,
    ACTIONS(1497), 1,
      anon_sym_DOT,
    STATE(882), 1,
      sym_simpleId,
    STATE(890), 1,
      sym_varName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1480), 2,
      sym__upper_id,
      sym__lower_id,
  [29090] = 6,
    ACTIONS(1458), 1,
      sym__lower_id,
    ACTIONS(1462), 1,
      sym__upper_id,
    STATE(830), 1,
      sym_annotName,
    STATE(1103), 1,
      sym_annotation,
    STATE(1189), 1,
      sym_className,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29110] = 6,
    ACTIONS(1464), 1,
      sym__lower_id,
    ACTIONS(1499), 1,
      sym__upper_id,
    STATE(462), 1,
      sym_className,
    STATE(943), 1,
      sym_literalId,
    STATE(1114), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29130] = 5,
    ACTIONS(1501), 1,
      anon_sym_DOT,
    STATE(882), 1,
      sym_simpleId,
    STATE(890), 1,
      sym_varName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1480), 2,
      sym__upper_id,
      sym__lower_id,
  [29148] = 5,
    ACTIONS(992), 1,
      anon_sym_RPAREN,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1505), 1,
      anon_sym_PIPE,
    STATE(891), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29165] = 5,
    ACTIONS(1507), 1,
      sym__lower_id,
    ACTIONS(1509), 1,
      anon_sym_LPAREN,
    STATE(350), 1,
      sym_qualifiedRhs,
    STATE(911), 1,
      sym_predicateName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29182] = 5,
    ACTIONS(1480), 1,
      sym__upper_id,
    ACTIONS(1511), 1,
      sym__lower_id,
    STATE(882), 1,
      sym_simpleId,
    STATE(890), 1,
      sym_varName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29199] = 5,
    ACTIONS(1083), 1,
      anon_sym_select,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1514), 1,
      anon_sym_where,
    STATE(908), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29216] = 4,
    STATE(983), 1,
      sym_moduleName,
    STATE(1094), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1480), 2,
      sym__upper_id,
      sym__lower_id,
  [29231] = 4,
    ACTIONS(1516), 1,
      anon_sym_LPAREN,
    STATE(1131), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1518), 2,
      sym_star,
      sym_plus,
  [29246] = 5,
    ACTIONS(1081), 1,
      anon_sym_select,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1520), 1,
      anon_sym_where,
    STATE(891), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29263] = 5,
    ACTIONS(970), 1,
      anon_sym_RPAREN,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1522), 1,
      anon_sym_PIPE,
    STATE(891), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29280] = 4,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1101), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1480), 2,
      sym__upper_id,
      sym__lower_id,
  [29295] = 4,
    ACTIONS(1524), 1,
      anon_sym_LPAREN,
    STATE(1196), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1518), 2,
      sym_star,
      sym_plus,
  [29310] = 5,
    ACTIONS(895), 1,
      anon_sym_RPAREN,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1526), 1,
      anon_sym_PIPE,
    STATE(891), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29327] = 4,
    ACTIONS(1528), 1,
      anon_sym_LPAREN,
    STATE(1213), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1518), 2,
      sym_star,
      sym_plus,
  [29342] = 4,
    STATE(943), 1,
      sym_literalId,
    STATE(1114), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1464), 2,
      sym__upper_id,
      sym__lower_id,
  [29357] = 5,
    ACTIONS(1163), 1,
      anon_sym_RPAREN,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1530), 1,
      anon_sym_PIPE,
    STATE(912), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29374] = 4,
    ACTIONS(1532), 1,
      anon_sym_LPAREN,
    STATE(1137), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1518), 2,
      sym_star,
      sym_plus,
  [29389] = 5,
    ACTIONS(1507), 1,
      sym__lower_id,
    ACTIONS(1534), 1,
      anon_sym_LPAREN,
    STATE(381), 1,
      sym_qualifiedRhs,
    STATE(949), 1,
      sym_predicateName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29406] = 4,
    ACTIONS(1536), 1,
      anon_sym_LPAREN,
    STATE(1150), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1518), 2,
      sym_star,
      sym_plus,
  [29421] = 5,
    ACTIONS(321), 1,
      anon_sym_RPAREN,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1538), 1,
      anon_sym_PIPE,
    STATE(891), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29438] = 5,
    ACTIONS(1414), 1,
      sym__upper_id,
    ACTIONS(1480), 1,
      sym__lower_id,
    STATE(419), 1,
      sym_className,
    STATE(1114), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29455] = 4,
    ACTIONS(1540), 1,
      anon_sym_LPAREN,
    STATE(1157), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1518), 2,
      sym_star,
      sym_plus,
  [29470] = 5,
    ACTIONS(951), 1,
      anon_sym_RPAREN,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1542), 1,
      anon_sym_PIPE,
    STATE(891), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29487] = 4,
    ACTIONS(1544), 1,
      anon_sym_LPAREN,
    STATE(1170), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1518), 2,
      sym_star,
      sym_plus,
  [29502] = 5,
    ACTIONS(1114), 1,
      anon_sym_select,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1546), 1,
      anon_sym_where,
    STATE(956), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29519] = 4,
    STATE(882), 1,
      sym_simpleId,
    STATE(890), 1,
      sym_varName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1480), 2,
      sym__upper_id,
      sym__lower_id,
  [29534] = 3,
    ACTIONS(1550), 1,
      sym_slash,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1548), 3,
      anon_sym_LPAREN,
      sym_star,
      sym_plus,
  [29547] = 5,
    ACTIONS(1007), 1,
      anon_sym_RPAREN,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1552), 1,
      anon_sym_PIPE,
    STATE(891), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29564] = 5,
    ACTIONS(1507), 1,
      sym__lower_id,
    ACTIONS(1554), 1,
      anon_sym_LPAREN,
    STATE(589), 1,
      sym_qualifiedRhs,
    STATE(916), 1,
      sym_predicateName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29581] = 4,
    ACTIONS(1556), 1,
      anon_sym_LPAREN,
    STATE(1210), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1518), 2,
      sym_star,
      sym_plus,
  [29596] = 5,
    ACTIONS(1201), 1,
      anon_sym_RPAREN,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1558), 1,
      anon_sym_PIPE,
    STATE(927), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29613] = 4,
    ACTIONS(1560), 1,
      anon_sym_COMMA,
    STATE(937), 1,
      aux_sym_asExprs_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(881), 2,
      anon_sym_RPAREN,
      anon_sym_order,
  [29628] = 5,
    ACTIONS(1426), 1,
      sym__upper_id,
    ACTIONS(1480), 1,
      sym__lower_id,
    STATE(446), 1,
      sym_className,
    STATE(1114), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29645] = 5,
    ACTIONS(1507), 1,
      sym__lower_id,
    ACTIONS(1562), 1,
      anon_sym_LPAREN,
    STATE(342), 1,
      sym_qualifiedRhs,
    STATE(935), 1,
      sym_predicateName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29662] = 5,
    ACTIONS(1110), 1,
      anon_sym_RPAREN,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1564), 1,
      anon_sym_PIPE,
    STATE(902), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29679] = 4,
    ACTIONS(1566), 1,
      anon_sym_LPAREN,
    STATE(1177), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1518), 2,
      sym_star,
      sym_plus,
  [29694] = 4,
    STATE(882), 1,
      sym_simpleId,
    STATE(987), 1,
      sym_varName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1480), 2,
      sym__upper_id,
      sym__lower_id,
  [29709] = 4,
    ACTIONS(1560), 1,
      anon_sym_COMMA,
    STATE(942), 1,
      aux_sym_asExprs_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(917), 2,
      anon_sym_RPAREN,
      anon_sym_order,
  [29724] = 5,
    ACTIONS(269), 1,
      anon_sym_RPAREN,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1568), 1,
      anon_sym_PIPE,
    STATE(919), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29741] = 4,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    STATE(1190), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1518), 2,
      sym_star,
      sym_plus,
  [29756] = 5,
    ACTIONS(23), 1,
      sym__upper_id,
    ACTIONS(1480), 1,
      sym__lower_id,
    STATE(462), 1,
      sym_className,
    STATE(1114), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29773] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1572), 4,
      anon_sym_LPAREN,
      sym_eq,
      sym_star,
      sym_plus,
  [29784] = 4,
    ACTIONS(1574), 1,
      anon_sym_COMMA,
    STATE(942), 1,
      aux_sym_asExprs_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(965), 2,
      anon_sym_RPAREN,
      anon_sym_order,
  [29799] = 3,
    ACTIONS(1579), 1,
      sym_slash,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1577), 3,
      anon_sym_LPAREN,
      sym_star,
      sym_plus,
  [29812] = 5,
    ACTIONS(1507), 1,
      sym__lower_id,
    ACTIONS(1581), 1,
      anon_sym_LPAREN,
    STATE(476), 1,
      sym_qualifiedRhs,
    STATE(960), 1,
      sym_predicateName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29829] = 4,
    STATE(643), 1,
      sym_varName,
    STATE(734), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1495), 2,
      sym__upper_id,
      sym__lower_id,
  [29844] = 5,
    ACTIONS(1112), 1,
      anon_sym_RPAREN,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1583), 1,
      anon_sym_PIPE,
    STATE(909), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29861] = 5,
    ACTIONS(1157), 1,
      anon_sym_RPAREN,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1585), 1,
      anon_sym_PIPE,
    STATE(922), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29878] = 4,
    STATE(775), 1,
      sym_simpleId,
    STATE(794), 1,
      sym_moduleName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1495), 2,
      sym__upper_id,
      sym__lower_id,
  [29893] = 4,
    ACTIONS(1587), 1,
      anon_sym_LPAREN,
    STATE(1197), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1518), 2,
      sym_star,
      sym_plus,
  [29908] = 5,
    ACTIONS(1507), 1,
      sym__lower_id,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    STATE(307), 1,
      sym_qualifiedRhs,
    STATE(921), 1,
      sym_predicateName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29925] = 4,
    STATE(773), 1,
      sym_moduleName,
    STATE(783), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1491), 2,
      sym__upper_id,
      sym__lower_id,
  [29940] = 5,
    ACTIONS(1402), 1,
      sym__upper_id,
    ACTIONS(1480), 1,
      sym__lower_id,
    STATE(437), 1,
      sym_className,
    STATE(1114), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29957] = 4,
    STATE(1033), 1,
      sym_moduleName,
    STATE(1094), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1480), 2,
      sym__upper_id,
      sym__lower_id,
  [29972] = 5,
    ACTIONS(1420), 1,
      sym__upper_id,
    ACTIONS(1480), 1,
      sym__lower_id,
    STATE(728), 1,
      sym_className,
    STATE(1114), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [29989] = 4,
    STATE(1091), 1,
      sym_simpleId,
    STATE(1130), 1,
      sym_moduleExpr,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1480), 2,
      sym__upper_id,
      sym__lower_id,
  [30004] = 5,
    ACTIONS(1175), 1,
      anon_sym_select,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1591), 1,
      anon_sym_where,
    STATE(891), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30021] = 4,
    STATE(654), 1,
      sym_varName,
    STATE(665), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1491), 2,
      sym__upper_id,
      sym__lower_id,
  [30036] = 5,
    ACTIONS(911), 1,
      anon_sym_RPAREN,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1593), 1,
      anon_sym_PIPE,
    STATE(891), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30053] = 5,
    ACTIONS(1140), 1,
      anon_sym_RPAREN,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1595), 1,
      anon_sym_PIPE,
    STATE(958), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30070] = 4,
    ACTIONS(1597), 1,
      anon_sym_LPAREN,
    STATE(1159), 1,
      sym_closure,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1518), 2,
      sym_star,
      sym_plus,
  [30085] = 5,
    ACTIONS(1408), 1,
      sym__upper_id,
    ACTIONS(1480), 1,
      sym__lower_id,
    STATE(414), 1,
      sym_className,
    STATE(1114), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30102] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1601), 1,
      anon_sym_RPAREN,
    STATE(998), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30116] = 4,
    ACTIONS(169), 1,
      anon_sym_RPAREN,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    STATE(1031), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30130] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1603), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30144] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1603), 1,
      anon_sym_RPAREN,
    STATE(968), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30158] = 4,
    ACTIONS(229), 1,
      anon_sym_RPAREN,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    STATE(971), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30172] = 4,
    ACTIONS(1605), 1,
      anon_sym_LPAREN,
    ACTIONS(1607), 1,
      sym_eq,
    STATE(784), 1,
      sym_predicateAliasBody,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30186] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1609), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30200] = 3,
    STATE(583), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1491), 2,
      sym__upper_id,
      sym__lower_id,
  [30212] = 3,
    STATE(726), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1491), 2,
      sym__upper_id,
      sym__lower_id,
  [30224] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1611), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30238] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1611), 1,
      anon_sym_RPAREN,
    STATE(973), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30252] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30266] = 4,
    ACTIONS(1615), 1,
      anon_sym_COMMA,
    ACTIONS(1617), 1,
      anon_sym_RPAREN,
    STATE(1000), 1,
      aux_sym_higherOrderTerm_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30280] = 4,
    ACTIONS(1615), 1,
      anon_sym_COMMA,
    ACTIONS(1619), 1,
      anon_sym_RPAREN,
    STATE(974), 1,
      aux_sym_higherOrderTerm_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30294] = 4,
    ACTIONS(835), 1,
      anon_sym_COMMA,
    ACTIONS(1621), 1,
      anon_sym_RBRACK,
    STATE(1077), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30308] = 3,
    STATE(651), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1495), 2,
      sym__upper_id,
      sym__lower_id,
  [30320] = 3,
    STATE(572), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1495), 2,
      sym__upper_id,
      sym__lower_id,
  [30332] = 4,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(1625), 1,
      anon_sym_RBRACK,
    STATE(1008), 1,
      aux_sym_annotation_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30346] = 4,
    ACTIONS(1627), 1,
      anon_sym_LPAREN,
    ACTIONS(1629), 1,
      sym_eq,
    STATE(823), 1,
      sym_predicateAliasBody,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30360] = 4,
    ACTIONS(1631), 1,
      sym_extends,
    ACTIONS(1633), 1,
      sym_eq,
    STATE(786), 1,
      sym_typeAliasBody,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30374] = 4,
    ACTIONS(233), 1,
      anon_sym_RPAREN,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    STATE(985), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30388] = 4,
    ACTIONS(1635), 1,
      anon_sym_LBRACE,
    ACTIONS(1637), 1,
      sym_eq,
    STATE(774), 1,
      sym_moduleAliasBody,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30402] = 4,
    ACTIONS(1037), 1,
      anon_sym_RPAREN,
    ACTIONS(1639), 1,
      anon_sym_COMMA,
    STATE(984), 1,
      aux_sym_orderBys_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30416] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1642), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30430] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1642), 1,
      anon_sym_RPAREN,
    STATE(990), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30444] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1054), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_order,
  [30454] = 4,
    ACTIONS(177), 1,
      anon_sym_RPAREN,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    STATE(993), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30468] = 4,
    ACTIONS(1029), 1,
      anon_sym_RPAREN,
    ACTIONS(1644), 1,
      anon_sym_COMMA,
    STATE(984), 1,
      aux_sym_orderBys_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30482] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1646), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30496] = 4,
    ACTIONS(1376), 1,
      anon_sym_RPAREN,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    STATE(891), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30510] = 4,
    ACTIONS(1070), 1,
      anon_sym_RPAREN,
    ACTIONS(1644), 1,
      anon_sym_COMMA,
    STATE(989), 1,
      aux_sym_orderBys_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30524] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1601), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30538] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1648), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [30548] = 4,
    ACTIONS(153), 1,
      anon_sym_RPAREN,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    STATE(1030), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30562] = 4,
    ACTIONS(1374), 1,
      anon_sym_RPAREN,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    STATE(991), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30576] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(965), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_order,
  [30586] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1650), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30600] = 4,
    ACTIONS(835), 1,
      anon_sym_COMMA,
    ACTIONS(1652), 1,
      anon_sym_RBRACK,
    STATE(1077), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30614] = 4,
    ACTIONS(1654), 1,
      anon_sym_COMMA,
    ACTIONS(1657), 1,
      anon_sym_RPAREN,
    STATE(1000), 1,
      aux_sym_higherOrderTerm_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30628] = 4,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1659), 1,
      anon_sym_RPAREN,
    STATE(1050), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30642] = 4,
    ACTIONS(835), 1,
      anon_sym_COMMA,
    ACTIONS(1661), 1,
      anon_sym_RBRACK,
    STATE(1077), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30656] = 4,
    ACTIONS(1663), 1,
      anon_sym_RPAREN,
    ACTIONS(1665), 1,
      anon_sym_order,
    STATE(1152), 1,
      sym_orderBys,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30670] = 4,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_COMMA,
    STATE(1042), 1,
      aux_sym_dataclass_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30684] = 4,
    ACTIONS(1671), 1,
      sym_extends,
    ACTIONS(1673), 1,
      sym_eq,
    STATE(805), 1,
      sym_typeAliasBody,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30698] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(511), 3,
      anon_sym_LPAREN,
      sym_extends,
      sym_eq,
  [30708] = 4,
    ACTIONS(193), 1,
      anon_sym_RPAREN,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    STATE(964), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30722] = 4,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(1675), 1,
      anon_sym_RBRACK,
    STATE(1044), 1,
      aux_sym_annotation_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30736] = 4,
    ACTIONS(1376), 1,
      anon_sym_RPAREN,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    STATE(1075), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30750] = 4,
    ACTIONS(149), 1,
      anon_sym_RPAREN,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    STATE(1037), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30764] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1677), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30778] = 4,
    ACTIONS(835), 1,
      anon_sym_COMMA,
    ACTIONS(1679), 1,
      anon_sym_RBRACK,
    STATE(1077), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30792] = 4,
    ACTIONS(209), 1,
      anon_sym_RPAREN,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    STATE(1022), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30806] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1681), 1,
      anon_sym_RPAREN,
    STATE(1011), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30820] = 4,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1683), 1,
      anon_sym_RPAREN,
    STATE(1049), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30834] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1681), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30848] = 4,
    ACTIONS(197), 1,
      anon_sym_RPAREN,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    STATE(1016), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30862] = 4,
    ACTIONS(197), 1,
      anon_sym_RPAREN,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30876] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1685), 1,
      anon_sym_RPAREN,
    STATE(1068), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30890] = 4,
    ACTIONS(835), 1,
      anon_sym_COMMA,
    ACTIONS(1687), 1,
      anon_sym_RBRACK,
    STATE(1077), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30904] = 4,
    ACTIONS(265), 1,
      anon_sym_RPAREN,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    STATE(1084), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30918] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1689), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30932] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1689), 1,
      anon_sym_RPAREN,
    STATE(1027), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30946] = 3,
    STATE(1114), 1,
      sym_simpleId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1480), 2,
      sym__upper_id,
      sym__lower_id,
  [30958] = 4,
    ACTIONS(107), 1,
      anon_sym_RPAREN,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    STATE(1057), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30972] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1691), 1,
      anon_sym_RPAREN,
    STATE(1086), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [30986] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1693), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31000] = 4,
    ACTIONS(245), 1,
      anon_sym_RPAREN,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    STATE(1018), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31014] = 4,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1695), 1,
      anon_sym_RPAREN,
    STATE(891), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31028] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1697), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31042] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1699), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31056] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1699), 1,
      anon_sym_RPAREN,
    STATE(1036), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31070] = 4,
    ACTIONS(1701), 1,
      anon_sym_LBRACE,
    ACTIONS(1703), 1,
      sym_eq,
    STATE(811), 1,
      sym_moduleAliasBody,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31084] = 4,
    ACTIONS(1615), 1,
      anon_sym_COMMA,
    ACTIONS(1705), 1,
      anon_sym_RPAREN,
    STATE(1000), 1,
      aux_sym_higherOrderTerm_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31098] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1697), 1,
      anon_sym_RPAREN,
    STATE(1085), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31112] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1707), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31126] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1691), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31140] = 4,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1709), 1,
      anon_sym_RPAREN,
    STATE(891), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31154] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1711), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31168] = 4,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1713), 1,
      anon_sym_RPAREN,
    STATE(1029), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31182] = 4,
    ACTIONS(835), 1,
      anon_sym_COMMA,
    ACTIONS(1715), 1,
      anon_sym_RBRACK,
    STATE(1077), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31196] = 4,
    ACTIONS(1669), 1,
      anon_sym_COMMA,
    ACTIONS(1717), 1,
      anon_sym_LBRACE,
    STATE(1082), 1,
      aux_sym_dataclass_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31210] = 4,
    ACTIONS(1665), 1,
      anon_sym_order,
    ACTIONS(1719), 1,
      anon_sym_RPAREN,
    STATE(1162), 1,
      sym_orderBys,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31224] = 4,
    ACTIONS(1721), 1,
      anon_sym_COMMA,
    ACTIONS(1724), 1,
      anon_sym_RBRACK,
    STATE(1044), 1,
      aux_sym_annotation_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31238] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1726), 1,
      anon_sym_RPAREN,
    STATE(1039), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31252] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1726), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31266] = 3,
    STATE(1216), 1,
      sym_literalId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1728), 2,
      sym__upper_id,
      sym__lower_id,
  [31278] = 4,
    ACTIONS(1615), 1,
      anon_sym_COMMA,
    ACTIONS(1730), 1,
      anon_sym_RPAREN,
    STATE(1034), 1,
      aux_sym_higherOrderTerm_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31292] = 4,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1732), 1,
      anon_sym_RPAREN,
    STATE(891), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31306] = 4,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1734), 1,
      anon_sym_RPAREN,
    STATE(891), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31320] = 4,
    ACTIONS(173), 1,
      anon_sym_RPAREN,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    STATE(1060), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31334] = 4,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1736), 1,
      anon_sym_RPAREN,
    STATE(891), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31348] = 4,
    ACTIONS(237), 1,
      anon_sym_RPAREN,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    STATE(1046), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31362] = 4,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1736), 1,
      anon_sym_RPAREN,
    STATE(1038), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31376] = 4,
    ACTIONS(1669), 1,
      anon_sym_COMMA,
    ACTIONS(1738), 1,
      anon_sym_LBRACE,
    STATE(1082), 1,
      aux_sym_dataclass_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31390] = 4,
    ACTIONS(237), 1,
      anon_sym_RPAREN,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31404] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1685), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31418] = 3,
    ACTIONS(1740), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(611), 2,
      sym__upper_id,
      sym__lower_id,
  [31430] = 4,
    ACTIONS(1665), 1,
      anon_sym_order,
    ACTIONS(1742), 1,
      anon_sym_RPAREN,
    STATE(1135), 1,
      sym_orderBys,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31444] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1744), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31458] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1744), 1,
      anon_sym_RPAREN,
    STATE(1065), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31472] = 4,
    ACTIONS(249), 1,
      anon_sym_RPAREN,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    STATE(1056), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31486] = 4,
    ACTIONS(133), 1,
      anon_sym_RPAREN,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    STATE(1069), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31500] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1746), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31514] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1748), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31528] = 4,
    ACTIONS(1398), 1,
      anon_sym_RPAREN,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    STATE(891), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31542] = 4,
    ACTIONS(1398), 1,
      anon_sym_RPAREN,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    STATE(1052), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31556] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1750), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31570] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1752), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31584] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1752), 1,
      anon_sym_RPAREN,
    STATE(1074), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31598] = 4,
    ACTIONS(1669), 1,
      anon_sym_COMMA,
    ACTIONS(1754), 1,
      anon_sym_LBRACE,
    STATE(1055), 1,
      aux_sym_dataclass_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31612] = 4,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1756), 1,
      anon_sym_RPAREN,
    STATE(891), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31626] = 4,
    ACTIONS(1758), 1,
      anon_sym_COMMA,
    ACTIONS(1761), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31640] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1763), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31654] = 4,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1765), 1,
      anon_sym_RPAREN,
    STATE(891), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31668] = 4,
    ACTIONS(978), 1,
      anon_sym_RPAREN,
    ACTIONS(1665), 1,
      anon_sym_order,
    STATE(1250), 1,
      sym_orderBys,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31682] = 4,
    ACTIONS(1015), 1,
      anon_sym_RBRACK,
    ACTIONS(1767), 1,
      anon_sym_COMMA,
    STATE(1077), 1,
      aux_sym_aggregate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31696] = 4,
    ACTIONS(1390), 1,
      anon_sym_RPAREN,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    STATE(1066), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31710] = 4,
    ACTIONS(1503), 1,
      anon_sym_COMMA,
    ACTIONS(1765), 1,
      anon_sym_RPAREN,
    STATE(1072), 1,
      aux_sym_classlessPredicate_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31724] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1770), 1,
      anon_sym_RPAREN,
    STATE(1064), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31738] = 4,
    ACTIONS(317), 1,
      anon_sym_RPAREN,
    ACTIONS(1665), 1,
      anon_sym_order,
    STATE(1232), 1,
      sym_orderBys,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31752] = 4,
    ACTIONS(1772), 1,
      anon_sym_LBRACE,
    ACTIONS(1774), 1,
      anon_sym_COMMA,
    STATE(1082), 1,
      aux_sym_dataclass_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31766] = 3,
    STATE(1242), 1,
      sym_literalId,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1728), 2,
      sym__upper_id,
      sym__lower_id,
  [31778] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1770), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31792] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1777), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31806] = 4,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    ACTIONS(1779), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_higherOrderTerm_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31820] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1229), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [31829] = 3,
    ACTIONS(111), 1,
      anon_sym_LBRACK,
    STATE(489), 1,
      sym_range,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31840] = 3,
    ACTIONS(1462), 1,
      sym__upper_id,
    STATE(1005), 1,
      sym_className,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31851] = 3,
    ACTIONS(1462), 1,
      sym__upper_id,
    STATE(1228), 1,
      sym_className,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31862] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(501), 2,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
  [31871] = 3,
    ACTIONS(1507), 1,
      sym__lower_id,
    STATE(967), 1,
      sym_predicateName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31882] = 3,
    ACTIONS(1501), 1,
      anon_sym_DOT,
    ACTIONS(1781), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31893] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1282), 2,
      anon_sym_LBRACE,
      sym_eq,
  [31902] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1783), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
  [31911] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    STATE(656), 1,
      sym_range,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31922] = 3,
    ACTIONS(1501), 1,
      anon_sym_DOT,
    ACTIONS(1785), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31933] = 3,
    ACTIONS(1787), 1,
      anon_sym_LPAREN,
    ACTIONS(1789), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31944] = 3,
    ACTIONS(1462), 1,
      sym__upper_id,
    STATE(981), 1,
      sym_className,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31955] = 3,
    ACTIONS(1507), 1,
      sym__lower_id,
    STATE(980), 1,
      sym_predicateName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31966] = 3,
    ACTIONS(1791), 1,
      anon_sym_SEMI,
    ACTIONS(1793), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31977] = 3,
    ACTIONS(1501), 1,
      anon_sym_DOT,
    ACTIONS(1795), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31988] = 3,
    ACTIONS(1462), 1,
      sym__upper_id,
    STATE(1179), 1,
      sym_className,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [31999] = 3,
    ACTIONS(1797), 1,
      anon_sym_LPAREN,
    ACTIONS(1799), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32010] = 3,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    STATE(443), 1,
      sym_range,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32021] = 3,
    ACTIONS(1462), 1,
      sym__upper_id,
    STATE(1189), 1,
      sym_className,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32032] = 3,
    ACTIONS(1501), 1,
      anon_sym_DOT,
    ACTIONS(1801), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32043] = 3,
    ACTIONS(1462), 1,
      sym__upper_id,
    STATE(1217), 1,
      sym_className,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32054] = 3,
    ACTIONS(279), 1,
      anon_sym_LBRACK,
    STATE(434), 1,
      sym_range,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32065] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1803), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [32074] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1772), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
  [32083] = 3,
    ACTIONS(1507), 1,
      sym__lower_id,
    STATE(1249), 1,
      sym_predicateName,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32094] = 3,
    ACTIONS(1501), 1,
      anon_sym_DOT,
    ACTIONS(1805), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32105] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1807), 2,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
  [32114] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1037), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [32123] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1219), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [32132] = 3,
    ACTIONS(1809), 1,
      anon_sym_LPAREN,
    ACTIONS(1811), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32143] = 3,
    ACTIONS(1501), 1,
      anon_sym_DOT,
    ACTIONS(1813), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32154] = 3,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    STATE(426), 1,
      sym_range,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32165] = 3,
    ACTIONS(1462), 1,
      sym__upper_id,
    STATE(1140), 1,
      sym_className,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32176] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1761), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [32185] = 3,
    ACTIONS(1815), 1,
      anon_sym_LPAREN,
    ACTIONS(1817), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32196] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1657), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [32205] = 3,
    ACTIONS(1819), 1,
      anon_sym_LPAREN,
    ACTIONS(1821), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32216] = 3,
    ACTIONS(1501), 1,
      anon_sym_DOT,
    ACTIONS(1823), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32227] = 3,
    ACTIONS(333), 1,
      anon_sym_LBRACK,
    STATE(401), 1,
      sym_range,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32238] = 3,
    ACTIONS(1462), 1,
      sym__upper_id,
    STATE(1203), 1,
      sym_className,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32249] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1724), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [32258] = 3,
    ACTIONS(1825), 1,
      anon_sym_LPAREN,
    ACTIONS(1827), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32269] = 3,
    ACTIONS(1793), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1829), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32280] = 2,
    ACTIONS(1831), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32288] = 2,
    ACTIONS(1833), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32296] = 2,
    ACTIONS(1835), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32304] = 2,
    ACTIONS(1837), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32312] = 2,
    ACTIONS(1719), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32320] = 2,
    ACTIONS(1839), 1,
      sym_super,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32328] = 2,
    ACTIONS(1841), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32336] = 2,
    ACTIONS(1843), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32344] = 2,
    ACTIONS(1845), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32352] = 2,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32360] = 2,
    ACTIONS(1849), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32368] = 2,
    ACTIONS(1851), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32376] = 2,
    ACTIONS(1853), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32384] = 2,
    ACTIONS(1855), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32392] = 2,
    ACTIONS(1857), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32400] = 2,
    ACTIONS(1859), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32408] = 2,
    ACTIONS(1497), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32416] = 2,
    ACTIONS(1861), 1,
      sym_integer,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32424] = 2,
    ACTIONS(1863), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32432] = 2,
    ACTIONS(1865), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32440] = 2,
    ACTIONS(1867), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32448] = 2,
    ACTIONS(1869), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32456] = 2,
    ACTIONS(1871), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32464] = 2,
    ACTIONS(1873), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32472] = 2,
    ACTIONS(1875), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32480] = 2,
    ACTIONS(101), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32488] = 2,
    ACTIONS(1877), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32496] = 2,
    ACTIONS(1879), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32504] = 2,
    ACTIONS(1881), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32512] = 2,
    ACTIONS(201), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32520] = 2,
    ACTIONS(1883), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32528] = 2,
    ACTIONS(1885), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32536] = 2,
    ACTIONS(1887), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32544] = 2,
    ACTIONS(1889), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32552] = 2,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32560] = 2,
    ACTIONS(1893), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32568] = 2,
    ACTIONS(1895), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32576] = 2,
    ACTIONS(1897), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32584] = 2,
    ACTIONS(1899), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32592] = 2,
    ACTIONS(1901), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32600] = 2,
    ACTIONS(1903), 1,
      sym_slash,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32608] = 2,
    ACTIONS(1905), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32616] = 2,
    ACTIONS(137), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32624] = 2,
    ACTIONS(1907), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32632] = 2,
    ACTIONS(1909), 1,
      sym_super,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32640] = 2,
    ACTIONS(1911), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32648] = 2,
    ACTIONS(1913), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32656] = 2,
    ACTIONS(1915), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32664] = 2,
    ACTIONS(1917), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32672] = 2,
    ACTIONS(1919), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32680] = 2,
    ACTIONS(1921), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32688] = 2,
    ACTIONS(1923), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32696] = 2,
    ACTIONS(1925), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32704] = 2,
    ACTIONS(1927), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32712] = 2,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32720] = 2,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32728] = 2,
    ACTIONS(1933), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32736] = 2,
    ACTIONS(1935), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32744] = 2,
    ACTIONS(1937), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32752] = 2,
    ACTIONS(1939), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32760] = 2,
    ACTIONS(1941), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32768] = 2,
    ACTIONS(1943), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32776] = 2,
    ACTIONS(75), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32784] = 2,
    ACTIONS(1945), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32792] = 2,
    ACTIONS(165), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32800] = 2,
    ACTIONS(1947), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32808] = 2,
    ACTIONS(1949), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32816] = 2,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32824] = 2,
    ACTIONS(1953), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32832] = 2,
    ACTIONS(1955), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32840] = 2,
    ACTIONS(1957), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32848] = 2,
    ACTIONS(1959), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32856] = 2,
    ACTIONS(1961), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32864] = 2,
    ACTIONS(1963), 1,
      sym_super,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32872] = 2,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32880] = 2,
    ACTIONS(1965), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32888] = 2,
    ACTIONS(1967), 1,
      anon_sym_by,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32896] = 2,
    ACTIONS(1969), 1,
      anon_sym_by,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32904] = 2,
    ACTIONS(1971), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32912] = 2,
    ACTIONS(1973), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32920] = 2,
    ACTIONS(1975), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32928] = 2,
    ACTIONS(1977), 1,
      sym_super,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32936] = 2,
    ACTIONS(1979), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32944] = 2,
    ACTIONS(1981), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32952] = 2,
    ACTIONS(1983), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32960] = 2,
    ACTIONS(1985), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32968] = 2,
    ACTIONS(1987), 1,
      sym_eq,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32976] = 2,
    ACTIONS(1989), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32984] = 2,
    ACTIONS(1991), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [32992] = 2,
    ACTIONS(1993), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33000] = 2,
    ACTIONS(1995), 1,
      sym_super,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33008] = 2,
    ACTIONS(1997), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33016] = 2,
    ACTIONS(1999), 1,
      anon_sym_by,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33024] = 2,
    ACTIONS(85), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33032] = 2,
    ACTIONS(2001), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33040] = 2,
    ACTIONS(217), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33048] = 2,
    ACTIONS(2003), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33056] = 2,
    ACTIONS(2005), 1,
      sym_eq,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33064] = 2,
    ACTIONS(2007), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33072] = 2,
    ACTIONS(2009), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33080] = 2,
    ACTIONS(2011), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33088] = 2,
    ACTIONS(978), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33096] = 2,
    ACTIONS(2013), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33104] = 2,
    ACTIONS(185), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33112] = 2,
    ACTIONS(1501), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33120] = 2,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33128] = 2,
    ACTIONS(2017), 1,
      sym_super,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33136] = 2,
    ACTIONS(2019), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33144] = 2,
    ACTIONS(2021), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33152] = 2,
    ACTIONS(2023), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33160] = 2,
    ACTIONS(2025), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33168] = 2,
    ACTIONS(2027), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33176] = 2,
    ACTIONS(2029), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33184] = 2,
    ACTIONS(79), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33192] = 2,
    ACTIONS(95), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33200] = 2,
    ACTIONS(2031), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33208] = 2,
    ACTIONS(2033), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33216] = 2,
    ACTIONS(69), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33224] = 2,
    ACTIONS(2035), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33232] = 2,
    ACTIONS(1742), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33240] = 2,
    ACTIONS(2037), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33248] = 2,
    ACTIONS(2039), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33256] = 2,
    ACTIONS(2041), 1,
      sym__lower_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33264] = 2,
    ACTIONS(161), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33272] = 2,
    ACTIONS(2043), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [33280] = 2,
    ACTIONS(2045), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(242)] = 0,
  [SMALL_STATE(243)] = 82,
  [SMALL_STATE(244)] = 164,
  [SMALL_STATE(245)] = 221,
  [SMALL_STATE(246)] = 286,
  [SMALL_STATE(247)] = 361,
  [SMALL_STATE(248)] = 432,
  [SMALL_STATE(249)] = 509,
  [SMALL_STATE(250)] = 574,
  [SMALL_STATE(251)] = 647,
  [SMALL_STATE(252)] = 722,
  [SMALL_STATE(253)] = 783,
  [SMALL_STATE(254)] = 860,
  [SMALL_STATE(255)] = 917,
  [SMALL_STATE(256)] = 978,
  [SMALL_STATE(257)] = 1055,
  [SMALL_STATE(258)] = 1126,
  [SMALL_STATE(259)] = 1181,
  [SMALL_STATE(260)] = 1236,
  [SMALL_STATE(261)] = 1293,
  [SMALL_STATE(262)] = 1372,
  [SMALL_STATE(263)] = 1449,
  [SMALL_STATE(264)] = 1522,
  [SMALL_STATE(265)] = 1601,
  [SMALL_STATE(266)] = 1658,
  [SMALL_STATE(267)] = 1729,
  [SMALL_STATE(268)] = 1800,
  [SMALL_STATE(269)] = 1871,
  [SMALL_STATE(270)] = 1936,
  [SMALL_STATE(271)] = 2007,
  [SMALL_STATE(272)] = 2078,
  [SMALL_STATE(273)] = 2135,
  [SMALL_STATE(274)] = 2192,
  [SMALL_STATE(275)] = 2247,
  [SMALL_STATE(276)] = 2312,
  [SMALL_STATE(277)] = 2383,
  [SMALL_STATE(278)] = 2460,
  [SMALL_STATE(279)] = 2517,
  [SMALL_STATE(280)] = 2590,
  [SMALL_STATE(281)] = 2661,
  [SMALL_STATE(282)] = 2736,
  [SMALL_STATE(283)] = 2797,
  [SMALL_STATE(284)] = 2854,
  [SMALL_STATE(285)] = 2915,
  [SMALL_STATE(286)] = 2992,
  [SMALL_STATE(287)] = 3063,
  [SMALL_STATE(288)] = 3134,
  [SMALL_STATE(289)] = 3189,
  [SMALL_STATE(290)] = 3264,
  [SMALL_STATE(291)] = 3335,
  [SMALL_STATE(292)] = 3412,
  [SMALL_STATE(293)] = 3485,
  [SMALL_STATE(294)] = 3562,
  [SMALL_STATE(295)] = 3614,
  [SMALL_STATE(296)] = 3666,
  [SMALL_STATE(297)] = 3718,
  [SMALL_STATE(298)] = 3770,
  [SMALL_STATE(299)] = 3819,
  [SMALL_STATE(300)] = 3868,
  [SMALL_STATE(301)] = 3919,
  [SMALL_STATE(302)] = 3970,
  [SMALL_STATE(303)] = 4019,
  [SMALL_STATE(304)] = 4068,
  [SMALL_STATE(305)] = 4117,
  [SMALL_STATE(306)] = 4166,
  [SMALL_STATE(307)] = 4215,
  [SMALL_STATE(308)] = 4264,
  [SMALL_STATE(309)] = 4313,
  [SMALL_STATE(310)] = 4362,
  [SMALL_STATE(311)] = 4411,
  [SMALL_STATE(312)] = 4460,
  [SMALL_STATE(313)] = 4509,
  [SMALL_STATE(314)] = 4558,
  [SMALL_STATE(315)] = 4609,
  [SMALL_STATE(316)] = 4658,
  [SMALL_STATE(317)] = 4707,
  [SMALL_STATE(318)] = 4756,
  [SMALL_STATE(319)] = 4805,
  [SMALL_STATE(320)] = 4854,
  [SMALL_STATE(321)] = 4903,
  [SMALL_STATE(322)] = 4952,
  [SMALL_STATE(323)] = 5001,
  [SMALL_STATE(324)] = 5050,
  [SMALL_STATE(325)] = 5099,
  [SMALL_STATE(326)] = 5148,
  [SMALL_STATE(327)] = 5197,
  [SMALL_STATE(328)] = 5248,
  [SMALL_STATE(329)] = 5297,
  [SMALL_STATE(330)] = 5346,
  [SMALL_STATE(331)] = 5395,
  [SMALL_STATE(332)] = 5444,
  [SMALL_STATE(333)] = 5493,
  [SMALL_STATE(334)] = 5542,
  [SMALL_STATE(335)] = 5591,
  [SMALL_STATE(336)] = 5642,
  [SMALL_STATE(337)] = 5691,
  [SMALL_STATE(338)] = 5740,
  [SMALL_STATE(339)] = 5789,
  [SMALL_STATE(340)] = 5838,
  [SMALL_STATE(341)] = 5887,
  [SMALL_STATE(342)] = 5936,
  [SMALL_STATE(343)] = 5985,
  [SMALL_STATE(344)] = 6034,
  [SMALL_STATE(345)] = 6083,
  [SMALL_STATE(346)] = 6132,
  [SMALL_STATE(347)] = 6181,
  [SMALL_STATE(348)] = 6230,
  [SMALL_STATE(349)] = 6279,
  [SMALL_STATE(350)] = 6328,
  [SMALL_STATE(351)] = 6377,
  [SMALL_STATE(352)] = 6426,
  [SMALL_STATE(353)] = 6475,
  [SMALL_STATE(354)] = 6524,
  [SMALL_STATE(355)] = 6573,
  [SMALL_STATE(356)] = 6622,
  [SMALL_STATE(357)] = 6671,
  [SMALL_STATE(358)] = 6720,
  [SMALL_STATE(359)] = 6769,
  [SMALL_STATE(360)] = 6818,
  [SMALL_STATE(361)] = 6867,
  [SMALL_STATE(362)] = 6916,
  [SMALL_STATE(363)] = 6965,
  [SMALL_STATE(364)] = 7014,
  [SMALL_STATE(365)] = 7063,
  [SMALL_STATE(366)] = 7112,
  [SMALL_STATE(367)] = 7163,
  [SMALL_STATE(368)] = 7212,
  [SMALL_STATE(369)] = 7261,
  [SMALL_STATE(370)] = 7312,
  [SMALL_STATE(371)] = 7361,
  [SMALL_STATE(372)] = 7410,
  [SMALL_STATE(373)] = 7459,
  [SMALL_STATE(374)] = 7508,
  [SMALL_STATE(375)] = 7557,
  [SMALL_STATE(376)] = 7606,
  [SMALL_STATE(377)] = 7655,
  [SMALL_STATE(378)] = 7706,
  [SMALL_STATE(379)] = 7755,
  [SMALL_STATE(380)] = 7804,
  [SMALL_STATE(381)] = 7853,
  [SMALL_STATE(382)] = 7902,
  [SMALL_STATE(383)] = 7951,
  [SMALL_STATE(384)] = 8000,
  [SMALL_STATE(385)] = 8049,
  [SMALL_STATE(386)] = 8098,
  [SMALL_STATE(387)] = 8147,
  [SMALL_STATE(388)] = 8196,
  [SMALL_STATE(389)] = 8245,
  [SMALL_STATE(390)] = 8294,
  [SMALL_STATE(391)] = 8342,
  [SMALL_STATE(392)] = 8390,
  [SMALL_STATE(393)] = 8438,
  [SMALL_STATE(394)] = 8486,
  [SMALL_STATE(395)] = 8534,
  [SMALL_STATE(396)] = 8582,
  [SMALL_STATE(397)] = 8630,
  [SMALL_STATE(398)] = 8676,
  [SMALL_STATE(399)] = 8724,
  [SMALL_STATE(400)] = 8772,
  [SMALL_STATE(401)] = 8820,
  [SMALL_STATE(402)] = 8868,
  [SMALL_STATE(403)] = 8916,
  [SMALL_STATE(404)] = 8964,
  [SMALL_STATE(405)] = 9012,
  [SMALL_STATE(406)] = 9060,
  [SMALL_STATE(407)] = 9108,
  [SMALL_STATE(408)] = 9156,
  [SMALL_STATE(409)] = 9202,
  [SMALL_STATE(410)] = 9250,
  [SMALL_STATE(411)] = 9298,
  [SMALL_STATE(412)] = 9346,
  [SMALL_STATE(413)] = 9394,
  [SMALL_STATE(414)] = 9442,
  [SMALL_STATE(415)] = 9490,
  [SMALL_STATE(416)] = 9538,
  [SMALL_STATE(417)] = 9586,
  [SMALL_STATE(418)] = 9634,
  [SMALL_STATE(419)] = 9682,
  [SMALL_STATE(420)] = 9730,
  [SMALL_STATE(421)] = 9778,
  [SMALL_STATE(422)] = 9824,
  [SMALL_STATE(423)] = 9872,
  [SMALL_STATE(424)] = 9920,
  [SMALL_STATE(425)] = 9968,
  [SMALL_STATE(426)] = 10014,
  [SMALL_STATE(427)] = 10062,
  [SMALL_STATE(428)] = 10110,
  [SMALL_STATE(429)] = 10158,
  [SMALL_STATE(430)] = 10206,
  [SMALL_STATE(431)] = 10254,
  [SMALL_STATE(432)] = 10302,
  [SMALL_STATE(433)] = 10350,
  [SMALL_STATE(434)] = 10398,
  [SMALL_STATE(435)] = 10446,
  [SMALL_STATE(436)] = 10494,
  [SMALL_STATE(437)] = 10542,
  [SMALL_STATE(438)] = 10590,
  [SMALL_STATE(439)] = 10638,
  [SMALL_STATE(440)] = 10686,
  [SMALL_STATE(441)] = 10734,
  [SMALL_STATE(442)] = 10782,
  [SMALL_STATE(443)] = 10830,
  [SMALL_STATE(444)] = 10878,
  [SMALL_STATE(445)] = 10926,
  [SMALL_STATE(446)] = 10974,
  [SMALL_STATE(447)] = 11022,
  [SMALL_STATE(448)] = 11070,
  [SMALL_STATE(449)] = 11118,
  [SMALL_STATE(450)] = 11166,
  [SMALL_STATE(451)] = 11257,
  [SMALL_STATE(452)] = 11348,
  [SMALL_STATE(453)] = 11439,
  [SMALL_STATE(454)] = 11530,
  [SMALL_STATE(455)] = 11621,
  [SMALL_STATE(456)] = 11712,
  [SMALL_STATE(457)] = 11803,
  [SMALL_STATE(458)] = 11847,
  [SMALL_STATE(459)] = 11888,
  [SMALL_STATE(460)] = 11967,
  [SMALL_STATE(461)] = 12008,
  [SMALL_STATE(462)] = 12049,
  [SMALL_STATE(463)] = 12090,
  [SMALL_STATE(464)] = 12169,
  [SMALL_STATE(465)] = 12212,
  [SMALL_STATE(466)] = 12252,
  [SMALL_STATE(467)] = 12291,
  [SMALL_STATE(468)] = 12328,
  [SMALL_STATE(469)] = 12365,
  [SMALL_STATE(470)] = 12402,
  [SMALL_STATE(471)] = 12439,
  [SMALL_STATE(472)] = 12476,
  [SMALL_STATE(473)] = 12513,
  [SMALL_STATE(474)] = 12550,
  [SMALL_STATE(475)] = 12587,
  [SMALL_STATE(476)] = 12624,
  [SMALL_STATE(477)] = 12661,
  [SMALL_STATE(478)] = 12698,
  [SMALL_STATE(479)] = 12735,
  [SMALL_STATE(480)] = 12772,
  [SMALL_STATE(481)] = 12809,
  [SMALL_STATE(482)] = 12846,
  [SMALL_STATE(483)] = 12883,
  [SMALL_STATE(484)] = 12920,
  [SMALL_STATE(485)] = 12957,
  [SMALL_STATE(486)] = 12994,
  [SMALL_STATE(487)] = 13031,
  [SMALL_STATE(488)] = 13068,
  [SMALL_STATE(489)] = 13104,
  [SMALL_STATE(490)] = 13140,
  [SMALL_STATE(491)] = 13212,
  [SMALL_STATE(492)] = 13248,
  [SMALL_STATE(493)] = 13284,
  [SMALL_STATE(494)] = 13356,
  [SMALL_STATE(495)] = 13392,
  [SMALL_STATE(496)] = 13428,
  [SMALL_STATE(497)] = 13500,
  [SMALL_STATE(498)] = 13572,
  [SMALL_STATE(499)] = 13644,
  [SMALL_STATE(500)] = 13680,
  [SMALL_STATE(501)] = 13716,
  [SMALL_STATE(502)] = 13788,
  [SMALL_STATE(503)] = 13860,
  [SMALL_STATE(504)] = 13896,
  [SMALL_STATE(505)] = 13968,
  [SMALL_STATE(506)] = 14004,
  [SMALL_STATE(507)] = 14076,
  [SMALL_STATE(508)] = 14120,
  [SMALL_STATE(509)] = 14179,
  [SMALL_STATE(510)] = 14232,
  [SMALL_STATE(511)] = 14289,
  [SMALL_STATE(512)] = 14342,
  [SMALL_STATE(513)] = 14397,
  [SMALL_STATE(514)] = 14456,
  [SMALL_STATE(515)] = 14509,
  [SMALL_STATE(516)] = 14554,
  [SMALL_STATE(517)] = 14599,
  [SMALL_STATE(518)] = 14640,
  [SMALL_STATE(519)] = 14689,
  [SMALL_STATE(520)] = 14733,
  [SMALL_STATE(521)] = 14784,
  [SMALL_STATE(522)] = 14835,
  [SMALL_STATE(523)] = 14878,
  [SMALL_STATE(524)] = 14929,
  [SMALL_STATE(525)] = 14986,
  [SMALL_STATE(526)] = 15039,
  [SMALL_STATE(527)] = 15094,
  [SMALL_STATE(528)] = 15133,
  [SMALL_STATE(529)] = 15194,
  [SMALL_STATE(530)] = 15241,
  [SMALL_STATE(531)] = 15298,
  [SMALL_STATE(532)] = 15354,
  [SMALL_STATE(533)] = 15406,
  [SMALL_STATE(534)] = 15466,
  [SMALL_STATE(535)] = 15522,
  [SMALL_STATE(536)] = 15576,
  [SMALL_STATE(537)] = 15618,
  [SMALL_STATE(538)] = 15656,
  [SMALL_STATE(539)] = 15702,
  [SMALL_STATE(540)] = 15756,
  [SMALL_STATE(541)] = 15792,
  [SMALL_STATE(542)] = 15826,
  [SMALL_STATE(543)] = 15884,
  [SMALL_STATE(544)] = 15918,
  [SMALL_STATE(545)] = 15970,
  [SMALL_STATE(546)] = 16022,
  [SMALL_STATE(547)] = 16081,
  [SMALL_STATE(548)] = 16118,
  [SMALL_STATE(549)] = 16155,
  [SMALL_STATE(550)] = 16192,
  [SMALL_STATE(551)] = 16251,
  [SMALL_STATE(552)] = 16310,
  [SMALL_STATE(553)] = 16369,
  [SMALL_STATE(554)] = 16402,
  [SMALL_STATE(555)] = 16461,
  [SMALL_STATE(556)] = 16498,
  [SMALL_STATE(557)] = 16557,
  [SMALL_STATE(558)] = 16594,
  [SMALL_STATE(559)] = 16631,
  [SMALL_STATE(560)] = 16667,
  [SMALL_STATE(561)] = 16703,
  [SMALL_STATE(562)] = 16739,
  [SMALL_STATE(563)] = 16769,
  [SMALL_STATE(564)] = 16799,
  [SMALL_STATE(565)] = 16829,
  [SMALL_STATE(566)] = 16859,
  [SMALL_STATE(567)] = 16891,
  [SMALL_STATE(568)] = 16947,
  [SMALL_STATE(569)] = 16983,
  [SMALL_STATE(570)] = 17039,
  [SMALL_STATE(571)] = 17095,
  [SMALL_STATE(572)] = 17131,
  [SMALL_STATE(573)] = 17163,
  [SMALL_STATE(574)] = 17199,
  [SMALL_STATE(575)] = 17255,
  [SMALL_STATE(576)] = 17291,
  [SMALL_STATE(577)] = 17327,
  [SMALL_STATE(578)] = 17357,
  [SMALL_STATE(579)] = 17393,
  [SMALL_STATE(580)] = 17449,
  [SMALL_STATE(581)] = 17481,
  [SMALL_STATE(582)] = 17517,
  [SMALL_STATE(583)] = 17553,
  [SMALL_STATE(584)] = 17585,
  [SMALL_STATE(585)] = 17641,
  [SMALL_STATE(586)] = 17677,
  [SMALL_STATE(587)] = 17713,
  [SMALL_STATE(588)] = 17769,
  [SMALL_STATE(589)] = 17825,
  [SMALL_STATE(590)] = 17855,
  [SMALL_STATE(591)] = 17885,
  [SMALL_STATE(592)] = 17915,
  [SMALL_STATE(593)] = 17945,
  [SMALL_STATE(594)] = 17981,
  [SMALL_STATE(595)] = 18037,
  [SMALL_STATE(596)] = 18073,
  [SMALL_STATE(597)] = 18129,
  [SMALL_STATE(598)] = 18165,
  [SMALL_STATE(599)] = 18195,
  [SMALL_STATE(600)] = 18225,
  [SMALL_STATE(601)] = 18281,
  [SMALL_STATE(602)] = 18337,
  [SMALL_STATE(603)] = 18373,
  [SMALL_STATE(604)] = 18403,
  [SMALL_STATE(605)] = 18459,
  [SMALL_STATE(606)] = 18489,
  [SMALL_STATE(607)] = 18519,
  [SMALL_STATE(608)] = 18573,
  [SMALL_STATE(609)] = 18629,
  [SMALL_STATE(610)] = 18665,
  [SMALL_STATE(611)] = 18721,
  [SMALL_STATE(612)] = 18757,
  [SMALL_STATE(613)] = 18787,
  [SMALL_STATE(614)] = 18817,
  [SMALL_STATE(615)] = 18847,
  [SMALL_STATE(616)] = 18903,
  [SMALL_STATE(617)] = 18959,
  [SMALL_STATE(618)] = 18995,
  [SMALL_STATE(619)] = 19025,
  [SMALL_STATE(620)] = 19055,
  [SMALL_STATE(621)] = 19091,
  [SMALL_STATE(622)] = 19121,
  [SMALL_STATE(623)] = 19151,
  [SMALL_STATE(624)] = 19207,
  [SMALL_STATE(625)] = 19263,
  [SMALL_STATE(626)] = 19319,
  [SMALL_STATE(627)] = 19373,
  [SMALL_STATE(628)] = 19409,
  [SMALL_STATE(629)] = 19465,
  [SMALL_STATE(630)] = 19494,
  [SMALL_STATE(631)] = 19529,
  [SMALL_STATE(632)] = 19564,
  [SMALL_STATE(633)] = 19593,
  [SMALL_STATE(634)] = 19628,
  [SMALL_STATE(635)] = 19663,
  [SMALL_STATE(636)] = 19692,
  [SMALL_STATE(637)] = 19721,
  [SMALL_STATE(638)] = 19750,
  [SMALL_STATE(639)] = 19785,
  [SMALL_STATE(640)] = 19838,
  [SMALL_STATE(641)] = 19891,
  [SMALL_STATE(642)] = 19944,
  [SMALL_STATE(643)] = 19975,
  [SMALL_STATE(644)] = 20006,
  [SMALL_STATE(645)] = 20059,
  [SMALL_STATE(646)] = 20094,
  [SMALL_STATE(647)] = 20147,
  [SMALL_STATE(648)] = 20200,
  [SMALL_STATE(649)] = 20229,
  [SMALL_STATE(650)] = 20282,
  [SMALL_STATE(651)] = 20317,
  [SMALL_STATE(652)] = 20348,
  [SMALL_STATE(653)] = 20377,
  [SMALL_STATE(654)] = 20408,
  [SMALL_STATE(655)] = 20439,
  [SMALL_STATE(656)] = 20468,
  [SMALL_STATE(657)] = 20497,
  [SMALL_STATE(658)] = 20526,
  [SMALL_STATE(659)] = 20561,
  [SMALL_STATE(660)] = 20590,
  [SMALL_STATE(661)] = 20643,
  [SMALL_STATE(662)] = 20696,
  [SMALL_STATE(663)] = 20749,
  [SMALL_STATE(664)] = 20802,
  [SMALL_STATE(665)] = 20855,
  [SMALL_STATE(666)] = 20886,
  [SMALL_STATE(667)] = 20939,
  [SMALL_STATE(668)] = 20992,
  [SMALL_STATE(669)] = 21045,
  [SMALL_STATE(670)] = 21080,
  [SMALL_STATE(671)] = 21133,
  [SMALL_STATE(672)] = 21186,
  [SMALL_STATE(673)] = 21239,
  [SMALL_STATE(674)] = 21292,
  [SMALL_STATE(675)] = 21327,
  [SMALL_STATE(676)] = 21380,
  [SMALL_STATE(677)] = 21433,
  [SMALL_STATE(678)] = 21486,
  [SMALL_STATE(679)] = 21539,
  [SMALL_STATE(680)] = 21592,
  [SMALL_STATE(681)] = 21645,
  [SMALL_STATE(682)] = 21698,
  [SMALL_STATE(683)] = 21751,
  [SMALL_STATE(684)] = 21804,
  [SMALL_STATE(685)] = 21857,
  [SMALL_STATE(686)] = 21910,
  [SMALL_STATE(687)] = 21963,
  [SMALL_STATE(688)] = 22016,
  [SMALL_STATE(689)] = 22069,
  [SMALL_STATE(690)] = 22122,
  [SMALL_STATE(691)] = 22157,
  [SMALL_STATE(692)] = 22210,
  [SMALL_STATE(693)] = 22263,
  [SMALL_STATE(694)] = 22316,
  [SMALL_STATE(695)] = 22351,
  [SMALL_STATE(696)] = 22404,
  [SMALL_STATE(697)] = 22457,
  [SMALL_STATE(698)] = 22510,
  [SMALL_STATE(699)] = 22563,
  [SMALL_STATE(700)] = 22616,
  [SMALL_STATE(701)] = 22669,
  [SMALL_STATE(702)] = 22722,
  [SMALL_STATE(703)] = 22757,
  [SMALL_STATE(704)] = 22810,
  [SMALL_STATE(705)] = 22863,
  [SMALL_STATE(706)] = 22916,
  [SMALL_STATE(707)] = 22951,
  [SMALL_STATE(708)] = 23004,
  [SMALL_STATE(709)] = 23057,
  [SMALL_STATE(710)] = 23092,
  [SMALL_STATE(711)] = 23145,
  [SMALL_STATE(712)] = 23198,
  [SMALL_STATE(713)] = 23233,
  [SMALL_STATE(714)] = 23286,
  [SMALL_STATE(715)] = 23339,
  [SMALL_STATE(716)] = 23392,
  [SMALL_STATE(717)] = 23445,
  [SMALL_STATE(718)] = 23498,
  [SMALL_STATE(719)] = 23551,
  [SMALL_STATE(720)] = 23604,
  [SMALL_STATE(721)] = 23657,
  [SMALL_STATE(722)] = 23692,
  [SMALL_STATE(723)] = 23745,
  [SMALL_STATE(724)] = 23798,
  [SMALL_STATE(725)] = 23833,
  [SMALL_STATE(726)] = 23868,
  [SMALL_STATE(727)] = 23899,
  [SMALL_STATE(728)] = 23934,
  [SMALL_STATE(729)] = 23963,
  [SMALL_STATE(730)] = 24016,
  [SMALL_STATE(731)] = 24069,
  [SMALL_STATE(732)] = 24104,
  [SMALL_STATE(733)] = 24157,
  [SMALL_STATE(734)] = 24192,
  [SMALL_STATE(735)] = 24223,
  [SMALL_STATE(736)] = 24258,
  [SMALL_STATE(737)] = 24287,
  [SMALL_STATE(738)] = 24340,
  [SMALL_STATE(739)] = 24369,
  [SMALL_STATE(740)] = 24404,
  [SMALL_STATE(741)] = 24457,
  [SMALL_STATE(742)] = 24510,
  [SMALL_STATE(743)] = 24540,
  [SMALL_STATE(744)] = 24570,
  [SMALL_STATE(745)] = 24602,
  [SMALL_STATE(746)] = 24632,
  [SMALL_STATE(747)] = 24662,
  [SMALL_STATE(748)] = 24692,
  [SMALL_STATE(749)] = 24722,
  [SMALL_STATE(750)] = 24752,
  [SMALL_STATE(751)] = 24786,
  [SMALL_STATE(752)] = 24816,
  [SMALL_STATE(753)] = 24846,
  [SMALL_STATE(754)] = 24876,
  [SMALL_STATE(755)] = 24906,
  [SMALL_STATE(756)] = 24936,
  [SMALL_STATE(757)] = 24966,
  [SMALL_STATE(758)] = 24996,
  [SMALL_STATE(759)] = 25026,
  [SMALL_STATE(760)] = 25056,
  [SMALL_STATE(761)] = 25086,
  [SMALL_STATE(762)] = 25116,
  [SMALL_STATE(763)] = 25146,
  [SMALL_STATE(764)] = 25176,
  [SMALL_STATE(765)] = 25208,
  [SMALL_STATE(766)] = 25237,
  [SMALL_STATE(767)] = 25266,
  [SMALL_STATE(768)] = 25295,
  [SMALL_STATE(769)] = 25324,
  [SMALL_STATE(770)] = 25353,
  [SMALL_STATE(771)] = 25382,
  [SMALL_STATE(772)] = 25411,
  [SMALL_STATE(773)] = 25440,
  [SMALL_STATE(774)] = 25469,
  [SMALL_STATE(775)] = 25498,
  [SMALL_STATE(776)] = 25527,
  [SMALL_STATE(777)] = 25556,
  [SMALL_STATE(778)] = 25585,
  [SMALL_STATE(779)] = 25614,
  [SMALL_STATE(780)] = 25643,
  [SMALL_STATE(781)] = 25672,
  [SMALL_STATE(782)] = 25701,
  [SMALL_STATE(783)] = 25730,
  [SMALL_STATE(784)] = 25759,
  [SMALL_STATE(785)] = 25788,
  [SMALL_STATE(786)] = 25817,
  [SMALL_STATE(787)] = 25846,
  [SMALL_STATE(788)] = 25875,
  [SMALL_STATE(789)] = 25904,
  [SMALL_STATE(790)] = 25933,
  [SMALL_STATE(791)] = 25962,
  [SMALL_STATE(792)] = 25991,
  [SMALL_STATE(793)] = 26020,
  [SMALL_STATE(794)] = 26049,
  [SMALL_STATE(795)] = 26078,
  [SMALL_STATE(796)] = 26107,
  [SMALL_STATE(797)] = 26136,
  [SMALL_STATE(798)] = 26165,
  [SMALL_STATE(799)] = 26194,
  [SMALL_STATE(800)] = 26223,
  [SMALL_STATE(801)] = 26252,
  [SMALL_STATE(802)] = 26281,
  [SMALL_STATE(803)] = 26310,
  [SMALL_STATE(804)] = 26339,
  [SMALL_STATE(805)] = 26368,
  [SMALL_STATE(806)] = 26397,
  [SMALL_STATE(807)] = 26426,
  [SMALL_STATE(808)] = 26455,
  [SMALL_STATE(809)] = 26484,
  [SMALL_STATE(810)] = 26513,
  [SMALL_STATE(811)] = 26542,
  [SMALL_STATE(812)] = 26571,
  [SMALL_STATE(813)] = 26600,
  [SMALL_STATE(814)] = 26629,
  [SMALL_STATE(815)] = 26658,
  [SMALL_STATE(816)] = 26687,
  [SMALL_STATE(817)] = 26716,
  [SMALL_STATE(818)] = 26745,
  [SMALL_STATE(819)] = 26774,
  [SMALL_STATE(820)] = 26803,
  [SMALL_STATE(821)] = 26832,
  [SMALL_STATE(822)] = 26861,
  [SMALL_STATE(823)] = 26890,
  [SMALL_STATE(824)] = 26919,
  [SMALL_STATE(825)] = 26948,
  [SMALL_STATE(826)] = 26977,
  [SMALL_STATE(827)] = 27006,
  [SMALL_STATE(828)] = 27035,
  [SMALL_STATE(829)] = 27081,
  [SMALL_STATE(830)] = 27107,
  [SMALL_STATE(831)] = 27135,
  [SMALL_STATE(832)] = 27181,
  [SMALL_STATE(833)] = 27224,
  [SMALL_STATE(834)] = 27267,
  [SMALL_STATE(835)] = 27292,
  [SMALL_STATE(836)] = 27317,
  [SMALL_STATE(837)] = 27360,
  [SMALL_STATE(838)] = 27403,
  [SMALL_STATE(839)] = 27446,
  [SMALL_STATE(840)] = 27489,
  [SMALL_STATE(841)] = 27532,
  [SMALL_STATE(842)] = 27575,
  [SMALL_STATE(843)] = 27618,
  [SMALL_STATE(844)] = 27658,
  [SMALL_STATE(845)] = 27695,
  [SMALL_STATE(846)] = 27732,
  [SMALL_STATE(847)] = 27769,
  [SMALL_STATE(848)] = 27806,
  [SMALL_STATE(849)] = 27843,
  [SMALL_STATE(850)] = 27880,
  [SMALL_STATE(851)] = 27917,
  [SMALL_STATE(852)] = 27954,
  [SMALL_STATE(853)] = 27991,
  [SMALL_STATE(854)] = 28028,
  [SMALL_STATE(855)] = 28065,
  [SMALL_STATE(856)] = 28102,
  [SMALL_STATE(857)] = 28139,
  [SMALL_STATE(858)] = 28176,
  [SMALL_STATE(859)] = 28213,
  [SMALL_STATE(860)] = 28250,
  [SMALL_STATE(861)] = 28287,
  [SMALL_STATE(862)] = 28309,
  [SMALL_STATE(863)] = 28331,
  [SMALL_STATE(864)] = 28353,
  [SMALL_STATE(865)] = 28375,
  [SMALL_STATE(866)] = 28397,
  [SMALL_STATE(867)] = 28419,
  [SMALL_STATE(868)] = 28437,
  [SMALL_STATE(869)] = 28459,
  [SMALL_STATE(870)] = 28490,
  [SMALL_STATE(871)] = 28509,
  [SMALL_STATE(872)] = 28536,
  [SMALL_STATE(873)] = 28563,
  [SMALL_STATE(874)] = 28594,
  [SMALL_STATE(875)] = 28614,
  [SMALL_STATE(876)] = 28634,
  [SMALL_STATE(877)] = 28654,
  [SMALL_STATE(878)] = 28682,
  [SMALL_STATE(879)] = 28702,
  [SMALL_STATE(880)] = 28730,
  [SMALL_STATE(881)] = 28750,
  [SMALL_STATE(882)] = 28770,
  [SMALL_STATE(883)] = 28784,
  [SMALL_STATE(884)] = 28804,
  [SMALL_STATE(885)] = 28824,
  [SMALL_STATE(886)] = 28848,
  [SMALL_STATE(887)] = 28868,
  [SMALL_STATE(888)] = 28892,
  [SMALL_STATE(889)] = 28916,
  [SMALL_STATE(890)] = 28937,
  [SMALL_STATE(891)] = 28950,
  [SMALL_STATE(892)] = 28967,
  [SMALL_STATE(893)] = 28988,
  [SMALL_STATE(894)] = 29006,
  [SMALL_STATE(895)] = 29018,
  [SMALL_STATE(896)] = 29038,
  [SMALL_STATE(897)] = 29054,
  [SMALL_STATE(898)] = 29072,
  [SMALL_STATE(899)] = 29090,
  [SMALL_STATE(900)] = 29110,
  [SMALL_STATE(901)] = 29130,
  [SMALL_STATE(902)] = 29148,
  [SMALL_STATE(903)] = 29165,
  [SMALL_STATE(904)] = 29182,
  [SMALL_STATE(905)] = 29199,
  [SMALL_STATE(906)] = 29216,
  [SMALL_STATE(907)] = 29231,
  [SMALL_STATE(908)] = 29246,
  [SMALL_STATE(909)] = 29263,
  [SMALL_STATE(910)] = 29280,
  [SMALL_STATE(911)] = 29295,
  [SMALL_STATE(912)] = 29310,
  [SMALL_STATE(913)] = 29327,
  [SMALL_STATE(914)] = 29342,
  [SMALL_STATE(915)] = 29357,
  [SMALL_STATE(916)] = 29374,
  [SMALL_STATE(917)] = 29389,
  [SMALL_STATE(918)] = 29406,
  [SMALL_STATE(919)] = 29421,
  [SMALL_STATE(920)] = 29438,
  [SMALL_STATE(921)] = 29455,
  [SMALL_STATE(922)] = 29470,
  [SMALL_STATE(923)] = 29487,
  [SMALL_STATE(924)] = 29502,
  [SMALL_STATE(925)] = 29519,
  [SMALL_STATE(926)] = 29534,
  [SMALL_STATE(927)] = 29547,
  [SMALL_STATE(928)] = 29564,
  [SMALL_STATE(929)] = 29581,
  [SMALL_STATE(930)] = 29596,
  [SMALL_STATE(931)] = 29613,
  [SMALL_STATE(932)] = 29628,
  [SMALL_STATE(933)] = 29645,
  [SMALL_STATE(934)] = 29662,
  [SMALL_STATE(935)] = 29679,
  [SMALL_STATE(936)] = 29694,
  [SMALL_STATE(937)] = 29709,
  [SMALL_STATE(938)] = 29724,
  [SMALL_STATE(939)] = 29741,
  [SMALL_STATE(940)] = 29756,
  [SMALL_STATE(941)] = 29773,
  [SMALL_STATE(942)] = 29784,
  [SMALL_STATE(943)] = 29799,
  [SMALL_STATE(944)] = 29812,
  [SMALL_STATE(945)] = 29829,
  [SMALL_STATE(946)] = 29844,
  [SMALL_STATE(947)] = 29861,
  [SMALL_STATE(948)] = 29878,
  [SMALL_STATE(949)] = 29893,
  [SMALL_STATE(950)] = 29908,
  [SMALL_STATE(951)] = 29925,
  [SMALL_STATE(952)] = 29940,
  [SMALL_STATE(953)] = 29957,
  [SMALL_STATE(954)] = 29972,
  [SMALL_STATE(955)] = 29989,
  [SMALL_STATE(956)] = 30004,
  [SMALL_STATE(957)] = 30021,
  [SMALL_STATE(958)] = 30036,
  [SMALL_STATE(959)] = 30053,
  [SMALL_STATE(960)] = 30070,
  [SMALL_STATE(961)] = 30085,
  [SMALL_STATE(962)] = 30102,
  [SMALL_STATE(963)] = 30116,
  [SMALL_STATE(964)] = 30130,
  [SMALL_STATE(965)] = 30144,
  [SMALL_STATE(966)] = 30158,
  [SMALL_STATE(967)] = 30172,
  [SMALL_STATE(968)] = 30186,
  [SMALL_STATE(969)] = 30200,
  [SMALL_STATE(970)] = 30212,
  [SMALL_STATE(971)] = 30224,
  [SMALL_STATE(972)] = 30238,
  [SMALL_STATE(973)] = 30252,
  [SMALL_STATE(974)] = 30266,
  [SMALL_STATE(975)] = 30280,
  [SMALL_STATE(976)] = 30294,
  [SMALL_STATE(977)] = 30308,
  [SMALL_STATE(978)] = 30320,
  [SMALL_STATE(979)] = 30332,
  [SMALL_STATE(980)] = 30346,
  [SMALL_STATE(981)] = 30360,
  [SMALL_STATE(982)] = 30374,
  [SMALL_STATE(983)] = 30388,
  [SMALL_STATE(984)] = 30402,
  [SMALL_STATE(985)] = 30416,
  [SMALL_STATE(986)] = 30430,
  [SMALL_STATE(987)] = 30444,
  [SMALL_STATE(988)] = 30454,
  [SMALL_STATE(989)] = 30468,
  [SMALL_STATE(990)] = 30482,
  [SMALL_STATE(991)] = 30496,
  [SMALL_STATE(992)] = 30510,
  [SMALL_STATE(993)] = 30524,
  [SMALL_STATE(994)] = 30538,
  [SMALL_STATE(995)] = 30548,
  [SMALL_STATE(996)] = 30562,
  [SMALL_STATE(997)] = 30576,
  [SMALL_STATE(998)] = 30586,
  [SMALL_STATE(999)] = 30600,
  [SMALL_STATE(1000)] = 30614,
  [SMALL_STATE(1001)] = 30628,
  [SMALL_STATE(1002)] = 30642,
  [SMALL_STATE(1003)] = 30656,
  [SMALL_STATE(1004)] = 30670,
  [SMALL_STATE(1005)] = 30684,
  [SMALL_STATE(1006)] = 30698,
  [SMALL_STATE(1007)] = 30708,
  [SMALL_STATE(1008)] = 30722,
  [SMALL_STATE(1009)] = 30736,
  [SMALL_STATE(1010)] = 30750,
  [SMALL_STATE(1011)] = 30764,
  [SMALL_STATE(1012)] = 30778,
  [SMALL_STATE(1013)] = 30792,
  [SMALL_STATE(1014)] = 30806,
  [SMALL_STATE(1015)] = 30820,
  [SMALL_STATE(1016)] = 30834,
  [SMALL_STATE(1017)] = 30848,
  [SMALL_STATE(1018)] = 30862,
  [SMALL_STATE(1019)] = 30876,
  [SMALL_STATE(1020)] = 30890,
  [SMALL_STATE(1021)] = 30904,
  [SMALL_STATE(1022)] = 30918,
  [SMALL_STATE(1023)] = 30932,
  [SMALL_STATE(1024)] = 30946,
  [SMALL_STATE(1025)] = 30958,
  [SMALL_STATE(1026)] = 30972,
  [SMALL_STATE(1027)] = 30986,
  [SMALL_STATE(1028)] = 31000,
  [SMALL_STATE(1029)] = 31014,
  [SMALL_STATE(1030)] = 31028,
  [SMALL_STATE(1031)] = 31042,
  [SMALL_STATE(1032)] = 31056,
  [SMALL_STATE(1033)] = 31070,
  [SMALL_STATE(1034)] = 31084,
  [SMALL_STATE(1035)] = 31098,
  [SMALL_STATE(1036)] = 31112,
  [SMALL_STATE(1037)] = 31126,
  [SMALL_STATE(1038)] = 31140,
  [SMALL_STATE(1039)] = 31154,
  [SMALL_STATE(1040)] = 31168,
  [SMALL_STATE(1041)] = 31182,
  [SMALL_STATE(1042)] = 31196,
  [SMALL_STATE(1043)] = 31210,
  [SMALL_STATE(1044)] = 31224,
  [SMALL_STATE(1045)] = 31238,
  [SMALL_STATE(1046)] = 31252,
  [SMALL_STATE(1047)] = 31266,
  [SMALL_STATE(1048)] = 31278,
  [SMALL_STATE(1049)] = 31292,
  [SMALL_STATE(1050)] = 31306,
  [SMALL_STATE(1051)] = 31320,
  [SMALL_STATE(1052)] = 31334,
  [SMALL_STATE(1053)] = 31348,
  [SMALL_STATE(1054)] = 31362,
  [SMALL_STATE(1055)] = 31376,
  [SMALL_STATE(1056)] = 31390,
  [SMALL_STATE(1057)] = 31404,
  [SMALL_STATE(1058)] = 31418,
  [SMALL_STATE(1059)] = 31430,
  [SMALL_STATE(1060)] = 31444,
  [SMALL_STATE(1061)] = 31458,
  [SMALL_STATE(1062)] = 31472,
  [SMALL_STATE(1063)] = 31486,
  [SMALL_STATE(1064)] = 31500,
  [SMALL_STATE(1065)] = 31514,
  [SMALL_STATE(1066)] = 31528,
  [SMALL_STATE(1067)] = 31542,
  [SMALL_STATE(1068)] = 31556,
  [SMALL_STATE(1069)] = 31570,
  [SMALL_STATE(1070)] = 31584,
  [SMALL_STATE(1071)] = 31598,
  [SMALL_STATE(1072)] = 31612,
  [SMALL_STATE(1073)] = 31626,
  [SMALL_STATE(1074)] = 31640,
  [SMALL_STATE(1075)] = 31654,
  [SMALL_STATE(1076)] = 31668,
  [SMALL_STATE(1077)] = 31682,
  [SMALL_STATE(1078)] = 31696,
  [SMALL_STATE(1079)] = 31710,
  [SMALL_STATE(1080)] = 31724,
  [SMALL_STATE(1081)] = 31738,
  [SMALL_STATE(1082)] = 31752,
  [SMALL_STATE(1083)] = 31766,
  [SMALL_STATE(1084)] = 31778,
  [SMALL_STATE(1085)] = 31792,
  [SMALL_STATE(1086)] = 31806,
  [SMALL_STATE(1087)] = 31820,
  [SMALL_STATE(1088)] = 31829,
  [SMALL_STATE(1089)] = 31840,
  [SMALL_STATE(1090)] = 31851,
  [SMALL_STATE(1091)] = 31862,
  [SMALL_STATE(1092)] = 31871,
  [SMALL_STATE(1093)] = 31882,
  [SMALL_STATE(1094)] = 31893,
  [SMALL_STATE(1095)] = 31902,
  [SMALL_STATE(1096)] = 31911,
  [SMALL_STATE(1097)] = 31922,
  [SMALL_STATE(1098)] = 31933,
  [SMALL_STATE(1099)] = 31944,
  [SMALL_STATE(1100)] = 31955,
  [SMALL_STATE(1101)] = 31966,
  [SMALL_STATE(1102)] = 31977,
  [SMALL_STATE(1103)] = 31988,
  [SMALL_STATE(1104)] = 31999,
  [SMALL_STATE(1105)] = 32010,
  [SMALL_STATE(1106)] = 32021,
  [SMALL_STATE(1107)] = 32032,
  [SMALL_STATE(1108)] = 32043,
  [SMALL_STATE(1109)] = 32054,
  [SMALL_STATE(1110)] = 32065,
  [SMALL_STATE(1111)] = 32074,
  [SMALL_STATE(1112)] = 32083,
  [SMALL_STATE(1113)] = 32094,
  [SMALL_STATE(1114)] = 32105,
  [SMALL_STATE(1115)] = 32114,
  [SMALL_STATE(1116)] = 32123,
  [SMALL_STATE(1117)] = 32132,
  [SMALL_STATE(1118)] = 32143,
  [SMALL_STATE(1119)] = 32154,
  [SMALL_STATE(1120)] = 32165,
  [SMALL_STATE(1121)] = 32176,
  [SMALL_STATE(1122)] = 32185,
  [SMALL_STATE(1123)] = 32196,
  [SMALL_STATE(1124)] = 32205,
  [SMALL_STATE(1125)] = 32216,
  [SMALL_STATE(1126)] = 32227,
  [SMALL_STATE(1127)] = 32238,
  [SMALL_STATE(1128)] = 32249,
  [SMALL_STATE(1129)] = 32258,
  [SMALL_STATE(1130)] = 32269,
  [SMALL_STATE(1131)] = 32280,
  [SMALL_STATE(1132)] = 32288,
  [SMALL_STATE(1133)] = 32296,
  [SMALL_STATE(1134)] = 32304,
  [SMALL_STATE(1135)] = 32312,
  [SMALL_STATE(1136)] = 32320,
  [SMALL_STATE(1137)] = 32328,
  [SMALL_STATE(1138)] = 32336,
  [SMALL_STATE(1139)] = 32344,
  [SMALL_STATE(1140)] = 32352,
  [SMALL_STATE(1141)] = 32360,
  [SMALL_STATE(1142)] = 32368,
  [SMALL_STATE(1143)] = 32376,
  [SMALL_STATE(1144)] = 32384,
  [SMALL_STATE(1145)] = 32392,
  [SMALL_STATE(1146)] = 32400,
  [SMALL_STATE(1147)] = 32408,
  [SMALL_STATE(1148)] = 32416,
  [SMALL_STATE(1149)] = 32424,
  [SMALL_STATE(1150)] = 32432,
  [SMALL_STATE(1151)] = 32440,
  [SMALL_STATE(1152)] = 32448,
  [SMALL_STATE(1153)] = 32456,
  [SMALL_STATE(1154)] = 32464,
  [SMALL_STATE(1155)] = 32472,
  [SMALL_STATE(1156)] = 32480,
  [SMALL_STATE(1157)] = 32488,
  [SMALL_STATE(1158)] = 32496,
  [SMALL_STATE(1159)] = 32504,
  [SMALL_STATE(1160)] = 32512,
  [SMALL_STATE(1161)] = 32520,
  [SMALL_STATE(1162)] = 32528,
  [SMALL_STATE(1163)] = 32536,
  [SMALL_STATE(1164)] = 32544,
  [SMALL_STATE(1165)] = 32552,
  [SMALL_STATE(1166)] = 32560,
  [SMALL_STATE(1167)] = 32568,
  [SMALL_STATE(1168)] = 32576,
  [SMALL_STATE(1169)] = 32584,
  [SMALL_STATE(1170)] = 32592,
  [SMALL_STATE(1171)] = 32600,
  [SMALL_STATE(1172)] = 32608,
  [SMALL_STATE(1173)] = 32616,
  [SMALL_STATE(1174)] = 32624,
  [SMALL_STATE(1175)] = 32632,
  [SMALL_STATE(1176)] = 32640,
  [SMALL_STATE(1177)] = 32648,
  [SMALL_STATE(1178)] = 32656,
  [SMALL_STATE(1179)] = 32664,
  [SMALL_STATE(1180)] = 32672,
  [SMALL_STATE(1181)] = 32680,
  [SMALL_STATE(1182)] = 32688,
  [SMALL_STATE(1183)] = 32696,
  [SMALL_STATE(1184)] = 32704,
  [SMALL_STATE(1185)] = 32712,
  [SMALL_STATE(1186)] = 32720,
  [SMALL_STATE(1187)] = 32728,
  [SMALL_STATE(1188)] = 32736,
  [SMALL_STATE(1189)] = 32744,
  [SMALL_STATE(1190)] = 32752,
  [SMALL_STATE(1191)] = 32760,
  [SMALL_STATE(1192)] = 32768,
  [SMALL_STATE(1193)] = 32776,
  [SMALL_STATE(1194)] = 32784,
  [SMALL_STATE(1195)] = 32792,
  [SMALL_STATE(1196)] = 32800,
  [SMALL_STATE(1197)] = 32808,
  [SMALL_STATE(1198)] = 32816,
  [SMALL_STATE(1199)] = 32824,
  [SMALL_STATE(1200)] = 32832,
  [SMALL_STATE(1201)] = 32840,
  [SMALL_STATE(1202)] = 32848,
  [SMALL_STATE(1203)] = 32856,
  [SMALL_STATE(1204)] = 32864,
  [SMALL_STATE(1205)] = 32872,
  [SMALL_STATE(1206)] = 32880,
  [SMALL_STATE(1207)] = 32888,
  [SMALL_STATE(1208)] = 32896,
  [SMALL_STATE(1209)] = 32904,
  [SMALL_STATE(1210)] = 32912,
  [SMALL_STATE(1211)] = 32920,
  [SMALL_STATE(1212)] = 32928,
  [SMALL_STATE(1213)] = 32936,
  [SMALL_STATE(1214)] = 32944,
  [SMALL_STATE(1215)] = 32952,
  [SMALL_STATE(1216)] = 32960,
  [SMALL_STATE(1217)] = 32968,
  [SMALL_STATE(1218)] = 32976,
  [SMALL_STATE(1219)] = 32984,
  [SMALL_STATE(1220)] = 32992,
  [SMALL_STATE(1221)] = 33000,
  [SMALL_STATE(1222)] = 33008,
  [SMALL_STATE(1223)] = 33016,
  [SMALL_STATE(1224)] = 33024,
  [SMALL_STATE(1225)] = 33032,
  [SMALL_STATE(1226)] = 33040,
  [SMALL_STATE(1227)] = 33048,
  [SMALL_STATE(1228)] = 33056,
  [SMALL_STATE(1229)] = 33064,
  [SMALL_STATE(1230)] = 33072,
  [SMALL_STATE(1231)] = 33080,
  [SMALL_STATE(1232)] = 33088,
  [SMALL_STATE(1233)] = 33096,
  [SMALL_STATE(1234)] = 33104,
  [SMALL_STATE(1235)] = 33112,
  [SMALL_STATE(1236)] = 33120,
  [SMALL_STATE(1237)] = 33128,
  [SMALL_STATE(1238)] = 33136,
  [SMALL_STATE(1239)] = 33144,
  [SMALL_STATE(1240)] = 33152,
  [SMALL_STATE(1241)] = 33160,
  [SMALL_STATE(1242)] = 33168,
  [SMALL_STATE(1243)] = 33176,
  [SMALL_STATE(1244)] = 33184,
  [SMALL_STATE(1245)] = 33192,
  [SMALL_STATE(1246)] = 33200,
  [SMALL_STATE(1247)] = 33208,
  [SMALL_STATE(1248)] = 33216,
  [SMALL_STATE(1249)] = 33224,
  [SMALL_STATE(1250)] = 33232,
  [SMALL_STATE(1251)] = 33240,
  [SMALL_STATE(1252)] = 33248,
  [SMALL_STATE(1253)] = 33256,
  [SMALL_STATE(1254)] = 33264,
  [SMALL_STATE(1255)] = 33272,
  [SMALL_STATE(1256)] = 33280,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [5] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [7] = {.count = 1, .reusable = true}, REDUCE(sym_ql, 0),
  [9] = {.count = 1, .reusable = false}, SHIFT(817),
  [11] = {.count = 1, .reusable = false}, SHIFT(953),
  [13] = {.count = 1, .reusable = false}, SHIFT(831),
  [15] = {.count = 1, .reusable = false}, SHIFT(87),
  [17] = {.count = 1, .reusable = false}, SHIFT(72),
  [19] = {.count = 1, .reusable = true}, SHIFT(825),
  [21] = {.count = 1, .reusable = false}, SHIFT(458),
  [23] = {.count = 1, .reusable = true}, SHIFT(457),
  [25] = {.count = 1, .reusable = true}, SHIFT(460),
  [27] = {.count = 1, .reusable = false}, SHIFT(1089),
  [29] = {.count = 1, .reusable = false}, SHIFT(1090),
  [31] = {.count = 1, .reusable = false}, SHIFT(897),
  [33] = {.count = 1, .reusable = false}, SHIFT(1253),
  [35] = {.count = 1, .reusable = false}, SHIFT(540),
  [37] = {.count = 1, .reusable = true}, SHIFT(226),
  [39] = {.count = 1, .reusable = true}, SHIFT(357),
  [41] = {.count = 1, .reusable = false}, SHIFT(116),
  [43] = {.count = 1, .reusable = true}, SHIFT(56),
  [45] = {.count = 1, .reusable = true}, SHIFT(130),
  [47] = {.count = 1, .reusable = true}, SHIFT(519),
  [49] = {.count = 1, .reusable = false}, SHIFT(562),
  [51] = {.count = 1, .reusable = true}, SHIFT(562),
  [53] = {.count = 1, .reusable = false}, SHIFT(1095),
  [55] = {.count = 1, .reusable = false}, SHIFT(1243),
  [57] = {.count = 1, .reusable = false}, SHIFT(563),
  [59] = {.count = 1, .reusable = false}, SHIFT(181),
  [61] = {.count = 1, .reusable = false}, SHIFT(1241),
  [63] = {.count = 1, .reusable = false}, SHIFT(564),
  [65] = {.count = 1, .reusable = false}, SHIFT(565),
  [67] = {.count = 1, .reusable = true}, SHIFT(397),
  [69] = {.count = 1, .reusable = true}, SHIFT(372),
  [71] = {.count = 1, .reusable = true}, SHIFT(481),
  [73] = {.count = 1, .reusable = true}, SHIFT(318),
  [75] = {.count = 1, .reusable = true}, SHIFT(322),
  [77] = {.count = 1, .reusable = true}, SHIFT(592),
  [79] = {.count = 1, .reusable = true}, SHIFT(468),
  [81] = {.count = 1, .reusable = true}, SHIFT(310),
  [83] = {.count = 1, .reusable = true}, SHIFT(348),
  [85] = {.count = 1, .reusable = true}, SHIFT(619),
  [87] = {.count = 1, .reusable = true}, SHIFT(345),
  [89] = {.count = 1, .reusable = true}, SHIFT(614),
  [91] = {.count = 1, .reusable = true}, SHIFT(328),
  [93] = {.count = 1, .reusable = true}, SHIFT(386),
  [95] = {.count = 1, .reusable = true}, SHIFT(323),
  [97] = {.count = 1, .reusable = true}, SHIFT(378),
  [99] = {.count = 1, .reusable = true}, SHIFT(480),
  [101] = {.count = 1, .reusable = true}, SHIFT(359),
  [103] = {.count = 1, .reusable = false}, SHIFT(464),
  [105] = {.count = 1, .reusable = true}, SHIFT(221),
  [107] = {.count = 1, .reusable = true}, SHIFT(341),
  [109] = {.count = 1, .reusable = false}, SHIFT(152),
  [111] = {.count = 1, .reusable = true}, SHIFT(149),
  [113] = {.count = 1, .reusable = true}, SHIFT(516),
  [115] = {.count = 1, .reusable = false}, SHIFT(483),
  [117] = {.count = 1, .reusable = true}, SHIFT(483),
  [119] = {.count = 1, .reusable = false}, SHIFT(482),
  [121] = {.count = 1, .reusable = false}, SHIFT(199),
  [123] = {.count = 1, .reusable = false}, SHIFT(479),
  [125] = {.count = 1, .reusable = false}, SHIFT(477),
  [127] = {.count = 1, .reusable = true}, SHIFT(1019),
  [129] = {.count = 1, .reusable = true}, SHIFT(448),
  [131] = {.count = 1, .reusable = true}, SHIFT(129),
  [133] = {.count = 1, .reusable = true}, SHIFT(380),
  [135] = {.count = 1, .reusable = true}, SHIFT(1070),
  [137] = {.count = 1, .reusable = true}, SHIFT(352),
  [139] = {.count = 1, .reusable = true}, SHIFT(963),
  [141] = {.count = 1, .reusable = true}, SHIFT(494),
  [143] = {.count = 1, .reusable = true}, SHIFT(147),
  [145] = {.count = 1, .reusable = true}, SHIFT(410),
  [147] = {.count = 1, .reusable = true}, SHIFT(161),
  [149] = {.count = 1, .reusable = true}, SHIFT(330),
  [151] = {.count = 1, .reusable = true}, SHIFT(1026),
  [153] = {.count = 1, .reusable = true}, SHIFT(474),
  [155] = {.count = 1, .reusable = true}, SHIFT(1035),
  [157] = {.count = 1, .reusable = true}, SHIFT(385),
  [159] = {.count = 1, .reusable = true}, SHIFT(1051),
  [161] = {.count = 1, .reusable = true}, SHIFT(384),
  [163] = {.count = 1, .reusable = true}, SHIFT(1063),
  [165] = {.count = 1, .reusable = true}, SHIFT(315),
  [167] = {.count = 1, .reusable = true}, SHIFT(988),
  [169] = {.count = 1, .reusable = true}, SHIFT(355),
  [171] = {.count = 1, .reusable = true}, SHIFT(1032),
  [173] = {.count = 1, .reusable = true}, SHIFT(387),
  [175] = {.count = 1, .reusable = true}, SHIFT(1061),
  [177] = {.count = 1, .reusable = true}, SHIFT(298),
  [179] = {.count = 1, .reusable = true}, SHIFT(962),
  [181] = {.count = 1, .reusable = true}, SHIFT(793),
  [183] = {.count = 1, .reusable = true}, SHIFT(1028),
  [185] = {.count = 1, .reusable = true}, SHIFT(337),
  [187] = {.count = 1, .reusable = true}, SHIFT(1010),
  [189] = {.count = 1, .reusable = true}, SHIFT(591),
  [191] = {.count = 1, .reusable = true}, SHIFT(1007),
  [193] = {.count = 1, .reusable = true}, SHIFT(598),
  [195] = {.count = 1, .reusable = true}, SHIFT(965),
  [197] = {.count = 1, .reusable = true}, SHIFT(782),
  [199] = {.count = 1, .reusable = true}, SHIFT(1014),
  [201] = {.count = 1, .reusable = true}, SHIFT(469),
  [203] = {.count = 1, .reusable = true}, SHIFT(1021),
  [205] = {.count = 1, .reusable = true}, SHIFT(657),
  [207] = {.count = 1, .reusable = true}, SHIFT(230),
  [209] = {.count = 1, .reusable = true}, SHIFT(346),
  [211] = {.count = 1, .reusable = true}, SHIFT(1023),
  [213] = {.count = 1, .reusable = true}, SHIFT(472),
  [215] = {.count = 1, .reusable = true}, SHIFT(995),
  [217] = {.count = 1, .reusable = true}, SHIFT(605),
  [219] = {.count = 1, .reusable = true}, SHIFT(966),
  [221] = {.count = 1, .reusable = true}, SHIFT(418),
  [223] = {.count = 1, .reusable = true}, SHIFT(86),
  [225] = {.count = 1, .reusable = true}, SHIFT(344),
  [227] = {.count = 1, .reusable = true}, SHIFT(1013),
  [229] = {.count = 1, .reusable = true}, SHIFT(612),
  [231] = {.count = 1, .reusable = true}, SHIFT(972),
  [233] = {.count = 1, .reusable = true}, SHIFT(311),
  [235] = {.count = 1, .reusable = true}, SHIFT(986),
  [237] = {.count = 1, .reusable = true}, SHIFT(791),
  [239] = {.count = 1, .reusable = true}, SHIFT(1045),
  [241] = {.count = 1, .reusable = true}, SHIFT(309),
  [243] = {.count = 1, .reusable = true}, SHIFT(982),
  [245] = {.count = 1, .reusable = true}, SHIFT(787),
  [247] = {.count = 1, .reusable = true}, SHIFT(1017),
  [249] = {.count = 1, .reusable = true}, SHIFT(792),
  [251] = {.count = 1, .reusable = true}, SHIFT(1053),
  [253] = {.count = 1, .reusable = true}, SHIFT(349),
  [255] = {.count = 1, .reusable = true}, SHIFT(1025),
  [257] = {.count = 1, .reusable = true}, SHIFT(766),
  [259] = {.count = 1, .reusable = true}, SHIFT(1062),
  [261] = {.count = 1, .reusable = true}, SHIFT(428),
  [263] = {.count = 1, .reusable = true}, SHIFT(218),
  [265] = {.count = 1, .reusable = true}, SHIFT(473),
  [267] = {.count = 1, .reusable = true}, SHIFT(1080),
  [269] = {.count = 1, .reusable = true}, REDUCE(sym_full_aggregate_body, 1),
  [271] = {.count = 1, .reusable = true}, SHIFT(67),
  [273] = {.count = 1, .reusable = false}, SHIFT(274),
  [275] = {.count = 1, .reusable = true}, SHIFT(196),
  [277] = {.count = 1, .reusable = false}, SHIFT(98),
  [279] = {.count = 1, .reusable = true}, SHIFT(113),
  [281] = {.count = 1, .reusable = true}, SHIFT(273),
  [283] = {.count = 1, .reusable = false}, SHIFT(305),
  [285] = {.count = 1, .reusable = true}, SHIFT(305),
  [287] = {.count = 1, .reusable = false}, SHIFT(304),
  [289] = {.count = 1, .reusable = false}, SHIFT(151),
  [291] = {.count = 1, .reusable = false}, SHIFT(303),
  [293] = {.count = 1, .reusable = false}, SHIFT(302),
  [295] = {.count = 1, .reusable = false}, SHIFT(258),
  [297] = {.count = 1, .reusable = true}, SHIFT(148),
  [299] = {.count = 1, .reusable = false}, SHIFT(158),
  [301] = {.count = 1, .reusable = true}, SHIFT(157),
  [303] = {.count = 1, .reusable = true}, SHIFT(260),
  [305] = {.count = 1, .reusable = false}, SHIFT(376),
  [307] = {.count = 1, .reusable = true}, SHIFT(376),
  [309] = {.count = 1, .reusable = false}, SHIFT(375),
  [311] = {.count = 1, .reusable = false}, SHIFT(208),
  [313] = {.count = 1, .reusable = false}, SHIFT(373),
  [315] = {.count = 1, .reusable = false}, SHIFT(371),
  [317] = {.count = 1, .reusable = true}, REDUCE(sym_full_aggregate_body, 3),
  [319] = {.count = 1, .reusable = true}, SHIFT(58),
  [321] = {.count = 1, .reusable = true}, REDUCE(sym_full_aggregate_body, 2),
  [323] = {.count = 1, .reusable = true}, SHIFT(64),
  [325] = {.count = 1, .reusable = true}, SHIFT(1121),
  [327] = {.count = 1, .reusable = false}, SHIFT(259),
  [329] = {.count = 1, .reusable = true}, SHIFT(120),
  [331] = {.count = 1, .reusable = false}, SHIFT(175),
  [333] = {.count = 1, .reusable = true}, SHIFT(89),
  [335] = {.count = 1, .reusable = true}, SHIFT(278),
  [337] = {.count = 1, .reusable = false}, SHIFT(362),
  [339] = {.count = 1, .reusable = true}, SHIFT(362),
  [341] = {.count = 1, .reusable = false}, SHIFT(363),
  [343] = {.count = 1, .reusable = false}, SHIFT(204),
  [345] = {.count = 1, .reusable = false}, SHIFT(364),
  [347] = {.count = 1, .reusable = false}, SHIFT(365),
  [349] = {.count = 1, .reusable = false}, SHIFT(288),
  [351] = {.count = 1, .reusable = true}, SHIFT(170),
  [353] = {.count = 1, .reusable = false}, SHIFT(90),
  [355] = {.count = 1, .reusable = true}, SHIFT(96),
  [357] = {.count = 1, .reusable = true}, SHIFT(272),
  [359] = {.count = 1, .reusable = false}, SHIFT(331),
  [361] = {.count = 1, .reusable = true}, SHIFT(331),
  [363] = {.count = 1, .reusable = false}, SHIFT(332),
  [365] = {.count = 1, .reusable = false}, SHIFT(115),
  [367] = {.count = 1, .reusable = false}, SHIFT(333),
  [369] = {.count = 1, .reusable = false}, SHIFT(334),
  [371] = {.count = 1, .reusable = true}, SHIFT(134),
  [373] = {.count = 1, .reusable = false}, SHIFT(136),
  [375] = {.count = 1, .reusable = true}, SHIFT(507),
  [377] = {.count = 1, .reusable = false}, SHIFT(156),
  [379] = {.count = 1, .reusable = true}, REDUCE(sym_orderBy, 1),
  [381] = {.count = 1, .reusable = false}, REDUCE(sym_orderBy, 1),
  [383] = {.count = 1, .reusable = false}, SHIFT(107),
  [385] = {.count = 1, .reusable = false}, SHIFT(106),
  [387] = {.count = 1, .reusable = false}, SHIFT(105),
  [389] = {.count = 1, .reusable = false}, SHIFT(742),
  [391] = {.count = 1, .reusable = false}, SHIFT(1119),
  [393] = {.count = 1, .reusable = false}, SHIFT(857),
  [395] = {.count = 1, .reusable = false}, SHIFT(408),
  [397] = {.count = 1, .reusable = true}, SHIFT(408),
  [399] = {.count = 1, .reusable = true}, SHIFT(421),
  [401] = {.count = 1, .reusable = false}, SHIFT(425),
  [403] = {.count = 1, .reusable = true}, SHIFT(425),
  [405] = {.count = 1, .reusable = false}, SHIFT(206),
  [407] = {.count = 1, .reusable = false}, SHIFT(209),
  [409] = {.count = 1, .reusable = false}, SHIFT(213),
  [411] = {.count = 1, .reusable = false}, SHIFT(758),
  [413] = {.count = 1, .reusable = false}, SHIFT(1126),
  [415] = {.count = 1, .reusable = false}, SHIFT(853),
  [417] = {.count = 1, .reusable = false}, REDUCE(sym_mul_expr, 3, .production_id = 2),
  [419] = {.count = 1, .reusable = true}, REDUCE(sym_mul_expr, 3, .production_id = 2),
  [421] = {.count = 1, .reusable = true}, REDUCE(sym_comp_term, 3, .production_id = 2),
  [423] = {.count = 1, .reusable = false}, REDUCE(sym_comp_term, 3, .production_id = 2),
  [425] = {.count = 1, .reusable = true}, REDUCE(sym_implication, 3, .production_id = 2),
  [427] = {.count = 1, .reusable = false}, REDUCE(sym_implication, 3, .production_id = 2),
  [429] = {.count = 1, .reusable = false}, SHIFT(229),
  [431] = {.count = 1, .reusable = false}, SHIFT(231),
  [433] = {.count = 1, .reusable = false}, SHIFT(1105),
  [435] = {.count = 1, .reusable = false}, SHIFT(859),
  [437] = {.count = 1, .reusable = true}, REDUCE(sym_negation, 2),
  [439] = {.count = 1, .reusable = false}, REDUCE(sym_negation, 2),
  [441] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expr, 2),
  [443] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expr, 2),
  [445] = {.count = 1, .reusable = false}, REDUCE(sym_disjunction, 3, .production_id = 2),
  [447] = {.count = 1, .reusable = true}, REDUCE(sym_disjunction, 3, .production_id = 2),
  [449] = {.count = 1, .reusable = false}, REDUCE(sym_add_expr, 3, .production_id = 2),
  [451] = {.count = 1, .reusable = true}, REDUCE(sym_add_expr, 3, .production_id = 2),
  [453] = {.count = 1, .reusable = false}, REDUCE(sym_prefix_cast, 4, .dynamic_precedence = 10),
  [455] = {.count = 1, .reusable = true}, REDUCE(sym_prefix_cast, 4, .dynamic_precedence = 10),
  [457] = {.count = 1, .reusable = false}, SHIFT(241),
  [459] = {.count = 1, .reusable = true}, REDUCE(sym_if_term, 6, .production_id = 6),
  [461] = {.count = 1, .reusable = false}, REDUCE(sym_if_term, 6, .production_id = 6),
  [463] = {.count = 1, .reusable = true}, REDUCE(sym_simpleId, 1),
  [465] = {.count = 1, .reusable = false}, REDUCE(sym_simpleId, 1),
  [467] = {.count = 1, .reusable = true}, REDUCE(sym_literalId, 1),
  [469] = {.count = 2, .reusable = true}, REDUCE(sym_literalId, 1), REDUCE(sym_simpleId, 1),
  [472] = {.count = 2, .reusable = true}, REDUCE(sym_simpleId, 1), REDUCE(sym_className, 1),
  [475] = {.count = 1, .reusable = false}, REDUCE(sym_asExpr, 1),
  [477] = {.count = 1, .reusable = true}, REDUCE(sym_asExpr, 1),
  [479] = {.count = 1, .reusable = false}, SHIFT(146),
  [481] = {.count = 1, .reusable = false}, SHIFT(145),
  [483] = {.count = 1, .reusable = false}, SHIFT(141),
  [485] = {.count = 1, .reusable = false}, SHIFT(957),
  [487] = {.count = 1, .reusable = false}, SHIFT(1109),
  [489] = {.count = 1, .reusable = false}, SHIFT(852),
  [491] = {.count = 1, .reusable = false}, SHIFT(945),
  [493] = {.count = 1, .reusable = false}, REDUCE(sym_conjunction, 3, .production_id = 2),
  [495] = {.count = 1, .reusable = true}, REDUCE(sym_conjunction, 3, .production_id = 2),
  [497] = {.count = 1, .reusable = false}, REDUCE(sym_varName, 1),
  [499] = {.count = 1, .reusable = true}, REDUCE(sym_varName, 1),
  [501] = {.count = 1, .reusable = true}, REDUCE(sym_moduleExpr, 1),
  [503] = {.count = 1, .reusable = false}, REDUCE(sym_qualifiedRhs, 4),
  [505] = {.count = 1, .reusable = true}, REDUCE(sym_qualifiedRhs, 4),
  [507] = {.count = 1, .reusable = true}, REDUCE(sym_super_ref, 3),
  [509] = {.count = 1, .reusable = false}, REDUCE(sym_super_ref, 3),
  [511] = {.count = 1, .reusable = true}, REDUCE(sym_className, 1),
  [513] = {.count = 1, .reusable = false}, REDUCE(sym_className, 1),
  [515] = {.count = 1, .reusable = false}, REDUCE(sym__exprOrTerm, 1),
  [517] = {.count = 1, .reusable = true}, REDUCE(sym__exprOrTerm, 1),
  [519] = {.count = 1, .reusable = true}, SHIFT(950),
  [521] = {.count = 1, .reusable = false}, REDUCE(sym_super_ref, 1),
  [523] = {.count = 1, .reusable = true}, REDUCE(sym_super_ref, 1),
  [525] = {.count = 1, .reusable = false}, REDUCE(sym_variable, 1),
  [527] = {.count = 1, .reusable = true}, REDUCE(sym_variable, 1),
  [529] = {.count = 1, .reusable = false}, REDUCE(sym_bool, 1),
  [531] = {.count = 1, .reusable = true}, REDUCE(sym_bool, 1),
  [533] = {.count = 1, .reusable = false}, REDUCE(sym_literal, 1),
  [535] = {.count = 1, .reusable = true}, REDUCE(sym_literal, 1),
  [537] = {.count = 1, .reusable = false}, REDUCE(sym_par_expr, 3),
  [539] = {.count = 1, .reusable = true}, REDUCE(sym_par_expr, 3),
  [541] = {.count = 1, .reusable = false}, REDUCE(sym_qualified_expr, 3),
  [543] = {.count = 1, .reusable = true}, REDUCE(sym_qualified_expr, 3),
  [545] = {.count = 1, .reusable = false}, REDUCE(sym_classless_predicate_call, 3, .dynamic_precedence = 10),
  [547] = {.count = 1, .reusable = true}, REDUCE(sym_classless_predicate_call, 3, .dynamic_precedence = 10),
  [549] = {.count = 1, .reusable = false}, REDUCE(sym_aggregate, 3),
  [551] = {.count = 1, .reusable = true}, REDUCE(sym_aggregate, 3),
  [553] = {.count = 1, .reusable = false}, REDUCE(sym_classless_predicate_call, 4, .dynamic_precedence = 10),
  [555] = {.count = 1, .reusable = true}, REDUCE(sym_classless_predicate_call, 4, .dynamic_precedence = 10),
  [557] = {.count = 1, .reusable = false}, REDUCE(sym_aggregate, 4),
  [559] = {.count = 1, .reusable = true}, REDUCE(sym_aggregate, 4),
  [561] = {.count = 1, .reusable = false}, REDUCE(sym_range, 5, .production_id = 5),
  [563] = {.count = 1, .reusable = true}, REDUCE(sym_range, 5, .production_id = 5),
  [565] = {.count = 1, .reusable = false}, REDUCE(sym_qualifiedRhs, 3),
  [567] = {.count = 1, .reusable = true}, REDUCE(sym_qualifiedRhs, 3),
  [569] = {.count = 1, .reusable = false}, REDUCE(sym_classless_predicate_call, 5, .dynamic_precedence = 10),
  [571] = {.count = 1, .reusable = true}, REDUCE(sym_classless_predicate_call, 5, .dynamic_precedence = 10),
  [573] = {.count = 1, .reusable = false}, REDUCE(sym_classless_predicate_call, 6, .dynamic_precedence = 10),
  [575] = {.count = 1, .reusable = true}, REDUCE(sym_classless_predicate_call, 6, .dynamic_precedence = 10),
  [577] = {.count = 1, .reusable = false}, REDUCE(sym_aggregate, 6),
  [579] = {.count = 1, .reusable = true}, REDUCE(sym_aggregate, 6),
  [581] = {.count = 1, .reusable = false}, REDUCE(sym_qualifiedRhs, 5),
  [583] = {.count = 1, .reusable = true}, REDUCE(sym_qualifiedRhs, 5),
  [585] = {.count = 1, .reusable = true}, REDUCE(sym_aggregate, 8),
  [587] = {.count = 1, .reusable = false}, REDUCE(sym_aggregate, 8),
  [589] = {.count = 1, .reusable = true}, REDUCE(sym_qualifiedRhs, 6),
  [591] = {.count = 1, .reusable = false}, REDUCE(sym_qualifiedRhs, 6),
  [593] = {.count = 1, .reusable = false}, REDUCE(sym_aggregate, 7),
  [595] = {.count = 1, .reusable = true}, REDUCE(sym_aggregate, 7),
  [597] = {.count = 1, .reusable = true}, SHIFT(933),
  [599] = {.count = 1, .reusable = true}, SHIFT(917),
  [601] = {.count = 1, .reusable = true}, SHIFT(903),
  [603] = {.count = 1, .reusable = false}, REDUCE(sym_quantified, 4),
  [605] = {.count = 1, .reusable = true}, REDUCE(sym_quantified, 4),
  [607] = {.count = 1, .reusable = false}, REDUCE(sym_quantified, 9),
  [609] = {.count = 1, .reusable = true}, REDUCE(sym_quantified, 9),
  [611] = {.count = 1, .reusable = true}, REDUCE(sym_typeExpr, 1),
  [613] = {.count = 1, .reusable = false}, REDUCE(sym_typeExpr, 1),
  [615] = {.count = 1, .reusable = false}, REDUCE(sym_typeLiteral, 1),
  [617] = {.count = 1, .reusable = true}, REDUCE(sym_typeLiteral, 1),
  [619] = {.count = 1, .reusable = true}, REDUCE(sym_dbtype, 1),
  [621] = {.count = 1, .reusable = false}, REDUCE(sym_dbtype, 1),
  [623] = {.count = 1, .reusable = false}, REDUCE(sym_quantified, 6),
  [625] = {.count = 1, .reusable = true}, REDUCE(sym_quantified, 6),
  [627] = {.count = 1, .reusable = false}, REDUCE(sym_unop, 1),
  [629] = {.count = 1, .reusable = true}, REDUCE(sym_unop, 1),
  [631] = {.count = 1, .reusable = false}, REDUCE(sym_instance_of, 3),
  [633] = {.count = 1, .reusable = true}, REDUCE(sym_instance_of, 3),
  [635] = {.count = 1, .reusable = false}, REDUCE(sym_in_expr, 3, .production_id = 2),
  [637] = {.count = 1, .reusable = true}, REDUCE(sym_in_expr, 3, .production_id = 2),
  [639] = {.count = 1, .reusable = true}, REDUCE(sym_quantified, 7),
  [641] = {.count = 1, .reusable = false}, REDUCE(sym_quantified, 7),
  [643] = {.count = 1, .reusable = false}, REDUCE(sym_compop, 1),
  [645] = {.count = 1, .reusable = true}, REDUCE(sym_compop, 1),
  [647] = {.count = 1, .reusable = false}, REDUCE(sym_quantified, 8),
  [649] = {.count = 1, .reusable = true}, REDUCE(sym_quantified, 8),
  [651] = {.count = 1, .reusable = false}, REDUCE(sym_quantified, 3),
  [653] = {.count = 1, .reusable = true}, REDUCE(sym_quantified, 3),
  [655] = {.count = 1, .reusable = true}, REDUCE(sym_quantified, 5),
  [657] = {.count = 1, .reusable = false}, REDUCE(sym_quantified, 5),
  [659] = {.count = 1, .reusable = false}, REDUCE(sym_typeExpr, 3),
  [661] = {.count = 1, .reusable = true}, REDUCE(sym_typeExpr, 3),
  [663] = {.count = 1, .reusable = true}, REDUCE(sym_special_call, 3),
  [665] = {.count = 1, .reusable = false}, REDUCE(sym_special_call, 3),
  [667] = {.count = 1, .reusable = false}, REDUCE(sym_addop, 1),
  [669] = {.count = 1, .reusable = true}, REDUCE(sym_addop, 1),
  [671] = {.count = 1, .reusable = false}, REDUCE(sym_mulop, 1),
  [673] = {.count = 1, .reusable = true}, REDUCE(sym_mulop, 1),
  [675] = {.count = 1, .reusable = false}, SHIFT(906),
  [677] = {.count = 1, .reusable = true}, SHIFT(768),
  [679] = {.count = 1, .reusable = false}, SHIFT(828),
  [681] = {.count = 1, .reusable = false}, SHIFT(111),
  [683] = {.count = 1, .reusable = false}, SHIFT(61),
  [685] = {.count = 1, .reusable = true}, SHIFT(776),
  [687] = {.count = 1, .reusable = false}, SHIFT(1099),
  [689] = {.count = 1, .reusable = false}, SHIFT(1108),
  [691] = {.count = 1, .reusable = false}, SHIFT(893),
  [693] = {.count = 1, .reusable = true}, REDUCE(aux_sym_ql_repeat1, 2),
  [695] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(817),
  [698] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(953),
  [701] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(831),
  [704] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(87),
  [707] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(72),
  [710] = {.count = 2, .reusable = true}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(825),
  [713] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(458),
  [716] = {.count = 2, .reusable = true}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(457),
  [719] = {.count = 2, .reusable = true}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(460),
  [722] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(1089),
  [725] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(1090),
  [728] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(897),
  [731] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(1253),
  [734] = {.count = 1, .reusable = true}, SHIFT(779),
  [736] = {.count = 1, .reusable = true}, SHIFT(800),
  [738] = {.count = 1, .reusable = true}, REDUCE(sym_ql, 1),
  [740] = {.count = 1, .reusable = true}, SHIFT(819),
  [742] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(906),
  [745] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(828),
  [748] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(111),
  [751] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(61),
  [754] = {.count = 2, .reusable = true}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(776),
  [757] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(1099),
  [760] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(1108),
  [763] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(893),
  [766] = {.count = 1, .reusable = false}, SHIFT(944),
  [768] = {.count = 1, .reusable = true}, SHIFT(797),
  [770] = {.count = 1, .reusable = true}, SHIFT(863),
  [772] = {.count = 1, .reusable = true}, SHIFT(788),
  [774] = {.count = 1, .reusable = true}, SHIFT(804),
  [776] = {.count = 1, .reusable = true}, SHIFT(824),
  [778] = {.count = 2, .reusable = false}, REDUCE(aux_sym_dataclass_repeat2, 2), SHIFT_REPEAT(817),
  [781] = {.count = 1, .reusable = true}, REDUCE(aux_sym_dataclass_repeat2, 2),
  [783] = {.count = 2, .reusable = true}, REDUCE(aux_sym_dataclass_repeat2, 2), SHIFT_REPEAT(863),
  [786] = {.count = 2, .reusable = false}, REDUCE(aux_sym_dataclass_repeat2, 2), SHIFT_REPEAT(458),
  [789] = {.count = 2, .reusable = true}, REDUCE(aux_sym_dataclass_repeat2, 2), SHIFT_REPEAT(457),
  [792] = {.count = 2, .reusable = true}, REDUCE(aux_sym_dataclass_repeat2, 2), SHIFT_REPEAT(460),
  [795] = {.count = 2, .reusable = false}, REDUCE(aux_sym_dataclass_repeat2, 2), SHIFT_REPEAT(1253),
  [798] = {.count = 1, .reusable = true}, SHIFT(807),
  [800] = {.count = 1, .reusable = true}, SHIFT(821),
  [802] = {.count = 2, .reusable = false}, REDUCE(sym_simpleId, 1), REDUCE(sym_className, 1),
  [805] = {.count = 1, .reusable = true}, SHIFT(92),
  [807] = {.count = 1, .reusable = true}, SHIFT(93),
  [809] = {.count = 1, .reusable = true}, SHIFT(94),
  [811] = {.count = 1, .reusable = false}, SHIFT(1088),
  [813] = {.count = 1, .reusable = true}, SHIFT(849),
  [815] = {.count = 1, .reusable = true}, SHIFT(191),
  [817] = {.count = 1, .reusable = true}, SHIFT(190),
  [819] = {.count = 1, .reusable = true}, SHIFT(189),
  [821] = {.count = 1, .reusable = true}, SHIFT(1116),
  [823] = {.count = 1, .reusable = false}, SHIFT(174),
  [825] = {.count = 1, .reusable = true}, SHIFT(173),
  [827] = {.count = 1, .reusable = true}, SHIFT(168),
  [829] = {.count = 1, .reusable = false}, SHIFT(1096),
  [831] = {.count = 1, .reusable = true}, SHIFT(858),
  [833] = {.count = 1, .reusable = true}, SHIFT(936),
  [835] = {.count = 1, .reusable = true}, SHIFT(225),
  [837] = {.count = 1, .reusable = true}, SHIFT(1138),
  [839] = {.count = 1, .reusable = true}, REDUCE(sym_qualModuleExpr, 1),
  [841] = {.count = 1, .reusable = false}, REDUCE(sym_qualModuleExpr, 1),
  [843] = {.count = 1, .reusable = true}, SHIFT(978),
  [845] = {.count = 1, .reusable = false}, REDUCE(aux_sym_qualModuleExpr_repeat1, 2),
  [847] = {.count = 1, .reusable = true}, REDUCE(aux_sym_qualModuleExpr_repeat1, 2),
  [849] = {.count = 2, .reusable = true}, REDUCE(aux_sym_qualModuleExpr_repeat1, 2), SHIFT_REPEAT(969),
  [852] = {.count = 1, .reusable = false}, REDUCE(sym_qualModuleExpr, 2),
  [854] = {.count = 1, .reusable = true}, REDUCE(sym_qualModuleExpr, 2),
  [856] = {.count = 1, .reusable = true}, SHIFT(969),
  [858] = {.count = 1, .reusable = true}, SHIFT(1198),
  [860] = {.count = 1, .reusable = true}, SHIFT(1178),
  [862] = {.count = 1, .reusable = true}, SHIFT(1151),
  [864] = {.count = 1, .reusable = true}, SHIFT(1158),
  [866] = {.count = 2, .reusable = true}, REDUCE(aux_sym_qualModuleExpr_repeat1, 2), SHIFT_REPEAT(978),
  [869] = {.count = 1, .reusable = true}, SHIFT(1194),
  [871] = {.count = 1, .reusable = true}, REDUCE(sym_datatypeBranch, 4),
  [873] = {.count = 1, .reusable = false}, REDUCE(sym_datatypeBranch, 4),
  [875] = {.count = 1, .reusable = true}, SHIFT(236),
  [877] = {.count = 1, .reusable = true}, REDUCE(sym_datatypeBranch, 5),
  [879] = {.count = 1, .reusable = false}, REDUCE(sym_datatypeBranch, 5),
  [881] = {.count = 1, .reusable = true}, REDUCE(sym_asExprs, 1),
  [883] = {.count = 1, .reusable = false}, REDUCE(sym_asExprs, 1),
  [885] = {.count = 1, .reusable = true}, SHIFT(83),
  [887] = {.count = 1, .reusable = true}, SHIFT(928),
  [889] = {.count = 1, .reusable = true}, SHIFT(82),
  [891] = {.count = 1, .reusable = true}, SHIFT(396),
  [893] = {.count = 1, .reusable = true}, SHIFT(123),
  [895] = {.count = 1, .reusable = true}, SHIFT(445),
  [897] = {.count = 1, .reusable = true}, SHIFT(125),
  [899] = {.count = 1, .reusable = false}, REDUCE(sym_importModuleExpr, 2),
  [901] = {.count = 1, .reusable = true}, REDUCE(sym_importModuleExpr, 2),
  [903] = {.count = 1, .reusable = true}, SHIFT(970),
  [905] = {.count = 1, .reusable = true}, REDUCE(sym_importModuleExpr, 1),
  [907] = {.count = 1, .reusable = false}, REDUCE(sym_importModuleExpr, 1),
  [909] = {.count = 1, .reusable = true}, SHIFT(977),
  [911] = {.count = 1, .reusable = true}, SHIFT(440),
  [913] = {.count = 1, .reusable = true}, SHIFT(212),
  [915] = {.count = 1, .reusable = false}, REDUCE(sym_asExprs, 2),
  [917] = {.count = 1, .reusable = true}, REDUCE(sym_asExprs, 2),
  [919] = {.count = 1, .reusable = true}, SHIFT(169),
  [921] = {.count = 1, .reusable = true}, REDUCE(aux_sym_importModuleExpr_repeat1, 2),
  [923] = {.count = 1, .reusable = false}, REDUCE(aux_sym_importModuleExpr_repeat1, 2),
  [925] = {.count = 2, .reusable = true}, REDUCE(aux_sym_importModuleExpr_repeat1, 2), SHIFT_REPEAT(977),
  [928] = {.count = 1, .reusable = true}, SHIFT(398),
  [930] = {.count = 1, .reusable = true}, SHIFT(184),
  [932] = {.count = 2, .reusable = true}, REDUCE(aux_sym_importModuleExpr_repeat1, 2), SHIFT_REPEAT(970),
  [935] = {.count = 1, .reusable = true}, REDUCE(sym_datatypeBranch, 3),
  [937] = {.count = 1, .reusable = false}, REDUCE(sym_datatypeBranch, 3),
  [939] = {.count = 1, .reusable = true}, SHIFT(635),
  [941] = {.count = 1, .reusable = true}, SHIFT(227),
  [943] = {.count = 1, .reusable = false}, REDUCE(sym_datatypeBranch, 7),
  [945] = {.count = 1, .reusable = true}, REDUCE(sym_datatypeBranch, 7),
  [947] = {.count = 1, .reusable = true}, SHIFT(412),
  [949] = {.count = 1, .reusable = true}, SHIFT(121),
  [951] = {.count = 1, .reusable = true}, SHIFT(492),
  [953] = {.count = 1, .reusable = true}, SHIFT(203),
  [955] = {.count = 1, .reusable = false}, REDUCE(sym_datatypeBranch, 6),
  [957] = {.count = 1, .reusable = true}, REDUCE(sym_datatypeBranch, 6),
  [959] = {.count = 1, .reusable = true}, SHIFT(422),
  [961] = {.count = 1, .reusable = true}, SHIFT(197),
  [963] = {.count = 1, .reusable = false}, REDUCE(aux_sym_asExprs_repeat1, 2),
  [965] = {.count = 1, .reusable = true}, REDUCE(aux_sym_asExprs_repeat1, 2),
  [967] = {.count = 2, .reusable = true}, REDUCE(aux_sym_asExprs_repeat1, 2), SHIFT_REPEAT(82),
  [970] = {.count = 1, .reusable = true}, SHIFT(413),
  [972] = {.count = 1, .reusable = true}, SHIFT(176),
  [974] = {.count = 1, .reusable = true}, SHIFT(632),
  [976] = {.count = 1, .reusable = true}, SHIFT(232),
  [978] = {.count = 1, .reusable = true}, REDUCE(sym_full_aggregate_body, 4),
  [980] = {.count = 1, .reusable = true}, SHIFT(57),
  [982] = {.count = 1, .reusable = true}, SHIFT(430),
  [984] = {.count = 1, .reusable = true}, SHIFT(200),
  [986] = {.count = 1, .reusable = true}, REDUCE(sym__call_arg, 1),
  [988] = {.count = 1, .reusable = true}, SHIFT(407),
  [990] = {.count = 1, .reusable = true}, SHIFT(193),
  [992] = {.count = 1, .reusable = true}, SHIFT(648),
  [994] = {.count = 1, .reusable = true}, SHIFT(235),
  [996] = {.count = 1, .reusable = true}, SHIFT(491),
  [998] = {.count = 1, .reusable = true}, SHIFT(119),
  [1000] = {.count = 1, .reusable = true}, SHIFT(442),
  [1002] = {.count = 1, .reusable = true}, SHIFT(171),
  [1004] = {.count = 2, .reusable = true}, REDUCE(aux_sym_asExprs_repeat1, 2), SHIFT_REPEAT(83),
  [1007] = {.count = 1, .reusable = true}, SHIFT(444),
  [1009] = {.count = 1, .reusable = true}, SHIFT(179),
  [1011] = {.count = 1, .reusable = true}, SHIFT(495),
  [1013] = {.count = 1, .reusable = true}, SHIFT(131),
  [1015] = {.count = 1, .reusable = true}, REDUCE(aux_sym_aggregate_repeat1, 2),
  [1017] = {.count = 1, .reusable = true}, SHIFT(449),
  [1019] = {.count = 1, .reusable = true}, SHIFT(172),
  [1021] = {.count = 1, .reusable = true}, REDUCE(sym_select, 2),
  [1023] = {.count = 1, .reusable = false}, REDUCE(sym_select, 2),
  [1025] = {.count = 1, .reusable = false}, SHIFT(1208),
  [1027] = {.count = 1, .reusable = false}, REDUCE(sym_orderBys, 4),
  [1029] = {.count = 1, .reusable = true}, REDUCE(sym_orderBys, 4),
  [1031] = {.count = 1, .reusable = true}, SHIFT(84),
  [1033] = {.count = 1, .reusable = true}, SHIFT(78),
  [1035] = {.count = 1, .reusable = false}, REDUCE(aux_sym_orderBys_repeat1, 2),
  [1037] = {.count = 1, .reusable = true}, REDUCE(aux_sym_orderBys_repeat1, 2),
  [1039] = {.count = 2, .reusable = true}, REDUCE(aux_sym_orderBys_repeat1, 2), SHIFT_REPEAT(84),
  [1042] = {.count = 1, .reusable = true}, REDUCE(sym_datatypeBranches, 1),
  [1044] = {.count = 1, .reusable = false}, REDUCE(sym_datatypeBranches, 1),
  [1046] = {.count = 1, .reusable = false}, SHIFT(879),
  [1048] = {.count = 1, .reusable = true}, SHIFT(577),
  [1050] = {.count = 1, .reusable = true}, SHIFT(416),
  [1052] = {.count = 1, .reusable = true}, SHIFT(155),
  [1054] = {.count = 1, .reusable = true}, REDUCE(sym_asExpr, 3),
  [1056] = {.count = 1, .reusable = false}, REDUCE(sym_asExpr, 3),
  [1058] = {.count = 1, .reusable = true}, SHIFT(411),
  [1060] = {.count = 1, .reusable = true}, REDUCE(sym_select, 5),
  [1062] = {.count = 1, .reusable = false}, REDUCE(sym_select, 5),
  [1064] = {.count = 1, .reusable = true}, SHIFT(71),
  [1066] = {.count = 1, .reusable = true}, SHIFT(751),
  [1068] = {.count = 1, .reusable = false}, REDUCE(sym_orderBys, 3),
  [1070] = {.count = 1, .reusable = true}, REDUCE(sym_orderBys, 3),
  [1072] = {.count = 1, .reusable = true}, REDUCE(aux_sym_datatypeBranches_repeat1, 2),
  [1074] = {.count = 1, .reusable = false}, REDUCE(aux_sym_datatypeBranches_repeat1, 2),
  [1076] = {.count = 2, .reusable = false}, REDUCE(aux_sym_datatypeBranches_repeat1, 2), SHIFT_REPEAT(879),
  [1079] = {.count = 1, .reusable = true}, SHIFT(752),
  [1081] = {.count = 1, .reusable = true}, SHIFT(63),
  [1083] = {.count = 1, .reusable = true}, SHIFT(70),
  [1085] = {.count = 1, .reusable = true}, SHIFT(338),
  [1087] = {.count = 1, .reusable = true}, SHIFT(207),
  [1089] = {.count = 1, .reusable = true}, SHIFT(313),
  [1091] = {.count = 1, .reusable = true}, SHIFT(182),
  [1093] = {.count = 1, .reusable = true}, SHIFT(603),
  [1095] = {.count = 1, .reusable = true}, REDUCE(sym_select, 7),
  [1097] = {.count = 1, .reusable = false}, REDUCE(sym_select, 7),
  [1099] = {.count = 1, .reusable = true}, SHIFT(192),
  [1101] = {.count = 1, .reusable = true}, SHIFT(429),
  [1103] = {.count = 1, .reusable = true}, SHIFT(415),
  [1105] = {.count = 2, .reusable = true}, REDUCE(aux_sym_orderBys_repeat1, 2), SHIFT_REPEAT(78),
  [1108] = {.count = 1, .reusable = true}, SHIFT(118),
  [1110] = {.count = 1, .reusable = true}, SHIFT(652),
  [1112] = {.count = 1, .reusable = true}, SHIFT(423),
  [1114] = {.count = 1, .reusable = true}, SHIFT(75),
  [1116] = {.count = 1, .reusable = true}, SHIFT(162),
  [1118] = {.count = 1, .reusable = true}, SHIFT(165),
  [1120] = {.count = 1, .reusable = true}, SHIFT(636),
  [1122] = {.count = 1, .reusable = true}, SHIFT(637),
  [1124] = {.count = 1, .reusable = true}, SHIFT(194),
  [1126] = {.count = 1, .reusable = true}, SHIFT(306),
  [1128] = {.count = 1, .reusable = true}, SHIFT(354),
  [1130] = {.count = 1, .reusable = true}, SHIFT(195),
  [1132] = {.count = 1, .reusable = true}, SHIFT(62),
  [1134] = {.count = 1, .reusable = false}, SHIFT(1207),
  [1136] = {.count = 1, .reusable = true}, SHIFT(500),
  [1138] = {.count = 1, .reusable = true}, SHIFT(85),
  [1140] = {.count = 1, .reusable = true}, SHIFT(390),
  [1142] = {.count = 2, .reusable = false}, REDUCE(aux_sym_datatypeBranches_repeat1, 2), SHIFT_REPEAT(877),
  [1145] = {.count = 1, .reusable = true}, SHIFT(388),
  [1147] = {.count = 1, .reusable = true}, SHIFT(167),
  [1149] = {.count = 1, .reusable = true}, SHIFT(220),
  [1151] = {.count = 1, .reusable = true}, SHIFT(484),
  [1153] = {.count = 1, .reusable = true}, SHIFT(224),
  [1155] = {.count = 1, .reusable = true}, SHIFT(228),
  [1157] = {.count = 1, .reusable = true}, SHIFT(503),
  [1159] = {.count = 1, .reusable = false}, REDUCE(sym_select, 6),
  [1161] = {.count = 1, .reusable = true}, REDUCE(sym_select, 6),
  [1163] = {.count = 1, .reusable = true}, SHIFT(391),
  [1165] = {.count = 1, .reusable = true}, SHIFT(499),
  [1167] = {.count = 1, .reusable = true}, SHIFT(222),
  [1169] = {.count = 1, .reusable = true}, REDUCE(sym_select, 4),
  [1171] = {.count = 1, .reusable = false}, REDUCE(sym_select, 4),
  [1173] = {.count = 1, .reusable = true}, SHIFT(73),
  [1175] = {.count = 1, .reusable = true}, SHIFT(60),
  [1177] = {.count = 1, .reusable = true}, REDUCE(sym_select, 3),
  [1179] = {.count = 1, .reusable = false}, REDUCE(sym_select, 3),
  [1181] = {.count = 1, .reusable = true}, SHIFT(367),
  [1183] = {.count = 1, .reusable = true}, SHIFT(436),
  [1185] = {.count = 1, .reusable = false}, REDUCE(sym_datatypeBranches, 2),
  [1187] = {.count = 1, .reusable = true}, REDUCE(sym_datatypeBranches, 2),
  [1189] = {.count = 1, .reusable = false}, SHIFT(877),
  [1191] = {.count = 1, .reusable = true}, SHIFT(439),
  [1193] = {.count = 1, .reusable = true}, SHIFT(866),
  [1195] = {.count = 1, .reusable = true}, SHIFT(485),
  [1197] = {.count = 1, .reusable = true}, SHIFT(351),
  [1199] = {.count = 1, .reusable = true}, SHIFT(122),
  [1201] = {.count = 1, .reusable = true}, SHIFT(431),
  [1203] = {.count = 1, .reusable = true}, SHIFT(143),
  [1205] = {.count = 1, .reusable = true}, SHIFT(144),
  [1207] = {.count = 1, .reusable = true}, SHIFT(128),
  [1209] = {.count = 1, .reusable = true}, SHIFT(409),
  [1211] = {.count = 1, .reusable = true}, SHIFT(127),
  [1213] = {.count = 1, .reusable = true}, SHIFT(68),
  [1215] = {.count = 1, .reusable = true}, SHIFT(392),
  [1217] = {.count = 1, .reusable = true}, SHIFT(339),
  [1219] = {.count = 1, .reusable = true}, REDUCE(sym_direction, 1),
  [1221] = {.count = 1, .reusable = false}, REDUCE(sym_direction, 1),
  [1223] = {.count = 1, .reusable = true}, REDUCE(sym_imprt, 2),
  [1225] = {.count = 1, .reusable = false}, REDUCE(sym_imprt, 2),
  [1227] = {.count = 1, .reusable = false}, SHIFT(948),
  [1229] = {.count = 1, .reusable = true}, REDUCE(sym_orderBy, 2),
  [1231] = {.count = 1, .reusable = false}, REDUCE(sym_orderBy, 2),
  [1233] = {.count = 2, .reusable = false}, REDUCE(aux_sym_moduleMember_repeat1, 2), SHIFT_REPEAT(829),
  [1236] = {.count = 1, .reusable = false}, REDUCE(aux_sym_moduleMember_repeat1, 2),
  [1238] = {.count = 1, .reusable = true}, REDUCE(aux_sym_moduleMember_repeat1, 2),
  [1240] = {.count = 1, .reusable = false}, REDUCE(sym_body, 3),
  [1242] = {.count = 1, .reusable = true}, REDUCE(sym_body, 3),
  [1244] = {.count = 1, .reusable = false}, REDUCE(sym_datatypeBranch, 8),
  [1246] = {.count = 1, .reusable = true}, REDUCE(sym_datatypeBranch, 8),
  [1248] = {.count = 1, .reusable = false}, SHIFT(951),
  [1250] = {.count = 1, .reusable = true}, REDUCE(sym_classlessPredicate, 6),
  [1252] = {.count = 1, .reusable = false}, REDUCE(sym_classlessPredicate, 6),
  [1254] = {.count = 1, .reusable = false}, REDUCE(sym_higherOrderTerm, 6, .production_id = 7),
  [1256] = {.count = 1, .reusable = true}, REDUCE(sym_higherOrderTerm, 6, .production_id = 7),
  [1258] = {.count = 1, .reusable = true}, REDUCE(sym_module, 5),
  [1260] = {.count = 1, .reusable = false}, REDUCE(sym_module, 5),
  [1262] = {.count = 1, .reusable = false}, REDUCE(sym_moduleMember, 2),
  [1264] = {.count = 1, .reusable = true}, REDUCE(sym_moduleMember, 2),
  [1266] = {.count = 1, .reusable = false}, REDUCE(sym_datatype, 4),
  [1268] = {.count = 1, .reusable = true}, REDUCE(sym_datatype, 4),
  [1270] = {.count = 1, .reusable = true}, REDUCE(sym_moduleAliasBody, 3),
  [1272] = {.count = 1, .reusable = false}, REDUCE(sym_moduleAliasBody, 3),
  [1274] = {.count = 1, .reusable = false}, REDUCE(sym_imprt, 4),
  [1276] = {.count = 1, .reusable = true}, REDUCE(sym_imprt, 4),
  [1278] = {.count = 1, .reusable = false}, REDUCE(sym_module, 3),
  [1280] = {.count = 1, .reusable = true}, REDUCE(sym_module, 3),
  [1282] = {.count = 1, .reusable = true}, REDUCE(sym_moduleName, 1),
  [1284] = {.count = 1, .reusable = false}, REDUCE(sym_moduleName, 1),
  [1286] = {.count = 1, .reusable = false}, REDUCE(sym_moduleMember, 1),
  [1288] = {.count = 1, .reusable = true}, REDUCE(sym_moduleMember, 1),
  [1290] = {.count = 1, .reusable = true}, REDUCE(sym_higherOrderTerm, 10, .production_id = 7),
  [1292] = {.count = 1, .reusable = false}, REDUCE(sym_higherOrderTerm, 10, .production_id = 7),
  [1294] = {.count = 1, .reusable = true}, REDUCE(sym_higherOrderTerm, 9, .production_id = 7),
  [1296] = {.count = 1, .reusable = false}, REDUCE(sym_higherOrderTerm, 9, .production_id = 7),
  [1298] = {.count = 1, .reusable = true}, REDUCE(sym_higherOrderTerm, 8, .production_id = 7),
  [1300] = {.count = 1, .reusable = false}, REDUCE(sym_higherOrderTerm, 8, .production_id = 7),
  [1302] = {.count = 1, .reusable = true}, REDUCE(sym_classlessPredicate, 3),
  [1304] = {.count = 1, .reusable = false}, REDUCE(sym_classlessPredicate, 3),
  [1306] = {.count = 1, .reusable = false}, REDUCE(sym_dataclass, 3),
  [1308] = {.count = 1, .reusable = true}, REDUCE(sym_dataclass, 3),
  [1310] = {.count = 1, .reusable = true}, REDUCE(sym_higherOrderTerm, 7, .production_id = 7),
  [1312] = {.count = 1, .reusable = false}, REDUCE(sym_higherOrderTerm, 7, .production_id = 7),
  [1314] = {.count = 1, .reusable = false}, REDUCE(sym_dataclass, 7),
  [1316] = {.count = 1, .reusable = true}, REDUCE(sym_dataclass, 7),
  [1318] = {.count = 1, .reusable = true}, REDUCE(sym_typeAliasBody, 3),
  [1320] = {.count = 1, .reusable = false}, REDUCE(sym_typeAliasBody, 3),
  [1322] = {.count = 1, .reusable = true}, REDUCE(sym_module, 4),
  [1324] = {.count = 1, .reusable = false}, REDUCE(sym_module, 4),
  [1326] = {.count = 1, .reusable = true}, REDUCE(sym_predicateAliasBody, 3),
  [1328] = {.count = 1, .reusable = false}, REDUCE(sym_predicateAliasBody, 3),
  [1330] = {.count = 1, .reusable = false}, REDUCE(sym_empty, 1),
  [1332] = {.count = 1, .reusable = true}, REDUCE(sym_empty, 1),
  [1334] = {.count = 1, .reusable = true}, REDUCE(sym_dataclass, 6),
  [1336] = {.count = 1, .reusable = false}, REDUCE(sym_dataclass, 6),
  [1338] = {.count = 1, .reusable = true}, REDUCE(sym_classlessPredicate, 5),
  [1340] = {.count = 1, .reusable = false}, REDUCE(sym_classlessPredicate, 5),
  [1342] = {.count = 1, .reusable = false}, REDUCE(sym_dataclass, 8),
  [1344] = {.count = 1, .reusable = true}, REDUCE(sym_dataclass, 8),
  [1346] = {.count = 1, .reusable = false}, REDUCE(sym_select, 8),
  [1348] = {.count = 1, .reusable = true}, REDUCE(sym_select, 8),
  [1350] = {.count = 1, .reusable = false}, REDUCE(sym_classlessPredicate, 7),
  [1352] = {.count = 1, .reusable = true}, REDUCE(sym_classlessPredicate, 7),
  [1354] = {.count = 1, .reusable = false}, REDUCE(sym_annotName, 1),
  [1356] = {.count = 1, .reusable = true}, REDUCE(sym_annotName, 1),
  [1358] = {.count = 1, .reusable = false}, SHIFT(867),
  [1360] = {.count = 1, .reusable = false}, SHIFT(110),
  [1362] = {.count = 1, .reusable = false}, SHIFT(59),
  [1364] = {.count = 1, .reusable = false}, REDUCE(sym_annotation, 1, .production_id = 1),
  [1366] = {.count = 1, .reusable = true}, SHIFT(892),
  [1368] = {.count = 1, .reusable = true}, REDUCE(sym_annotation, 1, .production_id = 1),
  [1370] = {.count = 1, .reusable = false}, SHIFT(117),
  [1372] = {.count = 1, .reusable = false}, SHIFT(74),
  [1374] = {.count = 1, .reusable = true}, SHIFT(576),
  [1376] = {.count = 1, .reusable = true}, SHIFT(609),
  [1378] = {.count = 1, .reusable = false}, REDUCE(sym_annotation, 5, .production_id = 4),
  [1380] = {.count = 1, .reusable = true}, REDUCE(sym_annotation, 5, .production_id = 4),
  [1382] = {.count = 1, .reusable = false}, REDUCE(sym_annotation, 4, .production_id = 3),
  [1384] = {.count = 1, .reusable = true}, REDUCE(sym_annotation, 4, .production_id = 3),
  [1386] = {.count = 1, .reusable = true}, SHIFT(617),
  [1388] = {.count = 1, .reusable = true}, SHIFT(874),
  [1390] = {.count = 1, .reusable = true}, SHIFT(559),
  [1392] = {.count = 1, .reusable = true}, SHIFT(884),
  [1394] = {.count = 1, .reusable = true}, SHIFT(582),
  [1396] = {.count = 1, .reusable = true}, SHIFT(880),
  [1398] = {.count = 1, .reusable = true}, SHIFT(560),
  [1400] = {.count = 1, .reusable = false}, SHIFT(432),
  [1402] = {.count = 1, .reusable = true}, SHIFT(314),
  [1404] = {.count = 1, .reusable = true}, SHIFT(433),
  [1406] = {.count = 1, .reusable = false}, SHIFT(394),
  [1408] = {.count = 1, .reusable = true}, SHIFT(327),
  [1410] = {.count = 1, .reusable = true}, SHIFT(402),
  [1412] = {.count = 1, .reusable = false}, SHIFT(400),
  [1414] = {.count = 1, .reusable = true}, SHIFT(300),
  [1416] = {.count = 1, .reusable = true}, SHIFT(395),
  [1418] = {.count = 1, .reusable = false}, SHIFT(738),
  [1420] = {.count = 1, .reusable = true}, SHIFT(580),
  [1422] = {.count = 1, .reusable = true}, SHIFT(629),
  [1424] = {.count = 1, .reusable = false}, SHIFT(403),
  [1426] = {.count = 1, .reusable = true}, SHIFT(377),
  [1428] = {.count = 1, .reusable = true}, SHIFT(405),
  [1430] = {.count = 1, .reusable = false}, REDUCE(sym_classMember, 2),
  [1432] = {.count = 1, .reusable = true}, REDUCE(sym_classMember, 2),
  [1434] = {.count = 1, .reusable = false}, REDUCE(sym_memberPredicate, 7),
  [1436] = {.count = 1, .reusable = true}, REDUCE(sym_memberPredicate, 7),
  [1438] = {.count = 1, .reusable = false}, REDUCE(sym_classMember, 1),
  [1440] = {.count = 1, .reusable = true}, REDUCE(sym_classMember, 1),
  [1442] = {.count = 1, .reusable = false}, REDUCE(sym_memberPredicate, 5),
  [1444] = {.count = 1, .reusable = true}, REDUCE(sym_memberPredicate, 5),
  [1446] = {.count = 1, .reusable = false}, REDUCE(sym_field, 2),
  [1448] = {.count = 1, .reusable = true}, REDUCE(sym_field, 2),
  [1450] = {.count = 1, .reusable = false}, REDUCE(sym_charpred, 6),
  [1452] = {.count = 1, .reusable = true}, REDUCE(sym_charpred, 6),
  [1454] = {.count = 1, .reusable = false}, REDUCE(sym_memberPredicate, 6),
  [1456] = {.count = 1, .reusable = true}, REDUCE(sym_memberPredicate, 6),
  [1458] = {.count = 1, .reusable = true}, SHIFT(829),
  [1460] = {.count = 1, .reusable = true}, SHIFT(895),
  [1462] = {.count = 1, .reusable = true}, SHIFT(1006),
  [1464] = {.count = 1, .reusable = true}, SHIFT(896),
  [1466] = {.count = 1, .reusable = true}, SHIFT(1134),
  [1468] = {.count = 1, .reusable = true}, SHIFT(1169),
  [1470] = {.count = 1, .reusable = true}, SHIFT(899),
  [1472] = {.count = 1, .reusable = true}, SHIFT(812),
  [1474] = {.count = 1, .reusable = true}, SHIFT(1047),
  [1476] = {.count = 1, .reusable = true}, SHIFT(803),
  [1478] = {.count = 1, .reusable = true}, SHIFT(1083),
  [1480] = {.count = 1, .reusable = true}, SHIFT(867),
  [1482] = {.count = 1, .reusable = false}, SHIFT(1110),
  [1484] = {.count = 1, .reusable = true}, REDUCE(sym_varDecl, 2),
  [1486] = {.count = 2, .reusable = true}, REDUCE(aux_sym_classlessPredicate_repeat1, 2), SHIFT_REPEAT(843),
  [1489] = {.count = 1, .reusable = true}, REDUCE(aux_sym_classlessPredicate_repeat1, 2),
  [1491] = {.count = 1, .reusable = true}, SHIFT(541),
  [1493] = {.count = 1, .reusable = false}, REDUCE(sym_literalId, 1),
  [1495] = {.count = 1, .reusable = true}, SHIFT(543),
  [1497] = {.count = 1, .reusable = true}, SHIFT(1237),
  [1499] = {.count = 1, .reusable = true}, SHIFT(870),
  [1501] = {.count = 1, .reusable = true}, SHIFT(1212),
  [1503] = {.count = 1, .reusable = true}, SHIFT(843),
  [1505] = {.count = 1, .reusable = true}, SHIFT(234),
  [1507] = {.count = 1, .reusable = true}, SHIFT(941),
  [1509] = {.count = 1, .reusable = true}, SHIFT(846),
  [1511] = {.count = 2, .reusable = true}, REDUCE(sym_returnType, 1), SHIFT(867),
  [1514] = {.count = 1, .reusable = true}, SHIFT(108),
  [1516] = {.count = 1, .reusable = true}, SHIFT(36),
  [1518] = {.count = 1, .reusable = true}, SHIFT(1211),
  [1520] = {.count = 1, .reusable = true}, SHIFT(95),
  [1522] = {.count = 1, .reusable = true}, SHIFT(177),
  [1524] = {.count = 1, .reusable = true}, SHIFT(35),
  [1526] = {.count = 1, .reusable = true}, SHIFT(124),
  [1528] = {.count = 1, .reusable = true}, SHIFT(52),
  [1530] = {.count = 1, .reusable = true}, SHIFT(133),
  [1532] = {.count = 1, .reusable = true}, SHIFT(43),
  [1534] = {.count = 1, .reusable = true}, SHIFT(847),
  [1536] = {.count = 1, .reusable = true}, SHIFT(49),
  [1538] = {.count = 1, .reusable = true}, SHIFT(65),
  [1540] = {.count = 1, .reusable = true}, SHIFT(30),
  [1542] = {.count = 1, .reusable = true}, SHIFT(202),
  [1544] = {.count = 1, .reusable = true}, SHIFT(45),
  [1546] = {.count = 1, .reusable = true}, SHIFT(201),
  [1548] = {.count = 1, .reusable = true}, REDUCE(sym_aritylessPredicateExpr, 1),
  [1550] = {.count = 1, .reusable = false}, REDUCE(sym_aritylessPredicateExpr, 1),
  [1552] = {.count = 1, .reusable = true}, SHIFT(178),
  [1554] = {.count = 1, .reusable = true}, SHIFT(850),
  [1556] = {.count = 1, .reusable = true}, SHIFT(42),
  [1558] = {.count = 1, .reusable = true}, SHIFT(183),
  [1560] = {.count = 1, .reusable = true}, SHIFT(80),
  [1562] = {.count = 1, .reusable = true}, SHIFT(851),
  [1564] = {.count = 1, .reusable = true}, SHIFT(239),
  [1566] = {.count = 1, .reusable = true}, SHIFT(23),
  [1568] = {.count = 1, .reusable = true}, SHIFT(66),
  [1570] = {.count = 1, .reusable = true}, SHIFT(28),
  [1572] = {.count = 1, .reusable = true}, REDUCE(sym_predicateName, 1),
  [1574] = {.count = 2, .reusable = true}, REDUCE(aux_sym_asExprs_repeat1, 2), SHIFT_REPEAT(80),
  [1577] = {.count = 1, .reusable = true}, REDUCE(sym_aritylessPredicateExpr, 3),
  [1579] = {.count = 1, .reusable = false}, REDUCE(sym_aritylessPredicateExpr, 3),
  [1581] = {.count = 1, .reusable = true}, SHIFT(860),
  [1583] = {.count = 1, .reusable = true}, SHIFT(153),
  [1585] = {.count = 1, .reusable = true}, SHIFT(210),
  [1587] = {.count = 1, .reusable = true}, SHIFT(29),
  [1589] = {.count = 1, .reusable = true}, SHIFT(856),
  [1591] = {.count = 1, .reusable = true}, SHIFT(139),
  [1593] = {.count = 1, .reusable = true}, SHIFT(211),
  [1595] = {.count = 1, .reusable = true}, SHIFT(214),
  [1597] = {.count = 1, .reusable = true}, SHIFT(39),
  [1599] = {.count = 1, .reusable = true}, SHIFT(69),
  [1601] = {.count = 1, .reusable = true}, SHIFT(319),
  [1603] = {.count = 1, .reusable = true}, SHIFT(606),
  [1605] = {.count = 1, .reusable = true}, SHIFT(837),
  [1607] = {.count = 1, .reusable = true}, SHIFT(888),
  [1609] = {.count = 1, .reusable = true}, SHIFT(613),
  [1611] = {.count = 1, .reusable = true}, SHIFT(618),
  [1613] = {.count = 1, .reusable = true}, SHIFT(621),
  [1615] = {.count = 1, .reusable = true}, SHIFT(887),
  [1617] = {.count = 1, .reusable = true}, SHIFT(1149),
  [1619] = {.count = 1, .reusable = true}, SHIFT(1163),
  [1621] = {.count = 1, .reusable = true}, SHIFT(1182),
  [1623] = {.count = 1, .reusable = true}, SHIFT(889),
  [1625] = {.count = 1, .reusable = true}, SHIFT(835),
  [1627] = {.count = 1, .reusable = true}, SHIFT(839),
  [1629] = {.count = 1, .reusable = true}, SHIFT(885),
  [1631] = {.count = 1, .reusable = true}, SHIFT(845),
  [1633] = {.count = 1, .reusable = true}, SHIFT(855),
  [1635] = {.count = 1, .reusable = true}, SHIFT(455),
  [1637] = {.count = 1, .reusable = true}, SHIFT(910),
  [1639] = {.count = 2, .reusable = true}, REDUCE(aux_sym_orderBys_repeat1, 2), SHIFT_REPEAT(79),
  [1642] = {.count = 1, .reusable = true}, SHIFT(316),
  [1644] = {.count = 1, .reusable = true}, SHIFT(79),
  [1646] = {.count = 1, .reusable = true}, SHIFT(317),
  [1648] = {.count = 1, .reusable = true}, REDUCE(sym_predicateExpr, 3),
  [1650] = {.count = 1, .reusable = true}, SHIFT(325),
  [1652] = {.count = 1, .reusable = true}, SHIFT(1141),
  [1654] = {.count = 2, .reusable = true}, REDUCE(aux_sym_higherOrderTerm_repeat1, 2), SHIFT_REPEAT(887),
  [1657] = {.count = 1, .reusable = true}, REDUCE(aux_sym_higherOrderTerm_repeat1, 2),
  [1659] = {.count = 1, .reusable = true}, SHIFT(876),
  [1661] = {.count = 1, .reusable = true}, SHIFT(1161),
  [1663] = {.count = 1, .reusable = true}, REDUCE(sym_expr_aggregate_body, 1),
  [1665] = {.count = 1, .reusable = true}, SHIFT(1223),
  [1667] = {.count = 1, .reusable = true}, SHIFT(498),
  [1669] = {.count = 1, .reusable = true}, SHIFT(854),
  [1671] = {.count = 1, .reusable = true}, SHIFT(848),
  [1673] = {.count = 1, .reusable = true}, SHIFT(844),
  [1675] = {.count = 1, .reusable = true}, SHIFT(834),
  [1677] = {.count = 1, .reusable = true}, SHIFT(777),
  [1679] = {.count = 1, .reusable = true}, SHIFT(1181),
  [1681] = {.count = 1, .reusable = true}, SHIFT(778),
  [1683] = {.count = 1, .reusable = true}, SHIFT(875),
  [1685] = {.count = 1, .reusable = true}, SHIFT(336),
  [1687] = {.count = 1, .reusable = true}, SHIFT(1201),
  [1689] = {.count = 1, .reusable = true}, SHIFT(353),
  [1691] = {.count = 1, .reusable = true}, SHIFT(324),
  [1693] = {.count = 1, .reusable = true}, SHIFT(356),
  [1695] = {.count = 1, .reusable = true}, SHIFT(878),
  [1697] = {.count = 1, .reusable = true}, SHIFT(478),
  [1699] = {.count = 1, .reusable = true}, SHIFT(358),
  [1701] = {.count = 1, .reusable = true}, SHIFT(453),
  [1703] = {.count = 1, .reusable = true}, SHIFT(955),
  [1705] = {.count = 1, .reusable = true}, SHIFT(1168),
  [1707] = {.count = 1, .reusable = true}, SHIFT(360),
  [1709] = {.count = 1, .reusable = true}, SHIFT(627),
  [1711] = {.count = 1, .reusable = true}, SHIFT(785),
  [1713] = {.count = 1, .reusable = true}, SHIFT(883),
  [1715] = {.count = 1, .reusable = true}, SHIFT(1184),
  [1717] = {.count = 1, .reusable = true}, SHIFT(490),
  [1719] = {.count = 1, .reusable = true}, REDUCE(sym_full_aggregate_body, 6),
  [1721] = {.count = 2, .reusable = true}, REDUCE(aux_sym_annotation_repeat1, 2), SHIFT_REPEAT(889),
  [1724] = {.count = 1, .reusable = true}, REDUCE(aux_sym_annotation_repeat1, 2),
  [1726] = {.count = 1, .reusable = true}, SHIFT(790),
  [1728] = {.count = 1, .reusable = true}, SHIFT(1205),
  [1730] = {.count = 1, .reusable = true}, SHIFT(1132),
  [1732] = {.count = 1, .reusable = true}, SHIFT(881),
  [1734] = {.count = 1, .reusable = true}, SHIFT(886),
  [1736] = {.count = 1, .reusable = true}, SHIFT(611),
  [1738] = {.count = 1, .reusable = true}, SHIFT(497),
  [1740] = {.count = 1, .reusable = true}, SHIFT(1247),
  [1742] = {.count = 1, .reusable = true}, REDUCE(sym_full_aggregate_body, 5),
  [1744] = {.count = 1, .reusable = true}, SHIFT(382),
  [1746] = {.count = 1, .reusable = true}, SHIFT(486),
  [1748] = {.count = 1, .reusable = true}, SHIFT(379),
  [1750] = {.count = 1, .reusable = true}, SHIFT(329),
  [1752] = {.count = 1, .reusable = true}, SHIFT(374),
  [1754] = {.count = 1, .reusable = true}, SHIFT(501),
  [1756] = {.count = 1, .reusable = true}, SHIFT(586),
  [1758] = {.count = 2, .reusable = true}, REDUCE(aux_sym_higherOrderTerm_repeat2, 2), SHIFT_REPEAT(69),
  [1761] = {.count = 1, .reusable = true}, REDUCE(aux_sym_higherOrderTerm_repeat2, 2),
  [1763] = {.count = 1, .reusable = true}, SHIFT(370),
  [1765] = {.count = 1, .reusable = true}, SHIFT(593),
  [1767] = {.count = 2, .reusable = true}, REDUCE(aux_sym_aggregate_repeat1, 2), SHIFT_REPEAT(225),
  [1770] = {.count = 1, .reusable = true}, SHIFT(471),
  [1772] = {.count = 1, .reusable = true}, REDUCE(aux_sym_dataclass_repeat1, 2),
  [1774] = {.count = 2, .reusable = true}, REDUCE(aux_sym_dataclass_repeat1, 2), SHIFT_REPEAT(854),
  [1777] = {.count = 1, .reusable = true}, SHIFT(475),
  [1779] = {.count = 1, .reusable = true}, SHIFT(321),
  [1781] = {.count = 1, .reusable = true}, SHIFT(185),
  [1783] = {.count = 1, .reusable = true}, REDUCE(sym_aggId, 1),
  [1785] = {.count = 1, .reusable = true}, SHIFT(223),
  [1787] = {.count = 1, .reusable = true}, SHIFT(4),
  [1789] = {.count = 1, .reusable = true}, SHIFT(109),
  [1791] = {.count = 1, .reusable = true}, SHIFT(780),
  [1793] = {.count = 1, .reusable = true}, SHIFT(1024),
  [1795] = {.count = 1, .reusable = true}, SHIFT(142),
  [1797] = {.count = 1, .reusable = true}, SHIFT(10),
  [1799] = {.count = 1, .reusable = true}, SHIFT(154),
  [1801] = {.count = 1, .reusable = true}, SHIFT(160),
  [1803] = {.count = 1, .reusable = true}, REDUCE(sym_annotArg, 1),
  [1805] = {.count = 1, .reusable = true}, SHIFT(233),
  [1807] = {.count = 1, .reusable = true}, REDUCE(sym_moduleExpr, 3),
  [1809] = {.count = 1, .reusable = true}, SHIFT(15),
  [1811] = {.count = 1, .reusable = true}, SHIFT(88),
  [1813] = {.count = 1, .reusable = true}, SHIFT(135),
  [1815] = {.count = 1, .reusable = true}, SHIFT(12),
  [1817] = {.count = 1, .reusable = true}, SHIFT(91),
  [1819] = {.count = 1, .reusable = true}, SHIFT(9),
  [1821] = {.count = 1, .reusable = true}, SHIFT(112),
  [1823] = {.count = 1, .reusable = true}, SHIFT(97),
  [1825] = {.count = 1, .reusable = true}, SHIFT(7),
  [1827] = {.count = 1, .reusable = true}, SHIFT(126),
  [1829] = {.count = 1, .reusable = true}, SHIFT(772),
  [1831] = {.count = 1, .reusable = true}, SHIFT(37),
  [1833] = {.count = 1, .reusable = true}, SHIFT(50),
  [1835] = {.count = 1, .reusable = true}, SHIFT(389),
  [1837] = {.count = 1, .reusable = true}, SHIFT(34),
  [1839] = {.count = 1, .reusable = true}, SHIFT(383),
  [1841] = {.count = 1, .reusable = true}, SHIFT(46),
  [1843] = {.count = 1, .reusable = true}, SHIFT(13),
  [1845] = {.count = 1, .reusable = true}, SHIFT(1204),
  [1847] = {.count = 1, .reusable = true}, SHIFT(838),
  [1849] = {.count = 1, .reusable = true}, SHIFT(11),
  [1851] = {.count = 1, .reusable = true}, SHIFT(40),
  [1853] = {.count = 1, .reusable = true}, SHIFT(1246),
  [1855] = {.count = 1, .reusable = true}, SHIFT(420),
  [1857] = {.count = 1, .reusable = true}, SHIFT(1209),
  [1859] = {.count = 1, .reusable = true}, SHIFT(54),
  [1861] = {.count = 1, .reusable = true}, SHIFT(994),
  [1863] = {.count = 1, .reusable = true}, SHIFT(48),
  [1865] = {.count = 1, .reusable = true}, SHIFT(47),
  [1867] = {.count = 1, .reusable = true}, SHIFT(18),
  [1869] = {.count = 1, .reusable = true}, REDUCE(sym_expr_aggregate_body, 2),
  [1871] = {.count = 1, .reusable = true}, SHIFT(961),
  [1873] = {.count = 1, .reusable = true}, SHIFT(361),
  [1875] = {.count = 1, .reusable = true}, SHIFT(320),
  [1877] = {.count = 1, .reusable = true}, SHIFT(33),
  [1879] = {.count = 1, .reusable = true}, SHIFT(5),
  [1881] = {.count = 1, .reusable = true}, SHIFT(55),
  [1883] = {.count = 1, .reusable = true}, SHIFT(6),
  [1885] = {.count = 1, .reusable = true}, REDUCE(sym_full_aggregate_body, 7),
  [1887] = {.count = 1, .reusable = true}, SHIFT(51),
  [1889] = {.count = 1, .reusable = true}, SHIFT(802),
  [1891] = {.count = 1, .reusable = true}, SHIFT(1183),
  [1893] = {.count = 1, .reusable = true}, SHIFT(44),
  [1895] = {.count = 1, .reusable = true}, SHIFT(1175),
  [1897] = {.count = 1, .reusable = true}, SHIFT(38),
  [1899] = {.count = 1, .reusable = true}, SHIFT(53),
  [1901] = {.count = 1, .reusable = true}, SHIFT(41),
  [1903] = {.count = 1, .reusable = false}, SHIFT(1148),
  [1905] = {.count = 1, .reusable = true}, SHIFT(914),
  [1907] = {.count = 1, .reusable = true}, SHIFT(347),
  [1909] = {.count = 1, .reusable = true}, SHIFT(343),
  [1911] = {.count = 1, .reusable = true}, SHIFT(840),
  [1913] = {.count = 1, .reusable = true}, SHIFT(31),
  [1915] = {.count = 1, .reusable = true}, SHIFT(2),
  [1917] = {.count = 1, .reusable = true}, SHIFT(833),
  [1919] = {.count = 1, .reusable = true}, SHIFT(798),
  [1921] = {.count = 1, .reusable = true}, SHIFT(19),
  [1923] = {.count = 1, .reusable = true}, SHIFT(16),
  [1925] = {.count = 1, .reusable = true}, SHIFT(417),
  [1927] = {.count = 1, .reusable = true}, SHIFT(8),
  [1929] = {.count = 1, .reusable = true}, SHIFT(1144),
  [1931] = {.count = 1, .reusable = true}, SHIFT(25),
  [1933] = {.count = 1, .reusable = true}, SHIFT(1136),
  [1935] = {.count = 1, .reusable = true}, SHIFT(920),
  [1937] = {.count = 1, .reusable = true}, SHIFT(832),
  [1939] = {.count = 1, .reusable = true}, SHIFT(32),
  [1941] = {.count = 1, .reusable = true}, SHIFT(470),
  [1943] = {.count = 1, .reusable = true}, SHIFT(326),
  [1945] = {.count = 1, .reusable = true}, SHIFT(14),
  [1947] = {.count = 1, .reusable = true}, SHIFT(26),
  [1949] = {.count = 1, .reusable = true}, SHIFT(22),
  [1951] = {.count = 1, .reusable = true}, SHIFT(17),
  [1953] = {.count = 1, .reusable = true}, SHIFT(312),
  [1955] = {.count = 1, .reusable = true}, SHIFT(865),
  [1957] = {.count = 1, .reusable = true}, SHIFT(3),
  [1959] = {.count = 1, .reusable = true}, SHIFT(836),
  [1961] = {.count = 1, .reusable = true}, SHIFT(842),
  [1963] = {.count = 1, .reusable = true}, SHIFT(308),
  [1965] = {.count = 1, .reusable = true}, SHIFT(447),
  [1967] = {.count = 1, .reusable = true}, SHIFT(76),
  [1969] = {.count = 1, .reusable = true}, SHIFT(77),
  [1971] = {.count = 1, .reusable = true}, SHIFT(424),
  [1973] = {.count = 1, .reusable = true}, SHIFT(27),
  [1975] = {.count = 1, .reusable = true}, REDUCE(sym_closure, 1),
  [1977] = {.count = 1, .reusable = true}, SHIFT(467),
  [1979] = {.count = 1, .reusable = true}, SHIFT(20),
  [1981] = {.count = 1, .reusable = true}, SHIFT(132),
  [1983] = {.count = 1, .reusable = true}, SHIFT(488),
  [1985] = {.count = 1, .reusable = true}, SHIFT(871),
  [1987] = {.count = 1, .reusable = true}, SHIFT(873),
  [1989] = {.count = 1, .reusable = true}, SHIFT(1221),
  [1991] = {.count = 1, .reusable = true}, SHIFT(21),
  [1993] = {.count = 1, .reusable = true}, SHIFT(952),
  [1995] = {.count = 1, .reusable = true}, SHIFT(299),
  [1997] = {.count = 1, .reusable = true}, SHIFT(622),
  [1999] = {.count = 1, .reusable = true}, SHIFT(81),
  [2001] = {.count = 1, .reusable = true}, SHIFT(1206),
  [2003] = {.count = 1, .reusable = true}, SHIFT(340),
  [2005] = {.count = 1, .reusable = true}, SHIFT(869),
  [2007] = {.count = 1, .reusable = true}, SHIFT(799),
  [2009] = {.count = 1, .reusable = true}, SHIFT(813),
  [2011] = {.count = 1, .reusable = true}, SHIFT(599),
  [2013] = {.count = 1, .reusable = true}, SHIFT(932),
  [2015] = {.count = 1, .reusable = true}, SHIFT(900),
  [2017] = {.count = 1, .reusable = true}, SHIFT(590),
  [2019] = {.count = 1, .reusable = true}, SHIFT(368),
  [2021] = {.count = 1, .reusable = true}, SHIFT(24),
  [2023] = {.count = 1, .reusable = true}, SHIFT(1215),
  [2025] = {.count = 1, .reusable = true}, REDUCE(sym_specialId, 1),
  [2027] = {.count = 1, .reusable = true}, SHIFT(872),
  [2029] = {.count = 1, .reusable = true}, REDUCE(sym_quantifier, 1),
  [2031] = {.count = 1, .reusable = true}, SHIFT(659),
  [2033] = {.count = 1, .reusable = true}, SHIFT(1214),
  [2035] = {.count = 1, .reusable = true}, SHIFT(841),
  [2037] = {.count = 1, .reusable = true}, SHIFT(940),
  [2039] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [2041] = {.count = 1, .reusable = true}, REDUCE(sym_returnType, 1),
  [2043] = {.count = 1, .reusable = true}, SHIFT(487),
  [2045] = {.count = 1, .reusable = true}, SHIFT(954),
};

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_ql(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .public_symbol_map = ts_symbol_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym__lower_id,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
  };
  return &language;
}
